// TJC implementation of procedure compileproc_args_assign
package tjc;
import tcl.lang.*;

public class CompileprocArgsAssignCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 19, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "proc_args");
        }
        setVarScalar(interp, "proc_args", objv[1], compiledLocals, 0);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 1);
        } // End Invoke: global
        { // Invoke: set cmd_needs_init $...
            TclObject tmp0;
            tmp0 = getVarArray(interp, "_compileproc_key_info", "cmd_needs_init", compiledLocals, 1);
            setVarScalar(interp, "cmd_needs_init", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set constants_found $...
            TclObject tmp1;
            tmp1 = getVarArray(interp, "_compileproc_key_info", "constants_found", compiledLocals, 1);
            setVarScalar(interp, "constants_found", tmp1, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $proc_args
                TclObject tmp2 = getVarScalar(interp, "proc_args", compiledLocals, 0);
                int tmp3 = TclList.getLength(interp, tmp2);
                interp.setResult(tmp3);
            } // End Invoke: llength
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs0;
            TJC.exprInitValue(interp, tmp5, tmp4);
            ExprValue tmp6 = evs1;
            tmp6.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp5, tmp6);
            // End Binary operator: ==
            boolean tmp7 = ( tmp5.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: return [...]
                    { // Invoke: emitter_empty_args
                        TclObject[] objv8 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: emitter_empty_args
                            objv8[0] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv8, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv8, 1);
                        }
                    } // End Invoke: emitter_empty_args
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp9;
            { // Invoke: ... $proc_args
                TclObject[] objv10 = TJC.grabObjv(interp, 2);
                TclObject tmp11;
                try {
                    // Arg 0 constant: ...
                    objv10[0] = const2;
                    // Arg 1 variable: $proc_args
                    tmp11 = getVarScalar(interp, "proc_args", compiledLocals, 0);
                    tmp11.preserve();
                    objv10[1] = tmp11;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv10, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp11 = objv10[1];
                    if ( tmp11 != null ) {
                        tmp11.release();
                    }
                    TJC.releaseObjv(interp, objv10, 2);
                }
            } // End Invoke: ...
            tmp9 = interp.getResult();
            setVarScalar(interp, "result", tmp9, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set non_default_args [...]
            TclObject tmp12;
            { // Invoke: lindex $result 0
                TclObject tmp13 = getVarScalar(interp, "result", compiledLocals, 5);
                tmp13 = TclList.index(interp, tmp13, 0);
                if ( tmp13 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp13);
                }
            } // End Invoke: lindex
            tmp12 = interp.getResult();
            setVarScalar(interp, "non_default_args", tmp12, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set default_args [...]
            TclObject tmp14;
            { // Invoke: lindex $result 1
                TclObject tmp15 = getVarScalar(interp, "result", compiledLocals, 5);
                tmp15 = TclList.index(interp, tmp15, 1);
                if ( tmp15 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp15);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "default_args", tmp14, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set has_args [...]
            TclObject tmp16;
            { // Invoke: lindex $result 2
                TclObject tmp17 = getVarScalar(interp, "result", compiledLocals, 5);
                tmp17 = TclList.index(interp, tmp17, 2);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            tmp16 = interp.getResult();
            setVarScalar(interp, "has_args", tmp16, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set min_num_args [...]
            TclObject tmp18;
            { // Invoke: lindex $result 3
                TclObject tmp19 = getVarScalar(interp, "result", compiledLocals, 5);
                tmp19 = TclList.index(interp, tmp19, 3);
                if ( tmp19 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp19);
                }
            } // End Invoke: lindex
            tmp18 = interp.getResult();
            setVarScalar(interp, "min_num_args", tmp18, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set max_num_args [...]
            TclObject tmp20;
            { // Invoke: lindex $result 4
                TclObject tmp21 = getVarScalar(interp, "result", compiledLocals, 5);
                tmp21 = TclList.index(interp, tmp21, 4);
                if ( tmp21 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp21);
                }
            } // End Invoke: lindex
            tmp20 = interp.getResult();
            setVarScalar(interp, "max_num_args", tmp20, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ... elseif ... ... elseif ... ... elseif ... ... elseif ... ... elseif ... ... elseif ... ... else ...
            // Binary operator: () && ()
            // Binary operator: () && ()
            // Binary operator: [...] == 0
            { // Invoke: llength $non_default_args
                TclObject tmp22 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                int tmp23 = TclList.getLength(interp, tmp22);
                interp.setResult(tmp23);
            } // End Invoke: llength
            TclObject tmp24 = interp.getResult();
            ExprValue tmp25 = evs0;
            TJC.exprInitValue(interp, tmp25, tmp24);
            ExprValue tmp26 = evs1;
            tmp26.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp25, tmp26);
            // End Binary operator: ==
            if (tmp25.getBooleanValue(interp)) {
            // Binary operator: [...] == 0
            { // Invoke: llength $default_args
                TclObject tmp27 = getVarScalar(interp, "default_args", compiledLocals, 7);
                int tmp28 = TclList.getLength(interp, tmp27);
                interp.setResult(tmp28);
            } // End Invoke: llength
            TclObject tmp29 = interp.getResult();
            ExprValue tmp30 = evs1;
            TJC.exprInitValue(interp, tmp30, tmp29);
            ExprValue tmp31 = evs2;
            tmp31.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp30, tmp31);
            // End Binary operator: ==
            tmp25.setIntValue(tmp30.getBooleanValue(interp));
            } else {
            tmp25.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (tmp25.getBooleanValue(interp)) {
            // Unary operator: ! $has_args
            TclObject tmp32 = getVarScalar(interp, "has_args", compiledLocals, 8);
            ExprValue tmp33 = evs1;
            if ( tmp32.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp33, tmp32);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp33, tmp32);
            }
            // End Unary operator: !
            tmp25.setIntValue(tmp33.getBooleanValue(interp));
            } else {
            tmp25.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp34 = ( tmp25.getIntValue() != 0 );
            if ( tmp34 ) {
                { // Invoke: error "no arguments found"
                    TclObject[] objv35 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv35[0] = const3;
                        // Arg 1 constant: "no arguments found"
                        objv35[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv35, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv35, 2);
                    }
                } // End Invoke: error
            } else {
                // Binary operator: () && ()
                // Unary operator: ! $has_args
                TclObject tmp36 = getVarScalar(interp, "has_args", compiledLocals, 8);
                ExprValue tmp37 = evs0;
                if ( tmp36.isIntType() ) {
                    TJC.exprUnaryNotOperatorKnownInt(tmp37, tmp36);
                } else {
                    TJC.exprUnaryNotOperator(interp, tmp37, tmp36);
                }
                // End Unary operator: !
                if (tmp37.getBooleanValue(interp)) {
                // Binary operator: [...] == 0
                { // Invoke: llength $default_args
                    TclObject tmp38 = getVarScalar(interp, "default_args", compiledLocals, 7);
                    int tmp39 = TclList.getLength(interp, tmp38);
                    interp.setResult(tmp39);
                } // End Invoke: llength
                TclObject tmp40 = interp.getResult();
                ExprValue tmp41 = evs1;
                TJC.exprInitValue(interp, tmp41, tmp40);
                ExprValue tmp42 = evs2;
                tmp42.setIntValue(0);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp41, tmp42);
                // End Binary operator: ==
                tmp37.setIntValue(tmp41.getBooleanValue(interp));
                } else {
                tmp37.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                boolean tmp43 = ( tmp37.getIntValue() != 0 );
                if ( tmp43 ) {
                    { // Invoke: if ... ...
                        // Binary operator: $min_num_args != $max_num_args
                        TclObject tmp44 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                        ExprValue tmp45 = evs0;
                        TJC.exprInitValue(interp, tmp45, tmp44);
                        TclObject tmp46 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                        ExprValue tmp47 = evs1;
                        TJC.exprInitValue(interp, tmp47, tmp46);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp45, tmp47);
                        // End Binary operator: !=
                        boolean tmp48 = ( tmp45.getIntValue() != 0 );
                        if ( tmp48 ) {
                            { // Invoke: error "..."
                                TclObject[] objv49 = TJC.grabObjv(interp, 2);
                                TclObject tmp50;
                                try {
                                    // Arg 0 constant: error
                                    objv49[0] = const3;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp51 = new StringBuffer(64);
                                    sbtmp51.append("expected min to match max num args: ");
                                    tmp50 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                                    sbtmp51.append(tmp50.toString());
                                    sbtmp51.append(" ");
                                    tmp50 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                    sbtmp51.append(tmp50.toString());
                                    tmp50 = TclString.newInstance(sbtmp51);
                                    tmp50.preserve();
                                    objv49[1] = tmp50;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv49, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp50 = objv49[1];
                                    if ( tmp50 != null ) {
                                        tmp50.release();
                                    }
                                    TJC.releaseObjv(interp, objv49, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set args_str [...]
                        TclObject tmp52;
                        { // Invoke: join $non_default_args " "
                            TclObject[] objv53 = TJC.grabObjv(interp, 3);
                            TclObject tmp54;
                            try {
                                // Arg 0 constant: join
                                objv53[0] = const5;
                                // Arg 1 variable: $non_default_args
                                tmp54 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                tmp54.preserve();
                                objv53[1] = tmp54;
                                // Arg 2 constant: " "
                                objv53[2] = const6;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv53, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp54 = objv53[1];
                                if ( tmp54 != null ) {
                                    tmp54.release();
                                }
                                TJC.releaseObjv(interp, objv53, 3);
                            }
                        } // End Invoke: join
                        tmp52 = interp.getResult();
                        setVarScalar(interp, "args_str", tmp52, compiledLocals, 11);
                    } // End Invoke: set
                    { // Invoke: append buffer [...]
                        TclObject[] objv55 = TJC.grabObjv(interp, 1);
                        TclObject tmp56;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_num_args $max_num_args $args_str
                                TclObject[] objv57 = TJC.grabObjv(interp, 3);
                                TclObject tmp58;
                                try {
                                    // Arg 0 constant: emitter_num_args
                                    objv57[0] = const7;
                                    // Arg 1 variable: $max_num_args
                                    tmp58 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                    tmp58.preserve();
                                    objv57[1] = tmp58;
                                    // Arg 2 variable: $args_str
                                    tmp58 = getVarScalar(interp, "args_str", compiledLocals, 11);
                                    tmp58.preserve();
                                    objv57[2] = tmp58;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv57, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp58 = objv57[1];
                                    if ( tmp58 != null ) {
                                        tmp58.release();
                                    }
                                    tmp58 = objv57[2];
                                    if ( tmp58 != null ) {
                                        tmp58.release();
                                    }
                                    TJC.releaseObjv(interp, objv57, 3);
                                }
                            } // End Invoke: emitter_num_args
                            tmp56 = interp.getResult();
                            tmp56.preserve();
                            objv55[0] = tmp56;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv55, compiledLocals, 4);
                        } finally {
                            TJC.releaseObjvElems(interp, objv55, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: set index 1
                        setVarScalar(interp, "index", const8, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: foreach arg $non_default_args ...
                        TclObject tmp59 = null;
                        try {
                            tmp59 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                            tmp59.preserve();
                            final int tmp59_length = TclList.getLength(interp, tmp59);

                            for ( int index60 = 0 ; index60 < tmp59_length ; index60++ ) {
                                TclObject tmp61 = TclList.index(interp, tmp59, index60);
                                try {
                                    setVarScalar(interp, "arg", tmp61, compiledLocals, 13);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "arg");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: append buffer [...]
                                    TclObject[] objv62 = TJC.grabObjv(interp, 1);
                                    TclObject tmp63;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $arg $index
                                            TclObject[] objv64 = TJC.grabObjv(interp, 3);
                                            TclObject tmp65;
                                            try {
                                                // Arg 0 constant: ...
                                                objv64[0] = const9;
                                                // Arg 1 variable: $arg
                                                tmp65 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                tmp65.preserve();
                                                objv64[1] = tmp65;
                                                // Arg 2 variable: $index
                                                tmp65 = getVarScalar(interp, "index", compiledLocals, 12);
                                                tmp65.preserve();
                                                objv64[2] = tmp65;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                    ? cmdcache6.cmd : null), objv64, 0);
                                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                    updateCmdCache(interp, 6);
                                                }
                                            } finally {
                                                tmp65 = objv64[1];
                                                if ( tmp65 != null ) {
                                                    tmp65.release();
                                                }
                                                tmp65 = objv64[2];
                                                if ( tmp65 != null ) {
                                                    tmp65.release();
                                                }
                                                TJC.releaseObjv(interp, objv64, 3);
                                            }
                                        } // End Invoke: ...
                                        tmp63 = interp.getResult();
                                        tmp63.preserve();
                                        objv62[0] = tmp63;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv62, compiledLocals, 4);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv62, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: incr index
                                    interp.resetResult();
                                    incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                } // End Invoke: incr
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp59 != null ) {
                                tmp59.release();
                            }
                        }
                    } // End Invoke: foreach
                } else {
                    // Binary operator: () && ()
                    // Unary operator: ! $has_args
                    TclObject tmp66 = getVarScalar(interp, "has_args", compiledLocals, 8);
                    ExprValue tmp67 = evs0;
                    if ( tmp66.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp67, tmp66);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp67, tmp66);
                    }
                    // End Unary operator: !
                    if (tmp67.getBooleanValue(interp)) {
                    // Binary operator: [...] == 0
                    { // Invoke: llength $non_default_args
                        TclObject tmp68 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                        int tmp69 = TclList.getLength(interp, tmp68);
                        interp.setResult(tmp69);
                    } // End Invoke: llength
                    TclObject tmp70 = interp.getResult();
                    ExprValue tmp71 = evs1;
                    TJC.exprInitValue(interp, tmp71, tmp70);
                    ExprValue tmp72 = evs2;
                    tmp72.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp71, tmp72);
                    // End Binary operator: ==
                    tmp67.setIntValue(tmp71.getBooleanValue(interp));
                    } else {
                    tmp67.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp73 = ( tmp67.getIntValue() != 0 );
                    if ( tmp73 ) {
                        { // Invoke: if {$min_num_args != 0} ...
                            // Binary operator: $min_num_args != 0
                            TclObject tmp74 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                            ExprValue tmp75 = evs0;
                            TJC.exprInitValue(interp, tmp75, tmp74);
                            ExprValue tmp76 = evs1;
                            tmp76.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp75, tmp76);
                            // End Binary operator: !=
                            boolean tmp77 = ( tmp75.getIntValue() != 0 );
                            if ( tmp77 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv78 = TJC.grabObjv(interp, 2);
                                    TclObject tmp79;
                                    try {
                                        // Arg 0 constant: error
                                        objv78[0] = const3;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp80 = new StringBuffer(64);
                                        sbtmp80.append("expected min num arguments to be zero, got ");
                                        tmp79 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                                        sbtmp80.append(tmp79.toString());
                                        tmp79 = TclString.newInstance(sbtmp80);
                                        tmp79.preserve();
                                        objv78[1] = tmp79;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv78, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp79 = objv78[1];
                                        if ( tmp79 != null ) {
                                            tmp79.release();
                                        }
                                        TJC.releaseObjv(interp, objv78, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set arg_names [...]
                            TclObject tmp81;
                            { // Invoke: list
                                TclObject tmp82 = TclList.newInstance();
                                interp.setResult(tmp82);
                            } // End Invoke: list
                            tmp81 = interp.getResult();
                            setVarScalar(interp, "arg_names", tmp81, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: foreach arg $default_args ...
                            TclObject tmp83 = null;
                            try {
                                tmp83 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                tmp83.preserve();
                                final int tmp83_length = TclList.getLength(interp, tmp83);

                                for ( int index84 = 0 ; index84 < tmp83_length ; index84++ ) {
                                    TclObject tmp85 = TclList.index(interp, tmp83, index84);
                                    try {
                                        setVarScalar(interp, "arg", tmp85, compiledLocals, 13);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "arg");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: set name [...]
                                        TclObject tmp86;
                                        { // Invoke: lindex $arg 0
                                            TclObject tmp87 = getVarScalar(interp, "arg", compiledLocals, 13);
                                            tmp87 = TclList.index(interp, tmp87, 0);
                                            if ( tmp87 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp87);
                                            }
                                        } // End Invoke: lindex
                                        tmp86 = interp.getResult();
                                        setVarScalar(interp, "name", tmp86, compiledLocals, 15);
                                    } // End Invoke: set
                                    { // Invoke: set default [...]
                                        TclObject tmp88;
                                        { // Invoke: lindex $arg 1
                                            TclObject tmp89 = getVarScalar(interp, "arg", compiledLocals, 13);
                                            tmp89 = TclList.index(interp, tmp89, 1);
                                            if ( tmp89 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp89);
                                            }
                                        } // End Invoke: lindex
                                        tmp88 = interp.getResult();
                                        setVarScalar(interp, "default", tmp88, compiledLocals, 16);
                                    } // End Invoke: set
                                    { // Invoke: lappend arg_names "?${name}?"
                                        TclObject[] objv90 = TJC.grabObjv(interp, 1);
                                        TclObject tmp91;
                                        try {
                                            // Arg 2 word: "?${name}?"
                                            StringBuffer sbtmp92 = new StringBuffer(64);
                                            sbtmp92.append("?");
                                            tmp91 = getVarScalar(interp, "name", compiledLocals, 15);
                                            sbtmp92.append(tmp91.toString());
                                            sbtmp92.append("?");
                                            tmp91 = TclString.newInstance(sbtmp92);
                                            tmp91.preserve();
                                            objv90[0] = tmp91;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "arg_names", objv90, compiledLocals, 14);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv90, 1);
                                        }
                                    } // End Invoke: lappend
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp83 != null ) {
                                    tmp83.release();
                                }
                            }
                        } // End Invoke: foreach
                        { // Invoke: set args_str [...]
                            TclObject tmp93;
                            { // Invoke: join $arg_names " "
                                TclObject[] objv94 = TJC.grabObjv(interp, 3);
                                TclObject tmp95;
                                try {
                                    // Arg 0 constant: join
                                    objv94[0] = const5;
                                    // Arg 1 variable: $arg_names
                                    tmp95 = getVarScalar(interp, "arg_names", compiledLocals, 14);
                                    tmp95.preserve();
                                    objv94[1] = tmp95;
                                    // Arg 2 constant: " "
                                    objv94[2] = const6;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv94, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp95 = objv94[1];
                                    if ( tmp95 != null ) {
                                        tmp95.release();
                                    }
                                    TJC.releaseObjv(interp, objv94, 3);
                                }
                            } // End Invoke: join
                            tmp93 = interp.getResult();
                            setVarScalar(interp, "args_str", tmp93, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv96 = TJC.grabObjv(interp, 1);
                            TclObject tmp97;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $max_num_args $args_str
                                    TclObject[] objv98 = TJC.grabObjv(interp, 3);
                                    TclObject tmp99;
                                    try {
                                        // Arg 0 constant: ...
                                        objv98[0] = const10;
                                        // Arg 1 variable: $max_num_args
                                        tmp99 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                        tmp99.preserve();
                                        objv98[1] = tmp99;
                                        // Arg 2 variable: $args_str
                                        tmp99 = getVarScalar(interp, "args_str", compiledLocals, 11);
                                        tmp99.preserve();
                                        objv98[2] = tmp99;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv98, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        tmp99 = objv98[1];
                                        if ( tmp99 != null ) {
                                            tmp99.release();
                                        }
                                        tmp99 = objv98[2];
                                        if ( tmp99 != null ) {
                                            tmp99.release();
                                        }
                                        TJC.releaseObjv(interp, objv98, 3);
                                    }
                                } // End Invoke: ...
                                tmp97 = interp.getResult();
                                tmp97.preserve();
                                objv96[0] = tmp97;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv96, compiledLocals, 4);
                            } finally {
                                TJC.releaseObjvElems(interp, objv96, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set index 1
                            setVarScalar(interp, "index", const8, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: foreach arg $default_args ...
                            TclObject tmp100 = null;
                            try {
                                tmp100 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                tmp100.preserve();
                                final int tmp100_length = TclList.getLength(interp, tmp100);

                                for ( int index101 = 0 ; index101 < tmp100_length ; index101++ ) {
                                    TclObject tmp102 = TclList.index(interp, tmp100, index101);
                                    try {
                                        setVarScalar(interp, "arg", tmp102, compiledLocals, 13);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "arg");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: set name [...]
                                        TclObject tmp103;
                                        { // Invoke: lindex $arg 0
                                            TclObject tmp104 = getVarScalar(interp, "arg", compiledLocals, 13);
                                            tmp104 = TclList.index(interp, tmp104, 0);
                                            if ( tmp104 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp104);
                                            }
                                        } // End Invoke: lindex
                                        tmp103 = interp.getResult();
                                        setVarScalar(interp, "name", tmp103, compiledLocals, 15);
                                    } // End Invoke: set
                                    { // Invoke: set default [...]
                                        TclObject tmp105;
                                        { // Invoke: lindex $arg 1
                                            TclObject tmp106 = getVarScalar(interp, "arg", compiledLocals, 13);
                                            tmp106 = TclList.index(interp, tmp106, 1);
                                            if ( tmp106 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp106);
                                            }
                                        } // End Invoke: lindex
                                        tmp105 = interp.getResult();
                                        setVarScalar(interp, "default", tmp105, compiledLocals, 16);
                                    } // End Invoke: set
                                    { // Invoke: ... $default
                                        TclObject[] objv107 = TJC.grabObjv(interp, 2);
                                        TclObject tmp108;
                                        try {
                                            // Arg 0 constant: ...
                                            objv107[0] = const11;
                                            // Arg 1 variable: $default
                                            tmp108 = getVarScalar(interp, "default", compiledLocals, 16);
                                            tmp108.preserve();
                                            objv107[1] = tmp108;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                ? cmdcache8.cmd : null), objv107, 0);
                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                updateCmdCache(interp, 8);
                                            }
                                        } finally {
                                            tmp108 = objv107[1];
                                            if ( tmp108 != null ) {
                                                tmp108.release();
                                            }
                                            TJC.releaseObjv(interp, objv107, 2);
                                        }
                                    } // End Invoke: ...
                                    { // Invoke: set constants_found 1
                                        setVarScalar(interp, "constants_found", const8, compiledLocals, 3);
                                    } // End Invoke: set
                                    { // Invoke: set default_sym [...]
                                        TclObject tmp109;
                                        { // Invoke: ... $default
                                            TclObject[] objv110 = TJC.grabObjv(interp, 2);
                                            TclObject tmp111;
                                            try {
                                                // Arg 0 constant: ...
                                                objv110[0] = const12;
                                                // Arg 1 variable: $default
                                                tmp111 = getVarScalar(interp, "default", compiledLocals, 16);
                                                tmp111.preserve();
                                                objv110[1] = tmp111;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                    ? cmdcache9.cmd : null), objv110, 0);
                                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                    updateCmdCache(interp, 9);
                                                }
                                            } finally {
                                                tmp111 = objv110[1];
                                                if ( tmp111 != null ) {
                                                    tmp111.release();
                                                }
                                                TJC.releaseObjv(interp, objv110, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp109 = interp.getResult();
                                        setVarScalar(interp, "default_sym", tmp109, compiledLocals, 17);
                                    } // End Invoke: set
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv112 = TJC.grabObjv(interp, 1);
                                        TclObject tmp113;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... $name $index $default_sym
                                                TclObject[] objv114 = TJC.grabObjv(interp, 4);
                                                TclObject tmp115;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv114[0] = const13;
                                                    // Arg 1 variable: $name
                                                    tmp115 = getVarScalar(interp, "name", compiledLocals, 15);
                                                    tmp115.preserve();
                                                    objv114[1] = tmp115;
                                                    // Arg 2 variable: $index
                                                    tmp115 = getVarScalar(interp, "index", compiledLocals, 12);
                                                    tmp115.preserve();
                                                    objv114[2] = tmp115;
                                                    // Arg 3 variable: $default_sym
                                                    tmp115 = getVarScalar(interp, "default_sym", compiledLocals, 17);
                                                    tmp115.preserve();
                                                    objv114[3] = tmp115;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                        ? cmdcache10.cmd : null), objv114, 0);
                                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                        updateCmdCache(interp, 10);
                                                    }
                                                } finally {
                                                    tmp115 = objv114[1];
                                                    if ( tmp115 != null ) {
                                                        tmp115.release();
                                                    }
                                                    tmp115 = objv114[2];
                                                    if ( tmp115 != null ) {
                                                        tmp115.release();
                                                    }
                                                    tmp115 = objv114[3];
                                                    if ( tmp115 != null ) {
                                                        tmp115.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv114, 4);
                                                }
                                            } // End Invoke: ...
                                            tmp113 = interp.getResult();
                                            tmp113.preserve();
                                            objv112[0] = tmp113;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv112, compiledLocals, 4);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv112, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: incr index
                                        interp.resetResult();
                                        incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp100 != null ) {
                                    tmp100.release();
                                }
                            }
                        } // End Invoke: foreach
                    } else {
                        // Binary operator: () && ()
                        // Binary operator: $has_args && ()
                        TclObject tmp116 = getVarScalar(interp, "has_args", compiledLocals, 8);
                        ExprValue tmp117 = evs0;
                        TJC.exprInitValue(interp, tmp117, tmp116);
                        if (tmp117.getBooleanValue(interp)) {
                        // Binary operator: [...] == 0
                        { // Invoke: llength $non_default_args
                            TclObject tmp118 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                            int tmp119 = TclList.getLength(interp, tmp118);
                            interp.setResult(tmp119);
                        } // End Invoke: llength
                        TclObject tmp120 = interp.getResult();
                        ExprValue tmp121 = evs1;
                        TJC.exprInitValue(interp, tmp121, tmp120);
                        ExprValue tmp122 = evs2;
                        tmp122.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp121, tmp122);
                        // End Binary operator: ==
                        tmp117.setIntValue(tmp121.getBooleanValue(interp));
                        } else {
                        tmp117.setIntValue(0);
                        } // End if: $has_args
                        // End Binary operator: &&
                        if (tmp117.getBooleanValue(interp)) {
                        // Binary operator: [...] == 0
                        { // Invoke: llength $default_args
                            TclObject tmp123 = getVarScalar(interp, "default_args", compiledLocals, 7);
                            int tmp124 = TclList.getLength(interp, tmp123);
                            interp.setResult(tmp124);
                        } // End Invoke: llength
                        TclObject tmp125 = interp.getResult();
                        ExprValue tmp126 = evs1;
                        TJC.exprInitValue(interp, tmp126, tmp125);
                        ExprValue tmp127 = evs2;
                        tmp127.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp126, tmp127);
                        // End Binary operator: ==
                        tmp117.setIntValue(tmp126.getBooleanValue(interp));
                        } else {
                        tmp117.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp128 = ( tmp117.getIntValue() != 0 );
                        if ( tmp128 ) {
                            { // Invoke: append buffer [...]
                                TclObject[] objv129 = TJC.grabObjv(interp, 1);
                                TclObject tmp130;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... 1
                                        TclObject[] objv131 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: ...
                                            objv131[0] = const14;
                                            // Arg 1 constant: 1
                                            objv131[1] = const8;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv131, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv131, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp130 = interp.getResult();
                                    tmp130.preserve();
                                    objv129[0] = tmp130;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv129, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv129, 1);
                                }
                            } // End Invoke: append
                        } else {
                            // Binary operator: () && ()
                            // Binary operator: $has_args && ()
                            TclObject tmp132 = getVarScalar(interp, "has_args", compiledLocals, 8);
                            ExprValue tmp133 = evs0;
                            TJC.exprInitValue(interp, tmp133, tmp132);
                            if (tmp133.getBooleanValue(interp)) {
                            // Binary operator: [...] > 0
                            { // Invoke: llength $non_default_args
                                TclObject tmp134 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                int tmp135 = TclList.getLength(interp, tmp134);
                                interp.setResult(tmp135);
                            } // End Invoke: llength
                            TclObject tmp136 = interp.getResult();
                            ExprValue tmp137 = evs1;
                            TJC.exprInitValue(interp, tmp137, tmp136);
                            ExprValue tmp138 = evs2;
                            tmp138.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp137, tmp138);
                            // End Binary operator: >
                            tmp133.setIntValue(tmp137.getBooleanValue(interp));
                            } else {
                            tmp133.setIntValue(0);
                            } // End if: $has_args
                            // End Binary operator: &&
                            if (tmp133.getBooleanValue(interp)) {
                            // Binary operator: [...] == 0
                            { // Invoke: llength $default_args
                                TclObject tmp139 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                int tmp140 = TclList.getLength(interp, tmp139);
                                interp.setResult(tmp140);
                            } // End Invoke: llength
                            TclObject tmp141 = interp.getResult();
                            ExprValue tmp142 = evs1;
                            TJC.exprInitValue(interp, tmp142, tmp141);
                            ExprValue tmp143 = evs2;
                            tmp143.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp142, tmp143);
                            // End Binary operator: ==
                            tmp133.setIntValue(tmp142.getBooleanValue(interp));
                            } else {
                            tmp133.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp144 = ( tmp133.getIntValue() != 0 );
                            if ( tmp144 ) {
                                { // Invoke: if ... ...
                                    // Binary operator: $max_num_args != ""
                                    TclObject tmp145 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                    ExprValue tmp146 = evs0;
                                    TJC.exprEqualsEmptyString(tmp146, tmp145, true);
                                    // End Binary operator: !=
                                    boolean tmp147 = ( tmp146.getIntValue() != 0 );
                                    if ( tmp147 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv148 = TJC.grabObjv(interp, 2);
                                            TclObject tmp149;
                                            try {
                                                // Arg 0 constant: error
                                                objv148[0] = const3;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp150 = new StringBuffer(64);
                                                sbtmp150.append("expected empty max num args, got ");
                                                tmp149 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                                sbtmp150.append(tmp149.toString());
                                                tmp149 = TclString.newInstance(sbtmp150);
                                                tmp149.preserve();
                                                objv148[1] = tmp149;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv148, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp149 = objv148[1];
                                                if ( tmp149 != null ) {
                                                    tmp149.release();
                                                }
                                                TJC.releaseObjv(interp, objv148, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set all_args $non_default_args
                                    TclObject tmp151;
                                    tmp151 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                    setVarScalar(interp, "all_args", tmp151, compiledLocals, 18);
                                } // End Invoke: set
                                { // Invoke: lappend all_args args
                                    TclObject[] objv152 = TJC.grabObjv(interp, 1);
                                    TclObject tmp153;
                                    try {
                                        // Arg 2 constant: args
                                        objv152[0] = const15;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "all_args", objv152, compiledLocals, 18);
                                    } finally {
                                        TJC.releaseObjv(interp, objv152, 1);
                                    }
                                } // End Invoke: lappend
                                { // Invoke: set args_str [...]
                                    TclObject tmp154;
                                    { // Invoke: join $all_args " "
                                        TclObject[] objv155 = TJC.grabObjv(interp, 3);
                                        TclObject tmp156;
                                        try {
                                            // Arg 0 constant: join
                                            objv155[0] = const5;
                                            // Arg 1 variable: $all_args
                                            tmp156 = getVarScalar(interp, "all_args", compiledLocals, 18);
                                            tmp156.preserve();
                                            objv155[1] = tmp156;
                                            // Arg 2 constant: " "
                                            objv155[2] = const6;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv155, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp156 = objv155[1];
                                            if ( tmp156 != null ) {
                                                tmp156.release();
                                            }
                                            TJC.releaseObjv(interp, objv155, 3);
                                        }
                                    } // End Invoke: join
                                    tmp154 = interp.getResult();
                                    setVarScalar(interp, "args_str", tmp154, compiledLocals, 11);
                                } // End Invoke: set
                                { // Invoke: append buffer [...]
                                    TclObject[] objv157 = TJC.grabObjv(interp, 1);
                                    TclObject tmp158;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_num_min_args $min_num_args $args_str
                                            TclObject[] objv159 = TJC.grabObjv(interp, 3);
                                            TclObject tmp160;
                                            try {
                                                // Arg 0 constant: emitter_num_min_args
                                                objv159[0] = const16;
                                                // Arg 1 variable: $min_num_args
                                                tmp160 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                                                tmp160.preserve();
                                                objv159[1] = tmp160;
                                                // Arg 2 variable: $args_str
                                                tmp160 = getVarScalar(interp, "args_str", compiledLocals, 11);
                                                tmp160.preserve();
                                                objv159[2] = tmp160;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                    ? cmdcache12.cmd : null), objv159, 0);
                                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                    updateCmdCache(interp, 12);
                                                }
                                            } finally {
                                                tmp160 = objv159[1];
                                                if ( tmp160 != null ) {
                                                    tmp160.release();
                                                }
                                                tmp160 = objv159[2];
                                                if ( tmp160 != null ) {
                                                    tmp160.release();
                                                }
                                                TJC.releaseObjv(interp, objv159, 3);
                                            }
                                        } // End Invoke: emitter_num_min_args
                                        tmp158 = interp.getResult();
                                        tmp158.preserve();
                                        objv157[0] = tmp158;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv157, compiledLocals, 4);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv157, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: set index 1
                                    setVarScalar(interp, "index", const8, compiledLocals, 12);
                                } // End Invoke: set
                                { // Invoke: foreach arg $non_default_args ...
                                    TclObject tmp161 = null;
                                    try {
                                        tmp161 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                        tmp161.preserve();
                                        final int tmp161_length = TclList.getLength(interp, tmp161);

                                        for ( int index162 = 0 ; index162 < tmp161_length ; index162++ ) {
                                            TclObject tmp163 = TclList.index(interp, tmp161, index162);
                                            try {
                                                setVarScalar(interp, "arg", tmp163, compiledLocals, 13);
                                            } catch (TclException ex) {
                                                TJC.foreachVarErr(interp, "arg");
                                            }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: append buffer [...]
                                                TclObject[] objv164 = TJC.grabObjv(interp, 1);
                                                TclObject tmp165;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: ... $arg $index
                                                        TclObject[] objv166 = TJC.grabObjv(interp, 3);
                                                        TclObject tmp167;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv166[0] = const9;
                                                            // Arg 1 variable: $arg
                                                            tmp167 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                            tmp167.preserve();
                                                            objv166[1] = tmp167;
                                                            // Arg 2 variable: $index
                                                            tmp167 = getVarScalar(interp, "index", compiledLocals, 12);
                                                            tmp167.preserve();
                                                            objv166[2] = tmp167;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                                ? cmdcache6.cmd : null), objv166, 0);
                                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                                updateCmdCache(interp, 6);
                                                            }
                                                        } finally {
                                                            tmp167 = objv166[1];
                                                            if ( tmp167 != null ) {
                                                                tmp167.release();
                                                            }
                                                            tmp167 = objv166[2];
                                                            if ( tmp167 != null ) {
                                                                tmp167.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv166, 3);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp165 = interp.getResult();
                                                    tmp165.preserve();
                                                    objv164[0] = tmp165;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv164, compiledLocals, 4);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv164, 1);
                                                }
                                            } // End Invoke: append
                                            { // Invoke: incr index
                                                interp.resetResult();
                                                incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                            } // End Invoke: incr
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } finally {
                                        if ( tmp161 != null ) {
                                            tmp161.release();
                                        }
                                    }
                                } // End Invoke: foreach
                                { // Invoke: append buffer [...]
                                    TclObject[] objv168 = TJC.grabObjv(interp, 1);
                                    TclObject tmp169;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $index
                                            TclObject[] objv170 = TJC.grabObjv(interp, 2);
                                            TclObject tmp171;
                                            try {
                                                // Arg 0 constant: ...
                                                objv170[0] = const14;
                                                // Arg 1 variable: $index
                                                tmp171 = getVarScalar(interp, "index", compiledLocals, 12);
                                                tmp171.preserve();
                                                objv170[1] = tmp171;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                    ? cmdcache11.cmd : null), objv170, 0);
                                                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                    updateCmdCache(interp, 11);
                                                }
                                            } finally {
                                                tmp171 = objv170[1];
                                                if ( tmp171 != null ) {
                                                    tmp171.release();
                                                }
                                                TJC.releaseObjv(interp, objv170, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp169 = interp.getResult();
                                        tmp169.preserve();
                                        objv168[0] = tmp169;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv168, compiledLocals, 4);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv168, 1);
                                    }
                                } // End Invoke: append
                            } else {
                                // Binary operator: () && ()
                                // Binary operator: $has_args && ()
                                TclObject tmp172 = getVarScalar(interp, "has_args", compiledLocals, 8);
                                ExprValue tmp173 = evs0;
                                TJC.exprInitValue(interp, tmp173, tmp172);
                                if (tmp173.getBooleanValue(interp)) {
                                // Binary operator: [...] == 0
                                { // Invoke: llength $non_default_args
                                    TclObject tmp174 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                    int tmp175 = TclList.getLength(interp, tmp174);
                                    interp.setResult(tmp175);
                                } // End Invoke: llength
                                TclObject tmp176 = interp.getResult();
                                ExprValue tmp177 = evs1;
                                TJC.exprInitValue(interp, tmp177, tmp176);
                                ExprValue tmp178 = evs2;
                                tmp178.setIntValue(0);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp177, tmp178);
                                // End Binary operator: ==
                                tmp173.setIntValue(tmp177.getBooleanValue(interp));
                                } else {
                                tmp173.setIntValue(0);
                                } // End if: $has_args
                                // End Binary operator: &&
                                if (tmp173.getBooleanValue(interp)) {
                                // Binary operator: [...] > 0
                                { // Invoke: llength $default_args
                                    TclObject tmp179 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                    int tmp180 = TclList.getLength(interp, tmp179);
                                    interp.setResult(tmp180);
                                } // End Invoke: llength
                                TclObject tmp181 = interp.getResult();
                                ExprValue tmp182 = evs1;
                                TJC.exprInitValue(interp, tmp182, tmp181);
                                ExprValue tmp183 = evs2;
                                tmp183.setIntValue(0);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp182, tmp183);
                                // End Binary operator: >
                                tmp173.setIntValue(tmp182.getBooleanValue(interp));
                                } else {
                                tmp173.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                boolean tmp184 = ( tmp173.getIntValue() != 0 );
                                if ( tmp184 ) {
                                    { // Invoke: if ... ...
                                        // Binary operator: $max_num_args != ""
                                        TclObject tmp185 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                        ExprValue tmp186 = evs0;
                                        TJC.exprEqualsEmptyString(tmp186, tmp185, true);
                                        // End Binary operator: !=
                                        boolean tmp187 = ( tmp186.getIntValue() != 0 );
                                        if ( tmp187 ) {
                                            { // Invoke: error "..."
                                                TclObject[] objv188 = TJC.grabObjv(interp, 2);
                                                TclObject tmp189;
                                                try {
                                                    // Arg 0 constant: error
                                                    objv188[0] = const3;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp190 = new StringBuffer(64);
                                                    sbtmp190.append("expected empty max num args, got ");
                                                    tmp189 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                                    sbtmp190.append(tmp189.toString());
                                                    tmp189 = TclString.newInstance(sbtmp190);
                                                    tmp189.preserve();
                                                    objv188[1] = tmp189;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                        ? cmdcache3.cmd : null), objv188, 0);
                                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                        updateCmdCache(interp, 3);
                                                    }
                                                } finally {
                                                    tmp189 = objv188[1];
                                                    if ( tmp189 != null ) {
                                                        tmp189.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv188, 2);
                                                }
                                            } // End Invoke: error
                                        }
                                    } // End Invoke: if
                                    { // Invoke: if {$min_num_args != 0} ...
                                        // Binary operator: $min_num_args != 0
                                        TclObject tmp191 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                                        ExprValue tmp192 = evs0;
                                        TJC.exprInitValue(interp, tmp192, tmp191);
                                        ExprValue tmp193 = evs1;
                                        tmp193.setIntValue(0);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp192, tmp193);
                                        // End Binary operator: !=
                                        boolean tmp194 = ( tmp192.getIntValue() != 0 );
                                        if ( tmp194 ) {
                                            { // Invoke: error "..."
                                                TclObject[] objv195 = TJC.grabObjv(interp, 2);
                                                TclObject tmp196;
                                                try {
                                                    // Arg 0 constant: error
                                                    objv195[0] = const3;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp197 = new StringBuffer(64);
                                                    sbtmp197.append("expected zero min num args, got ");
                                                    tmp196 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                                                    sbtmp197.append(tmp196.toString());
                                                    tmp196 = TclString.newInstance(sbtmp197);
                                                    tmp196.preserve();
                                                    objv195[1] = tmp196;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                        ? cmdcache3.cmd : null), objv195, 0);
                                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                        updateCmdCache(interp, 3);
                                                    }
                                                } finally {
                                                    tmp196 = objv195[1];
                                                    if ( tmp196 != null ) {
                                                        tmp196.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv195, 2);
                                                }
                                            } // End Invoke: error
                                        }
                                    } // End Invoke: if
                                    { // Invoke: set arg_names [...]
                                        TclObject tmp198;
                                        { // Invoke: list
                                            TclObject tmp199 = TclList.newInstance();
                                            interp.setResult(tmp199);
                                        } // End Invoke: list
                                        tmp198 = interp.getResult();
                                        setVarScalar(interp, "arg_names", tmp198, compiledLocals, 14);
                                    } // End Invoke: set
                                    { // Invoke: foreach arg $default_args ...
                                        TclObject tmp200 = null;
                                        try {
                                            tmp200 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                            tmp200.preserve();
                                            final int tmp200_length = TclList.getLength(interp, tmp200);

                                            for ( int index201 = 0 ; index201 < tmp200_length ; index201++ ) {
                                                TclObject tmp202 = TclList.index(interp, tmp200, index201);
                                                try {
                                                    setVarScalar(interp, "arg", tmp202, compiledLocals, 13);
                                                } catch (TclException ex) {
                                                    TJC.foreachVarErr(interp, "arg");
                                                }

                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: set name [...]
                                                    TclObject tmp203;
                                                    { // Invoke: lindex $arg 0
                                                        TclObject tmp204 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                        tmp204 = TclList.index(interp, tmp204, 0);
                                                        if ( tmp204 == null ) {
                                                            interp.resetResult();
                                                        } else {
                                                            interp.setResult(tmp204);
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp203 = interp.getResult();
                                                    setVarScalar(interp, "name", tmp203, compiledLocals, 15);
                                                } // End Invoke: set
                                                { // Invoke: set default [...]
                                                    TclObject tmp205;
                                                    { // Invoke: lindex $arg 1
                                                        TclObject tmp206 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                        tmp206 = TclList.index(interp, tmp206, 1);
                                                        if ( tmp206 == null ) {
                                                            interp.resetResult();
                                                        } else {
                                                            interp.setResult(tmp206);
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp205 = interp.getResult();
                                                    setVarScalar(interp, "default", tmp205, compiledLocals, 16);
                                                } // End Invoke: set
                                                { // Invoke: lappend arg_names "?${name}?"
                                                    TclObject[] objv207 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp208;
                                                    try {
                                                        // Arg 2 word: "?${name}?"
                                                        StringBuffer sbtmp209 = new StringBuffer(64);
                                                        sbtmp209.append("?");
                                                        tmp208 = getVarScalar(interp, "name", compiledLocals, 15);
                                                        sbtmp209.append(tmp208.toString());
                                                        sbtmp209.append("?");
                                                        tmp208 = TclString.newInstance(sbtmp209);
                                                        tmp208.preserve();
                                                        objv207[0] = tmp208;
                                                        interp.resetResult();
                                                        lappendVarScalar(interp, "arg_names", objv207, compiledLocals, 14);
                                                    } finally {
                                                        TJC.releaseObjvElems(interp, objv207, 1);
                                                    }
                                                } // End Invoke: lappend
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else if (type == TCL.CONTINUE) {
                                                        continue;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }
                                        } finally {
                                            if ( tmp200 != null ) {
                                                tmp200.release();
                                            }
                                        }
                                    } // End Invoke: foreach
                                    { // Invoke: lappend arg_names "args"
                                        TclObject[] objv210 = TJC.grabObjv(interp, 1);
                                        TclObject tmp211;
                                        try {
                                            // Arg 2 constant: "args"
                                            objv210[0] = const15;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "arg_names", objv210, compiledLocals, 14);
                                        } finally {
                                            TJC.releaseObjv(interp, objv210, 1);
                                        }
                                    } // End Invoke: lappend
                                    { // Invoke: set args_str [...]
                                        TclObject tmp212;
                                        { // Invoke: join $arg_names " "
                                            TclObject[] objv213 = TJC.grabObjv(interp, 3);
                                            TclObject tmp214;
                                            try {
                                                // Arg 0 constant: join
                                                objv213[0] = const5;
                                                // Arg 1 variable: $arg_names
                                                tmp214 = getVarScalar(interp, "arg_names", compiledLocals, 14);
                                                tmp214.preserve();
                                                objv213[1] = tmp214;
                                                // Arg 2 constant: " "
                                                objv213[2] = const6;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv213, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp214 = objv213[1];
                                                if ( tmp214 != null ) {
                                                    tmp214.release();
                                                }
                                                TJC.releaseObjv(interp, objv213, 3);
                                            }
                                        } // End Invoke: join
                                        tmp212 = interp.getResult();
                                        setVarScalar(interp, "args_str", tmp212, compiledLocals, 11);
                                    } // End Invoke: set
                                    { // Invoke: set index 1
                                        setVarScalar(interp, "index", const8, compiledLocals, 12);
                                    } // End Invoke: set
                                    { // Invoke: foreach arg $default_args ...
                                        TclObject tmp215 = null;
                                        try {
                                            tmp215 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                            tmp215.preserve();
                                            final int tmp215_length = TclList.getLength(interp, tmp215);

                                            for ( int index216 = 0 ; index216 < tmp215_length ; index216++ ) {
                                                TclObject tmp217 = TclList.index(interp, tmp215, index216);
                                                try {
                                                    setVarScalar(interp, "arg", tmp217, compiledLocals, 13);
                                                } catch (TclException ex) {
                                                    TJC.foreachVarErr(interp, "arg");
                                                }

                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: set name [...]
                                                    TclObject tmp218;
                                                    { // Invoke: lindex $arg 0
                                                        TclObject tmp219 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                        tmp219 = TclList.index(interp, tmp219, 0);
                                                        if ( tmp219 == null ) {
                                                            interp.resetResult();
                                                        } else {
                                                            interp.setResult(tmp219);
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp218 = interp.getResult();
                                                    setVarScalar(interp, "name", tmp218, compiledLocals, 15);
                                                } // End Invoke: set
                                                { // Invoke: set default [...]
                                                    TclObject tmp220;
                                                    { // Invoke: lindex $arg 1
                                                        TclObject tmp221 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                        tmp221 = TclList.index(interp, tmp221, 1);
                                                        if ( tmp221 == null ) {
                                                            interp.resetResult();
                                                        } else {
                                                            interp.setResult(tmp221);
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp220 = interp.getResult();
                                                    setVarScalar(interp, "default", tmp220, compiledLocals, 16);
                                                } // End Invoke: set
                                                { // Invoke: ... $default
                                                    TclObject[] objv222 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp223;
                                                    try {
                                                        // Arg 0 constant: ...
                                                        objv222[0] = const11;
                                                        // Arg 1 variable: $default
                                                        tmp223 = getVarScalar(interp, "default", compiledLocals, 16);
                                                        tmp223.preserve();
                                                        objv222[1] = tmp223;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                            ? cmdcache8.cmd : null), objv222, 0);
                                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                            updateCmdCache(interp, 8);
                                                        }
                                                    } finally {
                                                        tmp223 = objv222[1];
                                                        if ( tmp223 != null ) {
                                                            tmp223.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv222, 2);
                                                    }
                                                } // End Invoke: ...
                                                { // Invoke: set constants_found 1
                                                    setVarScalar(interp, "constants_found", const8, compiledLocals, 3);
                                                } // End Invoke: set
                                                { // Invoke: set default_sym [...]
                                                    TclObject tmp224;
                                                    { // Invoke: ... $default
                                                        TclObject[] objv225 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp226;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv225[0] = const12;
                                                            // Arg 1 variable: $default
                                                            tmp226 = getVarScalar(interp, "default", compiledLocals, 16);
                                                            tmp226.preserve();
                                                            objv225[1] = tmp226;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                                ? cmdcache9.cmd : null), objv225, 0);
                                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                                updateCmdCache(interp, 9);
                                                            }
                                                        } finally {
                                                            tmp226 = objv225[1];
                                                            if ( tmp226 != null ) {
                                                                tmp226.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv225, 2);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp224 = interp.getResult();
                                                    setVarScalar(interp, "default_sym", tmp224, compiledLocals, 17);
                                                } // End Invoke: set
                                                { // Invoke: append buffer [...]
                                                    TclObject[] objv227 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp228;
                                                    try {
                                                        // Arg 2 command: [...]
                                                        { // Invoke: ... $name $index $default_sym
                                                            TclObject[] objv229 = TJC.grabObjv(interp, 4);
                                                            TclObject tmp230;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv229[0] = const13;
                                                                // Arg 1 variable: $name
                                                                tmp230 = getVarScalar(interp, "name", compiledLocals, 15);
                                                                tmp230.preserve();
                                                                objv229[1] = tmp230;
                                                                // Arg 2 variable: $index
                                                                tmp230 = getVarScalar(interp, "index", compiledLocals, 12);
                                                                tmp230.preserve();
                                                                objv229[2] = tmp230;
                                                                // Arg 3 variable: $default_sym
                                                                tmp230 = getVarScalar(interp, "default_sym", compiledLocals, 17);
                                                                tmp230.preserve();
                                                                objv229[3] = tmp230;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                                    ? cmdcache10.cmd : null), objv229, 0);
                                                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                                    updateCmdCache(interp, 10);
                                                                }
                                                            } finally {
                                                                tmp230 = objv229[1];
                                                                if ( tmp230 != null ) {
                                                                    tmp230.release();
                                                                }
                                                                tmp230 = objv229[2];
                                                                if ( tmp230 != null ) {
                                                                    tmp230.release();
                                                                }
                                                                tmp230 = objv229[3];
                                                                if ( tmp230 != null ) {
                                                                    tmp230.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv229, 4);
                                                            }
                                                        } // End Invoke: ...
                                                        tmp228 = interp.getResult();
                                                        tmp228.preserve();
                                                        objv227[0] = tmp228;
                                                        interp.resetResult();
                                                        appendVarScalar(interp, "buffer", objv227, compiledLocals, 4);
                                                    } finally {
                                                        TJC.releaseObjvElems(interp, objv227, 1);
                                                    }
                                                } // End Invoke: append
                                                { // Invoke: incr index
                                                    interp.resetResult();
                                                    incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                                } // End Invoke: incr
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else if (type == TCL.CONTINUE) {
                                                        continue;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }
                                        } finally {
                                            if ( tmp215 != null ) {
                                                tmp215.release();
                                            }
                                        }
                                    } // End Invoke: foreach
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv231 = TJC.grabObjv(interp, 1);
                                        TclObject tmp232;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... $index
                                                TclObject[] objv233 = TJC.grabObjv(interp, 2);
                                                TclObject tmp234;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv233[0] = const14;
                                                    // Arg 1 variable: $index
                                                    tmp234 = getVarScalar(interp, "index", compiledLocals, 12);
                                                    tmp234.preserve();
                                                    objv233[1] = tmp234;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                        ? cmdcache11.cmd : null), objv233, 0);
                                                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                        updateCmdCache(interp, 11);
                                                    }
                                                } finally {
                                                    tmp234 = objv233[1];
                                                    if ( tmp234 != null ) {
                                                        tmp234.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv233, 2);
                                                }
                                            } // End Invoke: ...
                                            tmp232 = interp.getResult();
                                            tmp232.preserve();
                                            objv231[0] = tmp232;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv231, compiledLocals, 4);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv231, 1);
                                        }
                                    } // End Invoke: append
                                } else {
                                    // Binary operator: () && ()
                                    // Binary operator: () && ()
                                    // Unary operator: ! $has_args
                                    TclObject tmp235 = getVarScalar(interp, "has_args", compiledLocals, 8);
                                    ExprValue tmp236 = evs0;
                                    if ( tmp235.isIntType() ) {
                                        TJC.exprUnaryNotOperatorKnownInt(tmp236, tmp235);
                                    } else {
                                        TJC.exprUnaryNotOperator(interp, tmp236, tmp235);
                                    }
                                    // End Unary operator: !
                                    if (tmp236.getBooleanValue(interp)) {
                                    // Binary operator: [...] > 0
                                    { // Invoke: llength $non_default_args
                                        TclObject tmp237 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                        int tmp238 = TclList.getLength(interp, tmp237);
                                        interp.setResult(tmp238);
                                    } // End Invoke: llength
                                    TclObject tmp239 = interp.getResult();
                                    ExprValue tmp240 = evs1;
                                    TJC.exprInitValue(interp, tmp240, tmp239);
                                    ExprValue tmp241 = evs2;
                                    tmp241.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp240, tmp241);
                                    // End Binary operator: >
                                    tmp236.setIntValue(tmp240.getBooleanValue(interp));
                                    } else {
                                    tmp236.setIntValue(0);
                                    } // End if: ()
                                    // End Binary operator: &&
                                    if (tmp236.getBooleanValue(interp)) {
                                    // Binary operator: [...] > 0
                                    { // Invoke: llength $default_args
                                        TclObject tmp242 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                        int tmp243 = TclList.getLength(interp, tmp242);
                                        interp.setResult(tmp243);
                                    } // End Invoke: llength
                                    TclObject tmp244 = interp.getResult();
                                    ExprValue tmp245 = evs1;
                                    TJC.exprInitValue(interp, tmp245, tmp244);
                                    ExprValue tmp246 = evs2;
                                    tmp246.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp245, tmp246);
                                    // End Binary operator: >
                                    tmp236.setIntValue(tmp245.getBooleanValue(interp));
                                    } else {
                                    tmp236.setIntValue(0);
                                    } // End if: ()
                                    // End Binary operator: &&
                                    boolean tmp247 = ( tmp236.getIntValue() != 0 );
                                    if ( tmp247 ) {
                                        { // Invoke: set arg_names $non_default_args
                                            TclObject tmp248;
                                            tmp248 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                            setVarScalar(interp, "arg_names", tmp248, compiledLocals, 14);
                                        } // End Invoke: set
                                        { // Invoke: foreach arg $default_args ...
                                            TclObject tmp249 = null;
                                            try {
                                                tmp249 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                                tmp249.preserve();
                                                final int tmp249_length = TclList.getLength(interp, tmp249);

                                                for ( int index250 = 0 ; index250 < tmp249_length ; index250++ ) {
                                                    TclObject tmp251 = TclList.index(interp, tmp249, index250);
                                                    try {
                                                        setVarScalar(interp, "arg", tmp251, compiledLocals, 13);
                                                    } catch (TclException ex) {
                                                        TJC.foreachVarErr(interp, "arg");
                                                    }

                                                    try {
                                                    if ( false ) { throw (TclException) null; }
                                                    { // Invoke: set name [...]
                                                        TclObject tmp252;
                                                        { // Invoke: lindex $arg 0
                                                            TclObject tmp253 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                            tmp253 = TclList.index(interp, tmp253, 0);
                                                            if ( tmp253 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp253);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp252 = interp.getResult();
                                                        setVarScalar(interp, "name", tmp252, compiledLocals, 15);
                                                    } // End Invoke: set
                                                    { // Invoke: set default [...]
                                                        TclObject tmp254;
                                                        { // Invoke: lindex $arg 1
                                                            TclObject tmp255 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                            tmp255 = TclList.index(interp, tmp255, 1);
                                                            if ( tmp255 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp255);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp254 = interp.getResult();
                                                        setVarScalar(interp, "default", tmp254, compiledLocals, 16);
                                                    } // End Invoke: set
                                                    { // Invoke: lappend arg_names "?${name}?"
                                                        TclObject[] objv256 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp257;
                                                        try {
                                                            // Arg 2 word: "?${name}?"
                                                            StringBuffer sbtmp258 = new StringBuffer(64);
                                                            sbtmp258.append("?");
                                                            tmp257 = getVarScalar(interp, "name", compiledLocals, 15);
                                                            sbtmp258.append(tmp257.toString());
                                                            sbtmp258.append("?");
                                                            tmp257 = TclString.newInstance(sbtmp258);
                                                            tmp257.preserve();
                                                            objv256[0] = tmp257;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "arg_names", objv256, compiledLocals, 14);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv256, 1);
                                                        }
                                                    } // End Invoke: lappend
                                                    } catch (TclException ex) {
                                                        int type = ex.getCompletionCode();
                                                        if (type == TCL.BREAK) {
                                                            break;
                                                        } else if (type == TCL.CONTINUE) {
                                                            continue;
                                                        } else {
                                                            throw ex;
                                                        }
                                                    }
                                                }
                                            } finally {
                                                if ( tmp249 != null ) {
                                                    tmp249.release();
                                                }
                                            }
                                        } // End Invoke: foreach
                                        { // Invoke: set args_str [...]
                                            TclObject tmp259;
                                            { // Invoke: join $arg_names " "
                                                TclObject[] objv260 = TJC.grabObjv(interp, 3);
                                                TclObject tmp261;
                                                try {
                                                    // Arg 0 constant: join
                                                    objv260[0] = const5;
                                                    // Arg 1 variable: $arg_names
                                                    tmp261 = getVarScalar(interp, "arg_names", compiledLocals, 14);
                                                    tmp261.preserve();
                                                    objv260[1] = tmp261;
                                                    // Arg 2 constant: " "
                                                    objv260[2] = const6;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv260, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    tmp261 = objv260[1];
                                                    if ( tmp261 != null ) {
                                                        tmp261.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv260, 3);
                                                }
                                            } // End Invoke: join
                                            tmp259 = interp.getResult();
                                            setVarScalar(interp, "args_str", tmp259, compiledLocals, 11);
                                        } // End Invoke: set
                                        { // Invoke: append buffer [...]
                                            TclObject[] objv262 = TJC.grabObjv(interp, 1);
                                            TclObject tmp263;
                                            try {
                                                // Arg 2 command: [...]
                                                { // Invoke: ... $min_num_args $max_num_args $args_str
                                                    TclObject[] objv264 = TJC.grabObjv(interp, 4);
                                                    TclObject tmp265;
                                                    try {
                                                        // Arg 0 constant: ...
                                                        objv264[0] = const17;
                                                        // Arg 1 variable: $min_num_args
                                                        tmp265 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                                                        tmp265.preserve();
                                                        objv264[1] = tmp265;
                                                        // Arg 2 variable: $max_num_args
                                                        tmp265 = getVarScalar(interp, "max_num_args", compiledLocals, 10);
                                                        tmp265.preserve();
                                                        objv264[2] = tmp265;
                                                        // Arg 3 variable: $args_str
                                                        tmp265 = getVarScalar(interp, "args_str", compiledLocals, 11);
                                                        tmp265.preserve();
                                                        objv264[3] = tmp265;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                            ? cmdcache13.cmd : null), objv264, 0);
                                                        if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                            updateCmdCache(interp, 13);
                                                        }
                                                    } finally {
                                                        tmp265 = objv264[1];
                                                        if ( tmp265 != null ) {
                                                            tmp265.release();
                                                        }
                                                        tmp265 = objv264[2];
                                                        if ( tmp265 != null ) {
                                                            tmp265.release();
                                                        }
                                                        tmp265 = objv264[3];
                                                        if ( tmp265 != null ) {
                                                            tmp265.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv264, 4);
                                                    }
                                                } // End Invoke: ...
                                                tmp263 = interp.getResult();
                                                tmp263.preserve();
                                                objv262[0] = tmp263;
                                                interp.resetResult();
                                                appendVarScalar(interp, "buffer", objv262, compiledLocals, 4);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv262, 1);
                                            }
                                        } // End Invoke: append
                                        { // Invoke: set index 1
                                            setVarScalar(interp, "index", const8, compiledLocals, 12);
                                        } // End Invoke: set
                                        { // Invoke: foreach arg $non_default_args ...
                                            TclObject tmp266 = null;
                                            try {
                                                tmp266 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                                tmp266.preserve();
                                                final int tmp266_length = TclList.getLength(interp, tmp266);

                                                for ( int index267 = 0 ; index267 < tmp266_length ; index267++ ) {
                                                    TclObject tmp268 = TclList.index(interp, tmp266, index267);
                                                    try {
                                                        setVarScalar(interp, "arg", tmp268, compiledLocals, 13);
                                                    } catch (TclException ex) {
                                                        TJC.foreachVarErr(interp, "arg");
                                                    }

                                                    try {
                                                    if ( false ) { throw (TclException) null; }
                                                    { // Invoke: set name [...]
                                                        TclObject tmp269;
                                                        { // Invoke: lindex $arg 0
                                                            TclObject tmp270 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                            tmp270 = TclList.index(interp, tmp270, 0);
                                                            if ( tmp270 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp270);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp269 = interp.getResult();
                                                        setVarScalar(interp, "name", tmp269, compiledLocals, 15);
                                                    } // End Invoke: set
                                                    { // Invoke: append buffer [...]
                                                        TclObject[] objv271 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp272;
                                                        try {
                                                            // Arg 2 command: [...]
                                                            { // Invoke: ... $name $index
                                                                TclObject[] objv273 = TJC.grabObjv(interp, 3);
                                                                TclObject tmp274;
                                                                try {
                                                                    // Arg 0 constant: ...
                                                                    objv273[0] = const9;
                                                                    // Arg 1 variable: $name
                                                                    tmp274 = getVarScalar(interp, "name", compiledLocals, 15);
                                                                    tmp274.preserve();
                                                                    objv273[1] = tmp274;
                                                                    // Arg 2 variable: $index
                                                                    tmp274 = getVarScalar(interp, "index", compiledLocals, 12);
                                                                    tmp274.preserve();
                                                                    objv273[2] = tmp274;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                                        ? cmdcache6.cmd : null), objv273, 0);
                                                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                                        updateCmdCache(interp, 6);
                                                                    }
                                                                } finally {
                                                                    tmp274 = objv273[1];
                                                                    if ( tmp274 != null ) {
                                                                        tmp274.release();
                                                                    }
                                                                    tmp274 = objv273[2];
                                                                    if ( tmp274 != null ) {
                                                                        tmp274.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv273, 3);
                                                                }
                                                            } // End Invoke: ...
                                                            tmp272 = interp.getResult();
                                                            tmp272.preserve();
                                                            objv271[0] = tmp272;
                                                            interp.resetResult();
                                                            appendVarScalar(interp, "buffer", objv271, compiledLocals, 4);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv271, 1);
                                                        }
                                                    } // End Invoke: append
                                                    { // Invoke: incr index
                                                        interp.resetResult();
                                                        incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                                    } // End Invoke: incr
                                                    } catch (TclException ex) {
                                                        int type = ex.getCompletionCode();
                                                        if (type == TCL.BREAK) {
                                                            break;
                                                        } else if (type == TCL.CONTINUE) {
                                                            continue;
                                                        } else {
                                                            throw ex;
                                                        }
                                                    }
                                                }
                                            } finally {
                                                if ( tmp266 != null ) {
                                                    tmp266.release();
                                                }
                                            }
                                        } // End Invoke: foreach
                                        { // Invoke: foreach arg $default_args ...
                                            TclObject tmp275 = null;
                                            try {
                                                tmp275 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                                tmp275.preserve();
                                                final int tmp275_length = TclList.getLength(interp, tmp275);

                                                for ( int index276 = 0 ; index276 < tmp275_length ; index276++ ) {
                                                    TclObject tmp277 = TclList.index(interp, tmp275, index276);
                                                    try {
                                                        setVarScalar(interp, "arg", tmp277, compiledLocals, 13);
                                                    } catch (TclException ex) {
                                                        TJC.foreachVarErr(interp, "arg");
                                                    }

                                                    try {
                                                    if ( false ) { throw (TclException) null; }
                                                    { // Invoke: set name [...]
                                                        TclObject tmp278;
                                                        { // Invoke: lindex $arg 0
                                                            TclObject tmp279 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                            tmp279 = TclList.index(interp, tmp279, 0);
                                                            if ( tmp279 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp279);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp278 = interp.getResult();
                                                        setVarScalar(interp, "name", tmp278, compiledLocals, 15);
                                                    } // End Invoke: set
                                                    { // Invoke: set default [...]
                                                        TclObject tmp280;
                                                        { // Invoke: lindex $arg 1
                                                            TclObject tmp281 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                            tmp281 = TclList.index(interp, tmp281, 1);
                                                            if ( tmp281 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp281);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp280 = interp.getResult();
                                                        setVarScalar(interp, "default", tmp280, compiledLocals, 16);
                                                    } // End Invoke: set
                                                    { // Invoke: ... $default
                                                        TclObject[] objv282 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp283;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv282[0] = const11;
                                                            // Arg 1 variable: $default
                                                            tmp283 = getVarScalar(interp, "default", compiledLocals, 16);
                                                            tmp283.preserve();
                                                            objv282[1] = tmp283;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                                ? cmdcache8.cmd : null), objv282, 0);
                                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                                updateCmdCache(interp, 8);
                                                            }
                                                        } finally {
                                                            tmp283 = objv282[1];
                                                            if ( tmp283 != null ) {
                                                                tmp283.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv282, 2);
                                                        }
                                                    } // End Invoke: ...
                                                    { // Invoke: set constants_found 1
                                                        setVarScalar(interp, "constants_found", const8, compiledLocals, 3);
                                                    } // End Invoke: set
                                                    { // Invoke: set default_sym [...]
                                                        TclObject tmp284;
                                                        { // Invoke: ... $default
                                                            TclObject[] objv285 = TJC.grabObjv(interp, 2);
                                                            TclObject tmp286;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv285[0] = const12;
                                                                // Arg 1 variable: $default
                                                                tmp286 = getVarScalar(interp, "default", compiledLocals, 16);
                                                                tmp286.preserve();
                                                                objv285[1] = tmp286;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                                    ? cmdcache9.cmd : null), objv285, 0);
                                                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                                    updateCmdCache(interp, 9);
                                                                }
                                                            } finally {
                                                                tmp286 = objv285[1];
                                                                if ( tmp286 != null ) {
                                                                    tmp286.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv285, 2);
                                                            }
                                                        } // End Invoke: ...
                                                        tmp284 = interp.getResult();
                                                        setVarScalar(interp, "default_sym", tmp284, compiledLocals, 17);
                                                    } // End Invoke: set
                                                    { // Invoke: append buffer [...]
                                                        TclObject[] objv287 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp288;
                                                        try {
                                                            // Arg 2 command: [...]
                                                            { // Invoke: ... $name $index $default_sym
                                                                TclObject[] objv289 = TJC.grabObjv(interp, 4);
                                                                TclObject tmp290;
                                                                try {
                                                                    // Arg 0 constant: ...
                                                                    objv289[0] = const13;
                                                                    // Arg 1 variable: $name
                                                                    tmp290 = getVarScalar(interp, "name", compiledLocals, 15);
                                                                    tmp290.preserve();
                                                                    objv289[1] = tmp290;
                                                                    // Arg 2 variable: $index
                                                                    tmp290 = getVarScalar(interp, "index", compiledLocals, 12);
                                                                    tmp290.preserve();
                                                                    objv289[2] = tmp290;
                                                                    // Arg 3 variable: $default_sym
                                                                    tmp290 = getVarScalar(interp, "default_sym", compiledLocals, 17);
                                                                    tmp290.preserve();
                                                                    objv289[3] = tmp290;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                                        ? cmdcache10.cmd : null), objv289, 0);
                                                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                                        updateCmdCache(interp, 10);
                                                                    }
                                                                } finally {
                                                                    tmp290 = objv289[1];
                                                                    if ( tmp290 != null ) {
                                                                        tmp290.release();
                                                                    }
                                                                    tmp290 = objv289[2];
                                                                    if ( tmp290 != null ) {
                                                                        tmp290.release();
                                                                    }
                                                                    tmp290 = objv289[3];
                                                                    if ( tmp290 != null ) {
                                                                        tmp290.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv289, 4);
                                                                }
                                                            } // End Invoke: ...
                                                            tmp288 = interp.getResult();
                                                            tmp288.preserve();
                                                            objv287[0] = tmp288;
                                                            interp.resetResult();
                                                            appendVarScalar(interp, "buffer", objv287, compiledLocals, 4);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv287, 1);
                                                        }
                                                    } // End Invoke: append
                                                    { // Invoke: incr index
                                                        interp.resetResult();
                                                        incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                                    } // End Invoke: incr
                                                    } catch (TclException ex) {
                                                        int type = ex.getCompletionCode();
                                                        if (type == TCL.BREAK) {
                                                            break;
                                                        } else if (type == TCL.CONTINUE) {
                                                            continue;
                                                        } else {
                                                            throw ex;
                                                        }
                                                    }
                                                }
                                            } finally {
                                                if ( tmp275 != null ) {
                                                    tmp275.release();
                                                }
                                            }
                                        } // End Invoke: foreach
                                    } else {
                                        // Binary operator: () && ()
                                        // Binary operator: $has_args && ()
                                        TclObject tmp291 = getVarScalar(interp, "has_args", compiledLocals, 8);
                                        ExprValue tmp292 = evs0;
                                        TJC.exprInitValue(interp, tmp292, tmp291);
                                        if (tmp292.getBooleanValue(interp)) {
                                        // Binary operator: [...] > 0
                                        { // Invoke: llength $non_default_args
                                            TclObject tmp293 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                            int tmp294 = TclList.getLength(interp, tmp293);
                                            interp.setResult(tmp294);
                                        } // End Invoke: llength
                                        TclObject tmp295 = interp.getResult();
                                        ExprValue tmp296 = evs1;
                                        TJC.exprInitValue(interp, tmp296, tmp295);
                                        ExprValue tmp297 = evs2;
                                        tmp297.setIntValue(0);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp296, tmp297);
                                        // End Binary operator: >
                                        tmp292.setIntValue(tmp296.getBooleanValue(interp));
                                        } else {
                                        tmp292.setIntValue(0);
                                        } // End if: $has_args
                                        // End Binary operator: &&
                                        if (tmp292.getBooleanValue(interp)) {
                                        // Binary operator: [...] > 0
                                        { // Invoke: llength $default_args
                                            TclObject tmp298 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                            int tmp299 = TclList.getLength(interp, tmp298);
                                            interp.setResult(tmp299);
                                        } // End Invoke: llength
                                        TclObject tmp300 = interp.getResult();
                                        ExprValue tmp301 = evs1;
                                        TJC.exprInitValue(interp, tmp301, tmp300);
                                        ExprValue tmp302 = evs2;
                                        tmp302.setIntValue(0);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp301, tmp302);
                                        // End Binary operator: >
                                        tmp292.setIntValue(tmp301.getBooleanValue(interp));
                                        } else {
                                        tmp292.setIntValue(0);
                                        } // End if: ()
                                        // End Binary operator: &&
                                        boolean tmp303 = ( tmp292.getIntValue() != 0 );
                                        if ( tmp303 ) {
                                            { // Invoke: set arg_names $non_default_args
                                                TclObject tmp304;
                                                tmp304 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                                setVarScalar(interp, "arg_names", tmp304, compiledLocals, 14);
                                            } // End Invoke: set
                                            { // Invoke: foreach arg $default_args ...
                                                TclObject tmp305 = null;
                                                try {
                                                    tmp305 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                                    tmp305.preserve();
                                                    final int tmp305_length = TclList.getLength(interp, tmp305);

                                                    for ( int index306 = 0 ; index306 < tmp305_length ; index306++ ) {
                                                        TclObject tmp307 = TclList.index(interp, tmp305, index306);
                                                        try {
                                                            setVarScalar(interp, "arg", tmp307, compiledLocals, 13);
                                                        } catch (TclException ex) {
                                                            TJC.foreachVarErr(interp, "arg");
                                                        }

                                                        try {
                                                        if ( false ) { throw (TclException) null; }
                                                        { // Invoke: set name [...]
                                                            TclObject tmp308;
                                                            { // Invoke: lindex $arg 0
                                                                TclObject tmp309 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                                tmp309 = TclList.index(interp, tmp309, 0);
                                                                if ( tmp309 == null ) {
                                                                    interp.resetResult();
                                                                } else {
                                                                    interp.setResult(tmp309);
                                                                }
                                                            } // End Invoke: lindex
                                                            tmp308 = interp.getResult();
                                                            setVarScalar(interp, "name", tmp308, compiledLocals, 15);
                                                        } // End Invoke: set
                                                        { // Invoke: set default [...]
                                                            TclObject tmp310;
                                                            { // Invoke: lindex $arg 1
                                                                TclObject tmp311 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                                tmp311 = TclList.index(interp, tmp311, 1);
                                                                if ( tmp311 == null ) {
                                                                    interp.resetResult();
                                                                } else {
                                                                    interp.setResult(tmp311);
                                                                }
                                                            } // End Invoke: lindex
                                                            tmp310 = interp.getResult();
                                                            setVarScalar(interp, "default", tmp310, compiledLocals, 16);
                                                        } // End Invoke: set
                                                        { // Invoke: lappend arg_names "?${name}?"
                                                            TclObject[] objv312 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp313;
                                                            try {
                                                                // Arg 2 word: "?${name}?"
                                                                StringBuffer sbtmp314 = new StringBuffer(64);
                                                                sbtmp314.append("?");
                                                                tmp313 = getVarScalar(interp, "name", compiledLocals, 15);
                                                                sbtmp314.append(tmp313.toString());
                                                                sbtmp314.append("?");
                                                                tmp313 = TclString.newInstance(sbtmp314);
                                                                tmp313.preserve();
                                                                objv312[0] = tmp313;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "arg_names", objv312, compiledLocals, 14);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv312, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        } catch (TclException ex) {
                                                            int type = ex.getCompletionCode();
                                                            if (type == TCL.BREAK) {
                                                                break;
                                                            } else if (type == TCL.CONTINUE) {
                                                                continue;
                                                            } else {
                                                                throw ex;
                                                            }
                                                        }
                                                    }
                                                } finally {
                                                    if ( tmp305 != null ) {
                                                        tmp305.release();
                                                    }
                                                }
                                            } // End Invoke: foreach
                                            { // Invoke: lappend arg_names "args"
                                                TclObject[] objv315 = TJC.grabObjv(interp, 1);
                                                TclObject tmp316;
                                                try {
                                                    // Arg 2 constant: "args"
                                                    objv315[0] = const15;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "arg_names", objv315, compiledLocals, 14);
                                                } finally {
                                                    TJC.releaseObjv(interp, objv315, 1);
                                                }
                                            } // End Invoke: lappend
                                            { // Invoke: set args_str [...]
                                                TclObject tmp317;
                                                { // Invoke: join $arg_names " "
                                                    TclObject[] objv318 = TJC.grabObjv(interp, 3);
                                                    TclObject tmp319;
                                                    try {
                                                        // Arg 0 constant: join
                                                        objv318[0] = const5;
                                                        // Arg 1 variable: $arg_names
                                                        tmp319 = getVarScalar(interp, "arg_names", compiledLocals, 14);
                                                        tmp319.preserve();
                                                        objv318[1] = tmp319;
                                                        // Arg 2 constant: " "
                                                        objv318[2] = const6;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                            ? cmdcache4.cmd : null), objv318, 0);
                                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                            updateCmdCache(interp, 4);
                                                        }
                                                    } finally {
                                                        tmp319 = objv318[1];
                                                        if ( tmp319 != null ) {
                                                            tmp319.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv318, 3);
                                                    }
                                                } // End Invoke: join
                                                tmp317 = interp.getResult();
                                                setVarScalar(interp, "args_str", tmp317, compiledLocals, 11);
                                            } // End Invoke: set
                                            { // Invoke: append buffer [...]
                                                TclObject[] objv320 = TJC.grabObjv(interp, 1);
                                                TclObject tmp321;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: emitter_num_min_args $min_num_args $args_str
                                                        TclObject[] objv322 = TJC.grabObjv(interp, 3);
                                                        TclObject tmp323;
                                                        try {
                                                            // Arg 0 constant: emitter_num_min_args
                                                            objv322[0] = const16;
                                                            // Arg 1 variable: $min_num_args
                                                            tmp323 = getVarScalar(interp, "min_num_args", compiledLocals, 9);
                                                            tmp323.preserve();
                                                            objv322[1] = tmp323;
                                                            // Arg 2 variable: $args_str
                                                            tmp323 = getVarScalar(interp, "args_str", compiledLocals, 11);
                                                            tmp323.preserve();
                                                            objv322[2] = tmp323;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                                ? cmdcache12.cmd : null), objv322, 0);
                                                            if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                                updateCmdCache(interp, 12);
                                                            }
                                                        } finally {
                                                            tmp323 = objv322[1];
                                                            if ( tmp323 != null ) {
                                                                tmp323.release();
                                                            }
                                                            tmp323 = objv322[2];
                                                            if ( tmp323 != null ) {
                                                                tmp323.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv322, 3);
                                                        }
                                                    } // End Invoke: emitter_num_min_args
                                                    tmp321 = interp.getResult();
                                                    tmp321.preserve();
                                                    objv320[0] = tmp321;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv320, compiledLocals, 4);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv320, 1);
                                                }
                                            } // End Invoke: append
                                            { // Invoke: set index 1
                                                setVarScalar(interp, "index", const8, compiledLocals, 12);
                                            } // End Invoke: set
                                            { // Invoke: foreach arg $non_default_args ...
                                                TclObject tmp324 = null;
                                                try {
                                                    tmp324 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                                    tmp324.preserve();
                                                    final int tmp324_length = TclList.getLength(interp, tmp324);

                                                    for ( int index325 = 0 ; index325 < tmp324_length ; index325++ ) {
                                                        TclObject tmp326 = TclList.index(interp, tmp324, index325);
                                                        try {
                                                            setVarScalar(interp, "arg", tmp326, compiledLocals, 13);
                                                        } catch (TclException ex) {
                                                            TJC.foreachVarErr(interp, "arg");
                                                        }

                                                        try {
                                                        if ( false ) { throw (TclException) null; }
                                                        { // Invoke: set name [...]
                                                            TclObject tmp327;
                                                            { // Invoke: lindex $arg 0
                                                                TclObject tmp328 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                                tmp328 = TclList.index(interp, tmp328, 0);
                                                                if ( tmp328 == null ) {
                                                                    interp.resetResult();
                                                                } else {
                                                                    interp.setResult(tmp328);
                                                                }
                                                            } // End Invoke: lindex
                                                            tmp327 = interp.getResult();
                                                            setVarScalar(interp, "name", tmp327, compiledLocals, 15);
                                                        } // End Invoke: set
                                                        { // Invoke: append buffer [...]
                                                            TclObject[] objv329 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp330;
                                                            try {
                                                                // Arg 2 command: [...]
                                                                { // Invoke: ... $name $index
                                                                    TclObject[] objv331 = TJC.grabObjv(interp, 3);
                                                                    TclObject tmp332;
                                                                    try {
                                                                        // Arg 0 constant: ...
                                                                        objv331[0] = const9;
                                                                        // Arg 1 variable: $name
                                                                        tmp332 = getVarScalar(interp, "name", compiledLocals, 15);
                                                                        tmp332.preserve();
                                                                        objv331[1] = tmp332;
                                                                        // Arg 2 variable: $index
                                                                        tmp332 = getVarScalar(interp, "index", compiledLocals, 12);
                                                                        tmp332.preserve();
                                                                        objv331[2] = tmp332;
                                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                            updateCmdCache(interp, 0);
                                                                        }
                                                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                                            ? cmdcache6.cmd : null), objv331, 0);
                                                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                                            updateCmdCache(interp, 6);
                                                                        }
                                                                    } finally {
                                                                        tmp332 = objv331[1];
                                                                        if ( tmp332 != null ) {
                                                                            tmp332.release();
                                                                        }
                                                                        tmp332 = objv331[2];
                                                                        if ( tmp332 != null ) {
                                                                            tmp332.release();
                                                                        }
                                                                        TJC.releaseObjv(interp, objv331, 3);
                                                                    }
                                                                } // End Invoke: ...
                                                                tmp330 = interp.getResult();
                                                                tmp330.preserve();
                                                                objv329[0] = tmp330;
                                                                interp.resetResult();
                                                                appendVarScalar(interp, "buffer", objv329, compiledLocals, 4);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv329, 1);
                                                            }
                                                        } // End Invoke: append
                                                        { // Invoke: incr index
                                                            interp.resetResult();
                                                            incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                                        } // End Invoke: incr
                                                        } catch (TclException ex) {
                                                            int type = ex.getCompletionCode();
                                                            if (type == TCL.BREAK) {
                                                                break;
                                                            } else if (type == TCL.CONTINUE) {
                                                                continue;
                                                            } else {
                                                                throw ex;
                                                            }
                                                        }
                                                    }
                                                } finally {
                                                    if ( tmp324 != null ) {
                                                        tmp324.release();
                                                    }
                                                }
                                            } // End Invoke: foreach
                                            { // Invoke: foreach arg $default_args ...
                                                TclObject tmp333 = null;
                                                try {
                                                    tmp333 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                                    tmp333.preserve();
                                                    final int tmp333_length = TclList.getLength(interp, tmp333);

                                                    for ( int index334 = 0 ; index334 < tmp333_length ; index334++ ) {
                                                        TclObject tmp335 = TclList.index(interp, tmp333, index334);
                                                        try {
                                                            setVarScalar(interp, "arg", tmp335, compiledLocals, 13);
                                                        } catch (TclException ex) {
                                                            TJC.foreachVarErr(interp, "arg");
                                                        }

                                                        try {
                                                        if ( false ) { throw (TclException) null; }
                                                        { // Invoke: set name [...]
                                                            TclObject tmp336;
                                                            { // Invoke: lindex $arg 0
                                                                TclObject tmp337 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                                tmp337 = TclList.index(interp, tmp337, 0);
                                                                if ( tmp337 == null ) {
                                                                    interp.resetResult();
                                                                } else {
                                                                    interp.setResult(tmp337);
                                                                }
                                                            } // End Invoke: lindex
                                                            tmp336 = interp.getResult();
                                                            setVarScalar(interp, "name", tmp336, compiledLocals, 15);
                                                        } // End Invoke: set
                                                        { // Invoke: set default [...]
                                                            TclObject tmp338;
                                                            { // Invoke: lindex $arg 1
                                                                TclObject tmp339 = getVarScalar(interp, "arg", compiledLocals, 13);
                                                                tmp339 = TclList.index(interp, tmp339, 1);
                                                                if ( tmp339 == null ) {
                                                                    interp.resetResult();
                                                                } else {
                                                                    interp.setResult(tmp339);
                                                                }
                                                            } // End Invoke: lindex
                                                            tmp338 = interp.getResult();
                                                            setVarScalar(interp, "default", tmp338, compiledLocals, 16);
                                                        } // End Invoke: set
                                                        { // Invoke: ... $default
                                                            TclObject[] objv340 = TJC.grabObjv(interp, 2);
                                                            TclObject tmp341;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv340[0] = const11;
                                                                // Arg 1 variable: $default
                                                                tmp341 = getVarScalar(interp, "default", compiledLocals, 16);
                                                                tmp341.preserve();
                                                                objv340[1] = tmp341;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                                    ? cmdcache8.cmd : null), objv340, 0);
                                                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                                    updateCmdCache(interp, 8);
                                                                }
                                                            } finally {
                                                                tmp341 = objv340[1];
                                                                if ( tmp341 != null ) {
                                                                    tmp341.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv340, 2);
                                                            }
                                                        } // End Invoke: ...
                                                        { // Invoke: set constants_found 1
                                                            setVarScalar(interp, "constants_found", const8, compiledLocals, 3);
                                                        } // End Invoke: set
                                                        { // Invoke: set default_sym [...]
                                                            TclObject tmp342;
                                                            { // Invoke: ... $default
                                                                TclObject[] objv343 = TJC.grabObjv(interp, 2);
                                                                TclObject tmp344;
                                                                try {
                                                                    // Arg 0 constant: ...
                                                                    objv343[0] = const12;
                                                                    // Arg 1 variable: $default
                                                                    tmp344 = getVarScalar(interp, "default", compiledLocals, 16);
                                                                    tmp344.preserve();
                                                                    objv343[1] = tmp344;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                                        ? cmdcache9.cmd : null), objv343, 0);
                                                                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                                        updateCmdCache(interp, 9);
                                                                    }
                                                                } finally {
                                                                    tmp344 = objv343[1];
                                                                    if ( tmp344 != null ) {
                                                                        tmp344.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv343, 2);
                                                                }
                                                            } // End Invoke: ...
                                                            tmp342 = interp.getResult();
                                                            setVarScalar(interp, "default_sym", tmp342, compiledLocals, 17);
                                                        } // End Invoke: set
                                                        { // Invoke: append buffer [...]
                                                            TclObject[] objv345 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp346;
                                                            try {
                                                                // Arg 2 command: [...]
                                                                { // Invoke: ... $name $index $default_sym
                                                                    TclObject[] objv347 = TJC.grabObjv(interp, 4);
                                                                    TclObject tmp348;
                                                                    try {
                                                                        // Arg 0 constant: ...
                                                                        objv347[0] = const13;
                                                                        // Arg 1 variable: $name
                                                                        tmp348 = getVarScalar(interp, "name", compiledLocals, 15);
                                                                        tmp348.preserve();
                                                                        objv347[1] = tmp348;
                                                                        // Arg 2 variable: $index
                                                                        tmp348 = getVarScalar(interp, "index", compiledLocals, 12);
                                                                        tmp348.preserve();
                                                                        objv347[2] = tmp348;
                                                                        // Arg 3 variable: $default_sym
                                                                        tmp348 = getVarScalar(interp, "default_sym", compiledLocals, 17);
                                                                        tmp348.preserve();
                                                                        objv347[3] = tmp348;
                                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                            updateCmdCache(interp, 0);
                                                                        }
                                                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                                            ? cmdcache10.cmd : null), objv347, 0);
                                                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                                            updateCmdCache(interp, 10);
                                                                        }
                                                                    } finally {
                                                                        tmp348 = objv347[1];
                                                                        if ( tmp348 != null ) {
                                                                            tmp348.release();
                                                                        }
                                                                        tmp348 = objv347[2];
                                                                        if ( tmp348 != null ) {
                                                                            tmp348.release();
                                                                        }
                                                                        tmp348 = objv347[3];
                                                                        if ( tmp348 != null ) {
                                                                            tmp348.release();
                                                                        }
                                                                        TJC.releaseObjv(interp, objv347, 4);
                                                                    }
                                                                } // End Invoke: ...
                                                                tmp346 = interp.getResult();
                                                                tmp346.preserve();
                                                                objv345[0] = tmp346;
                                                                interp.resetResult();
                                                                appendVarScalar(interp, "buffer", objv345, compiledLocals, 4);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv345, 1);
                                                            }
                                                        } // End Invoke: append
                                                        { // Invoke: incr index
                                                            interp.resetResult();
                                                            incrVarScalar(interp, "index", 1, compiledLocals, 12);
                                                        } // End Invoke: incr
                                                        } catch (TclException ex) {
                                                            int type = ex.getCompletionCode();
                                                            if (type == TCL.BREAK) {
                                                                break;
                                                            } else if (type == TCL.CONTINUE) {
                                                                continue;
                                                            } else {
                                                                throw ex;
                                                            }
                                                        }
                                                    }
                                                } finally {
                                                    if ( tmp333 != null ) {
                                                        tmp333.release();
                                                    }
                                                }
                                            } // End Invoke: foreach
                                            { // Invoke: append buffer [...]
                                                TclObject[] objv349 = TJC.grabObjv(interp, 1);
                                                TclObject tmp350;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: ... $index
                                                        TclObject[] objv351 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp352;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv351[0] = const14;
                                                            // Arg 1 variable: $index
                                                            tmp352 = getVarScalar(interp, "index", compiledLocals, 12);
                                                            tmp352.preserve();
                                                            objv351[1] = tmp352;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                                ? cmdcache11.cmd : null), objv351, 0);
                                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                                updateCmdCache(interp, 11);
                                                            }
                                                        } finally {
                                                            tmp352 = objv351[1];
                                                            if ( tmp352 != null ) {
                                                                tmp352.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv351, 2);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp350 = interp.getResult();
                                                    tmp350.preserve();
                                                    objv349[0] = tmp350;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv349, compiledLocals, 4);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv349, 1);
                                                }
                                            } // End Invoke: append
                                        } else {
                                            { // Invoke: error "..."
                                                TclObject[] objv353 = TJC.grabObjv(interp, 2);
                                                TclObject tmp354;
                                                try {
                                                    // Arg 0 constant: error
                                                    objv353[0] = const3;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp355 = new StringBuffer(64);
                                                    sbtmp355.append("unhandled args case: non_default_args ");
                                                    sbtmp355.append("{");
                                                    tmp354 = getVarScalar(interp, "non_default_args", compiledLocals, 6);
                                                    sbtmp355.append(tmp354.toString());
                                                    sbtmp355.append("}");
                                                    sbtmp355.append(", default_args ");
                                                    sbtmp355.append("{");
                                                    tmp354 = getVarScalar(interp, "default_args", compiledLocals, 7);
                                                    sbtmp355.append(tmp354.toString());
                                                    sbtmp355.append("}");
                                                    sbtmp355.append(", has_args ");
                                                    tmp354 = getVarScalar(interp, "has_args", compiledLocals, 8);
                                                    sbtmp355.append(tmp354.toString());
                                                    tmp354 = TclString.newInstance(sbtmp355);
                                                    tmp354.preserve();
                                                    objv353[1] = tmp354;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                        ? cmdcache3.cmd : null), objv353, 0);
                                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                        updateCmdCache(interp, 3);
                                                    }
                                                } finally {
                                                    tmp354 = objv353[1];
                                                    if ( tmp354 != null ) {
                                                        tmp354.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv353, 2);
                                                }
                                            } // End Invoke: error
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: if {$constants_found} ...
            TclObject tmp356 = getVarScalar(interp, "constants_found", compiledLocals, 3);
            boolean tmp357 = TJC.getBoolean(interp, tmp356);
            if ( tmp357 ) {
                { // Invoke: set cmd_needs_init 1
                    setVarScalar(interp, "cmd_needs_init", const8, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set ... $cmd_needs_init
            TclObject tmp358;
            tmp358 = getVarScalar(interp, "cmd_needs_init", compiledLocals, 2);
            setVarArray(interp, "_compileproc_key_info", "cmd_needs_init", tmp358, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set ... $constants_found
            TclObject tmp359;
            tmp359 = getVarScalar(interp, "constants_found", compiledLocals, 3);
            setVarArray(interp, "_compileproc_key_info", "constants_found", tmp359, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return $buffer
            TclObject tmp360 = getVarScalar(interp, "buffer", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp360);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_args_assign");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_empty_args");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_args_split");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("no arguments found");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("join");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(" ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_num_args");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(1);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_assign_arg");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_num_default_args");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_constant_cache_add");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_constant_cache_get");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_assign_default_arg");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_assign_args_arg");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("args");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_num_min_args");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("emitter_num_range_args");
        const17.preserve(); const17.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_empty_args";
                break;
            }
            case 2: {
                cmdName = "compileproc_args_split";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "join";
                break;
            }
            case 5: {
                cmdName = "emitter_num_args";
                break;
            }
            case 6: {
                cmdName = "compileproc_assign_arg";
                break;
            }
            case 7: {
                cmdName = "emitter_num_default_args";
                break;
            }
            case 8: {
                cmdName = "compileproc_constant_cache_add";
                break;
            }
            case 9: {
                cmdName = "compileproc_constant_cache_get";
                break;
            }
            case 10: {
                cmdName = "compileproc_assign_default_arg";
                break;
            }
            case 11: {
                cmdName = "compileproc_assign_args_arg";
                break;
            }
            case 12: {
                cmdName = "emitter_num_min_args";
                break;
            }
            case 13: {
                cmdName = "emitter_num_range_args";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_args",
        "_compileproc_key_info",
        "cmd_needs_init",
        "constants_found",
        "buffer",
        "result",
        "non_default_args",
        "default_args",
        "has_args",
        "min_num_args",
        "max_num_args",
        "args_str",
        "index",
        "arg",
        "arg_names",
        "name",
        "default",
        "default_sym",
        "all_args"
    };
} // end class CompileprocArgsAssignCmd

