// TJC implementation of procedure compileproc_command_cache_update
package tjc;
import tcl.lang.*;

public class CompileprocCommandCacheUpdateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "symbol");
        }
        setVarScalar(interp, "symbol", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set if_cond "..."
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            tmp0 = getVarScalar(interp, "symbol", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append("_cmdEpoch != ");
            tmp0 = getVarScalar(interp, "symbol", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(".cmdEpoch");
            tmp0 = TclString.newInstance(sbtmp1);
            setVarScalar(interp, "if_cond", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv2 = TJC.grabObjv(interp, 1);
            TclObject tmp3;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $if_cond
                    TclObject[] objv4 = TJC.grabObjv(interp, 2);
                    TclObject tmp5;
                    try {
                        // Arg 0 constant: ...
                        objv4[0] = const1;
                        // Arg 1 variable: $if_cond
                        tmp5 = getVarScalar(interp, "if_cond", compiledLocals, 2);
                        tmp5.preserve();
                        objv4[1] = tmp5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv4, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp5 = objv4[1];
                        if ( tmp5 != null ) {
                            tmp5.release();
                        }
                        TJC.releaseObjv(interp, objv4, 2);
                    }
                } // End Invoke: ...
                tmp3 = interp.getResult();
                tmp3.preserve();
                objv2[0] = tmp3;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv2, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv2, 1);
            }
        } // End Invoke: append
        { // Invoke: set cacheId [...]
            TclObject tmp6;
            { // Invoke: ... $symbol
                TclObject[] objv7 = TJC.grabObjv(interp, 2);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const2;
                    // Arg 1 variable: $symbol
                    tmp8 = getVarScalar(interp, "symbol", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 2);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "cacheId", tmp6, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: append buffer [...] [...]
            TclObject[] objv9 = TJC.grabObjv(interp, 2);
            TclObject tmp10;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv11 = TJC.grabObjv(interp, 2);
                    TclObject tmp12;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv11[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp13 = new StringBuffer(64);
                        sbtmp13.append("updateCmdCache(interp, ");
                        tmp12 = getVarScalar(interp, "cacheId", compiledLocals, 3);
                        sbtmp13.append(tmp12.toString());
                        sbtmp13.append(")");
                        tmp12 = TclString.newInstance(sbtmp13);
                        tmp12.preserve();
                        objv11[1] = tmp12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv11, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp12 = objv11[1];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        TJC.releaseObjv(interp, objv11, 2);
                    }
                } // End Invoke: emitter_statement
                tmp10 = interp.getResult();
                tmp10.preserve();
                objv9[0] = tmp10;
                // Arg 3 command: [...]
                { // Invoke: ...
                    TclObject[] objv14 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv14[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv14, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv14, 1);
                    }
                } // End Invoke: ...
                tmp10 = interp.getResult();
                tmp10.preserve();
                objv9[1] = tmp10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv9, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv9, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp15 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp15);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_command_cache_update");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_container_if_start");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_get_cache_id_from_symbol");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_statement");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_container_if_end");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 2: {
                cmdName = "compileproc_get_cache_id_from_symbol";
                break;
            }
            case 3: {
                cmdName = "emitter_statement";
                break;
            }
            case 4: {
                cmdName = "emitter_container_if_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "symbol",
        "buffer",
        "if_cond",
        "cacheId"
    };
} // end class CompileprocCommandCacheUpdateCmd

