// TJC implementation of procedure compileproc_compile
package tjc;
import tcl.lang.*;

public class CompileprocCompileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 17, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 3 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "proc_list class_name ?config_init?");
        }
        setVarScalar(interp, "proc_list", objv[1], compiledLocals, 0);
        setVarScalar(interp, "class_name", objv[2], compiledLocals, 1);
        setVarScalar(interp, "config_init", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 3);
        } // End Invoke: global
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 4);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: [...] != 3
            { // Invoke: llength $proc_list
                TclObject tmp0 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp3, tmp4);
            // End Binary operator: !=
            boolean tmp5 = ( tmp3.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "..."
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("expected ");
                        sbtmp8.append("{");
                        sbtmp8.append("PROC_NAME PROC_ARGS PROC_BODY");
                        sbtmp8.append("}");
                        sbtmp8.append(" : passed ");
                        { // Invoke: llength $proc_list
                            TclObject tmp9 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                            int tmp10 = TclList.getLength(interp, tmp9);
                            interp.setResult(tmp10);
                        } // End Invoke: llength
                        tmp7 = interp.getResult();
                        sbtmp8.append(tmp7.toString());
                        sbtmp8.append(" args");
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set name [...]
            TclObject tmp11;
            { // Invoke: lindex $proc_list 0
                TclObject tmp12 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp12 = TclList.index(interp, tmp12, 0);
                if ( tmp12 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp12);
                }
            } // End Invoke: lindex
            tmp11 = interp.getResult();
            setVarScalar(interp, "name", tmp11, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set args [...]
            TclObject tmp13;
            { // Invoke: lindex $proc_list 1
                TclObject tmp14 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp14 = TclList.index(interp, tmp14, 1);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "args", tmp13, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set body [...]
            TclObject tmp15;
            { // Invoke: lindex $proc_list 2
                TclObject tmp16 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp16 = TclList.index(interp, tmp16, 2);
                if ( tmp16 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp16);
                }
            } // End Invoke: lindex
            tmp15 = interp.getResult();
            setVarScalar(interp, "body", tmp15, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: compileproc_init
            TclObject[] objv17 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: compileproc_init
                objv17[0] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv17, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv17, 1);
            }
        } // End Invoke: compileproc_init
        { // Invoke: if {$config_init != {}} ...
            // Binary operator: $config_init != ""
            TclObject tmp18 = getVarScalar(interp, "config_init", compiledLocals, 2);
            ExprValue tmp19 = evs0;
            TJC.exprEqualsEmptyString(tmp19, tmp18, true);
            // End Binary operator: !=
            boolean tmp20 = ( tmp19.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: namespace eval :: [...]
                    TclObject[] objv21 = TJC.grabObjv(interp, 4);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: namespace
                        objv21[0] = const3;
                        // Arg 1 constant: eval
                        objv21[1] = const4;
                        // Arg 2 constant: ::
                        objv21[2] = const5;
                        // Arg 3 command: [...]
                        { // Invoke: list $config_init $name
                            TclObject tmp23 = TclList.newInstance();
                            TclObject tmp24;
                            try {
                                tmp24 = getVarScalar(interp, "config_init", compiledLocals, 2);
                                TclList.append(interp, tmp23, tmp24);
                                tmp24 = getVarScalar(interp, "name", compiledLocals, 5);
                                TclList.append(interp, tmp23, tmp24);
                            } catch (TclException ex) {
                                tmp23.release();
                                throw ex;
                            }
                            interp.setResult(tmp23);
                        } // End Invoke: list
                        tmp22 = interp.getResult();
                        tmp22.preserve();
                        objv21[3] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv21, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp22 = objv21[3];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 4);
                    }
                } // End Invoke: namespace
            }
        } // End Invoke: if
        { // Invoke: compileproc_start $proc_list
            TclObject[] objv25 = TJC.grabObjv(interp, 2);
            TclObject tmp26;
            try {
                // Arg 0 constant: compileproc_start
                objv25[0] = const6;
                // Arg 1 variable: $proc_list
                tmp26 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp26.preserve();
                objv25[1] = tmp26;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv25, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                tmp26 = objv25[1];
                if ( tmp26 != null ) {
                    tmp26.release();
                }
                TJC.releaseObjv(interp, objv25, 2);
            }
        } // End Invoke: compileproc_start
        { // Invoke: ... [...]
            TclObject[] objv27 = TJC.grabObjv(interp, 2);
            TclObject tmp28;
            try {
                // Arg 0 constant: ...
                objv27[0] = const7;
                // Arg 1 command: [...]
                { // Invoke: compileproc_keys
                    TclObject[] objv29 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: compileproc_keys
                        objv29[0] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv29, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv29, 1);
                    }
                } // End Invoke: compileproc_keys
                tmp28 = interp.getResult();
                tmp28.preserve();
                objv27[1] = tmp28;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                    ? cmdcache6.cmd : null), objv27, 0);
                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                    updateCmdCache(interp, 6);
                }
            } finally {
                tmp28 = objv27[1];
                if ( tmp28 != null ) {
                    tmp28.release();
                }
                TJC.releaseObjv(interp, objv27, 2);
            }
        } // End Invoke: ...
        { // Invoke: emitter_indent_level +2
            TclObject[] objv30 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv30[0] = const9;
                // Arg 1 constant: +2
                objv30[1] = const10;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv30, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv30, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set args_buffer [...]
            TclObject tmp31;
            { // Invoke: ... $args
                TclObject[] objv32 = TJC.grabObjv(interp, 2);
                TclObject tmp33;
                try {
                    // Arg 0 constant: ...
                    objv32[0] = const11;
                    // Arg 1 variable: $args
                    tmp33 = getVarScalar(interp, "args", compiledLocals, 6);
                    tmp33.preserve();
                    objv32[1] = tmp33;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv32, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp33 = objv32[1];
                    if ( tmp33 != null ) {
                        tmp33.release();
                    }
                    TJC.releaseObjv(interp, objv32, 2);
                }
            } // End Invoke: ...
            tmp31 = interp.getResult();
            setVarScalar(interp, "args_buffer", tmp31, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -2
            TclObject[] objv34 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv34[0] = const9;
                // Arg 1 constant: -2
                objv34[1] = const12;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv34, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv34, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set pair [...]
            TclObject tmp35;
            { // Invoke: ... $class_name
                TclObject[] objv36 = TJC.grabObjv(interp, 2);
                TclObject tmp37;
                try {
                    // Arg 0 constant: ...
                    objv36[0] = const13;
                    // Arg 1 variable: $class_name
                    tmp37 = getVarScalar(interp, "class_name", compiledLocals, 1);
                    tmp37.preserve();
                    objv36[1] = tmp37;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                        ? cmdcache9.cmd : null), objv36, 0);
                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                        updateCmdCache(interp, 9);
                    }
                } finally {
                    tmp37 = objv36[1];
                    if ( tmp37 != null ) {
                        tmp37.release();
                    }
                    TJC.releaseObjv(interp, objv36, 2);
                }
            } // End Invoke: ...
            tmp35 = interp.getResult();
            setVarScalar(interp, "pair", tmp35, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp38;
            { // Invoke: lindex $pair 0
                TclObject tmp39 = getVarScalar(interp, "pair", compiledLocals, 9);
                tmp39 = TclList.index(interp, tmp39, 0);
                if ( tmp39 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp39);
                }
            } // End Invoke: lindex
            tmp38 = interp.getResult();
            setVarArray(interp, "_compileproc", "package", tmp38, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp40;
            { // Invoke: lindex $pair 1
                TclObject tmp41 = getVarScalar(interp, "pair", compiledLocals, 9);
                tmp41 = TclList.index(interp, tmp41, 1);
                if ( tmp41 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp41);
                }
            } // End Invoke: lindex
            tmp40 = interp.getResult();
            setVarArray(interp, "_compileproc", "classname", tmp40, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv42 = TJC.grabObjv(interp, 1);
            TclObject tmp43;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $name
                    TclObject[] objv44 = TJC.grabObjv(interp, 2);
                    TclObject tmp45;
                    try {
                        // Arg 0 constant: ...
                        objv44[0] = const14;
                        // Arg 1 variable: $name
                        tmp45 = getVarScalar(interp, "name", compiledLocals, 5);
                        tmp45.preserve();
                        objv44[1] = tmp45;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                            ? cmdcache10.cmd : null), objv44, 0);
                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                            updateCmdCache(interp, 10);
                        }
                    } finally {
                        tmp45 = objv44[1];
                        if ( tmp45 != null ) {
                            tmp45.release();
                        }
                        TJC.releaseObjv(interp, objv44, 2);
                    }
                } // End Invoke: ...
                tmp43 = interp.getResult();
                tmp43.preserve();
                objv42[0] = tmp43;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv42, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv42, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv46 = TJC.grabObjv(interp, 1);
            TclObject tmp47;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_package_name $...
                    TclObject[] objv48 = TJC.grabObjv(interp, 2);
                    TclObject tmp49;
                    try {
                        // Arg 0 constant: emitter_package_name
                        objv48[0] = const15;
                        // Arg 1 variable: $...
                        tmp49 = getVarArray(interp, "_compileproc", "package", compiledLocals, 3);
                        tmp49.preserve();
                        objv48[1] = tmp49;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                            ? cmdcache11.cmd : null), objv48, 0);
                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                            updateCmdCache(interp, 11);
                        }
                    } finally {
                        tmp49 = objv48[1];
                        if ( tmp49 != null ) {
                            tmp49.release();
                        }
                        TJC.releaseObjv(interp, objv48, 2);
                    }
                } // End Invoke: emitter_package_name
                tmp47 = interp.getResult();
                tmp47.preserve();
                objv46[0] = tmp47;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv46, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv46, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv50 = TJC.grabObjv(interp, 1);
            TclObject tmp51;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_import_tcl
                    TclObject[] objv52 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_import_tcl
                        objv52[0] = const16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv52, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv52, 1);
                    }
                } // End Invoke: emitter_import_tcl
                tmp51 = interp.getResult();
                tmp51.preserve();
                objv50[0] = tmp51;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv50, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv50, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer ... [...]
            TclObject[] objv53 = TJC.grabObjv(interp, 2);
            TclObject tmp54;
            try {
                // Arg 2 constant: ...
                objv53[0] = const17;
                // Arg 3 command: [...]
                { // Invoke: emitter_class_start $...
                    TclObject[] objv55 = TJC.grabObjv(interp, 2);
                    TclObject tmp56;
                    try {
                        // Arg 0 constant: emitter_class_start
                        objv55[0] = const18;
                        // Arg 1 variable: $...
                        tmp56 = getVarArray(interp, "_compileproc", "classname", compiledLocals, 3);
                        tmp56.preserve();
                        objv55[1] = tmp56;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                            ? cmdcache13.cmd : null), objv55, 0);
                        if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                            updateCmdCache(interp, 13);
                        }
                    } finally {
                        tmp56 = objv55[1];
                        if ( tmp56 != null ) {
                            tmp56.release();
                        }
                        TJC.releaseObjv(interp, objv55, 2);
                    }
                } // End Invoke: emitter_class_start
                tmp54 = interp.getResult();
                tmp54.preserve();
                objv53[1] = tmp54;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv53, compiledLocals, 10);
            } finally {
                tmp54 = objv53[1];
                if ( tmp54 != null ) {
                    tmp54.release();
                }
                TJC.releaseObjv(interp, objv53, 2);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv57 = TJC.grabObjv(interp, 1);
            TclObject tmp58;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv59 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv59[0] = const19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                            ? cmdcache14.cmd : null), objv59, 0);
                        if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                            updateCmdCache(interp, 14);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv59, 1);
                    }
                } // End Invoke: ...
                tmp58 = interp.getResult();
                tmp58.preserve();
                objv57[0] = tmp58;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv57, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv57, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ...
            TclObject tmp60 = getVarArray(interp, "_compileproc_key_info", "cmd_needs_init", compiledLocals, 4);
            ExprValue tmp61 = evs0;
            TJC.exprInitValue(interp, tmp61, tmp60);
            boolean tmp62 = tmp61.getBooleanValue(interp);
            if ( tmp62 ) {
                { // Invoke: if ... ... else ...
                    TclObject tmp63 = getVarArray(interp, "_compileproc", "options,inline_commands", compiledLocals, 3);
                    ExprValue tmp64 = evs0;
                    TJC.exprInitValue(interp, tmp64, tmp63);
                    boolean tmp65 = tmp64.getBooleanValue(interp);
                    if ( tmp65 ) {
                        { // Invoke: lappend flags {inlineCmds}
                            TclObject[] objv66 = TJC.grabObjv(interp, 1);
                            TclObject tmp67;
                            try {
                                // Arg 2 constant: {inlineCmds}
                                objv66[0] = const20;
                                interp.resetResult();
                                lappendVarScalar(interp, "flags", objv66, compiledLocals, 11);
                            } finally {
                                TJC.releaseObjv(interp, objv66, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: set flags {}
                            setVarScalar(interp, "flags", const0, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv68 = TJC.grabObjv(interp, 1);
                    TclObject tmp69;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $flags
                            TclObject[] objv70 = TJC.grabObjv(interp, 2);
                            TclObject tmp71;
                            try {
                                // Arg 0 constant: ...
                                objv70[0] = const21;
                                // Arg 1 variable: $flags
                                tmp71 = getVarScalar(interp, "flags", compiledLocals, 11);
                                tmp71.preserve();
                                objv70[1] = tmp71;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                    ? cmdcache15.cmd : null), objv70, 0);
                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                    updateCmdCache(interp, 15);
                                }
                            } finally {
                                tmp71 = objv70[1];
                                if ( tmp71 != null ) {
                                    tmp71.release();
                                }
                                TJC.releaseObjv(interp, objv70, 2);
                            }
                        } // End Invoke: ...
                        tmp69 = interp.getResult();
                        tmp69.preserve();
                        objv68[0] = tmp69;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv68, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv68, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv72 = TJC.grabObjv(interp, 1);
            TclObject tmp73;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... wcmd.ns
                    TclObject[] objv74 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: ...
                        objv74[0] = const22;
                        // Arg 1 constant: wcmd.ns
                        objv74[1] = const23;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                            ? cmdcache16.cmd : null), objv74, 0);
                        if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                            updateCmdCache(interp, 16);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv74, 2);
                    }
                } // End Invoke: ...
                tmp73 = interp.getResult();
                tmp73.preserve();
                objv72[0] = tmp73;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv72, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv72, 1);
            }
        } // End Invoke: append
        { // Invoke: set body_bufer ""
            setVarScalar(interp, "body_bufer", const0, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: append body_buffer [...] $args_buffer
            TclObject[] objv75 = TJC.grabObjv(interp, 2);
            TclObject tmp76;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv77 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv77[0] = const24;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                            ? cmdcache17.cmd : null), objv77, 0);
                        if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                            updateCmdCache(interp, 17);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv77, 1);
                    }
                } // End Invoke: ...
                tmp76 = interp.getResult();
                tmp76.preserve();
                objv75[0] = tmp76;
                // Arg 3 variable: $args_buffer
                tmp76 = getVarScalar(interp, "args_buffer", compiledLocals, 8);
                tmp76.preserve();
                objv75[1] = tmp76;
                interp.resetResult();
                appendVarScalar(interp, "body_buffer", objv75, compiledLocals, 13);
            } finally {
                TJC.releaseObjvElems(interp, objv75, 2);
            }
        } // End Invoke: append
        { // Invoke: foreach key [...] ...
            TclObject tmp78 = null;
            try {
                { // Invoke: compileproc_keys
                    TclObject[] objv79 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: compileproc_keys
                        objv79[0] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv79, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv79, 1);
                    }
                } // End Invoke: compileproc_keys
                tmp78 = interp.getResult();
                tmp78.preserve();
                final int tmp78_length = TclList.getLength(interp, tmp78);

                for ( int index80 = 0 ; index80 < tmp78_length ; index80++ ) {
                    TclObject tmp81 = TclList.index(interp, tmp78, index80);
                    try {
                        setVarScalar(interp, "key", tmp81, compiledLocals, 14);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: append body_buffer [...]
                        TclObject[] objv82 = TJC.grabObjv(interp, 1);
                        TclObject tmp83;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $key
                                TclObject[] objv84 = TJC.grabObjv(interp, 2);
                                TclObject tmp85;
                                try {
                                    // Arg 0 constant: ...
                                    objv84[0] = const25;
                                    // Arg 1 variable: $key
                                    tmp85 = getVarScalar(interp, "key", compiledLocals, 14);
                                    tmp85.preserve();
                                    objv84[1] = tmp85;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                        ? cmdcache18.cmd : null), objv84, 0);
                                    if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                        updateCmdCache(interp, 18);
                                    }
                                } finally {
                                    tmp85 = objv84[1];
                                    if ( tmp85 != null ) {
                                        tmp85.release();
                                    }
                                    TJC.releaseObjv(interp, objv84, 2);
                                }
                            } // End Invoke: ...
                            tmp83 = interp.getResult();
                            tmp83.preserve();
                            objv82[0] = tmp83;
                            interp.resetResult();
                            appendVarScalar(interp, "body_buffer", objv82, compiledLocals, 13);
                        } finally {
                            TJC.releaseObjvElems(interp, objv82, 1);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp78 != null ) {
                    tmp78.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if ... ...
            { // Invoke: ...
                TclObject[] objv86 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv86[0] = const26;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                        ? cmdcache19.cmd : null), objv86, 0);
                    if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                        updateCmdCache(interp, 19);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv86, 1);
                }
            } // End Invoke: ...
            TclObject tmp87 = interp.getResult();
            ExprValue tmp88 = evs0;
            TJC.exprInitValue(interp, tmp88, tmp87);
            boolean tmp89 = tmp88.getBooleanValue(interp);
            if ( tmp89 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv90 = TJC.grabObjv(interp, 1);
                    TclObject tmp91;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... [...]
                            TclObject[] objv92 = TJC.grabObjv(interp, 2);
                            TclObject tmp93;
                            try {
                                // Arg 0 constant: ...
                                objv92[0] = const27;
                                // Arg 1 command: [...]
                                { // Invoke: ...
                                    TclObject[] objv94 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv94[0] = const28;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                                            ? cmdcache20.cmd : null), objv94, 0);
                                        if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                                            updateCmdCache(interp, 20);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv94, 1);
                                    }
                                } // End Invoke: ...
                                tmp93 = interp.getResult();
                                tmp93.preserve();
                                objv92[1] = tmp93;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache21_cmdEpoch == cmdcache21.cmdEpoch)
                                    ? cmdcache21.cmd : null), objv92, 0);
                                if ( cmdcache21_cmdEpoch != cmdcache21.cmdEpoch ) {
                                    updateCmdCache(interp, 21);
                                }
                            } finally {
                                tmp93 = objv92[1];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                TJC.releaseObjv(interp, objv92, 2);
                            }
                        } // End Invoke: ...
                        tmp91 = interp.getResult();
                        tmp91.preserve();
                        objv90[0] = tmp91;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv90, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv90, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: ...
                TclObject[] objv95 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv95[0] = const29;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache22_cmdEpoch == cmdcache22.cmdEpoch)
                        ? cmdcache22.cmd : null), objv95, 0);
                    if ( cmdcache22_cmdEpoch != cmdcache22.cmdEpoch ) {
                        updateCmdCache(interp, 22);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv95, 1);
                }
            } // End Invoke: ...
            TclObject tmp96 = interp.getResult();
            ExprValue tmp97 = evs0;
            TJC.exprInitValue(interp, tmp97, tmp96);
            boolean tmp98 = tmp97.getBooleanValue(interp);
            if ( tmp98 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv99 = TJC.grabObjv(interp, 1);
                    TclObject tmp100;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv101 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv101[0] = const30;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache23_cmdEpoch == cmdcache23.cmdEpoch)
                                    ? cmdcache23.cmd : null), objv101, 0);
                                if ( cmdcache23_cmdEpoch != cmdcache23.cmdEpoch ) {
                                    updateCmdCache(interp, 23);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv101, 1);
                            }
                        } // End Invoke: ...
                        tmp100 = interp.getResult();
                        tmp100.preserve();
                        objv99[0] = tmp100;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv99, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv99, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer $body_buffer
            TclObject[] objv102 = TJC.grabObjv(interp, 1);
            TclObject tmp103;
            try {
                // Arg 2 variable: $body_buffer
                tmp103 = getVarScalar(interp, "body_buffer", compiledLocals, 13);
                tmp103.preserve();
                objv102[0] = tmp103;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv102, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv102, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ... else ...
            { // Invoke: ...
                TclObject[] objv104 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv104[0] = const29;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache22_cmdEpoch == cmdcache22.cmdEpoch)
                        ? cmdcache22.cmd : null), objv104, 0);
                    if ( cmdcache22_cmdEpoch != cmdcache22.cmdEpoch ) {
                        updateCmdCache(interp, 22);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv104, 1);
                }
            } // End Invoke: ...
            TclObject tmp105 = interp.getResult();
            ExprValue tmp106 = evs0;
            TJC.exprInitValue(interp, tmp106, tmp105);
            boolean tmp107 = tmp106.getBooleanValue(interp);
            if ( tmp107 ) {
                { // Invoke: emitter_indent_level +1
                    TclObject[] objv108 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_indent_level
                        objv108[0] = const9;
                        // Arg 1 constant: +1
                        objv108[1] = const31;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv108, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv108, 2);
                    }
                } // End Invoke: emitter_indent_level
                { // Invoke: set expr_value_buffer [...]
                    TclObject tmp109;
                    { // Invoke: ...
                        TclObject[] objv110 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv110[0] = const32;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache24_cmdEpoch == cmdcache24.cmdEpoch)
                                ? cmdcache24.cmd : null), objv110, 0);
                            if ( cmdcache24_cmdEpoch != cmdcache24.cmdEpoch ) {
                                updateCmdCache(interp, 24);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv110, 1);
                        }
                    } // End Invoke: ...
                    tmp109 = interp.getResult();
                    setVarScalar(interp, "expr_value_buffer", tmp109, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: emitter_indent_level -1
                    TclObject[] objv111 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_indent_level
                        objv111[0] = const9;
                        // Arg 1 constant: -1
                        objv111[1] = const33;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv111, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv111, 2);
                    }
                } // End Invoke: emitter_indent_level
                { // Invoke: append buffer [...]
                    TclObject[] objv112 = TJC.grabObjv(interp, 1);
                    TclObject tmp113;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $name $expr_value_buffer
                            TclObject[] objv114 = TJC.grabObjv(interp, 3);
                            TclObject tmp115;
                            try {
                                // Arg 0 constant: ...
                                objv114[0] = const34;
                                // Arg 1 variable: $name
                                tmp115 = getVarScalar(interp, "name", compiledLocals, 5);
                                tmp115.preserve();
                                objv114[1] = tmp115;
                                // Arg 2 variable: $expr_value_buffer
                                tmp115 = getVarScalar(interp, "expr_value_buffer", compiledLocals, 15);
                                tmp115.preserve();
                                objv114[2] = tmp115;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache25_cmdEpoch == cmdcache25.cmdEpoch)
                                    ? cmdcache25.cmd : null), objv114, 0);
                                if ( cmdcache25_cmdEpoch != cmdcache25.cmdEpoch ) {
                                    updateCmdCache(interp, 25);
                                }
                            } finally {
                                tmp115 = objv114[1];
                                if ( tmp115 != null ) {
                                    tmp115.release();
                                }
                                tmp115 = objv114[2];
                                if ( tmp115 != null ) {
                                    tmp115.release();
                                }
                                TJC.releaseObjv(interp, objv114, 3);
                            }
                        } // End Invoke: ...
                        tmp113 = interp.getResult();
                        tmp113.preserve();
                        objv112[0] = tmp113;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv112, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv112, 1);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer [...]
                    TclObject[] objv116 = TJC.grabObjv(interp, 1);
                    TclObject tmp117;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $name
                            TclObject[] objv118 = TJC.grabObjv(interp, 2);
                            TclObject tmp119;
                            try {
                                // Arg 0 constant: ...
                                objv118[0] = const34;
                                // Arg 1 variable: $name
                                tmp119 = getVarScalar(interp, "name", compiledLocals, 5);
                                tmp119.preserve();
                                objv118[1] = tmp119;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache25_cmdEpoch == cmdcache25.cmdEpoch)
                                    ? cmdcache25.cmd : null), objv118, 0);
                                if ( cmdcache25_cmdEpoch != cmdcache25.cmdEpoch ) {
                                    updateCmdCache(interp, 25);
                                }
                            } finally {
                                tmp119 = objv118[1];
                                if ( tmp119 != null ) {
                                    tmp119.release();
                                }
                                TJC.releaseObjv(interp, objv118, 2);
                            }
                        } // End Invoke: ...
                        tmp117 = interp.getResult();
                        tmp117.preserve();
                        objv116[0] = tmp117;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv116, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv116, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv120 = TJC.grabObjv(interp, 1);
            TclObject tmp121;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_cmd_proc_end
                    TclObject[] objv122 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_cmd_proc_end
                        objv122[0] = const35;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache26_cmdEpoch == cmdcache26.cmdEpoch)
                            ? cmdcache26.cmd : null), objv122, 0);
                        if ( cmdcache26_cmdEpoch != cmdcache26.cmdEpoch ) {
                            updateCmdCache(interp, 26);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv122, 1);
                    }
                } // End Invoke: emitter_cmd_proc_end
                tmp121 = interp.getResult();
                tmp121.preserve();
                objv120[0] = tmp121;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv120, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv120, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ...
            TclObject tmp123 = getVarArray(interp, "_compileproc_key_info", "constants_found", compiledLocals, 4);
            ExprValue tmp124 = evs0;
            TJC.exprInitValue(interp, tmp124, tmp123);
            boolean tmp125 = tmp124.getBooleanValue(interp);
            if ( tmp125 ) {
                { // Invoke: set cdata [...]
                    TclObject tmp126;
                    { // Invoke: ...
                        TclObject[] objv127 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv127[0] = const36;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache27_cmdEpoch == cmdcache27.cmdEpoch)
                                ? cmdcache27.cmd : null), objv127, 0);
                            if ( cmdcache27_cmdEpoch != cmdcache27.cmdEpoch ) {
                                updateCmdCache(interp, 27);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv127, 1);
                        }
                    } // End Invoke: ...
                    tmp126 = interp.getResult();
                    setVarScalar(interp, "cdata", tmp126, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: if {$cdata != {}} ...
                    // Binary operator: $cdata != ""
                    TclObject tmp128 = getVarScalar(interp, "cdata", compiledLocals, 16);
                    ExprValue tmp129 = evs0;
                    TJC.exprEqualsEmptyString(tmp129, tmp128, true);
                    // End Binary operator: !=
                    boolean tmp130 = ( tmp129.getIntValue() != 0 );
                    if ( tmp130 ) {
                        { // Invoke: append buffer ... $cdata
                            TclObject[] objv131 = TJC.grabObjv(interp, 2);
                            TclObject tmp132;
                            try {
                                // Arg 2 constant: ...
                                objv131[0] = const17;
                                // Arg 3 variable: $cdata
                                tmp132 = getVarScalar(interp, "cdata", compiledLocals, 16);
                                tmp132.preserve();
                                objv131[1] = tmp132;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv131, compiledLocals, 10);
                            } finally {
                                tmp132 = objv131[1];
                                if ( tmp132 != null ) {
                                    tmp132.release();
                                }
                                TJC.releaseObjv(interp, objv131, 2);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp133 = getVarArray(interp, "_compileproc", "options,cache_commands", compiledLocals, 3);
            ExprValue tmp134 = evs0;
            TJC.exprInitValue(interp, tmp134, tmp133);
            boolean tmp135 = tmp134.getBooleanValue(interp);
            if ( tmp135 ) {
                { // Invoke: set cdata [...]
                    TclObject tmp136;
                    { // Invoke: ...
                        TclObject[] objv137 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv137[0] = const37;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache28_cmdEpoch == cmdcache28.cmdEpoch)
                                ? cmdcache28.cmd : null), objv137, 0);
                            if ( cmdcache28_cmdEpoch != cmdcache28.cmdEpoch ) {
                                updateCmdCache(interp, 28);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv137, 1);
                        }
                    } // End Invoke: ...
                    tmp136 = interp.getResult();
                    setVarScalar(interp, "cdata", tmp136, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: if {$cdata != ""} ...
                    // Binary operator: $cdata != ""
                    TclObject tmp138 = getVarScalar(interp, "cdata", compiledLocals, 16);
                    ExprValue tmp139 = evs0;
                    TJC.exprEqualsEmptyString(tmp139, tmp138, true);
                    // End Binary operator: !=
                    boolean tmp140 = ( tmp139.getIntValue() != 0 );
                    if ( tmp140 ) {
                        { // Invoke: append buffer ... $cdata
                            TclObject[] objv141 = TJC.grabObjv(interp, 2);
                            TclObject tmp142;
                            try {
                                // Arg 2 constant: ...
                                objv141[0] = const17;
                                // Arg 3 variable: $cdata
                                tmp142 = getVarScalar(interp, "cdata", compiledLocals, 16);
                                tmp142.preserve();
                                objv141[1] = tmp142;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv141, compiledLocals, 10);
                            } finally {
                                tmp142 = objv141[1];
                                if ( tmp142 != null ) {
                                    tmp142.release();
                                }
                                TJC.releaseObjv(interp, objv141, 2);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: ...
                TclObject[] objv143 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv143[0] = const26;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                        ? cmdcache19.cmd : null), objv143, 0);
                    if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                        updateCmdCache(interp, 19);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv143, 1);
                }
            } // End Invoke: ...
            TclObject tmp144 = interp.getResult();
            ExprValue tmp145 = evs0;
            TJC.exprInitValue(interp, tmp145, tmp144);
            boolean tmp146 = tmp145.getBooleanValue(interp);
            if ( tmp146 ) {
                { // Invoke: append buffer ... [...]
                    TclObject[] objv147 = TJC.grabObjv(interp, 2);
                    TclObject tmp148;
                    try {
                        // Arg 2 constant: ...
                        objv147[0] = const17;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv149 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv149[0] = const38;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache29_cmdEpoch == cmdcache29.cmdEpoch)
                                    ? cmdcache29.cmd : null), objv149, 0);
                                if ( cmdcache29_cmdEpoch != cmdcache29.cmdEpoch ) {
                                    updateCmdCache(interp, 29);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv149, 1);
                            }
                        } // End Invoke: ...
                        tmp148 = interp.getResult();
                        tmp148.preserve();
                        objv147[1] = tmp148;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv147, compiledLocals, 10);
                    } finally {
                        tmp148 = objv147[1];
                        if ( tmp148 != null ) {
                            tmp148.release();
                        }
                        TJC.releaseObjv(interp, objv147, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv150 = TJC.grabObjv(interp, 1);
            TclObject tmp151;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_class_end $...
                    TclObject[] objv152 = TJC.grabObjv(interp, 2);
                    TclObject tmp153;
                    try {
                        // Arg 0 constant: emitter_class_end
                        objv152[0] = const39;
                        // Arg 1 variable: $...
                        tmp153 = getVarArray(interp, "_compileproc", "classname", compiledLocals, 3);
                        tmp153.preserve();
                        objv152[1] = tmp153;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache30_cmdEpoch == cmdcache30.cmdEpoch)
                            ? cmdcache30.cmd : null), objv152, 0);
                        if ( cmdcache30_cmdEpoch != cmdcache30.cmdEpoch ) {
                            updateCmdCache(interp, 30);
                        }
                    } finally {
                        tmp153 = objv152[1];
                        if ( tmp153 != null ) {
                            tmp153.release();
                        }
                        TJC.releaseObjv(interp, objv152, 2);
                    }
                } // End Invoke: emitter_class_end
                tmp151 = interp.getResult();
                tmp151.preserve();
                objv150[0] = tmp151;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv150, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv150, 1);
            }
        } // End Invoke: append
        { // Invoke: ... proc
            TclObject[] objv154 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: ...
                objv154[0] = const40;
                // Arg 1 constant: proc
                objv154[1] = const41;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache31_cmdEpoch == cmdcache31.cmdEpoch)
                    ? cmdcache31.cmd : null), objv154, 0);
                if ( cmdcache31_cmdEpoch != cmdcache31.cmdEpoch ) {
                    updateCmdCache(interp, 31);
                }
            } finally {
                TJC.releaseObjv(interp, objv154, 2);
            }
        } // End Invoke: ...
        { // Invoke: set _compileproc(class) $buffer
            TclObject tmp155;
            tmp155 = getVarScalar(interp, "buffer", compiledLocals, 10);
            setVarArray(interp, "_compileproc", "class", tmp155, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: return $_compileproc(class)
            TclObject tmp156 = getVarArray(interp, "_compileproc", "class", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp156);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_compile");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_init");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("namespace");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("eval");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("::");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_start");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_scan_keys");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_keys");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_indent_level");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("+2");
        TclInteger.get(interp, const10);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_args_assign");
        const11.preserve(); const11.preserve();
        const12 = TclInteger.newInstance(-2);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_split_classname");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_class_comment");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_package_name");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_import_tcl");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("\n");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("emitter_class_start");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("emitter_cmd_proc_start");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("inlineCmds");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("emitter_init_cmd_check");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_callframe_push");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("wcmd.ns");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("emitter_callframe_try");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_emit_invoke");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("compileproc_variable_cache_is_used");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("emitter_callframe_init_compiledlocals");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("compileproc_variable_cache_count");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("compileproc_expr_value_stack_is_used");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("compileproc_expr_value_stack_generate");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("+1");
        TclInteger.get(interp, const31);
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("compileproc_expr_value_stack_release_generate");
        const32.preserve(); const32.preserve();
        const33 = TclInteger.newInstance(-1);
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("emitter_callframe_pop");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("emitter_cmd_proc_end");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("compileproc_constant_cache_generate");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("compileproc_command_cache_init_generate");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("compileproc_variable_cache_names_array");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("emitter_class_end");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("compileproc_pop_controls_context");
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("proc");
        const41.preserve(); const41.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;
    WrappedCommand cmdcache20;
    int cmdcache20_cmdEpoch;
    WrappedCommand cmdcache21;
    int cmdcache21_cmdEpoch;
    WrappedCommand cmdcache22;
    int cmdcache22_cmdEpoch;
    WrappedCommand cmdcache23;
    int cmdcache23_cmdEpoch;
    WrappedCommand cmdcache24;
    int cmdcache24_cmdEpoch;
    WrappedCommand cmdcache25;
    int cmdcache25_cmdEpoch;
    WrappedCommand cmdcache26;
    int cmdcache26_cmdEpoch;
    WrappedCommand cmdcache27;
    int cmdcache27_cmdEpoch;
    WrappedCommand cmdcache28;
    int cmdcache28_cmdEpoch;
    WrappedCommand cmdcache29;
    int cmdcache29_cmdEpoch;
    WrappedCommand cmdcache30;
    int cmdcache30_cmdEpoch;
    WrappedCommand cmdcache31;
    int cmdcache31_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                cmdcache20 = TJC.INVALID_COMMAND_CACHE;
                cmdcache20_cmdEpoch = 0;
                cmdcache21 = TJC.INVALID_COMMAND_CACHE;
                cmdcache21_cmdEpoch = 0;
                cmdcache22 = TJC.INVALID_COMMAND_CACHE;
                cmdcache22_cmdEpoch = 0;
                cmdcache23 = TJC.INVALID_COMMAND_CACHE;
                cmdcache23_cmdEpoch = 0;
                cmdcache24 = TJC.INVALID_COMMAND_CACHE;
                cmdcache24_cmdEpoch = 0;
                cmdcache25 = TJC.INVALID_COMMAND_CACHE;
                cmdcache25_cmdEpoch = 0;
                cmdcache26 = TJC.INVALID_COMMAND_CACHE;
                cmdcache26_cmdEpoch = 0;
                cmdcache27 = TJC.INVALID_COMMAND_CACHE;
                cmdcache27_cmdEpoch = 0;
                cmdcache28 = TJC.INVALID_COMMAND_CACHE;
                cmdcache28_cmdEpoch = 0;
                cmdcache29 = TJC.INVALID_COMMAND_CACHE;
                cmdcache29_cmdEpoch = 0;
                cmdcache30 = TJC.INVALID_COMMAND_CACHE;
                cmdcache30_cmdEpoch = 0;
                cmdcache31 = TJC.INVALID_COMMAND_CACHE;
                cmdcache31_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_init";
                break;
            }
            case 3: {
                cmdName = "namespace";
                break;
            }
            case 4: {
                cmdName = "compileproc_start";
                break;
            }
            case 5: {
                cmdName = "compileproc_keys";
                break;
            }
            case 6: {
                cmdName = "compileproc_scan_keys";
                break;
            }
            case 7: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 8: {
                cmdName = "compileproc_args_assign";
                break;
            }
            case 9: {
                cmdName = "compileproc_split_classname";
                break;
            }
            case 10: {
                cmdName = "emitter_class_comment";
                break;
            }
            case 11: {
                cmdName = "emitter_package_name";
                break;
            }
            case 12: {
                cmdName = "emitter_import_tcl";
                break;
            }
            case 13: {
                cmdName = "emitter_class_start";
                break;
            }
            case 14: {
                cmdName = "emitter_cmd_proc_start";
                break;
            }
            case 15: {
                cmdName = "emitter_init_cmd_check";
                break;
            }
            case 16: {
                cmdName = "emitter_callframe_push";
                break;
            }
            case 17: {
                cmdName = "emitter_callframe_try";
                break;
            }
            case 18: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 19: {
                cmdName = "compileproc_variable_cache_is_used";
                break;
            }
            case 20: {
                cmdName = "compileproc_variable_cache_count";
                break;
            }
            case 21: {
                cmdName = "emitter_callframe_init_compiledlocals";
                break;
            }
            case 22: {
                cmdName = "compileproc_expr_value_stack_is_used";
                break;
            }
            case 23: {
                cmdName = "compileproc_expr_value_stack_generate";
                break;
            }
            case 24: {
                cmdName = "compileproc_expr_value_stack_release_generate";
                break;
            }
            case 25: {
                cmdName = "emitter_callframe_pop";
                break;
            }
            case 26: {
                cmdName = "emitter_cmd_proc_end";
                break;
            }
            case 27: {
                cmdName = "compileproc_constant_cache_generate";
                break;
            }
            case 28: {
                cmdName = "compileproc_command_cache_init_generate";
                break;
            }
            case 29: {
                cmdName = "compileproc_variable_cache_names_array";
                break;
            }
            case 30: {
                cmdName = "emitter_class_end";
                break;
            }
            case 31: {
                cmdName = "compileproc_pop_controls_context";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
            case 20: {
                cmdcache20 = lwcmd;
                cmdcache20_cmdEpoch = cmdEpoch;
                break;
            }
            case 21: {
                cmdcache21 = lwcmd;
                cmdcache21_cmdEpoch = cmdEpoch;
                break;
            }
            case 22: {
                cmdcache22 = lwcmd;
                cmdcache22_cmdEpoch = cmdEpoch;
                break;
            }
            case 23: {
                cmdcache23 = lwcmd;
                cmdcache23_cmdEpoch = cmdEpoch;
                break;
            }
            case 24: {
                cmdcache24 = lwcmd;
                cmdcache24_cmdEpoch = cmdEpoch;
                break;
            }
            case 25: {
                cmdcache25 = lwcmd;
                cmdcache25_cmdEpoch = cmdEpoch;
                break;
            }
            case 26: {
                cmdcache26 = lwcmd;
                cmdcache26_cmdEpoch = cmdEpoch;
                break;
            }
            case 27: {
                cmdcache27 = lwcmd;
                cmdcache27_cmdEpoch = cmdEpoch;
                break;
            }
            case 28: {
                cmdcache28 = lwcmd;
                cmdcache28_cmdEpoch = cmdEpoch;
                break;
            }
            case 29: {
                cmdcache29 = lwcmd;
                cmdcache29_cmdEpoch = cmdEpoch;
                break;
            }
            case 30: {
                cmdcache30 = lwcmd;
                cmdcache30_cmdEpoch = cmdEpoch;
                break;
            }
            case 31: {
                cmdcache31 = lwcmd;
                cmdcache31_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_list",
        "class_name",
        "config_init",
        "_compileproc",
        "_compileproc_key_info",
        "name",
        "args",
        "body",
        "args_buffer",
        "pair",
        "buffer",
        "flags",
        "body_bufer",
        "body_buffer",
        "key",
        "expr_value_buffer",
        "cdata"
    };
} // end class CompileprocCompileCmd

