// TJC implementation of procedure compileproc_constant_cache_get
package tjc;
import tcl.lang.*;

public class CompileprocConstantCacheGetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tstr");
        }
        setVarScalar(interp, "tstr", objv[1], compiledLocals, 0);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_constant_cache", "_compileproc_constant_cache", 1);
        } // End Invoke: global
        { // Invoke: set key const,$tstr
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            sbtmp1.append("const,");
            tmp0 = getVarScalar(interp, "tstr", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            tmp0 = TclString.newInstance(sbtmp1);
            setVarScalar(interp, "key", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv2 = TJC.grabObjv(interp, 3);
                TclObject tmp3;
                try {
                    // Arg 0 constant: info
                    objv2[0] = const0;
                    // Arg 1 constant: exists
                    objv2[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp4 = new StringBuffer(64);
                    sbtmp4.append("_compileproc_constant_cache(");
                    tmp3 = getVarScalar(interp, "key", compiledLocals, 2);
                    sbtmp4.append(tmp3.toString());
                    sbtmp4.append(")");
                    tmp3 = TclString.newInstance(sbtmp4);
                    tmp3.preserve();
                    objv2[2] = tmp3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv2, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp3 = objv2[2];
                    if ( tmp3 != null ) {
                        tmp3.release();
                    }
                    TJC.releaseObjv(interp, objv2, 3);
                }
            } // End Invoke: info
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            if ( tmp5.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp6, tmp5);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp6, tmp5);
            }
            // End Unary operator: !
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: error "..."
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: error
                        objv8[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp10 = new StringBuffer(64);
                        sbtmp10.append("constant cache variable not found for ");
                        sbtmp10.append("\"");
                        tmp9 = getVarScalar(interp, "tstr", compiledLocals, 0);
                        sbtmp10.append(tmp9.toString());
                        sbtmp10.append("\"");
                        sbtmp10.append(", should have been setup via compileproc_constant_cache_add");
                        tmp9 = TclString.newInstance(sbtmp10);
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv8, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp9 = objv8[1];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set tuple $...
            TclObject tmp11;
            tmp11 = getVarScalar(interp, "key", compiledLocals, 2);
            tmp11 = getVarArray(interp, "_compileproc_constant_cache", tmp11.toString(), compiledLocals, 1);
            setVarScalar(interp, "tuple", tmp11, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ident [...]
            TclObject tmp12;
            { // Invoke: lindex $tuple 0
                TclObject tmp13 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp13 = TclList.index(interp, tmp13, 0);
                if ( tmp13 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp13);
                }
            } // End Invoke: lindex
            tmp12 = interp.getResult();
            setVarScalar(interp, "ident", tmp12, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$ident == {}} ...
            // Binary operator: $ident == ""
            TclObject tmp14 = getVarScalar(interp, "ident", compiledLocals, 4);
            ExprValue tmp15 = evs0;
            TJC.exprEqualsEmptyString(tmp15, tmp14, false);
            // End Binary operator: ==
            boolean tmp16 = ( tmp15.getIntValue() != 0 );
            if ( tmp16 ) {
                { // Invoke: set type [...]
                    TclObject tmp17;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp18 = getVarScalar(interp, "tuple", compiledLocals, 3);
                        tmp18 = TclList.index(interp, tmp18, 1);
                        if ( tmp18 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp18);
                        }
                    } // End Invoke: lindex
                    tmp17 = interp.getResult();
                    setVarScalar(interp, "type", tmp17, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set tstr [...]
                    TclObject tmp19;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp20 = getVarScalar(interp, "tuple", compiledLocals, 3);
                        tmp20 = TclList.index(interp, tmp20, 2);
                        if ( tmp20 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp20);
                        }
                    } // End Invoke: lindex
                    tmp19 = interp.getResult();
                    setVarScalar(interp, "tstr", tmp19, compiledLocals, 0);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Unary operator: ! [...]
                    { // Invoke: info exists ...
                        TclObject[] objv21 = TJC.grabObjv(interp, 3);
                        try {
                            // Arg 0 constant: info
                            objv21[0] = const0;
                            // Arg 1 constant: exists
                            objv21[1] = const1;
                            // Arg 2 constant: ...
                            objv21[2] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv21, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv21, 3);
                        }
                    } // End Invoke: info
                    TclObject tmp22 = interp.getResult();
                    ExprValue tmp23 = evs0;
                    if ( tmp22.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp23, tmp22);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp23, tmp22);
                    }
                    // End Unary operator: !
                    boolean tmp24 = ( tmp23.getIntValue() != 0 );
                    if ( tmp24 ) {
                        { // Invoke: set ... 0
                            setVarArray(interp, "_compileproc_constant_cache", "const_id", const4, compiledLocals, 1);
                        } // End Invoke: set
                    } else {
                        { // Invoke: incr ...
                            interp.resetResult();
                            incrVarArray(interp, "_compileproc_constant_cache", "const_id", 1, compiledLocals, 1);
                        } // End Invoke: incr
                    }
                } // End Invoke: if
                { // Invoke: set ident "..."
                    TclObject tmp25;
                    StringBuffer sbtmp26 = new StringBuffer(64);
                    sbtmp26.append("const");
                    tmp25 = getVarArray(interp, "_compileproc_constant_cache", "const_id", compiledLocals, 1);
                    sbtmp26.append(tmp25.toString());
                    tmp25 = TclString.newInstance(sbtmp26);
                    setVarScalar(interp, "ident", tmp25, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set tuple [...]
                    TclObject tmp27;
                    { // Invoke: list $ident $type $tstr
                        TclObject tmp28 = TclList.newInstance();
                        TclObject tmp29;
                        try {
                            tmp29 = getVarScalar(interp, "ident", compiledLocals, 4);
                            TclList.append(interp, tmp28, tmp29);
                            tmp29 = getVarScalar(interp, "type", compiledLocals, 5);
                            TclList.append(interp, tmp28, tmp29);
                            tmp29 = getVarScalar(interp, "tstr", compiledLocals, 0);
                            TclList.append(interp, tmp28, tmp29);
                        } catch (TclException ex) {
                            tmp28.release();
                            throw ex;
                        }
                        interp.setResult(tmp28);
                    } // End Invoke: list
                    tmp27 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp27, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set "..." $tuple
                    TclObject tmp30;
                    tmp30 = getVarScalar(interp, "key", compiledLocals, 2);
                    String tmp31 = tmp30.toString();
                    tmp30 = getVarScalar(interp, "tuple", compiledLocals, 3);
                    tmp30 = setVarArray(interp, "_compileproc_constant_cache", tmp31, tmp30, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: lappend ... $key
                    TclObject[] objv32 = TJC.grabObjv(interp, 1);
                    TclObject tmp33;
                    try {
                        // Arg 2 variable: $key
                        tmp33 = getVarScalar(interp, "key", compiledLocals, 2);
                        tmp33.preserve();
                        objv32[0] = tmp33;
                        interp.resetResult();
                        lappendVarArray(interp, "_compileproc_constant_cache", "ordered_keys", objv32, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv32, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: return $ident
            TclObject tmp34 = getVarScalar(interp, "ident", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp34);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_constant_cache_get");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_compileproc_constant_cache(const_id)");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tstr",
        "_compileproc_constant_cache",
        "key",
        "tuple",
        "ident",
        "type"
    };
} // end class CompileprocConstantCacheGetCmd

