// TJC implementation of procedure compileproc_container_catch_with_varname
package tjc;
import tcl.lang.*;

public class CompileprocContainerCatchWithVarnameCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                TclObject tmp1;
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp2 = new StringBuffer(64);
                    sbtmp2.append("_compileproc_ckeys(");
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp2.append(tmp1.toString());
                    sbtmp2.append(",info_key)");
                    tmp1 = TclString.newInstance(sbtmp2);
                    tmp1.preserve();
                    objv0[2] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[2];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp3 = interp.getResult();
            ExprValue tmp4 = evs0;
            if ( tmp3.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp4, tmp3);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp4, tmp3);
            }
            // End Unary operator: !
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: return {0 0}
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp6;
            { // Invoke: lindex $... 1
                TclObject tmp7;
                StringBuffer sbtmp8 = new StringBuffer(64);
                tmp7 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp8.append(tmp7.toString());
                sbtmp8.append(",info_key");
                tmp7 = getVarArray(interp, "_compileproc_ckeys", sbtmp8.toString(), compiledLocals, 1);
                tmp7 = TclList.index(interp, tmp7, 1);
                if ( tmp7 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp7);
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp6, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $cmdname == "_UNKNOWN"
            TclObject tmp9 = getVarScalar(interp, "cmdname", compiledLocals, 2);
            boolean tmp10 = tmp9.toString().equals("_UNKNOWN");
            ExprValue tmp11 = evs0;
            tmp11.setIntValue(tmp10);
            // End Binary operator: ==
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: return {0 0}
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: switch -exact -- $cmdname {::catch} - {catch} ... default ...
            TclObject tmp13 = getVarScalar(interp, "cmdname", compiledLocals, 2);
            String tmp14 = tmp13.toString();
            int tmp14_length = tmp14.length();
            char tmp14_first = '\n';
            if ( tmp14_length > 0 ) {
                tmp14_first = tmp14.charAt(0);
            }
            interp.resetResult();
            if ( ( tmp14_length == 7 && tmp14_first == ':'
                    && tmp14.compareTo("::catch") == 0 ) ||
                ( tmp14_length == 5 && tmp14_first == 'c'
                    && tmp14.compareTo("catch") == 0 ) ) {
                // Pattern {catch}
                { // Invoke: return [...]
                    { // Invoke: list 1 [...]
                        TclObject tmp15 = TclList.newInstance();
                        TclObject tmp16;
                        try {
                            TclList.append(interp, tmp15, const3);
                            { // Invoke: ... $key
                                TclObject[] objv17 = TJC.grabObjv(interp, 2);
                                TclObject tmp18;
                                try {
                                    // Arg 0 constant: ...
                                    objv17[0] = const4;
                                    // Arg 1 variable: $key
                                    tmp18 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp18.preserve();
                                    objv17[1] = tmp18;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv17, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp18 = objv17[1];
                                    if ( tmp18 != null ) {
                                        tmp18.release();
                                    }
                                    TJC.releaseObjv(interp, objv17, 2);
                                }
                            } // End Invoke: ...
                            tmp16 = interp.getResult();
                            TclList.append(interp, tmp15, tmp16);
                        } catch (TclException ex) {
                            tmp15.release();
                            throw ex;
                        }
                        interp.setResult(tmp15);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: return {0 0}
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_container_catch_with_varname");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("0 0");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_container_catch_has_variable");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "descend_container_catch_has_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc_ckeys",
        "cmdname"
    };
} // end class CompileprocContainerCatchWithVarnameCmd

