// TJC implementation of procedure compileproc_emit_container_for
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerForCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 25, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            if (!tmp3.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const2;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs1;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            tmp3.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp3.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp8 = ( tmp3.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("NOT valid or NOT static for key ");
                        tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set ccmds [...]
            TclObject tmp12;
            { // Invoke: descend_commands $key container
                TclObject[] objv13 = TJC.grabObjv(interp, 3);
                TclObject tmp14;
                try {
                    // Arg 0 constant: descend_commands
                    objv13[0] = const4;
                    // Arg 1 variable: $key
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    // Arg 2 constant: container
                    objv13[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv13, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 3);
                }
            } // End Invoke: descend_commands
            tmp12 = interp.getResult();
            setVarScalar(interp, "ccmds", tmp12, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 4
            { // Invoke: llength $ccmds
                TclObject tmp15 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            TclObject tmp17 = interp.getResult();
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            ExprValue tmp19 = evs1;
            tmp19.setIntValue(4);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp18, tmp19);
            // End Binary operator: !=
            boolean tmp20 = ( tmp18.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: error "..."
                    TclObject[] objv21 = TJC.grabObjv(interp, 2);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: error
                        objv21[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp23 = new StringBuffer(64);
                        sbtmp23.append("bad num container commands ");
                        sbtmp23.append("{");
                        tmp22 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append("}");
                        sbtmp23.append(" for key ");
                        tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp23.append(tmp22.toString());
                        tmp22 = TclString.newInstance(sbtmp23);
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv21, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp22 = objv21[1];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set start_keys [...]
            TclObject tmp24;
            { // Invoke: lindex $ccmds 0
                TclObject tmp25 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                tmp25 = TclList.index(interp, tmp25, 0);
                if ( tmp25 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp25);
                }
            } // End Invoke: lindex
            tmp24 = interp.getResult();
            setVarScalar(interp, "start_keys", tmp24, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set expr_keys [...]
            TclObject tmp26;
            { // Invoke: lindex $ccmds 1
                TclObject tmp27 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                tmp27 = TclList.index(interp, tmp27, 1);
                if ( tmp27 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp27);
                }
            } // End Invoke: lindex
            tmp26 = interp.getResult();
            setVarScalar(interp, "expr_keys", tmp26, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set next_keys [...]
            TclObject tmp28;
            { // Invoke: lindex $ccmds 2
                TclObject tmp29 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                tmp29 = TclList.index(interp, tmp29, 2);
                if ( tmp29 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp29);
                }
            } // End Invoke: lindex
            tmp28 = interp.getResult();
            setVarScalar(interp, "next_keys", tmp28, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set body_keys [...]
            TclObject tmp30;
            { // Invoke: lindex $ccmds 3
                TclObject tmp31 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                tmp31 = TclList.index(interp, tmp31, 3);
                if ( tmp31 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp31);
                }
            } // End Invoke: lindex
            tmp30 = interp.getResult();
            setVarScalar(interp, "body_keys", tmp30, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set start_index [...]
            TclObject tmp32;
            { // Invoke: ... $key
                TclObject[] objv33 = TJC.grabObjv(interp, 2);
                TclObject tmp34;
                try {
                    // Arg 0 constant: ...
                    objv33[0] = const6;
                    // Arg 1 variable: $key
                    tmp34 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp34.preserve();
                    objv33[1] = tmp34;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv33, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp34 = objv33[1];
                    if ( tmp34 != null ) {
                        tmp34.release();
                    }
                    TJC.releaseObjv(interp, objv33, 2);
                }
            } // End Invoke: ...
            tmp32 = interp.getResult();
            setVarScalar(interp, "start_index", tmp32, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set expr_index [...]
            TclObject tmp35;
            { // Invoke: ... $key
                TclObject[] objv36 = TJC.grabObjv(interp, 2);
                TclObject tmp37;
                try {
                    // Arg 0 constant: ...
                    objv36[0] = const7;
                    // Arg 1 variable: $key
                    tmp37 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp37.preserve();
                    objv36[1] = tmp37;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv36, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp37 = objv36[1];
                    if ( tmp37 != null ) {
                        tmp37.release();
                    }
                    TJC.releaseObjv(interp, objv36, 2);
                }
            } // End Invoke: ...
            tmp35 = interp.getResult();
            setVarScalar(interp, "expr_index", tmp35, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set next_index [...]
            TclObject tmp38;
            { // Invoke: ... $key
                TclObject[] objv39 = TJC.grabObjv(interp, 2);
                TclObject tmp40;
                try {
                    // Arg 0 constant: ...
                    objv39[0] = const8;
                    // Arg 1 variable: $key
                    tmp40 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp40.preserve();
                    objv39[1] = tmp40;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv39, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    tmp40 = objv39[1];
                    if ( tmp40 != null ) {
                        tmp40.release();
                    }
                    TJC.releaseObjv(interp, objv39, 2);
                }
            } // End Invoke: ...
            tmp38 = interp.getResult();
            setVarScalar(interp, "next_index", tmp38, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set body_index [...]
            TclObject tmp41;
            { // Invoke: ... $key
                TclObject[] objv42 = TJC.grabObjv(interp, 2);
                TclObject tmp43;
                try {
                    // Arg 0 constant: ...
                    objv42[0] = const9;
                    // Arg 1 variable: $key
                    tmp43 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp43.preserve();
                    objv42[1] = tmp43;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv42, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp43 = objv42[1];
                    if ( tmp43 != null ) {
                        tmp43.release();
                    }
                    TJC.releaseObjv(interp, objv42, 2);
                }
            } // End Invoke: ...
            tmp41 = interp.getResult();
            setVarScalar(interp, "body_index", tmp41, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: if {$start_keys != {}} ...
            // Binary operator: $start_keys != ""
            TclObject tmp44 = getVarScalar(interp, "start_keys", compiledLocals, 4);
            ExprValue tmp45 = evs0;
            TJC.exprEqualsEmptyString(tmp45, tmp44, true);
            // End Binary operator: !=
            boolean tmp46 = ( tmp45.getIntValue() != 0 );
            if ( tmp46 ) {
                { // Invoke: foreach start_key $start_keys ...
                    TclObject tmp47 = null;
                    try {
                        tmp47 = getVarScalar(interp, "start_keys", compiledLocals, 4);
                        tmp47.preserve();
                        final int tmp47_length = TclList.getLength(interp, tmp47);

                        for ( int index48 = 0 ; index48 < tmp47_length ; index48++ ) {
                            TclObject tmp49 = TclList.index(interp, tmp47, index48);
                            try {
                                setVarScalar(interp, "start_key", tmp49, compiledLocals, 12);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "start_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv50 = TJC.grabObjv(interp, 1);
                                TclObject tmp51;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $start_key
                                        TclObject[] objv52 = TJC.grabObjv(interp, 2);
                                        TclObject tmp53;
                                        try {
                                            // Arg 0 constant: ...
                                            objv52[0] = const10;
                                            // Arg 1 variable: $start_key
                                            tmp53 = getVarScalar(interp, "start_key", compiledLocals, 12);
                                            tmp53.preserve();
                                            objv52[1] = tmp53;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                ? cmdcache9.cmd : null), objv52, 0);
                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                updateCmdCache(interp, 9);
                                            }
                                        } finally {
                                            tmp53 = objv52[1];
                                            if ( tmp53 != null ) {
                                                tmp53.release();
                                            }
                                            TJC.releaseObjv(interp, objv52, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp51 = interp.getResult();
                                    tmp51.preserve();
                                    objv50[0] = tmp51;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv50, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv50, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp47 != null ) {
                            tmp47.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp54 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
            ExprValue tmp55 = evs0;
            TJC.exprInitValue(interp, tmp55, tmp54);
            boolean tmp56 = tmp55.getBooleanValue(interp);
            if ( tmp56 ) {
                { // Invoke: ... for 0 0
                    TclObject[] objv57 = TJC.grabObjv(interp, 4);
                    try {
                        // Arg 0 constant: ...
                        objv57[0] = const11;
                        // Arg 1 constant: for
                        objv57[1] = const12;
                        // Arg 2 constant: 0
                        objv57[2] = const13;
                        // Arg 3 constant: 0
                        objv57[3] = const13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                            ? cmdcache10.cmd : null), objv57, 0);
                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                            updateCmdCache(interp, 10);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv57, 4);
                    }
                } // End Invoke: ...
            }
        } // End Invoke: if
        { // Invoke: emitter_indent_level +1
            TclObject[] objv58 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv58[0] = const14;
                // Arg 1 constant: +1
                objv58[1] = const15;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                    ? cmdcache11.cmd : null), objv58, 0);
                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                    updateCmdCache(interp, 11);
                }
            } finally {
                TJC.releaseObjv(interp, objv58, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set tuple [...]
            TclObject tmp59;
            { // Invoke: ... $key $expr_index
                TclObject[] objv60 = TJC.grabObjv(interp, 3);
                TclObject tmp61;
                try {
                    // Arg 0 constant: ...
                    objv60[0] = const16;
                    // Arg 1 variable: $key
                    tmp61 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp61.preserve();
                    objv60[1] = tmp61;
                    // Arg 2 variable: $expr_index
                    tmp61 = getVarScalar(interp, "expr_index", compiledLocals, 9);
                    tmp61.preserve();
                    objv60[2] = tmp61;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                        ? cmdcache12.cmd : null), objv60, 0);
                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                        updateCmdCache(interp, 12);
                    }
                } finally {
                    tmp61 = objv60[1];
                    if ( tmp61 != null ) {
                        tmp61.release();
                    }
                    tmp61 = objv60[2];
                    if ( tmp61 != null ) {
                        tmp61.release();
                    }
                    TJC.releaseObjv(interp, objv60, 3);
                }
            } // End Invoke: ...
            tmp59 = interp.getResult();
            setVarScalar(interp, "tuple", tmp59, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -1
            TclObject[] objv62 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv62[0] = const14;
                // Arg 1 constant: -1
                objv62[1] = const17;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                    ? cmdcache11.cmd : null), objv62, 0);
                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                    updateCmdCache(interp, 11);
                }
            } finally {
                TJC.releaseObjv(interp, objv62, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if ... ...
            TclObject tmp63 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
            ExprValue tmp64 = evs0;
            TJC.exprInitValue(interp, tmp64, tmp63);
            boolean tmp65 = tmp64.getBooleanValue(interp);
            if ( tmp65 ) {
                { // Invoke: ... for
                    TclObject[] objv66 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: ...
                        objv66[0] = const18;
                        // Arg 1 constant: for
                        objv66[1] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                            ? cmdcache13.cmd : null), objv66, 0);
                        if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                            updateCmdCache(interp, 13);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv66, 2);
                    }
                } // End Invoke: ...
            }
        } // End Invoke: if
        { // Invoke: set tmpsymbol [...]
            TclObject tmp67;
            { // Invoke: lindex $tuple 0
                TclObject tmp68 = getVarScalar(interp, "tuple", compiledLocals, 13);
                tmp68 = TclList.index(interp, tmp68, 0);
                if ( tmp68 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp68);
                }
            } // End Invoke: lindex
            tmp67 = interp.getResult();
            setVarScalar(interp, "tmpsymbol", tmp67, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set tmpbuffer [...]
            TclObject tmp69;
            { // Invoke: lindex $tuple 1
                TclObject tmp70 = getVarScalar(interp, "tuple", compiledLocals, 13);
                tmp70 = TclList.index(interp, tmp70, 1);
                if ( tmp70 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp70);
                }
            } // End Invoke: lindex
            tmp69 = interp.getResult();
            setVarScalar(interp, "tmpbuffer", tmp69, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: set is_constant [...]
            TclObject tmp71;
            { // Invoke: lindex $tuple 2
                TclObject tmp72 = getVarScalar(interp, "tuple", compiledLocals, 13);
                tmp72 = TclList.index(interp, tmp72, 2);
                if ( tmp72 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp72);
                }
            } // End Invoke: lindex
            tmp71 = interp.getResult();
            setVarScalar(interp, "is_constant", tmp71, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: set is_constant_loopvar 1
            setVarScalar(interp, "is_constant_loopvar", const19, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: if {!$is_constant} ... else ...
            // Unary operator: ! $is_constant
            TclObject tmp73 = getVarScalar(interp, "is_constant", compiledLocals, 16);
            ExprValue tmp74 = evs0;
            if ( tmp73.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp74, tmp73);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp74, tmp73);
            }
            // End Unary operator: !
            boolean tmp75 = ( tmp74.getIntValue() != 0 );
            if ( tmp75 ) {
                { // Invoke: set is_constant_loopvar 1
                    setVarScalar(interp, "is_constant_loopvar", const19, compiledLocals, 17);
                } // End Invoke: set
            } else {
                { // Invoke: if ... ... elseif ... ... elseif ... ...
                    // Binary operator: $tmpsymbol == "false"
                    TclObject tmp76 = getVarScalar(interp, "tmpsymbol", compiledLocals, 14);
                    boolean tmp77 = tmp76.toString().equals("false");
                    ExprValue tmp78 = evs0;
                    tmp78.setIntValue(tmp77);
                    // End Binary operator: ==
                    boolean tmp79 = ( tmp78.getIntValue() != 0 );
                    if ( tmp79 ) {
                        { // Invoke: set is_constant_loopvar 0
                            setVarScalar(interp, "is_constant_loopvar", const13, compiledLocals, 17);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () && ()
                        // Binary operator: () && ()
                        // Binary operator: $tmpsymbol == "true"
                        TclObject tmp80 = getVarScalar(interp, "tmpsymbol", compiledLocals, 14);
                        boolean tmp81 = tmp80.toString().equals("true");
                        ExprValue tmp82 = evs0;
                        tmp82.setIntValue(tmp81);
                        // End Binary operator: ==
                        if (tmp82.getBooleanValue(interp)) {
                        // Binary operator: $body_keys == ""
                        TclObject tmp83 = getVarScalar(interp, "body_keys", compiledLocals, 7);
                        ExprValue tmp84 = evs1;
                        TJC.exprEqualsEmptyString(tmp84, tmp83, false);
                        // End Binary operator: ==
                        tmp82.setIntValue(tmp84.getBooleanValue(interp));
                        } else {
                        tmp82.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        if (tmp82.getBooleanValue(interp)) {
                        // Binary operator: $next_keys == ""
                        TclObject tmp85 = getVarScalar(interp, "next_keys", compiledLocals, 6);
                        ExprValue tmp86 = evs1;
                        TJC.exprEqualsEmptyString(tmp86, tmp85, false);
                        // End Binary operator: ==
                        tmp82.setIntValue(tmp86.getBooleanValue(interp));
                        } else {
                        tmp82.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp87 = ( tmp82.getIntValue() != 0 );
                        if ( tmp87 ) {
                            { // Invoke: set is_constant_loopvar 0
                                setVarScalar(interp, "is_constant_loopvar", const13, compiledLocals, 17);
                            } // End Invoke: set
                        } else {
                            // Binary operator: () && ()
                            // Binary operator: $tmpsymbol == "true"
                            TclObject tmp88 = getVarScalar(interp, "tmpsymbol", compiledLocals, 14);
                            boolean tmp89 = tmp88.toString().equals("true");
                            ExprValue tmp90 = evs0;
                            tmp90.setIntValue(tmp89);
                            // End Binary operator: ==
                            if (tmp90.getBooleanValue(interp)) {
                            // Binary operator: () || ()
                            // Binary operator: $body_keys != ""
                            TclObject tmp91 = getVarScalar(interp, "body_keys", compiledLocals, 7);
                            ExprValue tmp92 = evs1;
                            TJC.exprEqualsEmptyString(tmp92, tmp91, true);
                            // End Binary operator: !=
                            if (!tmp92.getBooleanValue(interp)) {
                            // Binary operator: $next_keys != ""
                            TclObject tmp93 = getVarScalar(interp, "next_keys", compiledLocals, 6);
                            ExprValue tmp94 = evs2;
                            TJC.exprEqualsEmptyString(tmp94, tmp93, true);
                            // End Binary operator: !=
                            tmp92.setIntValue(tmp94.getBooleanValue(interp));
                            } else {
                            tmp92.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            tmp90.setIntValue(tmp92.getBooleanValue(interp));
                            } else {
                            tmp90.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp95 = ( tmp90.getIntValue() != 0 );
                            if ( tmp95 ) {
                                { // Invoke: set is_constant_loopvar 1
                                    setVarScalar(interp, "is_constant_loopvar", const19, compiledLocals, 17);
                                } // End Invoke: set
                            }
                        }
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if {$next_keys != {}} ... else ...
            // Binary operator: $next_keys != ""
            TclObject tmp96 = getVarScalar(interp, "next_keys", compiledLocals, 6);
            ExprValue tmp97 = evs0;
            TJC.exprEqualsEmptyString(tmp97, tmp96, true);
            // End Binary operator: !=
            boolean tmp98 = ( tmp97.getIntValue() != 0 );
            if ( tmp98 ) {
                { // Invoke: set skip_tmpsymbol [...]
                    TclObject tmp99;
                    { // Invoke: ... skip
                        TclObject[] objv100 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: ...
                            objv100[0] = const20;
                            // Arg 1 constant: skip
                            objv100[1] = const21;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                ? cmdcache14.cmd : null), objv100, 0);
                            if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                updateCmdCache(interp, 14);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv100, 2);
                        }
                    } // End Invoke: ...
                    tmp99 = interp.getResult();
                    setVarScalar(interp, "skip_tmpsymbol", tmp99, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: set skip_init "..."
                    TclObject tmp101;
                    StringBuffer sbtmp102 = new StringBuffer(64);
                    tmp101 = getVarScalar(interp, "skip_tmpsymbol", compiledLocals, 18);
                    sbtmp102.append(tmp101.toString());
                    sbtmp102.append(" = true");
                    tmp101 = TclString.newInstance(sbtmp102);
                    setVarScalar(interp, "skip_init", tmp101, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: set skip_decl "boolean $skip_init"
                    TclObject tmp103;
                    StringBuffer sbtmp104 = new StringBuffer(64);
                    sbtmp104.append("boolean ");
                    tmp103 = getVarScalar(interp, "skip_init", compiledLocals, 19);
                    sbtmp104.append(tmp103.toString());
                    tmp103 = TclString.newInstance(sbtmp104);
                    setVarScalar(interp, "skip_decl", tmp103, compiledLocals, 20);
                } // End Invoke: set
            } else {
                { // Invoke: set skip_tmpsymbol ""
                    setVarScalar(interp, "skip_tmpsymbol", const0, compiledLocals, 18);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            TclObject tmp105 = getVarScalar(interp, "is_constant_loopvar", compiledLocals, 17);
            boolean tmp106 = TJC.getBoolean(interp, tmp105);
            if ( tmp106 ) {
                { // Invoke: set init_buffer ""
                    setVarScalar(interp, "init_buffer", const0, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $skip_tmpsymbol != ""
                    TclObject tmp107 = getVarScalar(interp, "skip_tmpsymbol", compiledLocals, 18);
                    ExprValue tmp108 = evs0;
                    TJC.exprEqualsEmptyString(tmp108, tmp107, true);
                    // End Binary operator: !=
                    boolean tmp109 = ( tmp108.getIntValue() != 0 );
                    if ( tmp109 ) {
                        { // Invoke: set init_buffer ${skip_decl}
                            TclObject tmp110;
                            tmp110 = getVarScalar(interp, "skip_decl", compiledLocals, 20);
                            setVarScalar(interp, "init_buffer", tmp110, compiledLocals, 21);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv111 = TJC.grabObjv(interp, 1);
                    TclObject tmp112;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $init_buffer true
                            TclObject[] objv113 = TJC.grabObjv(interp, 3);
                            TclObject tmp114;
                            try {
                                // Arg 0 constant: ...
                                objv113[0] = const22;
                                // Arg 1 variable: $init_buffer
                                tmp114 = getVarScalar(interp, "init_buffer", compiledLocals, 21);
                                tmp114.preserve();
                                objv113[1] = tmp114;
                                // Arg 2 constant: true
                                objv113[2] = const23;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                    ? cmdcache15.cmd : null), objv113, 0);
                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                    updateCmdCache(interp, 15);
                                }
                            } finally {
                                tmp114 = objv113[1];
                                if ( tmp114 != null ) {
                                    tmp114.release();
                                }
                                TJC.releaseObjv(interp, objv113, 3);
                            }
                        } // End Invoke: ...
                        tmp112 = interp.getResult();
                        tmp112.preserve();
                        objv111[0] = tmp112;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv111, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv111, 1);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: set bval $tmpsymbol
                    TclObject tmp115;
                    tmp115 = getVarScalar(interp, "tmpsymbol", compiledLocals, 14);
                    setVarScalar(interp, "bval", tmp115, compiledLocals, 22);
                } // End Invoke: set
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp116;
                    { // Invoke: ...
                        TclObject[] objv117 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv117[0] = const20;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                ? cmdcache14.cmd : null), objv117, 0);
                            if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                updateCmdCache(interp, 14);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv117, 1);
                        }
                    } // End Invoke: ...
                    tmp116 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp116, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set init_buffer "..."
                    TclObject tmp118;
                    StringBuffer sbtmp119 = new StringBuffer(64);
                    sbtmp119.append("boolean ");
                    tmp118 = getVarScalar(interp, "tmpsymbol", compiledLocals, 14);
                    sbtmp119.append(tmp118.toString());
                    sbtmp119.append(" = ");
                    tmp118 = getVarScalar(interp, "bval", compiledLocals, 22);
                    sbtmp119.append(tmp118.toString());
                    tmp118 = TclString.newInstance(sbtmp119);
                    setVarScalar(interp, "init_buffer", tmp118, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $skip_tmpsymbol != ""
                    TclObject tmp120 = getVarScalar(interp, "skip_tmpsymbol", compiledLocals, 18);
                    ExprValue tmp121 = evs0;
                    TJC.exprEqualsEmptyString(tmp121, tmp120, true);
                    // End Binary operator: !=
                    boolean tmp122 = ( tmp121.getIntValue() != 0 );
                    if ( tmp122 ) {
                        { // Invoke: append init_buffer ", $skip_init"
                            TclObject[] objv123 = TJC.grabObjv(interp, 1);
                            TclObject tmp124;
                            try {
                                // Arg 2 word: ", $skip_init"
                                StringBuffer sbtmp125 = new StringBuffer(64);
                                sbtmp125.append(", ");
                                tmp124 = getVarScalar(interp, "skip_init", compiledLocals, 19);
                                sbtmp125.append(tmp124.toString());
                                tmp124 = TclString.newInstance(sbtmp125);
                                tmp124.preserve();
                                objv123[0] = tmp124;
                                interp.resetResult();
                                appendVarScalar(interp, "init_buffer", objv123, compiledLocals, 21);
                            } finally {
                                TJC.releaseObjvElems(interp, objv123, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv126 = TJC.grabObjv(interp, 1);
                    TclObject tmp127;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $init_buffer $tmpsymbol
                            TclObject[] objv128 = TJC.grabObjv(interp, 3);
                            TclObject tmp129;
                            try {
                                // Arg 0 constant: ...
                                objv128[0] = const22;
                                // Arg 1 variable: $init_buffer
                                tmp129 = getVarScalar(interp, "init_buffer", compiledLocals, 21);
                                tmp129.preserve();
                                objv128[1] = tmp129;
                                // Arg 2 variable: $tmpsymbol
                                tmp129 = getVarScalar(interp, "tmpsymbol", compiledLocals, 14);
                                tmp129.preserve();
                                objv128[2] = tmp129;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                    ? cmdcache15.cmd : null), objv128, 0);
                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                    updateCmdCache(interp, 15);
                                }
                            } finally {
                                tmp129 = objv128[1];
                                if ( tmp129 != null ) {
                                    tmp129.release();
                                }
                                tmp129 = objv128[2];
                                if ( tmp129 != null ) {
                                    tmp129.release();
                                }
                                TJC.releaseObjv(interp, objv128, 3);
                            }
                        } // End Invoke: ...
                        tmp127 = interp.getResult();
                        tmp127.preserve();
                        objv126[0] = tmp127;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv126, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv126, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if {$next_keys != {}} ...
            // Binary operator: $next_keys != ""
            TclObject tmp130 = getVarScalar(interp, "next_keys", compiledLocals, 6);
            ExprValue tmp131 = evs0;
            TJC.exprEqualsEmptyString(tmp131, tmp130, true);
            // End Binary operator: !=
            boolean tmp132 = ( tmp131.getIntValue() != 0 );
            if ( tmp132 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv133 = TJC.grabObjv(interp, 1);
                    TclObject tmp134;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $skip_tmpsymbol
                            TclObject[] objv135 = TJC.grabObjv(interp, 2);
                            TclObject tmp136;
                            try {
                                // Arg 0 constant: ...
                                objv135[0] = const24;
                                // Arg 1 variable: $skip_tmpsymbol
                                tmp136 = getVarScalar(interp, "skip_tmpsymbol", compiledLocals, 18);
                                tmp136.preserve();
                                objv135[1] = tmp136;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                    ? cmdcache16.cmd : null), objv135, 0);
                                if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                    updateCmdCache(interp, 16);
                                }
                            } finally {
                                tmp136 = objv135[1];
                                if ( tmp136 != null ) {
                                    tmp136.release();
                                }
                                TJC.releaseObjv(interp, objv135, 2);
                            }
                        } // End Invoke: ...
                        tmp134 = interp.getResult();
                        tmp134.preserve();
                        objv133[0] = tmp134;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv133, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv133, 1);
                    }
                } // End Invoke: append
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv137 = TJC.grabObjv(interp, 2);
                    TclObject tmp138;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv139 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv139[0] = const25;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                    ? cmdcache17.cmd : null), objv139, 0);
                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                    updateCmdCache(interp, 17);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv139, 1);
                            }
                        } // End Invoke: ...
                        tmp138 = interp.getResult();
                        tmp138.preserve();
                        objv137[0] = tmp138;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv140 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv140[0] = const26;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                    ? cmdcache18.cmd : null), objv140, 0);
                                if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                    updateCmdCache(interp, 18);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv140, 1);
                            }
                        } // End Invoke: ...
                        tmp138 = interp.getResult();
                        tmp138.preserve();
                        objv137[1] = tmp138;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv137, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv137, 2);
                    }
                } // End Invoke: append
                { // Invoke: if ... ...
                    TclObject tmp141 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp142 = evs0;
                    TJC.exprInitValue(interp, tmp142, tmp141);
                    boolean tmp143 = tmp142.getBooleanValue(interp);
                    if ( tmp143 ) {
                        { // Invoke: ... for 1 0
                            TclObject[] objv144 = TJC.grabObjv(interp, 4);
                            try {
                                // Arg 0 constant: ...
                                objv144[0] = const11;
                                // Arg 1 constant: for
                                objv144[1] = const12;
                                // Arg 2 constant: 1
                                objv144[2] = const19;
                                // Arg 3 constant: 0
                                objv144[3] = const13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv144, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv144, 4);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: foreach next_key $next_keys ...
                    TclObject tmp145 = null;
                    try {
                        tmp145 = getVarScalar(interp, "next_keys", compiledLocals, 6);
                        tmp145.preserve();
                        final int tmp145_length = TclList.getLength(interp, tmp145);

                        for ( int index146 = 0 ; index146 < tmp145_length ; index146++ ) {
                            TclObject tmp147 = TclList.index(interp, tmp145, index146);
                            try {
                                setVarScalar(interp, "next_key", tmp147, compiledLocals, 23);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "next_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv148 = TJC.grabObjv(interp, 1);
                                TclObject tmp149;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $next_key
                                        TclObject[] objv150 = TJC.grabObjv(interp, 2);
                                        TclObject tmp151;
                                        try {
                                            // Arg 0 constant: ...
                                            objv150[0] = const10;
                                            // Arg 1 variable: $next_key
                                            tmp151 = getVarScalar(interp, "next_key", compiledLocals, 23);
                                            tmp151.preserve();
                                            objv150[1] = tmp151;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                ? cmdcache9.cmd : null), objv150, 0);
                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                updateCmdCache(interp, 9);
                                            }
                                        } finally {
                                            tmp151 = objv150[1];
                                            if ( tmp151 != null ) {
                                                tmp151.release();
                                            }
                                            TJC.releaseObjv(interp, objv150, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp149 = interp.getResult();
                                    tmp149.preserve();
                                    objv148[0] = tmp149;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv148, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv148, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp145 != null ) {
                            tmp145.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if ... ...
                    TclObject tmp152 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp153 = evs0;
                    TJC.exprInitValue(interp, tmp153, tmp152);
                    boolean tmp154 = tmp153.getBooleanValue(interp);
                    if ( tmp154 ) {
                        { // Invoke: ... for
                            TclObject[] objv155 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv155[0] = const18;
                                // Arg 1 constant: for
                                objv155[1] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                    ? cmdcache13.cmd : null), objv155, 0);
                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                    updateCmdCache(interp, 13);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv155, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...] [...] ...
                    TclObject[] objv156 = TJC.grabObjv(interp, 3);
                    TclObject tmp157;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... 0
                            TclObject[] objv158 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv158[0] = const27;
                                // Arg 1 constant: 0
                                objv158[1] = const13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                                    ? cmdcache19.cmd : null), objv158, 0);
                                if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                                    updateCmdCache(interp, 19);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv158, 2);
                            }
                        } // End Invoke: ...
                        tmp157 = interp.getResult();
                        tmp157.preserve();
                        objv156[0] = tmp157;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv159 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv159[0] = const28;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                                    ? cmdcache20.cmd : null), objv159, 0);
                                if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                                    updateCmdCache(interp, 20);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv159, 1);
                            }
                        } // End Invoke: ...
                        tmp157 = interp.getResult();
                        tmp157.preserve();
                        objv156[1] = tmp157;
                        // Arg 4 constant: ...
                        objv156[2] = const29;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv156, compiledLocals, 2);
                    } finally {
                        tmp157 = objv156[0];
                        if ( tmp157 != null ) {
                            tmp157.release();
                        }
                        tmp157 = objv156[1];
                        if ( tmp157 != null ) {
                            tmp157.release();
                        }
                        TJC.releaseObjv(interp, objv156, 3);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if {!$is_constant} ...
            // Unary operator: ! $is_constant
            TclObject tmp160 = getVarScalar(interp, "is_constant", compiledLocals, 16);
            ExprValue tmp161 = evs0;
            if ( tmp160.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp161, tmp160);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp161, tmp160);
            }
            // End Unary operator: !
            boolean tmp162 = ( tmp161.getIntValue() != 0 );
            if ( tmp162 ) {
                { // Invoke: append buffer $tmpbuffer [...]
                    TclObject[] objv163 = TJC.grabObjv(interp, 2);
                    TclObject tmp164;
                    try {
                        // Arg 2 variable: $tmpbuffer
                        tmp164 = getVarScalar(interp, "tmpbuffer", compiledLocals, 15);
                        tmp164.preserve();
                        objv163[0] = tmp164;
                        // Arg 3 command: [...]
                        { // Invoke: ... $tmpsymbol
                            TclObject[] objv165 = TJC.grabObjv(interp, 2);
                            TclObject tmp166;
                            try {
                                // Arg 0 constant: ...
                                objv165[0] = const30;
                                // Arg 1 variable: $tmpsymbol
                                tmp166 = getVarScalar(interp, "tmpsymbol", compiledLocals, 14);
                                tmp166.preserve();
                                objv165[1] = tmp166;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache21_cmdEpoch == cmdcache21.cmdEpoch)
                                    ? cmdcache21.cmd : null), objv165, 0);
                                if ( cmdcache21_cmdEpoch != cmdcache21.cmdEpoch ) {
                                    updateCmdCache(interp, 21);
                                }
                            } finally {
                                tmp166 = objv165[1];
                                if ( tmp166 != null ) {
                                    tmp166.release();
                                }
                                TJC.releaseObjv(interp, objv165, 2);
                            }
                        } // End Invoke: ...
                        tmp164 = interp.getResult();
                        tmp164.preserve();
                        objv163[1] = tmp164;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv163, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv163, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if {$body_keys != {}} ...
            // Binary operator: $body_keys != ""
            TclObject tmp167 = getVarScalar(interp, "body_keys", compiledLocals, 7);
            ExprValue tmp168 = evs0;
            TJC.exprEqualsEmptyString(tmp168, tmp167, true);
            // End Binary operator: !=
            boolean tmp169 = ( tmp168.getIntValue() != 0 );
            if ( tmp169 ) {
                { // Invoke: if {!$is_constant} ...
                    // Unary operator: ! $is_constant
                    TclObject tmp170 = getVarScalar(interp, "is_constant", compiledLocals, 16);
                    ExprValue tmp171 = evs0;
                    if ( tmp170.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp171, tmp170);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp171, tmp170);
                    }
                    // End Unary operator: !
                    boolean tmp172 = ( tmp171.getIntValue() != 0 );
                    if ( tmp172 ) {
                        { // Invoke: append buffer ...
                            TclObject[] objv173 = TJC.grabObjv(interp, 1);
                            TclObject tmp174;
                            try {
                                // Arg 2 constant: ...
                                objv173[0] = const29;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv173, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjv(interp, objv173, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv175 = TJC.grabObjv(interp, 2);
                    TclObject tmp176;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv177 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv177[0] = const25;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                    ? cmdcache17.cmd : null), objv177, 0);
                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                    updateCmdCache(interp, 17);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv177, 1);
                            }
                        } // End Invoke: ...
                        tmp176 = interp.getResult();
                        tmp176.preserve();
                        objv175[0] = tmp176;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv178 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv178[0] = const26;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                    ? cmdcache18.cmd : null), objv178, 0);
                                if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                    updateCmdCache(interp, 18);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv178, 1);
                            }
                        } // End Invoke: ...
                        tmp176 = interp.getResult();
                        tmp176.preserve();
                        objv175[1] = tmp176;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv175, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv175, 2);
                    }
                } // End Invoke: append
                { // Invoke: if ... ...
                    TclObject tmp179 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp180 = evs0;
                    TJC.exprInitValue(interp, tmp180, tmp179);
                    boolean tmp181 = tmp180.getBooleanValue(interp);
                    if ( tmp181 ) {
                        { // Invoke: ... for 1 1
                            TclObject[] objv182 = TJC.grabObjv(interp, 4);
                            try {
                                // Arg 0 constant: ...
                                objv182[0] = const11;
                                // Arg 1 constant: for
                                objv182[1] = const12;
                                // Arg 2 constant: 1
                                objv182[2] = const19;
                                // Arg 3 constant: 1
                                objv182[3] = const19;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv182, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv182, 4);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: foreach body_key $body_keys ...
                    TclObject tmp183 = null;
                    try {
                        tmp183 = getVarScalar(interp, "body_keys", compiledLocals, 7);
                        tmp183.preserve();
                        final int tmp183_length = TclList.getLength(interp, tmp183);

                        for ( int index184 = 0 ; index184 < tmp183_length ; index184++ ) {
                            TclObject tmp185 = TclList.index(interp, tmp183, index184);
                            try {
                                setVarScalar(interp, "body_key", tmp185, compiledLocals, 24);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "body_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv186 = TJC.grabObjv(interp, 1);
                                TclObject tmp187;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $body_key
                                        TclObject[] objv188 = TJC.grabObjv(interp, 2);
                                        TclObject tmp189;
                                        try {
                                            // Arg 0 constant: ...
                                            objv188[0] = const10;
                                            // Arg 1 variable: $body_key
                                            tmp189 = getVarScalar(interp, "body_key", compiledLocals, 24);
                                            tmp189.preserve();
                                            objv188[1] = tmp189;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                ? cmdcache9.cmd : null), objv188, 0);
                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                updateCmdCache(interp, 9);
                                            }
                                        } finally {
                                            tmp189 = objv188[1];
                                            if ( tmp189 != null ) {
                                                tmp189.release();
                                            }
                                            TJC.releaseObjv(interp, objv188, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp187 = interp.getResult();
                                    tmp187.preserve();
                                    objv186[0] = tmp187;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv186, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv186, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp183 != null ) {
                            tmp183.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if ... ...
                    TclObject tmp190 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp191 = evs0;
                    TJC.exprInitValue(interp, tmp191, tmp190);
                    boolean tmp192 = tmp191.getBooleanValue(interp);
                    if ( tmp192 ) {
                        { // Invoke: ... for
                            TclObject[] objv193 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv193[0] = const18;
                                // Arg 1 constant: for
                                objv193[1] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                    ? cmdcache13.cmd : null), objv193, 0);
                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                    updateCmdCache(interp, 13);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv193, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv194 = TJC.grabObjv(interp, 1);
                    TclObject tmp195;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv196 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv196[0] = const27;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                                    ? cmdcache19.cmd : null), objv196, 0);
                                if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                                    updateCmdCache(interp, 19);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv196, 1);
                            }
                        } // End Invoke: ...
                        tmp195 = interp.getResult();
                        tmp195.preserve();
                        objv194[0] = tmp195;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv194, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv194, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv197 = TJC.grabObjv(interp, 1);
            TclObject tmp198;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... [...]
                    TclObject[] objv199 = TJC.grabObjv(interp, 2);
                    TclObject tmp200;
                    try {
                        // Arg 0 constant: ...
                        objv199[0] = const31;
                        // Arg 1 command: [...]
                        { // Invoke: ... $key
                            TclObject[] objv201 = TJC.grabObjv(interp, 2);
                            TclObject tmp202;
                            try {
                                // Arg 0 constant: ...
                                objv201[0] = const32;
                                // Arg 1 variable: $key
                                tmp202 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp202.preserve();
                                objv201[1] = tmp202;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache22_cmdEpoch == cmdcache22.cmdEpoch)
                                    ? cmdcache22.cmd : null), objv201, 0);
                                if ( cmdcache22_cmdEpoch != cmdcache22.cmdEpoch ) {
                                    updateCmdCache(interp, 22);
                                }
                            } finally {
                                tmp202 = objv201[1];
                                if ( tmp202 != null ) {
                                    tmp202.release();
                                }
                                TJC.releaseObjv(interp, objv201, 2);
                            }
                        } // End Invoke: ...
                        tmp200 = interp.getResult();
                        tmp200.preserve();
                        objv199[1] = tmp200;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache23_cmdEpoch == cmdcache23.cmdEpoch)
                            ? cmdcache23.cmd : null), objv199, 0);
                        if ( cmdcache23_cmdEpoch != cmdcache23.cmdEpoch ) {
                            updateCmdCache(interp, 23);
                        }
                    } finally {
                        tmp200 = objv199[1];
                        if ( tmp200 != null ) {
                            tmp200.release();
                        }
                        TJC.releaseObjv(interp, objv199, 2);
                    }
                } // End Invoke: ...
                tmp198 = interp.getResult();
                tmp198.preserve();
                objv197[0] = tmp198;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv197, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv197, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp203 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp203);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_for");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_container_is_valid");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_is_static");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_commands");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("container");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_for_start");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_for_expr");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_for_next");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_container_for_body");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_emit_invoke");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_push_controls_context");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("for");
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(0);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_indent_level");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("+1");
        TclInteger.get(interp, const15);
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("compileproc_expr_evaluate_boolean_emit");
        const16.preserve(); const16.preserve();
        const17 = TclInteger.newInstance(-1);
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compileproc_pop_controls_context");
        const18.preserve(); const18.preserve();
        const19 = TclInteger.newInstance(1);
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("compileproc_tmpvar_next");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("skip");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_container_for_start");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("true");
        TclBoolean.get(interp, const23);
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("emitter_container_for_skip_start");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("emitter_container_for_try_start");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("emitter_container_fake_tclexception");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("emitter_container_for_try_end");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("emitter_container_for_skip_end");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("\n");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("emitter_container_for_expr");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("emitter_container_for_end");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("compileproc_omit_set_result");
        const32.preserve(); const32.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;
    WrappedCommand cmdcache20;
    int cmdcache20_cmdEpoch;
    WrappedCommand cmdcache21;
    int cmdcache21_cmdEpoch;
    WrappedCommand cmdcache22;
    int cmdcache22_cmdEpoch;
    WrappedCommand cmdcache23;
    int cmdcache23_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                cmdcache20 = TJC.INVALID_COMMAND_CACHE;
                cmdcache20_cmdEpoch = 0;
                cmdcache21 = TJC.INVALID_COMMAND_CACHE;
                cmdcache21_cmdEpoch = 0;
                cmdcache22 = TJC.INVALID_COMMAND_CACHE;
                cmdcache22_cmdEpoch = 0;
                cmdcache23 = TJC.INVALID_COMMAND_CACHE;
                cmdcache23_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 2: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "descend_commands";
                break;
            }
            case 5: {
                cmdName = "descend_container_for_start";
                break;
            }
            case 6: {
                cmdName = "descend_container_for_expr";
                break;
            }
            case 7: {
                cmdName = "descend_container_for_next";
                break;
            }
            case 8: {
                cmdName = "descend_container_for_body";
                break;
            }
            case 9: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 10: {
                cmdName = "compileproc_push_controls_context";
                break;
            }
            case 11: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 12: {
                cmdName = "compileproc_expr_evaluate_boolean_emit";
                break;
            }
            case 13: {
                cmdName = "compileproc_pop_controls_context";
                break;
            }
            case 14: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 15: {
                cmdName = "emitter_container_for_start";
                break;
            }
            case 16: {
                cmdName = "emitter_container_for_skip_start";
                break;
            }
            case 17: {
                cmdName = "emitter_container_for_try_start";
                break;
            }
            case 18: {
                cmdName = "emitter_container_fake_tclexception";
                break;
            }
            case 19: {
                cmdName = "emitter_container_for_try_end";
                break;
            }
            case 20: {
                cmdName = "emitter_container_for_skip_end";
                break;
            }
            case 21: {
                cmdName = "emitter_container_for_expr";
                break;
            }
            case 22: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 23: {
                cmdName = "emitter_container_for_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
            case 20: {
                cmdcache20 = lwcmd;
                cmdcache20_cmdEpoch = cmdEpoch;
                break;
            }
            case 21: {
                cmdcache21 = lwcmd;
                cmdcache21_cmdEpoch = cmdEpoch;
                break;
            }
            case 22: {
                cmdcache22 = lwcmd;
                cmdcache22_cmdEpoch = cmdEpoch;
                break;
            }
            case 23: {
                cmdcache23 = lwcmd;
                cmdcache23_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "ccmds",
        "start_keys",
        "expr_keys",
        "next_keys",
        "body_keys",
        "start_index",
        "expr_index",
        "next_index",
        "body_index",
        "start_key",
        "tuple",
        "tmpsymbol",
        "tmpbuffer",
        "is_constant",
        "is_constant_loopvar",
        "skip_tmpsymbol",
        "skip_init",
        "skip_decl",
        "init_buffer",
        "bval",
        "next_key",
        "body_key"
    };
} // end class CompileprocEmitContainerForCmd

