// TJC implementation of procedure compileproc_emit_container_while
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerWhileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 15, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            if (!tmp3.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const2;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs1;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            tmp3.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp3.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp8 = ( tmp3.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("NOT valid or NOT static for key ");
                        tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set ccmds [...]
            TclObject tmp12;
            { // Invoke: descend_commands $key container
                TclObject[] objv13 = TJC.grabObjv(interp, 3);
                TclObject tmp14;
                try {
                    // Arg 0 constant: descend_commands
                    objv13[0] = const4;
                    // Arg 1 variable: $key
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    // Arg 2 constant: container
                    objv13[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv13, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 3);
                }
            } // End Invoke: descend_commands
            tmp12 = interp.getResult();
            setVarScalar(interp, "ccmds", tmp12, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 2
            { // Invoke: llength $ccmds
                TclObject tmp15 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            TclObject tmp17 = interp.getResult();
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            ExprValue tmp19 = evs1;
            tmp19.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp18, tmp19);
            // End Binary operator: !=
            boolean tmp20 = ( tmp18.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: error "..."
                    TclObject[] objv21 = TJC.grabObjv(interp, 2);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: error
                        objv21[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp23 = new StringBuffer(64);
                        sbtmp23.append("bad num container commands ");
                        sbtmp23.append("{");
                        tmp22 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append("}");
                        sbtmp23.append(" for key ");
                        tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp23.append(tmp22.toString());
                        tmp22 = TclString.newInstance(sbtmp23);
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv21, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp22 = objv21[1];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set expr_keys [...]
            TclObject tmp24;
            { // Invoke: lindex $ccmds 0
                TclObject tmp25 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                tmp25 = TclList.index(interp, tmp25, 0);
                if ( tmp25 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp25);
                }
            } // End Invoke: lindex
            tmp24 = interp.getResult();
            setVarScalar(interp, "expr_keys", tmp24, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set body_keys [...]
            TclObject tmp26;
            { // Invoke: lindex $ccmds 1
                TclObject tmp27 = getVarScalar(interp, "ccmds", compiledLocals, 3);
                tmp27 = TclList.index(interp, tmp27, 1);
                if ( tmp27 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp27);
                }
            } // End Invoke: lindex
            tmp26 = interp.getResult();
            setVarScalar(interp, "body_keys", tmp26, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set expr_index [...]
            TclObject tmp28;
            { // Invoke: ... $key
                TclObject[] objv29 = TJC.grabObjv(interp, 2);
                TclObject tmp30;
                try {
                    // Arg 0 constant: ...
                    objv29[0] = const6;
                    // Arg 1 variable: $key
                    tmp30 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp30.preserve();
                    objv29[1] = tmp30;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv29, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp30 = objv29[1];
                    if ( tmp30 != null ) {
                        tmp30.release();
                    }
                    TJC.releaseObjv(interp, objv29, 2);
                }
            } // End Invoke: ...
            tmp28 = interp.getResult();
            setVarScalar(interp, "expr_index", tmp28, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            TclObject tmp31 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
            ExprValue tmp32 = evs0;
            TJC.exprInitValue(interp, tmp32, tmp31);
            boolean tmp33 = tmp32.getBooleanValue(interp);
            if ( tmp33 ) {
                { // Invoke: ... while 0 0
                    TclObject[] objv34 = TJC.grabObjv(interp, 4);
                    try {
                        // Arg 0 constant: ...
                        objv34[0] = const7;
                        // Arg 1 constant: while
                        objv34[1] = const8;
                        // Arg 2 constant: 0
                        objv34[2] = const9;
                        // Arg 3 constant: 0
                        objv34[3] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv34, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv34, 4);
                    }
                } // End Invoke: ...
            }
        } // End Invoke: if
        { // Invoke: emitter_indent_level +1
            TclObject[] objv35 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv35[0] = const10;
                // Arg 1 constant: +1
                objv35[1] = const11;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv35, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv35, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set tuple [...]
            TclObject tmp36;
            { // Invoke: ... $key $expr_index
                TclObject[] objv37 = TJC.grabObjv(interp, 3);
                TclObject tmp38;
                try {
                    // Arg 0 constant: ...
                    objv37[0] = const12;
                    // Arg 1 variable: $key
                    tmp38 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp38.preserve();
                    objv37[1] = tmp38;
                    // Arg 2 variable: $expr_index
                    tmp38 = getVarScalar(interp, "expr_index", compiledLocals, 6);
                    tmp38.preserve();
                    objv37[2] = tmp38;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv37, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp38 = objv37[1];
                    if ( tmp38 != null ) {
                        tmp38.release();
                    }
                    tmp38 = objv37[2];
                    if ( tmp38 != null ) {
                        tmp38.release();
                    }
                    TJC.releaseObjv(interp, objv37, 3);
                }
            } // End Invoke: ...
            tmp36 = interp.getResult();
            setVarScalar(interp, "tuple", tmp36, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -1
            TclObject[] objv39 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv39[0] = const10;
                // Arg 1 constant: -1
                objv39[1] = const13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv39, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv39, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if ... ...
            TclObject tmp40 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
            ExprValue tmp41 = evs0;
            TJC.exprInitValue(interp, tmp41, tmp40);
            boolean tmp42 = tmp41.getBooleanValue(interp);
            if ( tmp42 ) {
                { // Invoke: ... while
                    TclObject[] objv43 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: ...
                        objv43[0] = const14;
                        // Arg 1 constant: while
                        objv43[1] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv43, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv43, 2);
                    }
                } // End Invoke: ...
            }
        } // End Invoke: if
        { // Invoke: set tmpsymbol [...]
            TclObject tmp44;
            { // Invoke: lindex $tuple 0
                TclObject tmp45 = getVarScalar(interp, "tuple", compiledLocals, 7);
                tmp45 = TclList.index(interp, tmp45, 0);
                if ( tmp45 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp45);
                }
            } // End Invoke: lindex
            tmp44 = interp.getResult();
            setVarScalar(interp, "tmpsymbol", tmp44, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set tmpbuffer [...]
            TclObject tmp46;
            { // Invoke: lindex $tuple 1
                TclObject tmp47 = getVarScalar(interp, "tuple", compiledLocals, 7);
                tmp47 = TclList.index(interp, tmp47, 1);
                if ( tmp47 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp47);
                }
            } // End Invoke: lindex
            tmp46 = interp.getResult();
            setVarScalar(interp, "tmpbuffer", tmp46, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set is_constant [...]
            TclObject tmp48;
            { // Invoke: lindex $tuple 2
                TclObject tmp49 = getVarScalar(interp, "tuple", compiledLocals, 7);
                tmp49 = TclList.index(interp, tmp49, 2);
                if ( tmp49 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp49);
                }
            } // End Invoke: lindex
            tmp48 = interp.getResult();
            setVarScalar(interp, "is_constant", tmp48, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set is_constant_loopvar 1
            setVarScalar(interp, "is_constant_loopvar", const15, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: if {!$is_constant} ... else ...
            // Unary operator: ! $is_constant
            TclObject tmp50 = getVarScalar(interp, "is_constant", compiledLocals, 10);
            ExprValue tmp51 = evs0;
            if ( tmp50.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp51, tmp50);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp51, tmp50);
            }
            // End Unary operator: !
            boolean tmp52 = ( tmp51.getIntValue() != 0 );
            if ( tmp52 ) {
                { // Invoke: set is_constant_loopvar 1
                    setVarScalar(interp, "is_constant_loopvar", const15, compiledLocals, 11);
                } // End Invoke: set
            } else {
                { // Invoke: if ... ... elseif ... ... elseif ... ...
                    // Binary operator: $tmpsymbol == "false"
                    TclObject tmp53 = getVarScalar(interp, "tmpsymbol", compiledLocals, 8);
                    boolean tmp54 = tmp53.toString().equals("false");
                    ExprValue tmp55 = evs0;
                    tmp55.setIntValue(tmp54);
                    // End Binary operator: ==
                    boolean tmp56 = ( tmp55.getIntValue() != 0 );
                    if ( tmp56 ) {
                        { // Invoke: set is_constant_loopvar 0
                            setVarScalar(interp, "is_constant_loopvar", const9, compiledLocals, 11);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () && ()
                        // Binary operator: $tmpsymbol == "true"
                        TclObject tmp57 = getVarScalar(interp, "tmpsymbol", compiledLocals, 8);
                        boolean tmp58 = tmp57.toString().equals("true");
                        ExprValue tmp59 = evs0;
                        tmp59.setIntValue(tmp58);
                        // End Binary operator: ==
                        if (tmp59.getBooleanValue(interp)) {
                        // Binary operator: $body_keys == ""
                        TclObject tmp60 = getVarScalar(interp, "body_keys", compiledLocals, 5);
                        ExprValue tmp61 = evs1;
                        TJC.exprEqualsEmptyString(tmp61, tmp60, false);
                        // End Binary operator: ==
                        tmp59.setIntValue(tmp61.getBooleanValue(interp));
                        } else {
                        tmp59.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp62 = ( tmp59.getIntValue() != 0 );
                        if ( tmp62 ) {
                            { // Invoke: set is_constant_loopvar 0
                                setVarScalar(interp, "is_constant_loopvar", const9, compiledLocals, 11);
                            } // End Invoke: set
                        } else {
                            // Binary operator: () && ()
                            // Binary operator: $tmpsymbol == "true"
                            TclObject tmp63 = getVarScalar(interp, "tmpsymbol", compiledLocals, 8);
                            boolean tmp64 = tmp63.toString().equals("true");
                            ExprValue tmp65 = evs0;
                            tmp65.setIntValue(tmp64);
                            // End Binary operator: ==
                            if (tmp65.getBooleanValue(interp)) {
                            // Binary operator: $body_keys != ""
                            TclObject tmp66 = getVarScalar(interp, "body_keys", compiledLocals, 5);
                            ExprValue tmp67 = evs1;
                            TJC.exprEqualsEmptyString(tmp67, tmp66, true);
                            // End Binary operator: !=
                            tmp65.setIntValue(tmp67.getBooleanValue(interp));
                            } else {
                            tmp65.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp68 = ( tmp65.getIntValue() != 0 );
                            if ( tmp68 ) {
                                { // Invoke: set is_constant_loopvar 1
                                    setVarScalar(interp, "is_constant_loopvar", const15, compiledLocals, 11);
                                } // End Invoke: set
                            }
                        }
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            TclObject tmp69 = getVarScalar(interp, "is_constant_loopvar", compiledLocals, 11);
            boolean tmp70 = TJC.getBoolean(interp, tmp69);
            if ( tmp70 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv71 = TJC.grabObjv(interp, 1);
                    TclObject tmp72;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... {} true
                            TclObject[] objv73 = TJC.grabObjv(interp, 3);
                            try {
                                // Arg 0 constant: ...
                                objv73[0] = const16;
                                // Arg 1 constant: {}
                                objv73[1] = const0;
                                // Arg 2 constant: true
                                objv73[2] = const17;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv73, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv73, 3);
                            }
                        } // End Invoke: ...
                        tmp72 = interp.getResult();
                        tmp72.preserve();
                        objv71[0] = tmp72;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv71, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv71, 1);
                    }
                } // End Invoke: append
                { // Invoke: if {!$is_constant} ...
                    // Unary operator: ! $is_constant
                    TclObject tmp74 = getVarScalar(interp, "is_constant", compiledLocals, 10);
                    ExprValue tmp75 = evs0;
                    if ( tmp74.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp75, tmp74);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp75, tmp74);
                    }
                    // End Unary operator: !
                    boolean tmp76 = ( tmp75.getIntValue() != 0 );
                    if ( tmp76 ) {
                        { // Invoke: append buffer $tmpbuffer [...]
                            TclObject[] objv77 = TJC.grabObjv(interp, 2);
                            TclObject tmp78;
                            try {
                                // Arg 2 variable: $tmpbuffer
                                tmp78 = getVarScalar(interp, "tmpbuffer", compiledLocals, 9);
                                tmp78.preserve();
                                objv77[0] = tmp78;
                                // Arg 3 command: [...]
                                { // Invoke: ... $tmpsymbol
                                    TclObject[] objv79 = TJC.grabObjv(interp, 2);
                                    TclObject tmp80;
                                    try {
                                        // Arg 0 constant: ...
                                        objv79[0] = const18;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp80 = getVarScalar(interp, "tmpsymbol", compiledLocals, 8);
                                        tmp80.preserve();
                                        objv79[1] = tmp80;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv79, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        tmp80 = objv79[1];
                                        if ( tmp80 != null ) {
                                            tmp80.release();
                                        }
                                        TJC.releaseObjv(interp, objv79, 2);
                                    }
                                } // End Invoke: ...
                                tmp78 = interp.getResult();
                                tmp78.preserve();
                                objv77[1] = tmp78;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv77, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv77, 2);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set bval $tmpsymbol
                    TclObject tmp81;
                    tmp81 = getVarScalar(interp, "tmpsymbol", compiledLocals, 8);
                    setVarScalar(interp, "bval", tmp81, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp82;
                    { // Invoke: ...
                        TclObject[] objv83 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv83[0] = const19;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                ? cmdcache12.cmd : null), objv83, 0);
                            if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                updateCmdCache(interp, 12);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv83, 1);
                        }
                    } // End Invoke: ...
                    tmp82 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp82, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set init_buffer "..."
                    TclObject tmp84;
                    StringBuffer sbtmp85 = new StringBuffer(64);
                    sbtmp85.append("boolean ");
                    tmp84 = getVarScalar(interp, "tmpsymbol", compiledLocals, 8);
                    sbtmp85.append(tmp84.toString());
                    sbtmp85.append(" = ");
                    tmp84 = getVarScalar(interp, "bval", compiledLocals, 12);
                    sbtmp85.append(tmp84.toString());
                    tmp84 = TclString.newInstance(sbtmp85);
                    setVarScalar(interp, "init_buffer", tmp84, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv86 = TJC.grabObjv(interp, 1);
                    TclObject tmp87;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $init_buffer $tmpsymbol
                            TclObject[] objv88 = TJC.grabObjv(interp, 3);
                            TclObject tmp89;
                            try {
                                // Arg 0 constant: ...
                                objv88[0] = const16;
                                // Arg 1 variable: $init_buffer
                                tmp89 = getVarScalar(interp, "init_buffer", compiledLocals, 13);
                                tmp89.preserve();
                                objv88[1] = tmp89;
                                // Arg 2 variable: $tmpsymbol
                                tmp89 = getVarScalar(interp, "tmpsymbol", compiledLocals, 8);
                                tmp89.preserve();
                                objv88[2] = tmp89;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv88, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                tmp89 = objv88[1];
                                if ( tmp89 != null ) {
                                    tmp89.release();
                                }
                                tmp89 = objv88[2];
                                if ( tmp89 != null ) {
                                    tmp89.release();
                                }
                                TJC.releaseObjv(interp, objv88, 3);
                            }
                        } // End Invoke: ...
                        tmp87 = interp.getResult();
                        tmp87.preserve();
                        objv86[0] = tmp87;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv86, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv86, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if {$body_keys != {}} ...
            // Binary operator: $body_keys != ""
            TclObject tmp90 = getVarScalar(interp, "body_keys", compiledLocals, 5);
            ExprValue tmp91 = evs0;
            TJC.exprEqualsEmptyString(tmp91, tmp90, true);
            // End Binary operator: !=
            boolean tmp92 = ( tmp91.getIntValue() != 0 );
            if ( tmp92 ) {
                { // Invoke: if {!$is_constant} ...
                    // Unary operator: ! $is_constant
                    TclObject tmp93 = getVarScalar(interp, "is_constant", compiledLocals, 10);
                    ExprValue tmp94 = evs0;
                    if ( tmp93.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp94, tmp93);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp94, tmp93);
                    }
                    // End Unary operator: !
                    boolean tmp95 = ( tmp94.getIntValue() != 0 );
                    if ( tmp95 ) {
                        { // Invoke: append buffer ...
                            TclObject[] objv96 = TJC.grabObjv(interp, 1);
                            TclObject tmp97;
                            try {
                                // Arg 2 constant: ...
                                objv96[0] = const20;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv96, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjv(interp, objv96, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv98 = TJC.grabObjv(interp, 2);
                    TclObject tmp99;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv100 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv100[0] = const21;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                    ? cmdcache13.cmd : null), objv100, 0);
                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                    updateCmdCache(interp, 13);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv100, 1);
                            }
                        } // End Invoke: ...
                        tmp99 = interp.getResult();
                        tmp99.preserve();
                        objv98[0] = tmp99;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv101 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv101[0] = const22;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv101, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv101, 1);
                            }
                        } // End Invoke: ...
                        tmp99 = interp.getResult();
                        tmp99.preserve();
                        objv98[1] = tmp99;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv98, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv98, 2);
                    }
                } // End Invoke: append
                { // Invoke: if ... ...
                    TclObject tmp102 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp103 = evs0;
                    TJC.exprInitValue(interp, tmp103, tmp102);
                    boolean tmp104 = tmp103.getBooleanValue(interp);
                    if ( tmp104 ) {
                        { // Invoke: ... while 1 1
                            TclObject[] objv105 = TJC.grabObjv(interp, 4);
                            try {
                                // Arg 0 constant: ...
                                objv105[0] = const7;
                                // Arg 1 constant: while
                                objv105[1] = const8;
                                // Arg 2 constant: 1
                                objv105[2] = const15;
                                // Arg 3 constant: 1
                                objv105[3] = const15;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv105, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv105, 4);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: foreach body_key $body_keys ...
                    TclObject tmp106 = null;
                    try {
                        tmp106 = getVarScalar(interp, "body_keys", compiledLocals, 5);
                        tmp106.preserve();
                        final int tmp106_length = TclList.getLength(interp, tmp106);

                        for ( int index107 = 0 ; index107 < tmp106_length ; index107++ ) {
                            TclObject tmp108 = TclList.index(interp, tmp106, index107);
                            try {
                                setVarScalar(interp, "body_key", tmp108, compiledLocals, 14);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "body_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv109 = TJC.grabObjv(interp, 1);
                                TclObject tmp110;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $body_key
                                        TclObject[] objv111 = TJC.grabObjv(interp, 2);
                                        TclObject tmp112;
                                        try {
                                            // Arg 0 constant: ...
                                            objv111[0] = const23;
                                            // Arg 1 variable: $body_key
                                            tmp112 = getVarScalar(interp, "body_key", compiledLocals, 14);
                                            tmp112.preserve();
                                            objv111[1] = tmp112;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                                ? cmdcache15.cmd : null), objv111, 0);
                                            if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                                updateCmdCache(interp, 15);
                                            }
                                        } finally {
                                            tmp112 = objv111[1];
                                            if ( tmp112 != null ) {
                                                tmp112.release();
                                            }
                                            TJC.releaseObjv(interp, objv111, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp110 = interp.getResult();
                                    tmp110.preserve();
                                    objv109[0] = tmp110;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv109, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv109, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp106 != null ) {
                            tmp106.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if ... ...
                    TclObject tmp113 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp114 = evs0;
                    TJC.exprInitValue(interp, tmp114, tmp113);
                    boolean tmp115 = tmp114.getBooleanValue(interp);
                    if ( tmp115 ) {
                        { // Invoke: ... while
                            TclObject[] objv116 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv116[0] = const14;
                                // Arg 1 constant: while
                                objv116[1] = const8;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv116, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv116, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv117 = TJC.grabObjv(interp, 1);
                    TclObject tmp118;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv119 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv119[0] = const24;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                    ? cmdcache16.cmd : null), objv119, 0);
                                if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                    updateCmdCache(interp, 16);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv119, 1);
                            }
                        } // End Invoke: ...
                        tmp118 = interp.getResult();
                        tmp118.preserve();
                        objv117[0] = tmp118;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv117, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv117, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv120 = TJC.grabObjv(interp, 1);
            TclObject tmp121;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... [...]
                    TclObject[] objv122 = TJC.grabObjv(interp, 2);
                    TclObject tmp123;
                    try {
                        // Arg 0 constant: ...
                        objv122[0] = const25;
                        // Arg 1 command: [...]
                        { // Invoke: ... $key
                            TclObject[] objv124 = TJC.grabObjv(interp, 2);
                            TclObject tmp125;
                            try {
                                // Arg 0 constant: ...
                                objv124[0] = const26;
                                // Arg 1 variable: $key
                                tmp125 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp125.preserve();
                                objv124[1] = tmp125;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                    ? cmdcache17.cmd : null), objv124, 0);
                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                    updateCmdCache(interp, 17);
                                }
                            } finally {
                                tmp125 = objv124[1];
                                if ( tmp125 != null ) {
                                    tmp125.release();
                                }
                                TJC.releaseObjv(interp, objv124, 2);
                            }
                        } // End Invoke: ...
                        tmp123 = interp.getResult();
                        tmp123.preserve();
                        objv122[1] = tmp123;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                            ? cmdcache18.cmd : null), objv122, 0);
                        if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                            updateCmdCache(interp, 18);
                        }
                    } finally {
                        tmp123 = objv122[1];
                        if ( tmp123 != null ) {
                            tmp123.release();
                        }
                        TJC.releaseObjv(interp, objv122, 2);
                    }
                } // End Invoke: ...
                tmp121 = interp.getResult();
                tmp121.preserve();
                objv120[0] = tmp121;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv120, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv120, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp126 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp126);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_while");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_container_is_valid");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_is_static");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_commands");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("container");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_while_expr");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_push_controls_context");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("while");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(0);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_indent_level");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("+1");
        TclInteger.get(interp, const11);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_expr_evaluate_boolean_emit");
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(-1);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_pop_controls_context");
        const14.preserve(); const14.preserve();
        const15 = TclInteger.newInstance(1);
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_container_for_start");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("true");
        TclBoolean.get(interp, const17);
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("emitter_container_for_expr");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("compileproc_tmpvar_next");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("\n");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("emitter_container_for_try_start");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_container_fake_tclexception");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("compileproc_emit_invoke");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("emitter_container_for_try_end");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("emitter_container_for_end");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("compileproc_omit_set_result");
        const26.preserve(); const26.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 2: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "descend_commands";
                break;
            }
            case 5: {
                cmdName = "descend_container_while_expr";
                break;
            }
            case 6: {
                cmdName = "compileproc_push_controls_context";
                break;
            }
            case 7: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 8: {
                cmdName = "compileproc_expr_evaluate_boolean_emit";
                break;
            }
            case 9: {
                cmdName = "compileproc_pop_controls_context";
                break;
            }
            case 10: {
                cmdName = "emitter_container_for_start";
                break;
            }
            case 11: {
                cmdName = "emitter_container_for_expr";
                break;
            }
            case 12: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 13: {
                cmdName = "emitter_container_for_try_start";
                break;
            }
            case 14: {
                cmdName = "emitter_container_fake_tclexception";
                break;
            }
            case 15: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 16: {
                cmdName = "emitter_container_for_try_end";
                break;
            }
            case 17: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 18: {
                cmdName = "emitter_container_for_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "ccmds",
        "expr_keys",
        "body_keys",
        "expr_index",
        "tuple",
        "tmpsymbol",
        "tmpbuffer",
        "is_constant",
        "is_constant_loopvar",
        "bval",
        "init_buffer",
        "body_key"
    };
} // end class CompileprocEmitContainerWhileCmd

