// TJC implementation of procedure compileproc_emit_control
package tjc;
import tcl.lang.*;

public class CompileprocEmitControlCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: set cmdname [...]
            TclObject tmp0;
            { // Invoke: lindex $... 1
                TclObject tmp1;
                StringBuffer sbtmp2 = new StringBuffer(64);
                tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp2.append(tmp1.toString());
                sbtmp2.append(",info_key");
                tmp1 = getVarArray(interp, "_compileproc_ckeys", sbtmp2.toString(), compiledLocals, 2);
                tmp1 = TclList.index(interp, tmp1, 1);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: switch -exact -- $cmdname {::break} - {break} ... {::continue} - {continue} ... {::return} - {return} ... default ...
            TclObject tmp3 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            String tmp4 = tmp3.toString();
            int tmp4_length = tmp4.length();
            char tmp4_first = '\n';
            if ( tmp4_length > 0 ) {
                tmp4_first = tmp4.charAt(0);
            }
            if ( ( tmp4_length == 7 && tmp4_first == ':'
                    && tmp4.compareTo("::break") == 0 ) ||
                ( tmp4_length == 5 && tmp4_first == 'b'
                    && tmp4.compareTo("break") == 0 ) ) {
                // Pattern {break}
                { // Invoke: set statement "break"
                    setVarScalar(interp, "statement", const0, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp4_length == 10 && tmp4_first == ':'
                    && tmp4.compareTo("::continue") == 0 ) ||
                ( tmp4_length == 8 && tmp4_first == 'c'
                    && tmp4.compareTo("continue") == 0 ) ) {
                // Pattern {continue}
                { // Invoke: set statement "continue"
                    setVarScalar(interp, "statement", const1, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp4_length == 8 && tmp4_first == ':'
                    && tmp4.compareTo("::return") == 0 ) ||
                ( tmp4_length == 6 && tmp4_first == 'r'
                    && tmp4.compareTo("return") == 0 ) ) {
                // Pattern {return}
                { // Invoke: set statement "return"
                    setVarScalar(interp, "statement", const2, compiledLocals, 4);
                } // End Invoke: set
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("should have been break or continue command, got ");
                        tmp6 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                        sbtmp7.append(tmp6.toString());
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv5, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: if ... ... else ...
            // Binary operator: $statement == "return"
            TclObject tmp8 = getVarScalar(interp, "statement", compiledLocals, 4);
            boolean tmp9 = tmp8.toString().equals("return");
            ExprValue tmp10 = evs0;
            tmp10.setIntValue(tmp9);
            // End Binary operator: ==
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv12 = TJC.grabObjv(interp, 2);
                        TclObject tmp13;
                        try {
                            // Arg 0 constant: ...
                            objv12[0] = const4;
                            // Arg 1 variable: $key
                            tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp13.preserve();
                            objv12[1] = tmp13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv12, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp13 = objv12[1];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            TJC.releaseObjv(interp, objv12, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return [...]
                    { // Invoke: ... $statement
                        TclObject[] objv14 = TJC.grabObjv(interp, 2);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: ...
                            objv14[0] = const5;
                            // Arg 1 variable: $statement
                            tmp15 = getVarScalar(interp, "statement", compiledLocals, 4);
                            tmp15.preserve();
                            objv14[1] = tmp15;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv14, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp15 = objv14[1];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_control");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("break");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("continue");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("return");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_emit_control_return");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_container_loop_break_continue");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_emit_control_return";
                break;
            }
            case 3: {
                cmdName = "emitter_container_loop_break_continue";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_ckeys",
        "cmdname",
        "statement"
    };
} // end class CompileprocEmitControlCmd

