// TJC implementation of procedure compileproc_expr_container_index
package tjc;
import tcl.lang.*;

public class CompileprocExprContainerIndexCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key in_expr_index");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "in_expr_index", objv[2], compiledLocals, 1);
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: $in_expr_index == ""
            TclObject tmp0 = getVarScalar(interp, "in_expr_index", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: error ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv3[0] = const0;
                        // Arg 1 constant: ...
                        objv3[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp4;
            { // Invoke: lindex $... 1
                TclObject tmp5;
                StringBuffer sbtmp6 = new StringBuffer(64);
                tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp6.append(tmp5.toString());
                sbtmp6.append(",info_key");
                tmp5 = getVarArray(interp, "_compileproc_ckeys", sbtmp6.toString(), compiledLocals, 2);
                tmp5 = TclList.index(interp, tmp5, 1);
                if ( tmp5 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp5);
                }
            } // End Invoke: lindex
            tmp4 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp4, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$cmdname == "if"} ... elseif {$cmdname == "expr"} ...
            // Binary operator: $cmdname == "if"
            TclObject tmp7 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            boolean tmp8 = tmp7.toString().equals("if");
            ExprValue tmp9 = evs0;
            tmp9.setIntValue(tmp8);
            // End Binary operator: ==
            boolean tmp10 = ( tmp9.getIntValue() != 0 );
            if ( tmp10 ) {
                { // Invoke: set expr_indexes [...]
                    TclObject tmp11;
                    { // Invoke: list
                        TclObject tmp12 = TclList.newInstance();
                        interp.setResult(tmp12);
                    } // End Invoke: list
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "expr_indexes", tmp11, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set tuple [...]
                    TclObject tmp13;
                    { // Invoke: ... $key
                        TclObject[] objv14 = TJC.grabObjv(interp, 2);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: ...
                            objv14[0] = const2;
                            // Arg 1 variable: $key
                            tmp15 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp15.preserve();
                            objv14[1] = tmp15;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv14, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp15 = objv14[1];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 2);
                        }
                    } // End Invoke: ...
                    tmp13 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp13, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set expr_index [...]
                    TclObject tmp16;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp17 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp17 = TclList.index(interp, tmp17, 0);
                        if ( tmp17 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp17);
                        }
                    } // End Invoke: lindex
                    tmp16 = interp.getResult();
                    setVarScalar(interp, "expr_index", tmp16, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: lappend expr_indexes $expr_index {}
                    TclObject[] objv18 = TJC.grabObjv(interp, 2);
                    TclObject tmp19;
                    try {
                        // Arg 2 variable: $expr_index
                        tmp19 = getVarScalar(interp, "expr_index", compiledLocals, 6);
                        tmp19.preserve();
                        objv18[0] = tmp19;
                        // Arg 3 constant: {}
                        objv18[1] = const3;
                        interp.resetResult();
                        lappendVarScalar(interp, "expr_indexes", objv18, compiledLocals, 4);
                    } finally {
                        tmp19 = objv18[0];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 2);
                    }
                } // End Invoke: lappend
                { // Invoke: if ... ...
                    { // Invoke: ... $key
                        TclObject[] objv20 = TJC.grabObjv(interp, 2);
                        TclObject tmp21;
                        try {
                            // Arg 0 constant: ...
                            objv20[0] = const4;
                            // Arg 1 variable: $key
                            tmp21 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp21.preserve();
                            objv20[1] = tmp21;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv20, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp21 = objv20[1];
                            if ( tmp21 != null ) {
                                tmp21.release();
                            }
                            TJC.releaseObjv(interp, objv20, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp22 = interp.getResult();
                    ExprValue tmp23 = evs0;
                    TJC.exprInitValue(interp, tmp23, tmp22);
                    boolean tmp24 = tmp23.getBooleanValue(interp);
                    if ( tmp24 ) {
                        { // Invoke: foreach ... [...] ...
                            TclObject tmp25 = null;
                            try {
                                { // Invoke: ... $key
                                    TclObject[] objv26 = TJC.grabObjv(interp, 2);
                                    TclObject tmp27;
                                    try {
                                        // Arg 0 constant: ...
                                        objv26[0] = const5;
                                        // Arg 1 variable: $key
                                        tmp27 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp27.preserve();
                                        objv26[1] = tmp27;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv26, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp27 = objv26[1];
                                        if ( tmp27 != null ) {
                                            tmp27.release();
                                        }
                                        TJC.releaseObjv(interp, objv26, 2);
                                    }
                                } // End Invoke: ...
                                tmp25 = interp.getResult();
                                tmp25.preserve();
                                final int tmp25_length = TclList.getLength(interp, tmp25);

                                for ( int index28 = 0 ; index28 < tmp25_length ; index28 += 2 ) {
                                    TclObject tmp29 = null;
                                    if ( index28 < tmp25_length ) {
                                        tmp29 = TclList.index(interp, tmp25, index28);
                                    }
                                    TclObject tmp30 = null;
                                    if ( index28 + 1 < tmp25_length ) {
                                        tmp30 = TclList.index(interp, tmp25, index28 + 1);
                                    }
                                    try {
                                        if ( tmp29 == null ) {
                                            setVarScalar(interp, "expr_index", "", compiledLocals, 6);
                                        } else {
                                            setVarScalar(interp, "expr_index", tmp29, compiledLocals, 6);
                                        }
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "expr_index");
                                    }
                                    try {
                                        if ( tmp30 == null ) {
                                            setVarScalar(interp, "body_index", "", compiledLocals, 7);
                                        } else {
                                            setVarScalar(interp, "body_index", tmp30, compiledLocals, 7);
                                        }
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "body_index");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: lappend expr_indexes $expr_index {}
                                        TclObject[] objv31 = TJC.grabObjv(interp, 2);
                                        TclObject tmp32;
                                        try {
                                            // Arg 2 variable: $expr_index
                                            tmp32 = getVarScalar(interp, "expr_index", compiledLocals, 6);
                                            tmp32.preserve();
                                            objv31[0] = tmp32;
                                            // Arg 3 constant: {}
                                            objv31[1] = const3;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "expr_indexes", objv31, compiledLocals, 4);
                                        } finally {
                                            tmp32 = objv31[0];
                                            if ( tmp32 != null ) {
                                                tmp32.release();
                                            }
                                            TJC.releaseObjv(interp, objv31, 2);
                                        }
                                    } // End Invoke: lappend
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp25 != null ) {
                                    tmp25.release();
                                }
                            }
                        } // End Invoke: foreach
                    }
                } // End Invoke: if
                { // Invoke: set ind [...]
                    TclObject tmp33;
                    { // Invoke: lsearch -exact $expr_indexes $in_expr_index
                        TclObject[] objv34 = TJC.grabObjv(interp, 4);
                        TclObject tmp35;
                        try {
                            // Arg 0 constant: lsearch
                            objv34[0] = const6;
                            // Arg 1 constant: -exact
                            objv34[1] = const7;
                            // Arg 2 variable: $expr_indexes
                            tmp35 = getVarScalar(interp, "expr_indexes", compiledLocals, 4);
                            tmp35.preserve();
                            objv34[2] = tmp35;
                            // Arg 3 variable: $in_expr_index
                            tmp35 = getVarScalar(interp, "in_expr_index", compiledLocals, 1);
                            tmp35.preserve();
                            objv34[3] = tmp35;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv34, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp35 = objv34[2];
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                            tmp35 = objv34[3];
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                            TJC.releaseObjv(interp, objv34, 4);
                        }
                    } // End Invoke: lsearch
                    tmp33 = interp.getResult();
                    setVarScalar(interp, "ind", tmp33, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$ind == -1} ...
                    // Binary operator: $ind == ()
                    TclObject tmp36 = getVarScalar(interp, "ind", compiledLocals, 8);
                    ExprValue tmp37 = evs0;
                    TJC.exprInitValue(interp, tmp37, tmp36);
                    // Unary operator: - 1
                    ExprValue tmp38 = evs1;
                    tmp38.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp37, tmp38);
                    // End Binary operator: ==
                    boolean tmp39 = ( tmp37.getIntValue() != 0 );
                    if ( tmp39 ) {
                        { // Invoke: error "..."
                            TclObject[] objv40 = TJC.grabObjv(interp, 2);
                            TclObject tmp41;
                            try {
                                // Arg 0 constant: error
                                objv40[0] = const0;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp42 = new StringBuffer(64);
                                sbtmp42.append("if: failed to find expr index ");
                                tmp41 = getVarScalar(interp, "in_expr_index", compiledLocals, 1);
                                sbtmp42.append(tmp41.toString());
                                sbtmp42.append(" in ");
                                sbtmp42.append("{");
                                tmp41 = getVarScalar(interp, "expr_indexes", compiledLocals, 4);
                                sbtmp42.append(tmp41.toString());
                                sbtmp42.append("}");
                                tmp41 = TclString.newInstance(sbtmp42);
                                tmp41.preserve();
                                objv40[1] = tmp41;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv40, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp41 = objv40[1];
                                if ( tmp41 != null ) {
                                    tmp41.release();
                                }
                                TJC.releaseObjv(interp, objv40, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: return [...]
                    { // Invoke: list $cmdname $ind
                        TclObject tmp43 = TclList.newInstance();
                        TclObject tmp44;
                        try {
                            tmp44 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                            TclList.append(interp, tmp43, tmp44);
                            tmp44 = getVarScalar(interp, "ind", compiledLocals, 8);
                            TclList.append(interp, tmp43, tmp44);
                        } catch (TclException ex) {
                            tmp43.release();
                            throw ex;
                        }
                        interp.setResult(tmp43);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Binary operator: $cmdname == "expr"
                TclObject tmp45 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                boolean tmp46 = tmp45.toString().equals("expr");
                ExprValue tmp47 = evs0;
                tmp47.setIntValue(tmp46);
                // End Binary operator: ==
                boolean tmp48 = ( tmp47.getIntValue() != 0 );
                if ( tmp48 ) {
                    { // Invoke: return [...]
                        { // Invoke: list $cmdname -1
                            TclObject tmp49 = TclList.newInstance();
                            TclObject tmp50;
                            try {
                                tmp50 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                                TclList.append(interp, tmp49, tmp50);
                                TclList.append(interp, tmp49, const8);
                            } catch (TclException ex) {
                                tmp49.release();
                                throw ex;
                            }
                            interp.setResult(tmp49);
                        } // End Invoke: list
                        if ( true ) { return; }
                    } // End Invoke: return
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $cmdname [...]
                TclObject tmp51 = TclList.newInstance();
                TclObject tmp52;
                try {
                    tmp52 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                    TclList.append(interp, tmp51, tmp52);
                    { // Invoke: expr {$in_expr_index - 1}
                        // Binary operator: $in_expr_index - 1
                        TclObject tmp53 = getVarScalar(interp, "in_expr_index", compiledLocals, 1);
                        ExprValue tmp54 = evs0;
                        TJC.exprInitValue(interp, tmp54, tmp53);
                        ExprValue tmp55 = evs1;
                        tmp55.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp54, tmp55);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp54);
                    } // End Invoke: expr
                    tmp52 = interp.getResult();
                    TclList.append(interp, tmp51, tmp52);
                } catch (TclException ex) {
                    tmp51.release();
                    throw ex;
                }
                interp.setResult(tmp51);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_container_index");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("empty in_expr_index argument");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_if_expr_body");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_container_if_has_elseif_body");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_container_if_iterate_elseif_body");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("lsearch");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("-exact");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(-1);
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "descend_container_if_expr_body";
                break;
            }
            case 3: {
                cmdName = "descend_container_if_has_elseif_body";
                break;
            }
            case 4: {
                cmdName = "descend_container_if_iterate_elseif_body";
                break;
            }
            case 5: {
                cmdName = "lsearch";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "in_expr_index",
        "_compileproc_ckeys",
        "cmdname",
        "expr_indexes",
        "tuple",
        "expr_index",
        "body_index",
        "ind"
    };
} // end class CompileprocExprContainerIndexCmd

