// TJC implementation of procedure compileproc_expr_evaluate_boolean_emit
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateBooleanEmitCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 26, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key expr_index");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "expr_index", objv[2], compiledLocals, 1);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 2);
        } // End Invoke: global
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 3);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set expr_result [...]
            TclObject tmp0;
            { // Invoke: ... $key $expr_index
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 variable: $expr_index
                    tmp2 = getVarScalar(interp, "expr_index", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "expr_result", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp3;
            { // Invoke: lindex $expr_result 0
                TclObject tmp4 = getVarScalar(interp, "expr_result", compiledLocals, 5);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "type", tmp3, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: switch -exact -- $type {constant} - {constant boolean} - {constant string} ...
            TclObject tmp5 = getVarScalar(interp, "type", compiledLocals, 6);
            String tmp6 = tmp5.toString();
            int tmp6_length = tmp6.length();
            char tmp6_first = '\n';
            if ( tmp6_length > 0 ) {
                tmp6_first = tmp6.charAt(0);
            }
            if ( ( tmp6_length == 8 && tmp6_first == 'c'
                    && tmp6.compareTo("constant") == 0 ) ||
                ( tmp6_length == 16 && tmp6_first == 'c'
                    && tmp6.compareTo("constant boolean") == 0 ) ||
                ( tmp6_length == 15 && tmp6_first == 'c'
                    && tmp6.compareTo("constant string") == 0 ) ) {
                // Pattern {constant string}
                { // Invoke: set value [...]
                    TclObject tmp7;
                    { // Invoke: lindex $expr_result 1
                        TclObject tmp8 = getVarScalar(interp, "expr_result", compiledLocals, 5);
                        tmp8 = TclList.index(interp, tmp8, 1);
                        if ( tmp8 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp8);
                        }
                    } // End Invoke: lindex
                    tmp7 = interp.getResult();
                    setVarScalar(interp, "value", tmp7, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $type == "constant string"
                    TclObject tmp9 = getVarScalar(interp, "type", compiledLocals, 6);
                    boolean tmp10 = tmp9.toString().equals("constant string");
                    ExprValue tmp11 = evs0;
                    tmp11.setIntValue(tmp10);
                    // End Binary operator: ==
                    boolean tmp12 = ( tmp11.getIntValue() != 0 );
                    if ( tmp12 ) {
                        { // Invoke: set ovalue ...
                            TclObject tmp13;
                            StringBuffer sbtmp14 = new StringBuffer(64);
                            sbtmp14.append("\"");
                            tmp13 = getVarScalar(interp, "value", compiledLocals, 7);
                            sbtmp14.append(tmp13.toString());
                            sbtmp14.append("\"");
                            tmp13 = TclString.newInstance(sbtmp14);
                            setVarScalar(interp, "ovalue", tmp13, compiledLocals, 8);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set ovalue $value
                            TclObject tmp15;
                            tmp15 = getVarScalar(interp, "value", compiledLocals, 7);
                            setVarScalar(interp, "ovalue", tmp15, compiledLocals, 8);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if ... ... else ...
                    { // Invoke: catch {expr "!!$ovalue"} result
                        int code16 = TCL.OK;
                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: expr "!!$ovalue"
                            TclObject[] objv17 = TJC.grabObjv(interp, 2);
                            TclObject tmp18;
                            try {
                                // Arg 0 constant: expr
                                objv17[0] = const2;
                                // Arg 1 word: "!!$ovalue"
                                StringBuffer sbtmp19 = new StringBuffer(64);
                                sbtmp19.append("!!");
                                tmp18 = getVarScalar(interp, "ovalue", compiledLocals, 8);
                                sbtmp19.append(tmp18.toString());
                                tmp18 = TclString.newInstance(sbtmp19);
                                tmp18.preserve();
                                objv17[1] = tmp18;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv17, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp18 = objv17[1];
                                if ( tmp18 != null ) {
                                    tmp18.release();
                                }
                                TJC.releaseObjv(interp, objv17, 2);
                            }
                        } // End Invoke: expr
                        } catch (TclException ex) {
                            code16 = ex.getCompletionCode();
                        }
                        TclObject result = interp.getResult();
                        try {
                            setVarScalar(interp, "result", result, compiledLocals, 9);
                        } catch (TclException ex) {
                            TJC.catchVarErr(interp);
                        }
                        interp.resetResult();
                        interp.setResult(code16);
                    } // End Invoke: catch
                    TclObject tmp20 = interp.getResult();
                    ExprValue tmp21 = evs0;
                    TJC.exprInitValue(interp, tmp21, tmp20);
                    boolean tmp22 = tmp21.getBooleanValue(interp);
                    if ( tmp22 ) {
                    } else {
                        { // Invoke: if {$result} ... else ...
                            TclObject tmp23 = getVarScalar(interp, "result", compiledLocals, 9);
                            boolean tmp24 = TJC.getBoolean(interp, tmp23);
                            if ( tmp24 ) {
                                { // Invoke: set simple_bool_value true
                                    setVarScalar(interp, "simple_bool_value", const3, compiledLocals, 10);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set simple_bool_value false
                                    setVarScalar(interp, "simple_bool_value", const4, compiledLocals, 10);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: return [...]
                            { // Invoke: list $simple_bool_value $buffer 1
                                TclObject tmp25 = TclList.newInstance();
                                TclObject tmp26;
                                try {
                                    tmp26 = getVarScalar(interp, "simple_bool_value", compiledLocals, 10);
                                    TclList.append(interp, tmp25, tmp26);
                                    tmp26 = getVarScalar(interp, "buffer", compiledLocals, 4);
                                    TclList.append(interp, tmp25, tmp26);
                                    TclList.append(interp, tmp25, const5);
                                } catch (TclException ex) {
                                    tmp25.release();
                                    throw ex;
                                }
                                interp.setResult(tmp25);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            }
        } // End Invoke: switch
        { // Invoke: if ... ...
            // Binary operator: $type == "variable scalar"
            TclObject tmp27 = getVarScalar(interp, "type", compiledLocals, 6);
            boolean tmp28 = tmp27.toString().equals("variable scalar");
            ExprValue tmp29 = evs0;
            tmp29.setIntValue(tmp28);
            // End Binary operator: ==
            boolean tmp30 = ( tmp29.getIntValue() != 0 );
            if ( tmp30 ) {
                { // Invoke: set sname [...]
                    TclObject tmp31;
                    { // Invoke: lindex $expr_result 1
                        TclObject tmp32 = getVarScalar(interp, "expr_result", compiledLocals, 5);
                        tmp32 = TclList.index(interp, tmp32, 1);
                        if ( tmp32 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp32);
                        }
                    } // End Invoke: lindex
                    tmp31 = interp.getResult();
                    setVarScalar(interp, "sname", tmp31, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set vinfo [...]
                    TclObject tmp33;
                    { // Invoke: list scalar $sname
                        TclObject tmp34 = TclList.newInstance();
                        TclObject tmp35;
                        try {
                            TclList.append(interp, tmp34, const6);
                            tmp35 = getVarScalar(interp, "sname", compiledLocals, 11);
                            TclList.append(interp, tmp34, tmp35);
                        } catch (TclException ex) {
                            tmp34.release();
                            throw ex;
                        }
                        interp.setResult(tmp34);
                    } // End Invoke: list
                    tmp33 = interp.getResult();
                    setVarScalar(interp, "vinfo", tmp33, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: set tmpsymbol1 [...]
                    TclObject tmp36;
                    { // Invoke: ...
                        TclObject[] objv37 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv37[0] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv37, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv37, 1);
                        }
                    } // End Invoke: ...
                    tmp36 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol1", tmp36, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv38 = TJC.grabObjv(interp, 1);
                    TclObject tmp39;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $tmpsymbol1 $vinfo
                            TclObject[] objv40 = TJC.grabObjv(interp, 3);
                            TclObject tmp41;
                            try {
                                // Arg 0 constant: ...
                                objv40[0] = const8;
                                // Arg 1 variable: $tmpsymbol1
                                tmp41 = getVarScalar(interp, "tmpsymbol1", compiledLocals, 13);
                                tmp41.preserve();
                                objv40[1] = tmp41;
                                // Arg 2 variable: $vinfo
                                tmp41 = getVarScalar(interp, "vinfo", compiledLocals, 12);
                                tmp41.preserve();
                                objv40[2] = tmp41;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv40, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp41 = objv40[1];
                                if ( tmp41 != null ) {
                                    tmp41.release();
                                }
                                tmp41 = objv40[2];
                                if ( tmp41 != null ) {
                                    tmp41.release();
                                }
                                TJC.releaseObjv(interp, objv40, 3);
                            }
                        } // End Invoke: ...
                        tmp39 = interp.getResult();
                        tmp39.preserve();
                        objv38[0] = tmp39;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv38, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv38, 1);
                    }
                } // End Invoke: append
                { // Invoke: set tmpsymbol2 [...]
                    TclObject tmp42;
                    { // Invoke: ...
                        TclObject[] objv43 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv43[0] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv43, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv43, 1);
                        }
                    } // End Invoke: ...
                    tmp42 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol2", tmp42, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: append buffer [...] "boolean " $tmpsymbol2 " = " [...] ...
                    TclObject[] objv44 = TJC.grabObjv(interp, 6);
                    TclObject tmp45;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv46 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv46[0] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv46, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv46, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp45 = interp.getResult();
                        tmp45.preserve();
                        objv44[0] = tmp45;
                        // Arg 3 constant: "boolean "
                        objv44[1] = const10;
                        // Arg 4 variable: $tmpsymbol2
                        tmp45 = getVarScalar(interp, "tmpsymbol2", compiledLocals, 14);
                        tmp45.preserve();
                        objv44[2] = tmp45;
                        // Arg 5 constant: " = "
                        objv44[3] = const11;
                        // Arg 6 command: [...]
                        { // Invoke: ... $tmpsymbol1
                            TclObject[] objv47 = TJC.grabObjv(interp, 2);
                            TclObject tmp48;
                            try {
                                // Arg 0 constant: ...
                                objv47[0] = const12;
                                // Arg 1 variable: $tmpsymbol1
                                tmp48 = getVarScalar(interp, "tmpsymbol1", compiledLocals, 13);
                                tmp48.preserve();
                                objv47[1] = tmp48;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv47, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp48 = objv47[1];
                                if ( tmp48 != null ) {
                                    tmp48.release();
                                }
                                TJC.releaseObjv(interp, objv47, 2);
                            }
                        } // End Invoke: ...
                        tmp45 = interp.getResult();
                        tmp45.preserve();
                        objv44[4] = tmp45;
                        // Arg 7 constant: ...
                        objv44[5] = const13;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv44, compiledLocals, 4);
                    } finally {
                        tmp45 = objv44[0];
                        if ( tmp45 != null ) {
                            tmp45.release();
                        }
                        tmp45 = objv44[2];
                        if ( tmp45 != null ) {
                            tmp45.release();
                        }
                        tmp45 = objv44[4];
                        if ( tmp45 != null ) {
                            tmp45.release();
                        }
                        TJC.releaseObjv(interp, objv44, 6);
                    }
                } // End Invoke: append
                { // Invoke: set retsymbol $tmpsymbol2
                    TclObject tmp49;
                    tmp49 = getVarScalar(interp, "tmpsymbol2", compiledLocals, 14);
                    setVarScalar(interp, "retsymbol", tmp49, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list $tmpsymbol2 $buffer 0
                        TclObject tmp50 = TclList.newInstance();
                        TclObject tmp51;
                        try {
                            tmp51 = getVarScalar(interp, "tmpsymbol2", compiledLocals, 14);
                            TclList.append(interp, tmp50, tmp51);
                            tmp51 = getVarScalar(interp, "buffer", compiledLocals, 4);
                            TclList.append(interp, tmp50, tmp51);
                            TclList.append(interp, tmp50, const14);
                        } catch (TclException ex) {
                            tmp50.release();
                            throw ex;
                        }
                        interp.setResult(tmp50);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set inline 0
            setVarScalar(interp, "inline", const14, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $_compileproc(...) == "all"
            TclObject tmp52 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 3);
            boolean tmp53 = tmp52.toString().equals("all");
            ExprValue tmp54 = evs0;
            tmp54.setIntValue(tmp53);
            // End Binary operator: ==
            boolean tmp55 = ( tmp54.getIntValue() != 0 );
            if ( tmp55 ) {
                { // Invoke: set inline 1
                    setVarScalar(interp, "inline", const5, compiledLocals, 16);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$inline == 0} ...
            // Binary operator: $inline == 0
            TclObject tmp56 = getVarScalar(interp, "inline", compiledLocals, 16);
            ExprValue tmp57 = evs0;
            TJC.exprInitValue(interp, tmp57, tmp56);
            ExprValue tmp58 = evs1;
            tmp58.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp57, tmp58);
            // End Binary operator: ==
            boolean tmp59 = ( tmp57.getIntValue() != 0 );
            if ( tmp59 ) {
                { // Invoke: set ind [...]
                    TclObject tmp60;
                    { // Invoke: lsearch -exact $... "expr"
                        TclObject[] objv61 = TJC.grabObjv(interp, 4);
                        TclObject tmp62;
                        try {
                            // Arg 0 constant: lsearch
                            objv61[0] = const15;
                            // Arg 1 constant: -exact
                            objv61[1] = const16;
                            // Arg 2 variable: $...
                            tmp62 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 3);
                            tmp62.preserve();
                            objv61[2] = tmp62;
                            // Arg 3 constant: "expr"
                            objv61[3] = const2;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv61, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp62 = objv61[2];
                            if ( tmp62 != null ) {
                                tmp62.release();
                            }
                            TJC.releaseObjv(interp, objv61, 4);
                        }
                    } // End Invoke: lsearch
                    tmp60 = interp.getResult();
                    setVarScalar(interp, "ind", tmp60, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: if {$ind != -1} ...
                    // Binary operator: $ind != ()
                    TclObject tmp63 = getVarScalar(interp, "ind", compiledLocals, 17);
                    ExprValue tmp64 = evs0;
                    TJC.exprInitValue(interp, tmp64, tmp63);
                    // Unary operator: - 1
                    ExprValue tmp65 = evs1;
                    tmp65.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp64, tmp65);
                    // End Binary operator: !=
                    boolean tmp66 = ( tmp64.getIntValue() != 0 );
                    if ( tmp66 ) {
                        { // Invoke: set inline 1
                            setVarScalar(interp, "inline", const5, compiledLocals, 16);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if {!$inline} ... else ...
            // Unary operator: ! $inline
            TclObject tmp67 = getVarScalar(interp, "inline", compiledLocals, 16);
            ExprValue tmp68 = evs0;
            if ( tmp67.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp68, tmp67);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp68, tmp67);
            }
            // End Unary operator: !
            boolean tmp69 = ( tmp68.getIntValue() != 0 );
            if ( tmp69 ) {
                { // Invoke: set values $...
                    TclObject tmp70;
                    StringBuffer sbtmp71 = new StringBuffer(64);
                    tmp70 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp71.append(tmp70.toString());
                    sbtmp71.append(",values");
                    tmp70 = getVarArray(interp, "_compileproc_key_info", sbtmp71.toString(), compiledLocals, 2);
                    setVarScalar(interp, "values", tmp70, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: set expr_str [...]
                    TclObject tmp72;
                    { // Invoke: lindex $values $expr_index
                        TclObject tmp73 = null;
                        TclObject tmp74;
                        try {
                            tmp73 = getVarScalar(interp, "values", compiledLocals, 18);
                            tmp73.preserve();
                            tmp74 = getVarScalar(interp, "expr_index", compiledLocals, 1);
                            TJC.lindexNonconst(interp, tmp73, tmp74);
                        } finally {
                            if ( tmp73 != null ) {
                                tmp73.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp72 = interp.getResult();
                    setVarScalar(interp, "expr_str", tmp72, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: set gkey [...]
                    TclObject tmp75;
                    { // Invoke: ... expr [...] [...]
                        TclObject[] objv76 = TJC.grabObjv(interp, 4);
                        TclObject tmp77;
                        try {
                            // Arg 0 constant: ...
                            objv76[0] = const17;
                            // Arg 1 constant: expr
                            objv76[1] = const2;
                            // Arg 2 command: [...]
                            { // Invoke: list $expr_str
                                TclObject tmp78 = TclList.newInstance();
                                TclObject tmp79;
                                tmp79 = getVarScalar(interp, "expr_str", compiledLocals, 19);
                                TclList.append(interp, tmp78, tmp79);
                                interp.setResult(tmp78);
                            } // End Invoke: list
                            tmp77 = interp.getResult();
                            tmp77.preserve();
                            objv76[2] = tmp77;
                            // Arg 3 command: [...]
                            { // Invoke: list ...
                                TclObject tmp80 = TclList.newInstance();
                                TclObject tmp81;
                                StringBuffer sbtmp82 = new StringBuffer(64);
                                sbtmp82.append("{");
                                tmp81 = getVarScalar(interp, "expr_str", compiledLocals, 19);
                                sbtmp82.append(tmp81.toString());
                                sbtmp82.append("}");
                                tmp81 = TclString.newInstance(sbtmp82);
                                TclList.append(interp, tmp80, tmp81);
                                interp.setResult(tmp80);
                            } // End Invoke: list
                            tmp77 = interp.getResult();
                            tmp77.preserve();
                            objv76[3] = tmp77;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv76, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp77 = objv76[2];
                            if ( tmp77 != null ) {
                                tmp77.release();
                            }
                            tmp77 = objv76[3];
                            if ( tmp77 != null ) {
                                tmp77.release();
                            }
                            TJC.releaseObjv(interp, objv76, 4);
                        }
                    } // End Invoke: ...
                    tmp75 = interp.getResult();
                    setVarScalar(interp, "gkey", tmp75, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv83 = TJC.grabObjv(interp, 1);
                    TclObject tmp84;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $gkey
                            TclObject[] objv85 = TJC.grabObjv(interp, 2);
                            TclObject tmp86;
                            try {
                                // Arg 0 constant: ...
                                objv85[0] = const18;
                                // Arg 1 variable: $gkey
                                tmp86 = getVarScalar(interp, "gkey", compiledLocals, 20);
                                tmp86.preserve();
                                objv85[1] = tmp86;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv85, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                tmp86 = objv85[1];
                                if ( tmp86 != null ) {
                                    tmp86.release();
                                }
                                TJC.releaseObjv(interp, objv85, 2);
                            }
                        } // End Invoke: ...
                        tmp84 = interp.getResult();
                        tmp84.preserve();
                        objv83[0] = tmp84;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv83, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv83, 1);
                    }
                } // End Invoke: append
                { // Invoke: set tmpsymbol1 [...]
                    TclObject tmp87;
                    { // Invoke: ...
                        TclObject[] objv88 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv88[0] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv88, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv88, 1);
                        }
                    } // End Invoke: ...
                    tmp87 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol1", tmp87, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: append buffer [...] "TclObject " $tmpsymbol1 ... ...
                    TclObject[] objv89 = TJC.grabObjv(interp, 5);
                    TclObject tmp90;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv91 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv91[0] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv91, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv91, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp90 = interp.getResult();
                        tmp90.preserve();
                        objv89[0] = tmp90;
                        // Arg 3 constant: "TclObject "
                        objv89[1] = const19;
                        // Arg 4 variable: $tmpsymbol1
                        tmp90 = getVarScalar(interp, "tmpsymbol1", compiledLocals, 13);
                        tmp90.preserve();
                        objv89[2] = tmp90;
                        // Arg 5 constant: ...
                        objv89[3] = const20;
                        // Arg 6 constant: ...
                        objv89[4] = const13;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv89, compiledLocals, 4);
                    } finally {
                        tmp90 = objv89[0];
                        if ( tmp90 != null ) {
                            tmp90.release();
                        }
                        tmp90 = objv89[2];
                        if ( tmp90 != null ) {
                            tmp90.release();
                        }
                        TJC.releaseObjv(interp, objv89, 5);
                    }
                } // End Invoke: append
                { // Invoke: set tmpsymbol2 [...]
                    TclObject tmp92;
                    { // Invoke: ...
                        TclObject[] objv93 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv93[0] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv93, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv93, 1);
                        }
                    } // End Invoke: ...
                    tmp92 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol2", tmp92, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: append buffer [...] "boolean " $tmpsymbol2 " = " [...] ...
                    TclObject[] objv94 = TJC.grabObjv(interp, 6);
                    TclObject tmp95;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv96 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv96[0] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv96, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv96, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp95 = interp.getResult();
                        tmp95.preserve();
                        objv94[0] = tmp95;
                        // Arg 3 constant: "boolean "
                        objv94[1] = const10;
                        // Arg 4 variable: $tmpsymbol2
                        tmp95 = getVarScalar(interp, "tmpsymbol2", compiledLocals, 14);
                        tmp95.preserve();
                        objv94[2] = tmp95;
                        // Arg 5 constant: " = "
                        objv94[3] = const11;
                        // Arg 6 command: [...]
                        { // Invoke: ... $tmpsymbol1
                            TclObject[] objv97 = TJC.grabObjv(interp, 2);
                            TclObject tmp98;
                            try {
                                // Arg 0 constant: ...
                                objv97[0] = const12;
                                // Arg 1 variable: $tmpsymbol1
                                tmp98 = getVarScalar(interp, "tmpsymbol1", compiledLocals, 13);
                                tmp98.preserve();
                                objv97[1] = tmp98;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv97, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp98 = objv97[1];
                                if ( tmp98 != null ) {
                                    tmp98.release();
                                }
                                TJC.releaseObjv(interp, objv97, 2);
                            }
                        } // End Invoke: ...
                        tmp95 = interp.getResult();
                        tmp95.preserve();
                        objv94[4] = tmp95;
                        // Arg 7 constant: ...
                        objv94[5] = const13;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv94, compiledLocals, 4);
                    } finally {
                        tmp95 = objv94[0];
                        if ( tmp95 != null ) {
                            tmp95.release();
                        }
                        tmp95 = objv94[2];
                        if ( tmp95 != null ) {
                            tmp95.release();
                        }
                        tmp95 = objv94[4];
                        if ( tmp95 != null ) {
                            tmp95.release();
                        }
                        TJC.releaseObjv(interp, objv94, 6);
                    }
                } // End Invoke: append
                { // Invoke: return [...]
                    { // Invoke: list $tmpsymbol2 $buffer 0
                        TclObject tmp99 = TclList.newInstance();
                        TclObject tmp100;
                        try {
                            tmp100 = getVarScalar(interp, "tmpsymbol2", compiledLocals, 14);
                            TclList.append(interp, tmp99, tmp100);
                            tmp100 = getVarScalar(interp, "buffer", compiledLocals, 4);
                            TclList.append(interp, tmp99, tmp100);
                            TclList.append(interp, tmp99, const14);
                        } catch (TclException ex) {
                            tmp99.release();
                            throw ex;
                        }
                        interp.setResult(tmp99);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: set eval_tuple [...]
                    TclObject tmp101;
                    { // Invoke: ... $expr_result
                        TclObject[] objv102 = TJC.grabObjv(interp, 2);
                        TclObject tmp103;
                        try {
                            // Arg 0 constant: ...
                            objv102[0] = const21;
                            // Arg 1 variable: $expr_result
                            tmp103 = getVarScalar(interp, "expr_result", compiledLocals, 5);
                            tmp103.preserve();
                            objv102[1] = tmp103;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv102, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            tmp103 = objv102[1];
                            if ( tmp103 != null ) {
                                tmp103.release();
                            }
                            TJC.releaseObjv(interp, objv102, 2);
                        }
                    } // End Invoke: ...
                    tmp101 = interp.getResult();
                    setVarScalar(interp, "eval_tuple", tmp101, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: set infostr [...]
                    TclObject tmp104;
                    { // Invoke: lindex $eval_tuple 0
                        TclObject tmp105 = getVarScalar(interp, "eval_tuple", compiledLocals, 21);
                        tmp105 = TclList.index(interp, tmp105, 0);
                        if ( tmp105 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp105);
                        }
                    } // End Invoke: lindex
                    tmp104 = interp.getResult();
                    setVarScalar(interp, "infostr", tmp104, compiledLocals, 22);
                } // End Invoke: set
                { // Invoke: set ev [...]
                    TclObject tmp106;
                    { // Invoke: lindex $eval_tuple 1
                        TclObject tmp107 = getVarScalar(interp, "eval_tuple", compiledLocals, 21);
                        tmp107 = TclList.index(interp, tmp107, 1);
                        if ( tmp107 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp107);
                        }
                    } // End Invoke: lindex
                    tmp106 = interp.getResult();
                    setVarScalar(interp, "ev", tmp106, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv108 = TJC.grabObjv(interp, 1);
                    TclObject tmp109;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: lindex $eval_tuple 2
                            TclObject tmp110 = getVarScalar(interp, "eval_tuple", compiledLocals, 21);
                            tmp110 = TclList.index(interp, tmp110, 2);
                            if ( tmp110 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp110);
                            }
                        } // End Invoke: lindex
                        tmp109 = interp.getResult();
                        tmp109.preserve();
                        objv108[0] = tmp109;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv108, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv108, 1);
                    }
                } // End Invoke: append
                { // Invoke: set ev_types [...]
                    TclObject tmp111;
                    { // Invoke: lindex $eval_tuple 3 3
                        TclObject[] objv112 = TJC.grabObjv(interp, 4);
                        TclObject tmp113;
                        try {
                            // Arg 0 constant: lindex
                            objv112[0] = const22;
                            // Arg 1 variable: $eval_tuple
                            tmp113 = getVarScalar(interp, "eval_tuple", compiledLocals, 21);
                            tmp113.preserve();
                            objv112[1] = tmp113;
                            // Arg 2 constant: 3
                            objv112[2] = const23;
                            // Arg 3 constant: 3
                            objv112[3] = const23;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                ? cmdcache11.cmd : null), objv112, 0);
                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                updateCmdCache(interp, 11);
                            }
                        } finally {
                            tmp113 = objv112[1];
                            if ( tmp113 != null ) {
                                tmp113.release();
                            }
                            TJC.releaseObjv(interp, objv112, 4);
                        }
                    } // End Invoke: lindex
                    tmp111 = interp.getResult();
                    setVarScalar(interp, "ev_types", tmp111, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp114;
                    { // Invoke: ...
                        TclObject[] objv115 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv115[0] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv115, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv115, 1);
                        }
                    } // End Invoke: ...
                    tmp114 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp114, compiledLocals, 25);
                } // End Invoke: set
                { // Invoke: append buffer [...] "boolean " $tmpsymbol " = "
                    TclObject[] objv116 = TJC.grabObjv(interp, 4);
                    TclObject tmp117;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv118 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv118[0] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv118, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv118, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp117 = interp.getResult();
                        tmp117.preserve();
                        objv116[0] = tmp117;
                        // Arg 3 constant: "boolean "
                        objv116[1] = const10;
                        // Arg 4 variable: $tmpsymbol
                        tmp117 = getVarScalar(interp, "tmpsymbol", compiledLocals, 25);
                        tmp117.preserve();
                        objv116[2] = tmp117;
                        // Arg 5 constant: " = "
                        objv116[3] = const11;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv116, compiledLocals, 4);
                    } finally {
                        tmp117 = objv116[0];
                        if ( tmp117 != null ) {
                            tmp117.release();
                        }
                        tmp117 = objv116[2];
                        if ( tmp117 != null ) {
                            tmp117.release();
                        }
                        TJC.releaseObjv(interp, objv116, 4);
                    }
                } // End Invoke: append
                { // Invoke: if ... ... else ...
                    TclObject tmp119 = getVarArray(interp, "_compileproc", "options,expr_inline_set_result", compiledLocals, 3);
                    ExprValue tmp120 = evs0;
                    TJC.exprInitValue(interp, tmp120, tmp119);
                    boolean tmp121 = tmp120.getBooleanValue(interp);
                    if ( tmp121 ) {
                        { // Invoke: switch -- $ev_types {boolean} - {int} ... {double} ... default ...
                            TclObject tmp122 = getVarScalar(interp, "ev_types", compiledLocals, 24);
                            String tmp123 = tmp122.toString();
                            int tmp123_length = tmp123.length();
                            char tmp123_first = '\n';
                            if ( tmp123_length > 0 ) {
                                tmp123_first = tmp123.charAt(0);
                            }
                            if ( ( tmp123_length == 7 && tmp123_first == 'b'
                                    && tmp123.compareTo("boolean") == 0 ) ||
                                ( tmp123_length == 3 && tmp123_first == 'i'
                                    && tmp123.compareTo("int") == 0 ) ) {
                                // Pattern {int}
                                { // Invoke: append buffer "( " $ev ...
                                    TclObject[] objv124 = TJC.grabObjv(interp, 3);
                                    TclObject tmp125;
                                    try {
                                        // Arg 2 constant: "( "
                                        objv124[0] = const24;
                                        // Arg 3 variable: $ev
                                        tmp125 = getVarScalar(interp, "ev", compiledLocals, 23);
                                        tmp125.preserve();
                                        objv124[1] = tmp125;
                                        // Arg 4 constant: ...
                                        objv124[2] = const25;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv124, compiledLocals, 4);
                                    } finally {
                                        tmp125 = objv124[1];
                                        if ( tmp125 != null ) {
                                            tmp125.release();
                                        }
                                        TJC.releaseObjv(interp, objv124, 3);
                                    }
                                } // End Invoke: append
                            } else if ( tmp123_length == 6 && tmp123_first == 'd'
                                    && tmp123.compareTo("double") == 0 ) {
                                // Pattern {double}
                                { // Invoke: append buffer "( " $ev ...
                                    TclObject[] objv126 = TJC.grabObjv(interp, 3);
                                    TclObject tmp127;
                                    try {
                                        // Arg 2 constant: "( "
                                        objv126[0] = const24;
                                        // Arg 3 variable: $ev
                                        tmp127 = getVarScalar(interp, "ev", compiledLocals, 23);
                                        tmp127.preserve();
                                        objv126[1] = tmp127;
                                        // Arg 4 constant: ...
                                        objv126[2] = const26;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv126, compiledLocals, 4);
                                    } finally {
                                        tmp127 = objv126[1];
                                        if ( tmp127 != null ) {
                                            tmp127.release();
                                        }
                                        TJC.releaseObjv(interp, objv126, 3);
                                    }
                                } // End Invoke: append
                            } else {
                                // Pattern default
                                { // Invoke: append buffer $ev ...
                                    TclObject[] objv128 = TJC.grabObjv(interp, 2);
                                    TclObject tmp129;
                                    try {
                                        // Arg 2 variable: $ev
                                        tmp129 = getVarScalar(interp, "ev", compiledLocals, 23);
                                        tmp129.preserve();
                                        objv128[0] = tmp129;
                                        // Arg 3 constant: ...
                                        objv128[1] = const27;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv128, compiledLocals, 4);
                                    } finally {
                                        tmp129 = objv128[0];
                                        if ( tmp129 != null ) {
                                            tmp129.release();
                                        }
                                        TJC.releaseObjv(interp, objv128, 2);
                                    }
                                } // End Invoke: append
                            }
                        } // End Invoke: switch
                    } else {
                        { // Invoke: append buffer $ev ...
                            TclObject[] objv130 = TJC.grabObjv(interp, 2);
                            TclObject tmp131;
                            try {
                                // Arg 2 variable: $ev
                                tmp131 = getVarScalar(interp, "ev", compiledLocals, 23);
                                tmp131.preserve();
                                objv130[0] = tmp131;
                                // Arg 3 constant: ...
                                objv130[1] = const27;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv130, compiledLocals, 4);
                            } finally {
                                tmp131 = objv130[0];
                                if ( tmp131 != null ) {
                                    tmp131.release();
                                }
                                TJC.releaseObjv(interp, objv130, 2);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer ... [...]
                    TclObject[] objv132 = TJC.grabObjv(interp, 2);
                    TclObject tmp133;
                    try {
                        // Arg 2 constant: ...
                        objv132[0] = const13;
                        // Arg 3 command: [...]
                        { // Invoke: ... $ev
                            TclObject[] objv134 = TJC.grabObjv(interp, 2);
                            TclObject tmp135;
                            try {
                                // Arg 0 constant: ...
                                objv134[0] = const28;
                                // Arg 1 variable: $ev
                                tmp135 = getVarScalar(interp, "ev", compiledLocals, 23);
                                tmp135.preserve();
                                objv134[1] = tmp135;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                    ? cmdcache12.cmd : null), objv134, 0);
                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                    updateCmdCache(interp, 12);
                                }
                            } finally {
                                tmp135 = objv134[1];
                                if ( tmp135 != null ) {
                                    tmp135.release();
                                }
                                TJC.releaseObjv(interp, objv134, 2);
                            }
                        } // End Invoke: ...
                        tmp133 = interp.getResult();
                        tmp133.preserve();
                        objv132[1] = tmp133;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv132, compiledLocals, 4);
                    } finally {
                        tmp133 = objv132[1];
                        if ( tmp133 != null ) {
                            tmp133.release();
                        }
                        TJC.releaseObjv(interp, objv132, 2);
                    }
                } // End Invoke: append
                { // Invoke: return [...]
                    { // Invoke: list $tmpsymbol $buffer 0
                        TclObject tmp136 = TclList.newInstance();
                        TclObject tmp137;
                        try {
                            tmp137 = getVarScalar(interp, "tmpsymbol", compiledLocals, 25);
                            TclList.append(interp, tmp136, tmp137);
                            tmp137 = getVarScalar(interp, "buffer", compiledLocals, 4);
                            TclList.append(interp, tmp136, tmp137);
                            TclList.append(interp, tmp136, const14);
                        } catch (TclException ex) {
                            tmp136.release();
                            throw ex;
                        }
                        interp.setResult(tmp136);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_boolean_emit");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_expr_evaluate");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("expr");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("true");
        TclBoolean.get(interp, const3);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("false");
        TclBoolean.get(interp, const4);
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(1);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("scalar");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_tmpvar_next");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_emit_variable");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_indent");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("boolean ");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance(" = ");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_tclobject_to_boolean");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(";\n");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(0);
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("lsearch");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("-exact");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("compileproc_generate_key");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compileproc_emit_invoke");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("TclObject ");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance(" = interp.getResult()");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("lindex");
        const22.preserve(); const22.preserve();
        const23 = TclInteger.newInstance(3);
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("( ");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance(".getIntValue() != 0 )");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance(".getDoubleValue() != 0.0 )");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance(".getBooleanValue(interp)");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("compileproc_emit_exprvalue_release");
        const28.preserve(); const28.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_expr_evaluate";
                break;
            }
            case 2: {
                cmdName = "expr";
                break;
            }
            case 3: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_variable";
                break;
            }
            case 5: {
                cmdName = "emitter_indent";
                break;
            }
            case 6: {
                cmdName = "emitter_tclobject_to_boolean";
                break;
            }
            case 7: {
                cmdName = "lsearch";
                break;
            }
            case 8: {
                cmdName = "compileproc_generate_key";
                break;
            }
            case 9: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 10: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 11: {
                cmdName = "lindex";
                break;
            }
            case 12: {
                cmdName = "compileproc_emit_exprvalue_release";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "expr_index",
        "_compileproc_key_info",
        "_compileproc",
        "buffer",
        "expr_result",
        "type",
        "value",
        "ovalue",
        "result",
        "simple_bool_value",
        "sname",
        "vinfo",
        "tmpsymbol1",
        "tmpsymbol2",
        "retsymbol",
        "inline",
        "ind",
        "values",
        "expr_str",
        "gkey",
        "eval_tuple",
        "infostr",
        "ev",
        "ev_types",
        "tmpsymbol"
    };
} // end class CompileprocExprEvaluateBooleanEmitCmd

