// TJC implementation of procedure compileproc_expr_evaluate_emit_inlined_unary_not_operator
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitInlinedUnaryNotOperatorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "value_tuple value_type value_symbol value_has_null_string");
        }
        setVarScalar(interp, "value_tuple", objv[1], compiledLocals, 0);
        setVarScalar(interp, "value_type", objv[2], compiledLocals, 1);
        setVarScalar(interp, "value_symbol", objv[3], compiledLocals, 2);
        setVarScalar(interp, "value_has_null_string", objv[4], compiledLocals, 3);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $value_type == "TclObject"
            TclObject tmp0 = getVarScalar(interp, "value_type", compiledLocals, 1);
            boolean tmp1 = tmp0.toString().equals("TclObject");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set eval_tuple [...]
                    TclObject tmp4;
                    { // Invoke: ... $value_tuple {rtype TclObject}
                        TclObject[] objv5 = TJC.grabObjv(interp, 3);
                        TclObject tmp6;
                        try {
                            // Arg 0 constant: ...
                            objv5[0] = const1;
                            // Arg 1 variable: $value_tuple
                            tmp6 = getVarScalar(interp, "value_tuple", compiledLocals, 0);
                            tmp6.preserve();
                            objv5[1] = tmp6;
                            // Arg 2 constant: {rtype TclObject}
                            objv5[2] = const2;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv5, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp6 = objv5[1];
                            if ( tmp6 != null ) {
                                tmp6.release();
                            }
                            TJC.releaseObjv(interp, objv5, 3);
                        }
                    } // End Invoke: ...
                    tmp4 = interp.getResult();
                    setVarScalar(interp, "eval_tuple", tmp4, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set tclobject_sym [...]
                    TclObject tmp7;
                    { // Invoke: lindex $eval_tuple 1
                        TclObject tmp8 = getVarScalar(interp, "eval_tuple", compiledLocals, 5);
                        tmp8 = TclList.index(interp, tmp8, 1);
                        if ( tmp8 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp8);
                        }
                    } // End Invoke: lindex
                    tmp7 = interp.getResult();
                    setVarScalar(interp, "tclobject_sym", tmp7, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv9 = TJC.grabObjv(interp, 1);
                    TclObject tmp10;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: lindex $eval_tuple 2
                            TclObject tmp11 = getVarScalar(interp, "eval_tuple", compiledLocals, 5);
                            tmp11 = TclList.index(interp, tmp11, 2);
                            if ( tmp11 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp11);
                            }
                        } // End Invoke: lindex
                        tmp10 = interp.getResult();
                        tmp10.preserve();
                        objv9[0] = tmp10;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv9, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv9, 1);
                    }
                } // End Invoke: append
                { // Invoke: set ev [...]
                    TclObject tmp12;
                    { // Invoke: ...
                        TclObject[] objv13 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv13[0] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv13, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv13, 1);
                        }
                    } // End Invoke: ...
                    tmp12 = interp.getResult();
                    setVarScalar(interp, "ev", tmp12, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv14 = TJC.grabObjv(interp, 1);
                    TclObject tmp15;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $ev "" ""
                            TclObject[] objv16 = TJC.grabObjv(interp, 4);
                            TclObject tmp17;
                            try {
                                // Arg 0 constant: ...
                                objv16[0] = const4;
                                // Arg 1 variable: $ev
                                tmp17 = getVarScalar(interp, "ev", compiledLocals, 7);
                                tmp17.preserve();
                                objv16[1] = tmp17;
                                // Arg 2 constant: ""
                                objv16[2] = const0;
                                // Arg 3 constant: ""
                                objv16[3] = const0;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv16, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp17 = objv16[1];
                                if ( tmp17 != null ) {
                                    tmp17.release();
                                }
                                TJC.releaseObjv(interp, objv16, 4);
                            }
                        } // End Invoke: ...
                        tmp15 = interp.getResult();
                        tmp15.preserve();
                        objv14[0] = tmp15;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv14, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv14, 1);
                    }
                } // End Invoke: append
                { // Invoke: append buffer [...] [...] [...] [...] [...]
                    TclObject[] objv18 = TJC.grabObjv(interp, 5);
                    TclObject tmp19;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... "..."
                            TclObject[] objv20 = TJC.grabObjv(interp, 2);
                            TclObject tmp21;
                            try {
                                // Arg 0 constant: ...
                                objv20[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp22 = new StringBuffer(64);
                                tmp21 = getVarScalar(interp, "tclobject_sym", compiledLocals, 6);
                                sbtmp22.append(tmp21.toString());
                                sbtmp22.append(".isIntType()");
                                tmp21 = TclString.newInstance(sbtmp22);
                                tmp21.preserve();
                                objv20[1] = tmp21;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv20, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp21 = objv20[1];
                                if ( tmp21 != null ) {
                                    tmp21.release();
                                }
                                TJC.releaseObjv(interp, objv20, 2);
                            }
                        } // End Invoke: ...
                        tmp19 = interp.getResult();
                        tmp19.preserve();
                        objv18[0] = tmp19;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv23 = TJC.grabObjv(interp, 2);
                            TclObject tmp24;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv23[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp25 = new StringBuffer(64);
                                sbtmp25.append("TJC.exprUnaryNotOperatorKnownInt(");
                                tmp24 = getVarScalar(interp, "ev", compiledLocals, 7);
                                sbtmp25.append(tmp24.toString());
                                sbtmp25.append(", ");
                                tmp24 = getVarScalar(interp, "tclobject_sym", compiledLocals, 6);
                                sbtmp25.append(tmp24.toString());
                                sbtmp25.append(")");
                                tmp24 = TclString.newInstance(sbtmp25);
                                tmp24.preserve();
                                objv23[1] = tmp24;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv23, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp24 = objv23[1];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                TJC.releaseObjv(interp, objv23, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp19 = interp.getResult();
                        tmp19.preserve();
                        objv18[1] = tmp19;
                        // Arg 4 command: [...]
                        { // Invoke: ...
                            TclObject[] objv26 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv26[0] = const7;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv26, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv26, 1);
                            }
                        } // End Invoke: ...
                        tmp19 = interp.getResult();
                        tmp19.preserve();
                        objv18[2] = tmp19;
                        // Arg 5 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv27 = TJC.grabObjv(interp, 2);
                            TclObject tmp28;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv27[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp29 = new StringBuffer(64);
                                sbtmp29.append("TJC.exprUnaryNotOperator(interp, ");
                                tmp28 = getVarScalar(interp, "ev", compiledLocals, 7);
                                sbtmp29.append(tmp28.toString());
                                sbtmp29.append(", ");
                                tmp28 = getVarScalar(interp, "tclobject_sym", compiledLocals, 6);
                                sbtmp29.append(tmp28.toString());
                                sbtmp29.append(")");
                                tmp28 = TclString.newInstance(sbtmp29);
                                tmp28.preserve();
                                objv27[1] = tmp28;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv27, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp28 = objv27[1];
                                if ( tmp28 != null ) {
                                    tmp28.release();
                                }
                                TJC.releaseObjv(interp, objv27, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp19 = interp.getResult();
                        tmp19.preserve();
                        objv18[3] = tmp19;
                        // Arg 6 command: [...]
                        { // Invoke: ...
                            TclObject[] objv30 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv30[0] = const8;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv30, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv30, 1);
                            }
                        } // End Invoke: ...
                        tmp19 = interp.getResult();
                        tmp19.preserve();
                        objv18[4] = tmp19;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv18, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv18, 5);
                    }
                } // End Invoke: append
                { // Invoke: set ev_types {}
                    setVarScalar(interp, "ev_types", const0, compiledLocals, 8);
                } // End Invoke: set
            } else {
                { // Invoke: set eval_tuple [...]
                    TclObject tmp31;
                    { // Invoke: ... $value_tuple {nostr 1}
                        TclObject[] objv32 = TJC.grabObjv(interp, 3);
                        TclObject tmp33;
                        try {
                            // Arg 0 constant: ...
                            objv32[0] = const1;
                            // Arg 1 variable: $value_tuple
                            tmp33 = getVarScalar(interp, "value_tuple", compiledLocals, 0);
                            tmp33.preserve();
                            objv32[1] = tmp33;
                            // Arg 2 constant: {nostr 1}
                            objv32[2] = const9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv32, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp33 = objv32[1];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            TJC.releaseObjv(interp, objv32, 3);
                        }
                    } // End Invoke: ...
                    tmp31 = interp.getResult();
                    setVarScalar(interp, "eval_tuple", tmp31, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set ev [...]
                    TclObject tmp34;
                    { // Invoke: lindex $eval_tuple 1
                        TclObject tmp35 = getVarScalar(interp, "eval_tuple", compiledLocals, 5);
                        tmp35 = TclList.index(interp, tmp35, 1);
                        if ( tmp35 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp35);
                        }
                    } // End Invoke: lindex
                    tmp34 = interp.getResult();
                    setVarScalar(interp, "ev", tmp34, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv36 = TJC.grabObjv(interp, 1);
                    TclObject tmp37;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: lindex $eval_tuple 2
                            TclObject tmp38 = getVarScalar(interp, "eval_tuple", compiledLocals, 5);
                            tmp38 = TclList.index(interp, tmp38, 2);
                            if ( tmp38 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp38);
                            }
                        } // End Invoke: lindex
                        tmp37 = interp.getResult();
                        tmp37.preserve();
                        objv36[0] = tmp37;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv36, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv36, 1);
                    }
                } // End Invoke: append
                { // Invoke: set result_info [...]
                    TclObject tmp39;
                    { // Invoke: lindex $eval_tuple 3
                        TclObject tmp40 = getVarScalar(interp, "eval_tuple", compiledLocals, 5);
                        tmp40 = TclList.index(interp, tmp40, 3);
                        if ( tmp40 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp40);
                        }
                    } // End Invoke: lindex
                    tmp39 = interp.getResult();
                    setVarScalar(interp, "result_info", tmp39, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set ev_types [...]
                    TclObject tmp41;
                    { // Invoke: lindex $result_info 3
                        TclObject tmp42 = getVarScalar(interp, "result_info", compiledLocals, 9);
                        tmp42 = TclList.index(interp, tmp42, 3);
                        if ( tmp42 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp42);
                        }
                    } // End Invoke: lindex
                    tmp41 = interp.getResult();
                    setVarScalar(interp, "ev_types", tmp41, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Unary operator: ! $value_has_null_string
                    TclObject tmp43 = getVarScalar(interp, "value_has_null_string", compiledLocals, 3);
                    ExprValue tmp44 = evs0;
                    if ( tmp43.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp44, tmp43);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp44, tmp43);
                    }
                    // End Unary operator: !
                    boolean tmp45 = ( tmp44.getIntValue() != 0 );
                    if ( tmp45 ) {
                        { // Invoke: set ... [...]
                            TclObject tmp46;
                            { // Invoke: lindex $result_info 2
                                TclObject tmp47 = getVarScalar(interp, "result_info", compiledLocals, 9);
                                tmp47 = TclList.index(interp, tmp47, 2);
                                if ( tmp47 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp47);
                                }
                            } // End Invoke: lindex
                            tmp46 = interp.getResult();
                            setVarScalar(interp, "value_has_null_string", tmp46, compiledLocals, 3);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: () || ()
                    // Binary operator: $ev_types == "int"
                    TclObject tmp48 = getVarScalar(interp, "ev_types", compiledLocals, 8);
                    boolean tmp49 = tmp48.toString().equals("int");
                    ExprValue tmp50 = evs0;
                    tmp50.setIntValue(tmp49);
                    // End Binary operator: ==
                    if (!tmp50.getBooleanValue(interp)) {
                    // Binary operator: $ev_types == "boolean"
                    TclObject tmp51 = getVarScalar(interp, "ev_types", compiledLocals, 8);
                    boolean tmp52 = tmp51.toString().equals("boolean");
                    ExprValue tmp53 = evs1;
                    tmp53.setIntValue(tmp52);
                    // End Binary operator: ==
                    tmp50.setIntValue(tmp53.getBooleanValue(interp));
                    } else {
                    tmp50.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp54 = ( tmp50.getIntValue() != 0 );
                    if ( tmp54 ) {
                        { // Invoke: if ... ... else ...
                            TclObject tmp55 = getVarScalar(interp, "value_has_null_string", compiledLocals, 3);
                            boolean tmp56 = TJC.getBoolean(interp, tmp55);
                            if ( tmp56 ) {
                                { // Invoke: append buffer [...]
                                    TclObject[] objv57 = TJC.grabObjv(interp, 1);
                                    TclObject tmp58;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_statement "..."
                                            TclObject[] objv59 = TJC.grabObjv(interp, 2);
                                            TclObject tmp60;
                                            try {
                                                // Arg 0 constant: emitter_statement
                                                objv59[0] = const6;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp61 = new StringBuffer(64);
                                                tmp60 = getVarScalar(interp, "ev", compiledLocals, 7);
                                                sbtmp61.append(tmp60.toString());
                                                sbtmp61.append(".optIntUnaryNotNstr()");
                                                tmp60 = TclString.newInstance(sbtmp61);
                                                tmp60.preserve();
                                                objv59[1] = tmp60;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv59, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp60 = objv59[1];
                                                if ( tmp60 != null ) {
                                                    tmp60.release();
                                                }
                                                TJC.releaseObjv(interp, objv59, 2);
                                            }
                                        } // End Invoke: emitter_statement
                                        tmp58 = interp.getResult();
                                        tmp58.preserve();
                                        objv57[0] = tmp58;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv57, compiledLocals, 4);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv57, 1);
                                    }
                                } // End Invoke: append
                            } else {
                                { // Invoke: append buffer [...]
                                    TclObject[] objv62 = TJC.grabObjv(interp, 1);
                                    TclObject tmp63;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_statement "..."
                                            TclObject[] objv64 = TJC.grabObjv(interp, 2);
                                            TclObject tmp65;
                                            try {
                                                // Arg 0 constant: emitter_statement
                                                objv64[0] = const6;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp66 = new StringBuffer(64);
                                                tmp65 = getVarScalar(interp, "ev", compiledLocals, 7);
                                                sbtmp66.append(tmp65.toString());
                                                sbtmp66.append(".optIntUnaryNot()");
                                                tmp65 = TclString.newInstance(sbtmp66);
                                                tmp65.preserve();
                                                objv64[1] = tmp65;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv64, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp65 = objv64[1];
                                                if ( tmp65 != null ) {
                                                    tmp65.release();
                                                }
                                                TJC.releaseObjv(interp, objv64, 2);
                                            }
                                        } // End Invoke: emitter_statement
                                        tmp63 = interp.getResult();
                                        tmp63.preserve();
                                        objv62[0] = tmp63;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv62, compiledLocals, 4);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv62, 1);
                                    }
                                } // End Invoke: append
                            }
                        } // End Invoke: if
                    } else {
                        // Binary operator: $ev_types == "double"
                        TclObject tmp67 = getVarScalar(interp, "ev_types", compiledLocals, 8);
                        boolean tmp68 = tmp67.toString().equals("double");
                        ExprValue tmp69 = evs0;
                        tmp69.setIntValue(tmp68);
                        // End Binary operator: ==
                        boolean tmp70 = ( tmp69.getIntValue() != 0 );
                        if ( tmp70 ) {
                            { // Invoke: append buffer [...]
                                TclObject[] objv71 = TJC.grabObjv(interp, 1);
                                TclObject tmp72;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_statement "..."
                                        TclObject[] objv73 = TJC.grabObjv(interp, 2);
                                        TclObject tmp74;
                                        try {
                                            // Arg 0 constant: emitter_statement
                                            objv73[0] = const6;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp75 = new StringBuffer(64);
                                            sbtmp75.append("TJC.exprUnaryNotOperator(interp, ");
                                            tmp74 = getVarScalar(interp, "ev", compiledLocals, 7);
                                            sbtmp75.append(tmp74.toString());
                                            sbtmp75.append(")");
                                            tmp74 = TclString.newInstance(sbtmp75);
                                            tmp74.preserve();
                                            objv73[1] = tmp74;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv73, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp74 = objv73[1];
                                            if ( tmp74 != null ) {
                                                tmp74.release();
                                            }
                                            TJC.releaseObjv(interp, objv73, 2);
                                        }
                                    } // End Invoke: emitter_statement
                                    tmp72 = interp.getResult();
                                    tmp72.preserve();
                                    objv71[0] = tmp72;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv71, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv71, 1);
                                }
                            } // End Invoke: append
                        } else {
                            { // Invoke: append buffer [...]
                                TclObject[] objv76 = TJC.grabObjv(interp, 1);
                                TclObject tmp77;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... "$ev.isIntType()"
                                        TclObject[] objv78 = TJC.grabObjv(interp, 2);
                                        TclObject tmp79;
                                        try {
                                            // Arg 0 constant: ...
                                            objv78[0] = const5;
                                            // Arg 1 word: "$ev.isIntType()"
                                            StringBuffer sbtmp80 = new StringBuffer(64);
                                            tmp79 = getVarScalar(interp, "ev", compiledLocals, 7);
                                            sbtmp80.append(tmp79.toString());
                                            sbtmp80.append(".isIntType()");
                                            tmp79 = TclString.newInstance(sbtmp80);
                                            tmp79.preserve();
                                            objv78[1] = tmp79;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv78, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp79 = objv78[1];
                                            if ( tmp79 != null ) {
                                                tmp79.release();
                                            }
                                            TJC.releaseObjv(interp, objv78, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp77 = interp.getResult();
                                    tmp77.preserve();
                                    objv76[0] = tmp77;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv76, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv76, 1);
                                }
                            } // End Invoke: append
                            { // Invoke: if ... ... else ...
                                TclObject tmp81 = getVarScalar(interp, "value_has_null_string", compiledLocals, 3);
                                boolean tmp82 = TJC.getBoolean(interp, tmp81);
                                if ( tmp82 ) {
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv83 = TJC.grabObjv(interp, 1);
                                        TclObject tmp84;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_statement "..."
                                                TclObject[] objv85 = TJC.grabObjv(interp, 2);
                                                TclObject tmp86;
                                                try {
                                                    // Arg 0 constant: emitter_statement
                                                    objv85[0] = const6;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp87 = new StringBuffer(64);
                                                    tmp86 = getVarScalar(interp, "ev", compiledLocals, 7);
                                                    sbtmp87.append(tmp86.toString());
                                                    sbtmp87.append(".optIntUnaryNotNstr()");
                                                    tmp86 = TclString.newInstance(sbtmp87);
                                                    tmp86.preserve();
                                                    objv85[1] = tmp86;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                        ? cmdcache5.cmd : null), objv85, 0);
                                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                        updateCmdCache(interp, 5);
                                                    }
                                                } finally {
                                                    tmp86 = objv85[1];
                                                    if ( tmp86 != null ) {
                                                        tmp86.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv85, 2);
                                                }
                                            } // End Invoke: emitter_statement
                                            tmp84 = interp.getResult();
                                            tmp84.preserve();
                                            objv83[0] = tmp84;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv83, compiledLocals, 4);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv83, 1);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv88 = TJC.grabObjv(interp, 1);
                                        TclObject tmp89;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_statement "..."
                                                TclObject[] objv90 = TJC.grabObjv(interp, 2);
                                                TclObject tmp91;
                                                try {
                                                    // Arg 0 constant: emitter_statement
                                                    objv90[0] = const6;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp92 = new StringBuffer(64);
                                                    tmp91 = getVarScalar(interp, "ev", compiledLocals, 7);
                                                    sbtmp92.append(tmp91.toString());
                                                    sbtmp92.append(".optIntUnaryNot()");
                                                    tmp91 = TclString.newInstance(sbtmp92);
                                                    tmp91.preserve();
                                                    objv90[1] = tmp91;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                        ? cmdcache5.cmd : null), objv90, 0);
                                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                        updateCmdCache(interp, 5);
                                                    }
                                                } finally {
                                                    tmp91 = objv90[1];
                                                    if ( tmp91 != null ) {
                                                        tmp91.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv90, 2);
                                                }
                                            } // End Invoke: emitter_statement
                                            tmp89 = interp.getResult();
                                            tmp89.preserve();
                                            objv88[0] = tmp89;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv88, compiledLocals, 4);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv88, 1);
                                        }
                                    } // End Invoke: append
                                }
                            } // End Invoke: if
                            { // Invoke: append buffer [...] [...] [...]
                                TclObject[] objv93 = TJC.grabObjv(interp, 3);
                                TclObject tmp94;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ...
                                        TclObject[] objv95 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv95[0] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv95, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv95, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp94 = interp.getResult();
                                    tmp94.preserve();
                                    objv93[0] = tmp94;
                                    // Arg 3 command: [...]
                                    { // Invoke: emitter_statement "..."
                                        TclObject[] objv96 = TJC.grabObjv(interp, 2);
                                        TclObject tmp97;
                                        try {
                                            // Arg 0 constant: emitter_statement
                                            objv96[0] = const6;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp98 = new StringBuffer(64);
                                            sbtmp98.append("TJC.exprUnaryNotOperator(interp, ");
                                            tmp97 = getVarScalar(interp, "ev", compiledLocals, 7);
                                            sbtmp98.append(tmp97.toString());
                                            sbtmp98.append(")");
                                            tmp97 = TclString.newInstance(sbtmp98);
                                            tmp97.preserve();
                                            objv96[1] = tmp97;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv96, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp97 = objv96[1];
                                            if ( tmp97 != null ) {
                                                tmp97.release();
                                            }
                                            TJC.releaseObjv(interp, objv96, 2);
                                        }
                                    } // End Invoke: emitter_statement
                                    tmp94 = interp.getResult();
                                    tmp94.preserve();
                                    objv93[1] = tmp94;
                                    // Arg 4 command: [...]
                                    { // Invoke: ...
                                        TclObject[] objv99 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv99[0] = const8;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                ? cmdcache7.cmd : null), objv99, 0);
                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                updateCmdCache(interp, 7);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv99, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp94 = interp.getResult();
                                    tmp94.preserve();
                                    objv93[2] = tmp94;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv93, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv93, 3);
                                }
                            } // End Invoke: append
                        }
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $ev $buffer $ev_types
                TclObject tmp100 = TclList.newInstance();
                TclObject tmp101;
                try {
                    tmp101 = getVarScalar(interp, "ev", compiledLocals, 7);
                    TclList.append(interp, tmp100, tmp101);
                    tmp101 = getVarScalar(interp, "buffer", compiledLocals, 4);
                    TclList.append(interp, tmp100, tmp101);
                    tmp101 = getVarScalar(interp, "ev_types", compiledLocals, 8);
                    TclList.append(interp, tmp100, tmp101);
                } catch (TclException ex) {
                    tmp100.release();
                    throw ex;
                }
                interp.setResult(tmp100);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_inlined_unary_not_operator");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("rtype TclObject");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_tmpvar_next");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_emit_exprvalue_get");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_container_if_start");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_statement");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_container_if_else");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_container_if_end");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("nostr 1");
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 2: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 3: {
                cmdName = "compileproc_emit_exprvalue_get";
                break;
            }
            case 4: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 5: {
                cmdName = "emitter_statement";
                break;
            }
            case 6: {
                cmdName = "emitter_container_if_else";
                break;
            }
            case 7: {
                cmdName = "emitter_container_if_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "value_tuple",
        "value_type",
        "value_symbol",
        "value_has_null_string",
        "buffer",
        "eval_tuple",
        "tclobject_sym",
        "ev",
        "ev_types",
        "result_info"
    };
} // end class CompileprocExprEvaluateEmitInlinedUnaryNotOperatorCmd

