// TJC implementation of procedure compileproc_expr_evaluate_result_emit
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateResultEmitCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 2);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set expr_index 1
            setVarScalar(interp, "expr_index", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set expr_result [...]
            TclObject tmp0;
            { // Invoke: ... $key $expr_index
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const2;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 variable: $expr_index
                    tmp2 = getVarScalar(interp, "expr_index", compiledLocals, 4);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "expr_result", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set eval_tuple [...]
            TclObject tmp3;
            { // Invoke: ... $expr_result
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const3;
                    // Arg 1 variable: $expr_result
                    tmp5 = getVarScalar(interp, "expr_result", compiledLocals, 5);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            tmp3 = interp.getResult();
            setVarScalar(interp, "eval_tuple", tmp3, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set infostr [...]
            TclObject tmp6;
            { // Invoke: lindex $eval_tuple 0
                TclObject tmp7 = getVarScalar(interp, "eval_tuple", compiledLocals, 6);
                tmp7 = TclList.index(interp, tmp7, 0);
                if ( tmp7 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp7);
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "infostr", tmp6, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set ev [...]
            TclObject tmp8;
            { // Invoke: lindex $eval_tuple 1
                TclObject tmp9 = getVarScalar(interp, "eval_tuple", compiledLocals, 6);
                tmp9 = TclList.index(interp, tmp9, 1);
                if ( tmp9 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp9);
                }
            } // End Invoke: lindex
            tmp8 = interp.getResult();
            setVarScalar(interp, "ev", tmp8, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv10 = TJC.grabObjv(interp, 1);
            TclObject tmp11;
            try {
                // Arg 2 command: [...]
                { // Invoke: lindex $eval_tuple 2
                    TclObject tmp12 = getVarScalar(interp, "eval_tuple", compiledLocals, 6);
                    tmp12 = TclList.index(interp, tmp12, 2);
                    if ( tmp12 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp12);
                    }
                } // End Invoke: lindex
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[0] = tmp11;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv10, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv10, 1);
            }
        } // End Invoke: append
        { // Invoke: set ev_types [...]
            TclObject tmp13;
            { // Invoke: lindex $eval_tuple 3 3
                TclObject[] objv14 = TJC.grabObjv(interp, 4);
                TclObject tmp15;
                try {
                    // Arg 0 constant: lindex
                    objv14[0] = const4;
                    // Arg 1 variable: $eval_tuple
                    tmp15 = getVarScalar(interp, "eval_tuple", compiledLocals, 6);
                    tmp15.preserve();
                    objv14[1] = tmp15;
                    // Arg 2 constant: 3
                    objv14[2] = const5;
                    // Arg 3 constant: 3
                    objv14[3] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv14, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp15 = objv14[1];
                    if ( tmp15 != null ) {
                        tmp15.release();
                    }
                    TJC.releaseObjv(interp, objv14, 4);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "ev_types", tmp13, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            TclObject tmp16 = getVarArray(interp, "_compileproc", "options,expr_inline_set_result", compiledLocals, 1);
            ExprValue tmp17 = evs0;
            TJC.exprInitValue(interp, tmp17, tmp16);
            boolean tmp18 = tmp17.getBooleanValue(interp);
            if ( tmp18 ) {
                { // Invoke: if ... ... elseif {$ev_types == {int}} ... elseif ... ... elseif ... ... else ...
                    // Binary operator: $ev_types == "boolean"
                    TclObject tmp19 = getVarScalar(interp, "ev_types", compiledLocals, 9);
                    boolean tmp20 = tmp19.toString().equals("boolean");
                    ExprValue tmp21 = evs0;
                    tmp21.setIntValue(tmp20);
                    // End Binary operator: ==
                    boolean tmp22 = ( tmp21.getIntValue() != 0 );
                    if ( tmp22 ) {
                        { // Invoke: append buffer [...] "interp.setResult( " $ev ...
                            TclObject[] objv23 = TJC.grabObjv(interp, 4);
                            TclObject tmp24;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv25 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv25[0] = const6;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv25, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv25, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp24 = interp.getResult();
                                tmp24.preserve();
                                objv23[0] = tmp24;
                                // Arg 3 constant: "interp.setResult( "
                                objv23[1] = const7;
                                // Arg 4 variable: $ev
                                tmp24 = getVarScalar(interp, "ev", compiledLocals, 8);
                                tmp24.preserve();
                                objv23[2] = tmp24;
                                // Arg 5 constant: ...
                                objv23[3] = const8;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv23, compiledLocals, 3);
                            } finally {
                                tmp24 = objv23[0];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                tmp24 = objv23[2];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                TJC.releaseObjv(interp, objv23, 4);
                            }
                        } // End Invoke: append
                    } else {
                        // Binary operator: $ev_types == "int"
                        TclObject tmp26 = getVarScalar(interp, "ev_types", compiledLocals, 9);
                        boolean tmp27 = tmp26.toString().equals("int");
                        ExprValue tmp28 = evs0;
                        tmp28.setIntValue(tmp27);
                        // End Binary operator: ==
                        boolean tmp29 = ( tmp28.getIntValue() != 0 );
                        if ( tmp29 ) {
                            { // Invoke: append buffer [...] "interp.setResult( " $ev ...
                                TclObject[] objv30 = TJC.grabObjv(interp, 4);
                                TclObject tmp31;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv32 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv32[0] = const6;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv32, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv32, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp31 = interp.getResult();
                                    tmp31.preserve();
                                    objv30[0] = tmp31;
                                    // Arg 3 constant: "interp.setResult( "
                                    objv30[1] = const7;
                                    // Arg 4 variable: $ev
                                    tmp31 = getVarScalar(interp, "ev", compiledLocals, 8);
                                    tmp31.preserve();
                                    objv30[2] = tmp31;
                                    // Arg 5 constant: ...
                                    objv30[3] = const9;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv30, compiledLocals, 3);
                                } finally {
                                    tmp31 = objv30[0];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    tmp31 = objv30[2];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    TJC.releaseObjv(interp, objv30, 4);
                                }
                            } // End Invoke: append
                        } else {
                            // Binary operator: $ev_types == "double"
                            TclObject tmp33 = getVarScalar(interp, "ev_types", compiledLocals, 9);
                            boolean tmp34 = tmp33.toString().equals("double");
                            ExprValue tmp35 = evs0;
                            tmp35.setIntValue(tmp34);
                            // End Binary operator: ==
                            boolean tmp36 = ( tmp35.getIntValue() != 0 );
                            if ( tmp36 ) {
                                { // Invoke: append buffer [...] "interp.setResult( " $ev ...
                                    TclObject[] objv37 = TJC.grabObjv(interp, 4);
                                    TclObject tmp38;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv39 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv39[0] = const6;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv39, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv39, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp38 = interp.getResult();
                                        tmp38.preserve();
                                        objv37[0] = tmp38;
                                        // Arg 3 constant: "interp.setResult( "
                                        objv37[1] = const7;
                                        // Arg 4 variable: $ev
                                        tmp38 = getVarScalar(interp, "ev", compiledLocals, 8);
                                        tmp38.preserve();
                                        objv37[2] = tmp38;
                                        // Arg 5 constant: ...
                                        objv37[3] = const10;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv37, compiledLocals, 3);
                                    } finally {
                                        tmp38 = objv37[0];
                                        if ( tmp38 != null ) {
                                            tmp38.release();
                                        }
                                        tmp38 = objv37[2];
                                        if ( tmp38 != null ) {
                                            tmp38.release();
                                        }
                                        TJC.releaseObjv(interp, objv37, 4);
                                    }
                                } // End Invoke: append
                            } else {
                                // Binary operator: $ev_types == "String"
                                TclObject tmp40 = getVarScalar(interp, "ev_types", compiledLocals, 9);
                                boolean tmp41 = tmp40.toString().equals("String");
                                ExprValue tmp42 = evs0;
                                tmp42.setIntValue(tmp41);
                                // End Binary operator: ==
                                boolean tmp43 = ( tmp42.getIntValue() != 0 );
                                if ( tmp43 ) {
                                    { // Invoke: append buffer [...] "interp.setResult( " $ev ...
                                        TclObject[] objv44 = TJC.grabObjv(interp, 4);
                                        TclObject tmp45;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_indent
                                                TclObject[] objv46 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: emitter_indent
                                                    objv46[0] = const6;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv46, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv46, 1);
                                                }
                                            } // End Invoke: emitter_indent
                                            tmp45 = interp.getResult();
                                            tmp45.preserve();
                                            objv44[0] = tmp45;
                                            // Arg 3 constant: "interp.setResult( "
                                            objv44[1] = const7;
                                            // Arg 4 variable: $ev
                                            tmp45 = getVarScalar(interp, "ev", compiledLocals, 8);
                                            tmp45.preserve();
                                            objv44[2] = tmp45;
                                            // Arg 5 constant: ...
                                            objv44[3] = const11;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv44, compiledLocals, 3);
                                        } finally {
                                            tmp45 = objv44[0];
                                            if ( tmp45 != null ) {
                                                tmp45.release();
                                            }
                                            tmp45 = objv44[2];
                                            if ( tmp45 != null ) {
                                                tmp45.release();
                                            }
                                            TJC.releaseObjv(interp, objv44, 4);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: append buffer [...] ... $ev ...
                                        TclObject[] objv47 = TJC.grabObjv(interp, 4);
                                        TclObject tmp48;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_indent
                                                TclObject[] objv49 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: emitter_indent
                                                    objv49[0] = const6;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv49, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv49, 1);
                                                }
                                            } // End Invoke: emitter_indent
                                            tmp48 = interp.getResult();
                                            tmp48.preserve();
                                            objv47[0] = tmp48;
                                            // Arg 3 constant: ...
                                            objv47[1] = const12;
                                            // Arg 4 variable: $ev
                                            tmp48 = getVarScalar(interp, "ev", compiledLocals, 8);
                                            tmp48.preserve();
                                            objv47[2] = tmp48;
                                            // Arg 5 constant: ...
                                            objv47[3] = const13;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv47, compiledLocals, 3);
                                        } finally {
                                            tmp48 = objv47[0];
                                            if ( tmp48 != null ) {
                                                tmp48.release();
                                            }
                                            tmp48 = objv47[2];
                                            if ( tmp48 != null ) {
                                                tmp48.release();
                                            }
                                            TJC.releaseObjv(interp, objv47, 4);
                                        }
                                    } // End Invoke: append
                                }
                            }
                        }
                    }
                } // End Invoke: if
            } else {
                { // Invoke: append buffer [...] ... $ev ...
                    TclObject[] objv50 = TJC.grabObjv(interp, 4);
                    TclObject tmp51;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv52 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv52[0] = const6;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv52, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv52, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp51 = interp.getResult();
                        tmp51.preserve();
                        objv50[0] = tmp51;
                        // Arg 3 constant: ...
                        objv50[1] = const12;
                        // Arg 4 variable: $ev
                        tmp51 = getVarScalar(interp, "ev", compiledLocals, 8);
                        tmp51.preserve();
                        objv50[2] = tmp51;
                        // Arg 5 constant: ...
                        objv50[3] = const13;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv50, compiledLocals, 3);
                    } finally {
                        tmp51 = objv50[0];
                        if ( tmp51 != null ) {
                            tmp51.release();
                        }
                        tmp51 = objv50[2];
                        if ( tmp51 != null ) {
                            tmp51.release();
                        }
                        TJC.releaseObjv(interp, objv50, 4);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv53 = TJC.grabObjv(interp, 1);
            TclObject tmp54;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $ev
                    TclObject[] objv55 = TJC.grabObjv(interp, 2);
                    TclObject tmp56;
                    try {
                        // Arg 0 constant: ...
                        objv55[0] = const14;
                        // Arg 1 variable: $ev
                        tmp56 = getVarScalar(interp, "ev", compiledLocals, 8);
                        tmp56.preserve();
                        objv55[1] = tmp56;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv55, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp56 = objv55[1];
                        if ( tmp56 != null ) {
                            tmp56.release();
                        }
                        TJC.releaseObjv(interp, objv55, 2);
                    }
                } // End Invoke: ...
                tmp54 = interp.getResult();
                tmp54.preserve();
                objv53[0] = tmp54;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv53, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv53, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp57 = getVarScalar(interp, "buffer", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp57);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_result_emit");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_expr_evaluate");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("lindex");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(3);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_indent");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("interp.setResult( ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(".getIntValue() != 0 );\n");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(".getIntValue() );\n");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance(".getDoubleValue() );\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance(".getStringValue() );\n");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("TJC.exprSetResult(interp, ");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(");\n");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_emit_exprvalue_release");
        const14.preserve(); const14.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_expr_evaluate";
                break;
            }
            case 2: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 3: {
                cmdName = "lindex";
                break;
            }
            case 4: {
                cmdName = "emitter_indent";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_exprvalue_release";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_key_info",
        "buffer",
        "expr_index",
        "expr_result",
        "eval_tuple",
        "infostr",
        "ev",
        "ev_types"
    };
} // end class CompileprocExprEvaluateResultEmitCmd

