// TJC implementation of procedure compileproc_get_argument_tuple
package tjc;
import tcl.lang.*;

public class CompileprocGetArgumentTupleCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key i");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "i", objv[2], compiledLocals, 1);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 2);
        } // End Invoke: global
        { // Invoke: set types $...
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            tmp0 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(",types");
            tmp0 = getVarArray(interp, "_compileproc_key_info", sbtmp1.toString(), compiledLocals, 2);
            setVarScalar(interp, "types", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set values $...
            TclObject tmp2;
            StringBuffer sbtmp3 = new StringBuffer(64);
            tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp3.append(tmp2.toString());
            sbtmp3.append(",values");
            tmp2 = getVarArray(interp, "_compileproc_key_info", sbtmp3.toString(), compiledLocals, 2);
            setVarScalar(interp, "values", tmp2, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set num_args $...
            TclObject tmp4;
            StringBuffer sbtmp5 = new StringBuffer(64);
            tmp4 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp5.append(tmp4.toString());
            sbtmp5.append(",num_args");
            tmp4 = getVarArray(interp, "_compileproc_key_info", sbtmp5.toString(), compiledLocals, 2);
            setVarScalar(interp, "num_args", tmp4, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set instrs $...
            TclObject tmp6;
            StringBuffer sbtmp7 = new StringBuffer(64);
            tmp6 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append(",instrs");
            tmp6 = getVarArray(interp, "_compileproc_key_info", sbtmp7.toString(), compiledLocals, 2);
            setVarScalar(interp, "instrs", tmp6, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set cmaps $...
            TclObject tmp8;
            StringBuffer sbtmp9 = new StringBuffer(64);
            tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp9.append(tmp8.toString());
            sbtmp9.append(",cmaps");
            tmp8 = getVarArray(interp, "_compileproc_key_info", sbtmp9.toString(), compiledLocals, 2);
            setVarScalar(interp, "cmaps", tmp8, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: () || ()
            // Binary operator: $i < 0
            TclObject tmp10 = getVarScalar(interp, "i", compiledLocals, 1);
            ExprValue tmp11 = evs0;
            TJC.exprInitValue(interp, tmp11, tmp10);
            ExprValue tmp12 = evs1;
            tmp12.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp11, tmp12);
            // End Binary operator: <
            if (!tmp11.getBooleanValue(interp)) {
            // Binary operator: $i >= $num_args
            TclObject tmp13 = getVarScalar(interp, "i", compiledLocals, 1);
            ExprValue tmp14 = evs1;
            TJC.exprInitValue(interp, tmp14, tmp13);
            TclObject tmp15 = getVarScalar(interp, "num_args", compiledLocals, 5);
            ExprValue tmp16 = evs2;
            TJC.exprInitValue(interp, tmp16, tmp15);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp14, tmp16);
            // End Binary operator: >=
            tmp11.setIntValue(tmp14.getBooleanValue(interp));
            } else {
            tmp11.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp17 = ( tmp11.getIntValue() != 0 );
            if ( tmp17 ) {
                { // Invoke: error "..."
                    TclObject[] objv18 = TJC.grabObjv(interp, 2);
                    TclObject tmp19;
                    try {
                        // Arg 0 constant: error
                        objv18[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp20 = new StringBuffer(64);
                        sbtmp20.append("command argument index ");
                        tmp19 = getVarScalar(interp, "i", compiledLocals, 1);
                        sbtmp20.append(tmp19.toString());
                        sbtmp20.append(" is out of range : num_args is ");
                        tmp19 = getVarScalar(interp, "num_args", compiledLocals, 5);
                        sbtmp20.append(tmp19.toString());
                        tmp19 = TclString.newInstance(sbtmp20);
                        tmp19.preserve();
                        objv18[1] = tmp19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv18, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp19 = objv18[1];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 2);
                    }
                } // End Invoke: error
            } else {
                { // Invoke: set type [...]
                    TclObject tmp21;
                    { // Invoke: lindex $types $i
                        TclObject tmp22 = null;
                        TclObject tmp23;
                        try {
                            tmp22 = getVarScalar(interp, "types", compiledLocals, 3);
                            tmp22.preserve();
                            tmp23 = getVarScalar(interp, "i", compiledLocals, 1);
                            TJC.lindexNonconst(interp, tmp22, tmp23);
                        } finally {
                            if ( tmp22 != null ) {
                                tmp22.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp21 = interp.getResult();
                    setVarScalar(interp, "type", tmp21, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: switch -exact -- $type {constant} - {variable} - {command} - {word} ... default ...
                    TclObject tmp24 = getVarScalar(interp, "type", compiledLocals, 8);
                    String tmp25 = tmp24.toString();
                    int tmp25_length = tmp25.length();
                    char tmp25_first = '\n';
                    if ( tmp25_length > 0 ) {
                        tmp25_first = tmp25.charAt(0);
                    }
                    interp.resetResult();
                    if ( ( tmp25_length == 8 && tmp25_first == 'c'
                            && tmp25.compareTo("constant") == 0 ) ||
                        ( tmp25_length == 8 && tmp25_first == 'v'
                            && tmp25.compareTo("variable") == 0 ) ||
                        ( tmp25_length == 7 && tmp25_first == 'c'
                            && tmp25.compareTo("command") == 0 ) ||
                        ( tmp25_length == 4 && tmp25_first == 'w'
                            && tmp25.compareTo("word") == 0 ) ) {
                        // Pattern {word}
                        { // Invoke: return [...]
                            { // Invoke: list $type [...] [...] [...]
                                TclObject tmp26 = TclList.newInstance();
                                TclObject tmp27;
                                try {
                                    tmp27 = getVarScalar(interp, "type", compiledLocals, 8);
                                    TclList.append(interp, tmp26, tmp27);
                                    { // Invoke: lindex $values $i
                                        TclObject tmp28 = null;
                                        TclObject tmp29;
                                        try {
                                            tmp28 = getVarScalar(interp, "values", compiledLocals, 4);
                                            tmp28.preserve();
                                            tmp29 = getVarScalar(interp, "i", compiledLocals, 1);
                                            TJC.lindexNonconst(interp, tmp28, tmp29);
                                        } finally {
                                            if ( tmp28 != null ) {
                                                tmp28.release();
                                            }
                                        }
                                    } // End Invoke: lindex
                                    tmp27 = interp.getResult();
                                    TclList.append(interp, tmp26, tmp27);
                                    { // Invoke: lindex $instrs $i
                                        TclObject tmp30 = null;
                                        TclObject tmp31;
                                        try {
                                            tmp30 = getVarScalar(interp, "instrs", compiledLocals, 6);
                                            tmp30.preserve();
                                            tmp31 = getVarScalar(interp, "i", compiledLocals, 1);
                                            TJC.lindexNonconst(interp, tmp30, tmp31);
                                        } finally {
                                            if ( tmp30 != null ) {
                                                tmp30.release();
                                            }
                                        }
                                    } // End Invoke: lindex
                                    tmp27 = interp.getResult();
                                    TclList.append(interp, tmp26, tmp27);
                                    { // Invoke: lindex $cmaps $i
                                        TclObject tmp32 = null;
                                        TclObject tmp33;
                                        try {
                                            tmp32 = getVarScalar(interp, "cmaps", compiledLocals, 7);
                                            tmp32.preserve();
                                            tmp33 = getVarScalar(interp, "i", compiledLocals, 1);
                                            TJC.lindexNonconst(interp, tmp32, tmp33);
                                        } finally {
                                            if ( tmp32 != null ) {
                                                tmp32.release();
                                            }
                                        }
                                    } // End Invoke: lindex
                                    tmp27 = interp.getResult();
                                    TclList.append(interp, tmp26, tmp27);
                                } catch (TclException ex) {
                                    tmp26.release();
                                    throw ex;
                                }
                                interp.setResult(tmp26);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        // Pattern default
                        { // Invoke: error "..."
                            TclObject[] objv34 = TJC.grabObjv(interp, 2);
                            TclObject tmp35;
                            try {
                                // Arg 0 constant: error
                                objv34[0] = const0;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp36 = new StringBuffer(64);
                                sbtmp36.append("unknown type ");
                                sbtmp36.append("\"");
                                tmp35 = getVarScalar(interp, "type", compiledLocals, 8);
                                sbtmp36.append(tmp35.toString());
                                sbtmp36.append("\"");
                                tmp35 = TclString.newInstance(sbtmp36);
                                tmp35.preserve();
                                objv34[1] = tmp35;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv34, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp35 = objv34[1];
                                if ( tmp35 != null ) {
                                    tmp35.release();
                                }
                                TJC.releaseObjv(interp, objv34, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: switch
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_get_argument_tuple");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "i",
        "_compileproc_key_info",
        "types",
        "values",
        "num_args",
        "instrs",
        "cmaps",
        "type"
    };
} // end class CompileprocGetArgumentTupleCmd

