// TJC implementation of procedure compileproc_key_children
package tjc;
import tcl.lang.*;

public class CompileprocKeyChildrenCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "pkey");
        }
        setVarScalar(interp, "pkey", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: if ... ... else ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                TclObject tmp1;
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp2 = new StringBuffer(64);
                    sbtmp2.append("_compileproc_ckeys(");
                    tmp1 = getVarScalar(interp, "pkey", compiledLocals, 0);
                    sbtmp2.append(tmp1.toString());
                    sbtmp2.append(")");
                    tmp1 = TclString.newInstance(sbtmp2);
                    tmp1.preserve();
                    objv0[2] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[2];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp3 = interp.getResult();
            ExprValue tmp4 = evs0;
            if ( tmp3.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp4, tmp3);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp4, tmp3);
            }
            // End Unary operator: !
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: return {}
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return $...
                    TclObject tmp6 = getVarScalar(interp, "pkey", compiledLocals, 0);
                    tmp6 = getVarArray(interp, "_compileproc_ckeys", tmp6.toString(), compiledLocals, 2);
                    interp.resetResult();
                    interp.setResult(tmp6);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_key_children");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "pkey",
        "_compileproc",
        "_compileproc_ckeys"
    };
} // end class CompileprocKeyChildrenCmd

