// TJC implementation of procedure compileproc_keys_info
package tjc;
import tcl.lang.*;

public class CompileprocKeysInfoCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 0);
        } // End Invoke: global
        { // Invoke: return $...
            TclObject tmp0 = getVarArray(interp, "_compileproc_ckeys", "info_keys", compiledLocals, 0);
            interp.resetResult();
            interp.setResult(tmp0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_keys_info");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc_ckeys"
    };
} // end class CompileprocKeysInfoCmd

