// TJC implementation of procedure compileproc_push_controls_context
package tjc;
import tcl.lang.*;

public class CompileprocPushControlsContextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 4 || objv.length > 5) {
            throw new TclNumArgsException(interp, 1, objv, "type can_break can_continue ?can_return?");
        }
        setVarScalar(interp, "type", objv[1], compiledLocals, 0);
        setVarScalar(interp, "can_break", objv[2], compiledLocals, 1);
        setVarScalar(interp, "can_continue", objv[3], compiledLocals, 2);
        setVarScalar(interp, "can_return", 
            ((objv.length <= 4) ? const0 : objv[4]), compiledLocals, 3);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 4);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: $can_return == "keep"
            TclObject tmp0 = getVarScalar(interp, "can_return", compiledLocals, 3);
            boolean tmp1 = tmp0.toString().equals("keep");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set tuple [...]
                    TclObject tmp4;
                    { // Invoke: lindex $... 0
                        TclObject tmp5 = getVarArray(interp, "_compileproc", "options,controls_stack", compiledLocals, 4);
                        tmp5 = TclList.index(interp, tmp5, 0);
                        if ( tmp5 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp5);
                        }
                    } // End Invoke: lindex
                    tmp4 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp4, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set can_return [...]
                    TclObject tmp6;
                    { // Invoke: lindex $tuple 6
                        TclObject tmp7 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp7 = TclList.index(interp, tmp7, 6);
                        if ( tmp7 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp7);
                        }
                    } // End Invoke: lindex
                    tmp6 = interp.getResult();
                    setVarScalar(interp, "can_return", tmp6, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set tuple [...]
            TclObject tmp8;
            { // Invoke: list $type "break" $can_break "continue" $can_continue "return" $can_return
                TclObject tmp9 = TclList.newInstance();
                TclObject tmp10;
                try {
                    tmp10 = getVarScalar(interp, "type", compiledLocals, 0);
                    TclList.append(interp, tmp9, tmp10);
                    TclList.append(interp, tmp9, const1);
                    tmp10 = getVarScalar(interp, "can_break", compiledLocals, 1);
                    TclList.append(interp, tmp9, tmp10);
                    TclList.append(interp, tmp9, const2);
                    tmp10 = getVarScalar(interp, "can_continue", compiledLocals, 2);
                    TclList.append(interp, tmp9, tmp10);
                    TclList.append(interp, tmp9, const3);
                    tmp10 = getVarScalar(interp, "can_return", compiledLocals, 3);
                    TclList.append(interp, tmp9, tmp10);
                } catch (TclException ex) {
                    tmp9.release();
                    throw ex;
                }
                interp.setResult(tmp9);
            } // End Invoke: list
            tmp8 = interp.getResult();
            setVarScalar(interp, "tuple", tmp8, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp11;
            { // Invoke: linsert $... 0 $tuple
                TclObject[] objv12 = TJC.grabObjv(interp, 4);
                TclObject tmp13;
                try {
                    // Arg 0 constant: linsert
                    objv12[0] = const4;
                    // Arg 1 variable: $...
                    tmp13 = getVarArray(interp, "_compileproc", "options,controls_stack", compiledLocals, 4);
                    tmp13.preserve();
                    objv12[1] = tmp13;
                    // Arg 2 constant: 0
                    objv12[2] = const5;
                    // Arg 3 variable: $tuple
                    tmp13 = getVarScalar(interp, "tuple", compiledLocals, 5);
                    tmp13.preserve();
                    objv12[3] = tmp13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv12, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp13 = objv12[1];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    tmp13 = objv12[3];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 4);
                }
            } // End Invoke: linsert
            tmp11 = interp.getResult();
            tmp11 = setVarArray(interp, "_compileproc", "options,controls_stack", tmp11, compiledLocals, 4);
            interp.setResult(tmp11);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_push_controls_context");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("keep");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("break");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("continue");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("return");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("linsert");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "linsert";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "type",
        "can_break",
        "can_continue",
        "can_return",
        "_compileproc",
        "tuple"
    };
} // end class CompileprocPushControlsContextCmd

