// TJC implementation of procedure compileproc_scan_keys
package tjc;
import tcl.lang.*;

public class CompileprocScanKeysCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 38, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "keys");
        }
        setVarScalar(interp, "keys", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc ...
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 2);
        } // End Invoke: global
        { // Invoke: set cmd_needs_init $...
            TclObject tmp0;
            tmp0 = getVarArray(interp, "_compileproc_key_info", "cmd_needs_init", compiledLocals, 2);
            setVarScalar(interp, "cmd_needs_init", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set constants_found $...
            TclObject tmp1;
            tmp1 = getVarArray(interp, "_compileproc_key_info", "constants_found", compiledLocals, 2);
            setVarScalar(interp, "constants_found", tmp1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set last_key [...]
            TclObject tmp2;
            { // Invoke: lindex $keys end
                TclObject tmp3 = null;
                TclObject tmp4;
                try {
                    tmp3 = getVarScalar(interp, "keys", compiledLocals, 0);
                    tmp3.preserve();
                    tmp4 = const0;
                    TJC.lindexNonconst(interp, tmp3, tmp4);
                } finally {
                    if ( tmp3 != null ) {
                        tmp3.release();
                    }
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "last_key", tmp2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: foreach key $keys ...
            TclObject tmp5 = null;
            try {
                tmp5 = getVarScalar(interp, "keys", compiledLocals, 0);
                tmp5.preserve();
                final int tmp5_length = TclList.getLength(interp, tmp5);

                for ( int index6 = 0 ; index6 < tmp5_length ; index6++ ) {
                    TclObject tmp7 = TclList.index(interp, tmp5, index6);
                    try {
                        setVarScalar(interp, "key", tmp7, compiledLocals, 6);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ...
                        { // Invoke: ... $key
                            TclObject[] objv8 = TJC.grabObjv(interp, 2);
                            TclObject tmp9;
                            try {
                                // Arg 0 constant: ...
                                objv8[0] = const1;
                                // Arg 1 variable: $key
                                tmp9 = getVarScalar(interp, "key", compiledLocals, 6);
                                tmp9.preserve();
                                objv8[1] = tmp9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv8, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp9 = objv8[1];
                                if ( tmp9 != null ) {
                                    tmp9.release();
                                }
                                TJC.releaseObjv(interp, objv8, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp10 = interp.getResult();
                        ExprValue tmp11 = evs0;
                        TJC.exprInitValue(interp, tmp11, tmp10);
                        boolean tmp12 = tmp11.getBooleanValue(interp);
                        if ( tmp12 ) {
                            { // Invoke: error "..."
                                TclObject[] objv13 = TJC.grabObjv(interp, 2);
                                TclObject tmp14;
                                try {
                                    // Arg 0 constant: error
                                    objv13[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp15 = new StringBuffer(64);
                                    sbtmp15.append("unexpected undetermined arguments command key ");
                                    sbtmp15.append("\"");
                                    tmp14 = getVarScalar(interp, "key", compiledLocals, 6);
                                    sbtmp15.append(tmp14.toString());
                                    sbtmp15.append("\"");
                                    tmp14 = TclString.newInstance(sbtmp15);
                                    tmp14.preserve();
                                    objv13[1] = tmp14;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv13, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp14 = objv13[1];
                                    if ( tmp14 != null ) {
                                        tmp14.release();
                                    }
                                    TJC.releaseObjv(interp, objv13, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set script [...]
                        TclObject tmp16;
                        { // Invoke: descend_get_data $key script
                            TclObject[] objv17 = TJC.grabObjv(interp, 3);
                            TclObject tmp18;
                            try {
                                // Arg 0 constant: descend_get_data
                                objv17[0] = const3;
                                // Arg 1 variable: $key
                                tmp18 = getVarScalar(interp, "key", compiledLocals, 6);
                                tmp18.preserve();
                                objv17[1] = tmp18;
                                // Arg 2 constant: script
                                objv17[2] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv17, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp18 = objv17[1];
                                if ( tmp18 != null ) {
                                    tmp18.release();
                                }
                                TJC.releaseObjv(interp, objv17, 3);
                            }
                        } // End Invoke: descend_get_data
                        tmp16 = interp.getResult();
                        setVarScalar(interp, "script", tmp16, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: set tree [...]
                        TclObject tmp19;
                        { // Invoke: descend_get_data $key tree
                            TclObject[] objv20 = TJC.grabObjv(interp, 3);
                            TclObject tmp21;
                            try {
                                // Arg 0 constant: descend_get_data
                                objv20[0] = const3;
                                // Arg 1 variable: $key
                                tmp21 = getVarScalar(interp, "key", compiledLocals, 6);
                                tmp21.preserve();
                                objv20[1] = tmp21;
                                // Arg 2 constant: tree
                                objv20[2] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv20, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp21 = objv20[1];
                                if ( tmp21 != null ) {
                                    tmp21.release();
                                }
                                TJC.releaseObjv(interp, objv20, 3);
                            }
                        } // End Invoke: descend_get_data
                        tmp19 = interp.getResult();
                        setVarScalar(interp, "tree", tmp19, compiledLocals, 8);
                    } // End Invoke: set
                    { // Invoke: set num_args [...]
                        TclObject tmp22;
                        { // Invoke: llength $tree
                            TclObject tmp23 = getVarScalar(interp, "tree", compiledLocals, 8);
                            int tmp24 = TclList.getLength(interp, tmp23);
                            interp.setResult(tmp24);
                        } // End Invoke: llength
                        tmp22 = interp.getResult();
                        setVarScalar(interp, "num_args", tmp22, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: if {$num_args < 1} ...
                        // Binary operator: $num_args < 1
                        TclObject tmp25 = getVarScalar(interp, "num_args", compiledLocals, 9);
                        ExprValue tmp26 = evs0;
                        TJC.exprInitValue(interp, tmp26, tmp25);
                        ExprValue tmp27 = evs1;
                        tmp27.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp26, tmp27);
                        // End Binary operator: <
                        boolean tmp28 = ( tmp26.getIntValue() != 0 );
                        if ( tmp28 ) {
                            { // Invoke: error "..."
                                TclObject[] objv29 = TJC.grabObjv(interp, 2);
                                TclObject tmp30;
                                try {
                                    // Arg 0 constant: error
                                    objv29[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp31 = new StringBuffer(64);
                                    sbtmp31.append("num args (");
                                    tmp30 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                    sbtmp31.append(tmp30.toString());
                                    sbtmp31.append(") must be positive");
                                    tmp30 = TclString.newInstance(sbtmp31);
                                    tmp30.preserve();
                                    objv29[1] = tmp30;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv29, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp30 = objv29[1];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    TJC.releaseObjv(interp, objv29, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set types [...]
                        TclObject tmp32;
                        { // Invoke: list
                            TclObject tmp33 = TclList.newInstance();
                            interp.setResult(tmp33);
                        } // End Invoke: list
                        tmp32 = interp.getResult();
                        setVarScalar(interp, "types", tmp32, compiledLocals, 10);
                    } // End Invoke: set
                    { // Invoke: set values [...]
                        TclObject tmp34;
                        { // Invoke: list
                            TclObject tmp35 = TclList.newInstance();
                            interp.setResult(tmp35);
                        } // End Invoke: list
                        tmp34 = interp.getResult();
                        setVarScalar(interp, "values", tmp34, compiledLocals, 11);
                    } // End Invoke: set
                    { // Invoke: set cmaps [...]
                        TclObject tmp36;
                        { // Invoke: list
                            TclObject tmp37 = TclList.newInstance();
                            interp.setResult(tmp37);
                        } // End Invoke: list
                        tmp36 = interp.getResult();
                        setVarScalar(interp, "cmaps", tmp36, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: set instrs [...]
                        TclObject tmp38;
                        { // Invoke: list
                            TclObject tmp39 = TclList.newInstance();
                            interp.setResult(tmp39);
                        } // End Invoke: list
                        tmp38 = interp.getResult();
                        setVarScalar(interp, "instrs", tmp38, compiledLocals, 13);
                    } // End Invoke: set
                    { // Invoke: set argument_commands [...]
                        TclObject tmp40;
                        { // Invoke: descend_commands $key
                            TclObject[] objv41 = TJC.grabObjv(interp, 2);
                            TclObject tmp42;
                            try {
                                // Arg 0 constant: descend_commands
                                objv41[0] = const6;
                                // Arg 1 variable: $key
                                tmp42 = getVarScalar(interp, "key", compiledLocals, 6);
                                tmp42.preserve();
                                objv41[1] = tmp42;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv41, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp42 = objv41[1];
                                if ( tmp42 != null ) {
                                    tmp42.release();
                                }
                                TJC.releaseObjv(interp, objv41, 2);
                            }
                        } // End Invoke: descend_commands
                        tmp40 = interp.getResult();
                        setVarScalar(interp, "argument_commands", tmp40, compiledLocals, 14);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Binary operator: [...] != $num_args
                        { // Invoke: llength $argument_commands
                            TclObject tmp43 = getVarScalar(interp, "argument_commands", compiledLocals, 14);
                            int tmp44 = TclList.getLength(interp, tmp43);
                            interp.setResult(tmp44);
                        } // End Invoke: llength
                        TclObject tmp45 = interp.getResult();
                        ExprValue tmp46 = evs0;
                        TJC.exprInitValue(interp, tmp46, tmp45);
                        TclObject tmp47 = getVarScalar(interp, "num_args", compiledLocals, 9);
                        ExprValue tmp48 = evs1;
                        TJC.exprInitValue(interp, tmp48, tmp47);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp46, tmp48);
                        // End Binary operator: !=
                        boolean tmp49 = ( tmp46.getIntValue() != 0 );
                        if ( tmp49 ) {
                            { // Invoke: error "..."
                                TclObject[] objv50 = TJC.grabObjv(interp, 2);
                                TclObject tmp51;
                                try {
                                    // Arg 0 constant: error
                                    objv50[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp52 = new StringBuffer(64);
                                    sbtmp52.append("mismatched num_args (");
                                    tmp51 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                    sbtmp52.append(tmp51.toString());
                                    sbtmp52.append(") and num argument_commands ");
                                    { // Invoke: llength $argument_commands
                                        TclObject tmp53 = getVarScalar(interp, "argument_commands", compiledLocals, 14);
                                        int tmp54 = TclList.getLength(interp, tmp53);
                                        interp.setResult(tmp54);
                                    } // End Invoke: llength
                                    tmp51 = interp.getResult();
                                    sbtmp52.append(tmp51.toString());
                                    sbtmp52.append(" for key ");
                                    tmp51 = getVarScalar(interp, "key", compiledLocals, 6);
                                    sbtmp52.append(tmp51.toString());
                                    sbtmp52.append(", argument_commands\n                is ");
                                    sbtmp52.append("{");
                                    tmp51 = getVarScalar(interp, "argument_commands", compiledLocals, 14);
                                    sbtmp52.append(tmp51.toString());
                                    sbtmp52.append("}");
                                    tmp51 = TclString.newInstance(sbtmp52);
                                    tmp51.preserve();
                                    objv50[1] = tmp51;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv50, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp51 = objv50[1];
                                    if ( tmp51 != null ) {
                                        tmp51.release();
                                    }
                                    TJC.releaseObjv(interp, objv50, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set i 0
                        setVarScalar(interp, "i", const7, compiledLocals, 15);
                    } // End Invoke: set
                    { // Invoke: foreach telem $tree ...
                        TclObject tmp55 = null;
                        try {
                            tmp55 = getVarScalar(interp, "tree", compiledLocals, 8);
                            tmp55.preserve();
                            final int tmp55_length = TclList.getLength(interp, tmp55);

                            for ( int index56 = 0 ; index56 < tmp55_length ; index56++ ) {
                                TclObject tmp57 = TclList.index(interp, tmp55, index56);
                                try {
                                    setVarScalar(interp, "telem", tmp57, compiledLocals, 16);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "telem");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: if ... ... elseif ... ... elseif ... ... elseif ... ... else ...
                                    { // Invoke: parse_is_simple_text $telem
                                        TclObject[] objv58 = TJC.grabObjv(interp, 2);
                                        TclObject tmp59;
                                        try {
                                            // Arg 0 constant: parse_is_simple_text
                                            objv58[0] = const8;
                                            // Arg 1 variable: $telem
                                            tmp59 = getVarScalar(interp, "telem", compiledLocals, 16);
                                            tmp59.preserve();
                                            objv58[1] = tmp59;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv58, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp59 = objv58[1];
                                            if ( tmp59 != null ) {
                                                tmp59.release();
                                            }
                                            TJC.releaseObjv(interp, objv58, 2);
                                        }
                                    } // End Invoke: parse_is_simple_text
                                    TclObject tmp60 = interp.getResult();
                                    ExprValue tmp61 = evs0;
                                    TJC.exprInitValue(interp, tmp61, tmp60);
                                    boolean tmp62 = tmp61.getBooleanValue(interp);
                                    if ( tmp62 ) {
                                        { // Invoke: set qtext [...]
                                            TclObject tmp63;
                                            { // Invoke: ... $script $telem
                                                TclObject[] objv64 = TJC.grabObjv(interp, 3);
                                                TclObject tmp65;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv64[0] = const9;
                                                    // Arg 1 variable: $script
                                                    tmp65 = getVarScalar(interp, "script", compiledLocals, 7);
                                                    tmp65.preserve();
                                                    objv64[1] = tmp65;
                                                    // Arg 2 variable: $telem
                                                    tmp65 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                    tmp65.preserve();
                                                    objv64[2] = tmp65;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                        ? cmdcache6.cmd : null), objv64, 0);
                                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                        updateCmdCache(interp, 6);
                                                    }
                                                } finally {
                                                    tmp65 = objv64[1];
                                                    if ( tmp65 != null ) {
                                                        tmp65.release();
                                                    }
                                                    tmp65 = objv64[2];
                                                    if ( tmp65 != null ) {
                                                        tmp65.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv64, 3);
                                                }
                                            } // End Invoke: ...
                                            tmp63 = interp.getResult();
                                            setVarScalar(interp, "qtext", tmp63, compiledLocals, 17);
                                        } // End Invoke: set
                                        { // Invoke: if ... ... else ...
                                            // Binary operator: () && ()
                                            // Binary operator: [...] == "{"
                                            { // Invoke: string index $qtext 0
                                                TclObject tmp66 = getVarScalar(interp, "qtext", compiledLocals, 17);
                                                String tmp67 = tmp66.toString();
                                                TclObject tmp68 = TJC.stringIndex(interp, tmp67, const7);
                                                interp.setResult(tmp68);
                                            } // End Invoke: string
                                            TclObject tmp69 = interp.getResult();
                                            boolean tmp70 = tmp69.toString().equals("{");
                                            ExprValue tmp71 = evs0;
                                            tmp71.setIntValue(tmp70);
                                            // End Binary operator: ==
                                            if (tmp71.getBooleanValue(interp)) {
                                            // Binary operator: [...] == "}"
                                            { // Invoke: string index $qtext end
                                                TclObject tmp72 = getVarScalar(interp, "qtext", compiledLocals, 17);
                                                String tmp73 = tmp72.toString();
                                                TclObject tmp74 = TJC.stringIndex(interp, tmp73, const0);
                                                interp.setResult(tmp74);
                                            } // End Invoke: string
                                            TclObject tmp75 = interp.getResult();
                                            boolean tmp76 = tmp75.toString().equals("}");
                                            ExprValue tmp77 = evs1;
                                            tmp77.setIntValue(tmp76);
                                            // End Binary operator: ==
                                            tmp71.setIntValue(tmp77.getBooleanValue(interp));
                                            } else {
                                            tmp71.setIntValue(0);
                                            } // End if: ()
                                            // End Binary operator: &&
                                            boolean tmp78 = ( tmp71.getIntValue() != 0 );
                                            if ( tmp78 ) {
                                                { // Invoke: set brace_quoted 1
                                                    setVarScalar(interp, "brace_quoted", const10, compiledLocals, 18);
                                                } // End Invoke: set
                                            } else {
                                                { // Invoke: set brace_quoted 0
                                                    setVarScalar(interp, "brace_quoted", const7, compiledLocals, 18);
                                                } // End Invoke: set
                                            }
                                        } // End Invoke: if
                                        { // Invoke: set uqtext [...]
                                            TclObject tmp79;
                                            { // Invoke: ... $script $telem "text"
                                                TclObject[] objv80 = TJC.grabObjv(interp, 4);
                                                TclObject tmp81;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv80[0] = const9;
                                                    // Arg 1 variable: $script
                                                    tmp81 = getVarScalar(interp, "script", compiledLocals, 7);
                                                    tmp81.preserve();
                                                    objv80[1] = tmp81;
                                                    // Arg 2 variable: $telem
                                                    tmp81 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                    tmp81.preserve();
                                                    objv80[2] = tmp81;
                                                    // Arg 3 constant: "text"
                                                    objv80[3] = const11;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                        ? cmdcache6.cmd : null), objv80, 0);
                                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                        updateCmdCache(interp, 6);
                                                    }
                                                } finally {
                                                    tmp81 = objv80[1];
                                                    if ( tmp81 != null ) {
                                                        tmp81.release();
                                                    }
                                                    tmp81 = objv80[2];
                                                    if ( tmp81 != null ) {
                                                        tmp81.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv80, 4);
                                                }
                                            } // End Invoke: ...
                                            tmp79 = interp.getResult();
                                            setVarScalar(interp, "uqtext", tmp79, compiledLocals, 19);
                                        } // End Invoke: set
                                        { // Invoke: if ... ... else ...
                                            // Binary operator: $brace_quoted && ()
                                            TclObject tmp82 = getVarScalar(interp, "brace_quoted", compiledLocals, 18);
                                            ExprValue tmp83 = evs0;
                                            TJC.exprInitValue(interp, tmp83, tmp82);
                                            if (tmp83.getBooleanValue(interp)) {
                                            // Binary operator: [...] != ()
                                            { // Invoke: string first ... $uqtext
                                                char tmp84 = '\\';
                                                TclObject tmp85 = getVarScalar(interp, "uqtext", compiledLocals, 19);
                                                String tmp86 = tmp85.toString();
                                                int tmp87 = tmp86.indexOf(tmp84);
                                                interp.setResult(tmp87);
                                            } // End Invoke: string
                                            TclObject tmp88 = interp.getResult();
                                            ExprValue tmp89 = evs1;
                                            TJC.exprInitValue(interp, tmp89, tmp88);
                                            // Unary operator: - 1
                                            ExprValue tmp90 = evs2;
                                            tmp90.setIntValue(-1);
                                            // End Unary operator: -
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp89, tmp90);
                                            // End Binary operator: !=
                                            tmp83.setIntValue(tmp89.getBooleanValue(interp));
                                            } else {
                                            tmp83.setIntValue(0);
                                            } // End if: $brace_quoted
                                            // End Binary operator: &&
                                            boolean tmp91 = ( tmp83.getIntValue() != 0 );
                                            if ( tmp91 ) {
                                                { // Invoke: set cmap {}
                                                    setVarScalar(interp, "cmap", const12, compiledLocals, 20);
                                                } // End Invoke: set
                                                { // Invoke: set bs_uqtext ""
                                                    setVarScalar(interp, "bs_uqtext", const12, compiledLocals, 21);
                                                } // End Invoke: set
                                                { // Invoke: set len [...]
                                                    TclObject tmp92;
                                                    { // Invoke: string length $uqtext
                                                        TclObject tmp93 = getVarScalar(interp, "uqtext", compiledLocals, 19);
                                                        int tmp94 = tmp93.toString().length();
                                                        interp.setResult(tmp94);
                                                    } // End Invoke: string
                                                    tmp92 = interp.getResult();
                                                    setVarScalar(interp, "len", tmp92, compiledLocals, 22);
                                                } // End Invoke: set
                                                { // Invoke: for {set i 0} {$i < $len} {incr i} ...
                                                    { // Invoke: set i 0
                                                        setVarScalar(interp, "i", const7, compiledLocals, 15);
                                                    } // End Invoke: set
                                                    for ( boolean skip100 = true ; true ; ) {
                                                        if ( skip100 ) {
                                                            skip100 = false;
                                                        } else {
                                                            try {
                                                            if ( false ) { throw (TclException) null; }
                                                            { // Invoke: incr i
                                                                interp.resetResult();
                                                                incrVarScalar(interp, "i", 1, compiledLocals, 15);
                                                            } // End Invoke: incr
                                                            } catch (TclException ex) {
                                                                int type = ex.getCompletionCode();
                                                                if (type == TCL.BREAK) {
                                                                    break;
                                                                } else {
                                                                    throw ex;
                                                                }
                                                            }
                                                        }

                                                        // Binary operator: $i < $len
                                                        TclObject tmp95 = getVarScalar(interp, "i", compiledLocals, 15);
                                                        ExprValue tmp96 = evs0;
                                                        TJC.exprInitValue(interp, tmp96, tmp95);
                                                        TclObject tmp97 = getVarScalar(interp, "len", compiledLocals, 22);
                                                        ExprValue tmp98 = evs1;
                                                        TJC.exprInitValue(interp, tmp98, tmp97);
                                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp96, tmp98);
                                                        // End Binary operator: <
                                                        boolean tmp99 = ( tmp96.getIntValue() != 0 );
                                                        if ( ! tmp99 ) { break; }

                                                        try {
                                                        if ( false ) { throw (TclException) null; }
                                                        { // Invoke: set c [...]
                                                            TclObject tmp101;
                                                            { // Invoke: string index $uqtext $i
                                                                TclObject tmp102 = getVarScalar(interp, "uqtext", compiledLocals, 19);
                                                                String tmp103 = tmp102.toString();
                                                                TclObject tmp104 = getVarScalar(interp, "i", compiledLocals, 15);
                                                                TclObject tmp105 = TJC.stringIndex(interp, tmp103, tmp104);
                                                                interp.setResult(tmp105);
                                                            } // End Invoke: string
                                                            tmp101 = interp.getResult();
                                                            setVarScalar(interp, "c", tmp101, compiledLocals, 23);
                                                        } // End Invoke: set
                                                        { // Invoke: if ... ... else ...
                                                            // Binary operator: $c == "\\"
                                                            TclObject tmp106 = getVarScalar(interp, "c", compiledLocals, 23);
                                                            boolean tmp107 = tmp106.toString().equals("\\");
                                                            ExprValue tmp108 = evs0;
                                                            tmp108.setIntValue(tmp107);
                                                            // End Binary operator: ==
                                                            boolean tmp109 = ( tmp108.getIntValue() != 0 );
                                                            if ( tmp109 ) {
                                                                { // Invoke: append bs_uqtext ...
                                                                    TclObject[] objv110 = TJC.grabObjv(interp, 1);
                                                                    TclObject tmp111;
                                                                    try {
                                                                        // Arg 2 constant: ...
                                                                        objv110[0] = const13;
                                                                        interp.resetResult();
                                                                        appendVarScalar(interp, "bs_uqtext", objv110, compiledLocals, 21);
                                                                    } finally {
                                                                        TJC.releaseObjv(interp, objv110, 1);
                                                                    }
                                                                } // End Invoke: append
                                                                { // Invoke: lappend cmap 2
                                                                    TclObject[] objv112 = TJC.grabObjv(interp, 1);
                                                                    TclObject tmp113;
                                                                    try {
                                                                        // Arg 2 constant: 2
                                                                        objv112[0] = const14;
                                                                        interp.resetResult();
                                                                        lappendVarScalar(interp, "cmap", objv112, compiledLocals, 20);
                                                                    } finally {
                                                                        TJC.releaseObjv(interp, objv112, 1);
                                                                    }
                                                                } // End Invoke: lappend
                                                            } else {
                                                                { // Invoke: append bs_uqtext $c
                                                                    TclObject[] objv114 = TJC.grabObjv(interp, 1);
                                                                    TclObject tmp115;
                                                                    try {
                                                                        // Arg 2 variable: $c
                                                                        tmp115 = getVarScalar(interp, "c", compiledLocals, 23);
                                                                        tmp115.preserve();
                                                                        objv114[0] = tmp115;
                                                                        interp.resetResult();
                                                                        appendVarScalar(interp, "bs_uqtext", objv114, compiledLocals, 21);
                                                                    } finally {
                                                                        TJC.releaseObjvElems(interp, objv114, 1);
                                                                    }
                                                                } // End Invoke: append
                                                                { // Invoke: lappend cmap 1
                                                                    TclObject[] objv116 = TJC.grabObjv(interp, 1);
                                                                    TclObject tmp117;
                                                                    try {
                                                                        // Arg 2 constant: 1
                                                                        objv116[0] = const10;
                                                                        interp.resetResult();
                                                                        lappendVarScalar(interp, "cmap", objv116, compiledLocals, 20);
                                                                    } finally {
                                                                        TJC.releaseObjv(interp, objv116, 1);
                                                                    }
                                                                } // End Invoke: lappend
                                                            }
                                                        } // End Invoke: if
                                                        } catch (TclException ex) {
                                                            int type = ex.getCompletionCode();
                                                            if (type == TCL.BREAK) {
                                                                break;
                                                            } else if (type == TCL.CONTINUE) {
                                                                continue;
                                                            } else {
                                                                throw ex;
                                                            }
                                                        }
                                                    }
                                                } // End Invoke: for
                                                { // Invoke: set uqtext $bs_uqtext
                                                    TclObject tmp118;
                                                    tmp118 = getVarScalar(interp, "bs_uqtext", compiledLocals, 21);
                                                    setVarScalar(interp, "uqtext", tmp118, compiledLocals, 19);
                                                } // End Invoke: set
                                            } else {
                                                { // Invoke: set cmap {}
                                                    setVarScalar(interp, "cmap", const12, compiledLocals, 20);
                                                } // End Invoke: set
                                            }
                                        } // End Invoke: if
                                        { // Invoke: set constants_found 1
                                            setVarScalar(interp, "constants_found", const10, compiledLocals, 4);
                                        } // End Invoke: set
                                        { // Invoke: lappend types constant
                                            TclObject[] objv119 = TJC.grabObjv(interp, 1);
                                            TclObject tmp120;
                                            try {
                                                // Arg 2 constant: constant
                                                objv119[0] = const15;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "types", objv119, compiledLocals, 10);
                                            } finally {
                                                TJC.releaseObjv(interp, objv119, 1);
                                            }
                                        } // End Invoke: lappend
                                        { // Invoke: lappend values $uqtext
                                            TclObject[] objv121 = TJC.grabObjv(interp, 1);
                                            TclObject tmp122;
                                            try {
                                                // Arg 2 variable: $uqtext
                                                tmp122 = getVarScalar(interp, "uqtext", compiledLocals, 19);
                                                tmp122.preserve();
                                                objv121[0] = tmp122;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "values", objv121, compiledLocals, 11);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv121, 1);
                                            }
                                        } // End Invoke: lappend
                                        { // Invoke: lappend instrs $qtext
                                            TclObject[] objv123 = TJC.grabObjv(interp, 1);
                                            TclObject tmp124;
                                            try {
                                                // Arg 2 variable: $qtext
                                                tmp124 = getVarScalar(interp, "qtext", compiledLocals, 17);
                                                tmp124.preserve();
                                                objv123[0] = tmp124;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "instrs", objv123, compiledLocals, 13);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv123, 1);
                                            }
                                        } // End Invoke: lappend
                                        { // Invoke: lappend cmaps $cmap
                                            TclObject[] objv125 = TJC.grabObjv(interp, 1);
                                            TclObject tmp126;
                                            try {
                                                // Arg 2 variable: $cmap
                                                tmp126 = getVarScalar(interp, "cmap", compiledLocals, 20);
                                                tmp126.preserve();
                                                objv125[0] = tmp126;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "cmaps", objv125, compiledLocals, 12);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv125, 1);
                                            }
                                        } // End Invoke: lappend
                                        { // Invoke: ... $uqtext
                                            TclObject[] objv127 = TJC.grabObjv(interp, 2);
                                            TclObject tmp128;
                                            try {
                                                // Arg 0 constant: ...
                                                objv127[0] = const16;
                                                // Arg 1 variable: $uqtext
                                                tmp128 = getVarScalar(interp, "uqtext", compiledLocals, 19);
                                                tmp128.preserve();
                                                objv127[1] = tmp128;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                    ? cmdcache7.cmd : null), objv127, 0);
                                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                    updateCmdCache(interp, 7);
                                                }
                                            } finally {
                                                tmp128 = objv127[1];
                                                if ( tmp128 != null ) {
                                                    tmp128.release();
                                                }
                                                TJC.releaseObjv(interp, objv127, 2);
                                            }
                                        } // End Invoke: ...
                                    } else {
                                        { // Invoke: ... $telem
                                            TclObject[] objv129 = TJC.grabObjv(interp, 2);
                                            TclObject tmp130;
                                            try {
                                                // Arg 0 constant: ...
                                                objv129[0] = const17;
                                                // Arg 1 variable: $telem
                                                tmp130 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                tmp130.preserve();
                                                objv129[1] = tmp130;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                    ? cmdcache8.cmd : null), objv129, 0);
                                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                    updateCmdCache(interp, 8);
                                                }
                                            } finally {
                                                tmp130 = objv129[1];
                                                if ( tmp130 != null ) {
                                                    tmp130.release();
                                                }
                                                TJC.releaseObjv(interp, objv129, 2);
                                            }
                                        } // End Invoke: ...
                                        TclObject tmp131 = interp.getResult();
                                        ExprValue tmp132 = evs0;
                                        TJC.exprInitValue(interp, tmp132, tmp131);
                                        boolean tmp133 = tmp132.getBooleanValue(interp);
                                        if ( tmp133 ) {
                                            { // Invoke: set commands [...]
                                                TclObject tmp134;
                                                { // Invoke: lindex $argument_commands $i
                                                    TclObject tmp135 = null;
                                                    TclObject tmp136;
                                                    try {
                                                        tmp135 = getVarScalar(interp, "argument_commands", compiledLocals, 14);
                                                        tmp135.preserve();
                                                        tmp136 = getVarScalar(interp, "i", compiledLocals, 15);
                                                        TJC.lindexNonconst(interp, tmp135, tmp136);
                                                    } finally {
                                                        if ( tmp135 != null ) {
                                                            tmp135.release();
                                                        }
                                                    }
                                                } // End Invoke: lindex
                                                tmp134 = interp.getResult();
                                                setVarScalar(interp, "commands", tmp134, compiledLocals, 24);
                                            } // End Invoke: set
                                            { // Invoke: if {$commands != {}} ...
                                                // Binary operator: $commands != ""
                                                TclObject tmp137 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                ExprValue tmp138 = evs0;
                                                TJC.exprEqualsEmptyString(tmp138, tmp137, true);
                                                // End Binary operator: !=
                                                boolean tmp139 = ( tmp138.getIntValue() != 0 );
                                                if ( tmp139 ) {
                                                    { // Invoke: ... $key $commands
                                                        TclObject[] objv140 = TJC.grabObjv(interp, 3);
                                                        TclObject tmp141;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv140[0] = const18;
                                                            // Arg 1 variable: $key
                                                            tmp141 = getVarScalar(interp, "key", compiledLocals, 6);
                                                            tmp141.preserve();
                                                            objv140[1] = tmp141;
                                                            // Arg 2 variable: $commands
                                                            tmp141 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                            tmp141.preserve();
                                                            objv140[2] = tmp141;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                                ? cmdcache9.cmd : null), objv140, 0);
                                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                                updateCmdCache(interp, 9);
                                                            }
                                                        } finally {
                                                            tmp141 = objv140[1];
                                                            if ( tmp141 != null ) {
                                                                tmp141.release();
                                                            }
                                                            tmp141 = objv140[2];
                                                            if ( tmp141 != null ) {
                                                                tmp141.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv140, 3);
                                                        }
                                                    } // End Invoke: ...
                                                }
                                            } // End Invoke: if
                                            { // Invoke: set vstree [...]
                                                TclObject tmp142;
                                                { // Invoke: lindex $telem 2 0
                                                    TclObject[] objv143 = TJC.grabObjv(interp, 4);
                                                    TclObject tmp144;
                                                    try {
                                                        // Arg 0 constant: lindex
                                                        objv143[0] = const19;
                                                        // Arg 1 variable: $telem
                                                        tmp144 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                        tmp144.preserve();
                                                        objv143[1] = tmp144;
                                                        // Arg 2 constant: 2
                                                        objv143[2] = const14;
                                                        // Arg 3 constant: 0
                                                        objv143[3] = const7;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                            ? cmdcache10.cmd : null), objv143, 0);
                                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                            updateCmdCache(interp, 10);
                                                        }
                                                    } finally {
                                                        tmp144 = objv143[1];
                                                        if ( tmp144 != null ) {
                                                            tmp144.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv143, 4);
                                                    }
                                                } // End Invoke: lindex
                                                tmp142 = interp.getResult();
                                                setVarScalar(interp, "vstree", tmp142, compiledLocals, 25);
                                            } // End Invoke: set
                                            { // Invoke: set vinfo [...]
                                                TclObject tmp145;
                                                { // Invoke: ... $key $script $vstree
                                                    TclObject[] objv146 = TJC.grabObjv(interp, 4);
                                                    TclObject tmp147;
                                                    try {
                                                        // Arg 0 constant: ...
                                                        objv146[0] = const20;
                                                        // Arg 1 variable: $key
                                                        tmp147 = getVarScalar(interp, "key", compiledLocals, 6);
                                                        tmp147.preserve();
                                                        objv146[1] = tmp147;
                                                        // Arg 2 variable: $script
                                                        tmp147 = getVarScalar(interp, "script", compiledLocals, 7);
                                                        tmp147.preserve();
                                                        objv146[2] = tmp147;
                                                        // Arg 3 variable: $vstree
                                                        tmp147 = getVarScalar(interp, "vstree", compiledLocals, 25);
                                                        tmp147.preserve();
                                                        objv146[3] = tmp147;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                            ? cmdcache11.cmd : null), objv146, 0);
                                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                            updateCmdCache(interp, 11);
                                                        }
                                                    } finally {
                                                        tmp147 = objv146[1];
                                                        if ( tmp147 != null ) {
                                                            tmp147.release();
                                                        }
                                                        tmp147 = objv146[2];
                                                        if ( tmp147 != null ) {
                                                            tmp147.release();
                                                        }
                                                        tmp147 = objv146[3];
                                                        if ( tmp147 != null ) {
                                                            tmp147.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv146, 4);
                                                    }
                                                } // End Invoke: ...
                                                tmp145 = interp.getResult();
                                                setVarScalar(interp, "vinfo", tmp145, compiledLocals, 26);
                                            } // End Invoke: set
                                            { // Invoke: if {$commands != {}} ...
                                                // Binary operator: $commands != ""
                                                TclObject tmp148 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                ExprValue tmp149 = evs0;
                                                TJC.exprEqualsEmptyString(tmp149, tmp148, true);
                                                // End Binary operator: !=
                                                boolean tmp150 = ( tmp149.getIntValue() != 0 );
                                                if ( tmp150 ) {
                                                    { // Invoke: ... $key
                                                        TclObject[] objv151 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp152;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv151[0] = const21;
                                                            // Arg 1 variable: $key
                                                            tmp152 = getVarScalar(interp, "key", compiledLocals, 6);
                                                            tmp152.preserve();
                                                            objv151[1] = tmp152;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                                ? cmdcache12.cmd : null), objv151, 0);
                                                            if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                                updateCmdCache(interp, 12);
                                                            }
                                                        } finally {
                                                            tmp152 = objv151[1];
                                                            if ( tmp152 != null ) {
                                                                tmp152.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv151, 2);
                                                        }
                                                    } // End Invoke: ...
                                                }
                                            } // End Invoke: if
                                            { // Invoke: lappend types variable
                                                TclObject[] objv153 = TJC.grabObjv(interp, 1);
                                                TclObject tmp154;
                                                try {
                                                    // Arg 2 constant: variable
                                                    objv153[0] = const22;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "types", objv153, compiledLocals, 10);
                                                } finally {
                                                    TJC.releaseObjv(interp, objv153, 1);
                                                }
                                            } // End Invoke: lappend
                                            { // Invoke: lappend values $vinfo
                                                TclObject[] objv155 = TJC.grabObjv(interp, 1);
                                                TclObject tmp156;
                                                try {
                                                    // Arg 2 variable: $vinfo
                                                    tmp156 = getVarScalar(interp, "vinfo", compiledLocals, 26);
                                                    tmp156.preserve();
                                                    objv155[0] = tmp156;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "values", objv155, compiledLocals, 11);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv155, 1);
                                                }
                                            } // End Invoke: lappend
                                            { // Invoke: lappend instrs [...]
                                                TclObject[] objv157 = TJC.grabObjv(interp, 1);
                                                TclObject tmp158;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: ... $script $telem
                                                        TclObject[] objv159 = TJC.grabObjv(interp, 3);
                                                        TclObject tmp160;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv159[0] = const23;
                                                            // Arg 1 variable: $script
                                                            tmp160 = getVarScalar(interp, "script", compiledLocals, 7);
                                                            tmp160.preserve();
                                                            objv159[1] = tmp160;
                                                            // Arg 2 variable: $telem
                                                            tmp160 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                            tmp160.preserve();
                                                            objv159[2] = tmp160;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                                ? cmdcache13.cmd : null), objv159, 0);
                                                            if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                                updateCmdCache(interp, 13);
                                                            }
                                                        } finally {
                                                            tmp160 = objv159[1];
                                                            if ( tmp160 != null ) {
                                                                tmp160.release();
                                                            }
                                                            tmp160 = objv159[2];
                                                            if ( tmp160 != null ) {
                                                                tmp160.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv159, 3);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp158 = interp.getResult();
                                                    tmp158.preserve();
                                                    objv157[0] = tmp158;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "instrs", objv157, compiledLocals, 13);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv157, 1);
                                                }
                                            } // End Invoke: lappend
                                            { // Invoke: lappend cmaps {}
                                                TclObject[] objv161 = TJC.grabObjv(interp, 1);
                                                TclObject tmp162;
                                                try {
                                                    // Arg 2 constant: {}
                                                    objv161[0] = const12;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "cmaps", objv161, compiledLocals, 12);
                                                } finally {
                                                    TJC.releaseObjv(interp, objv161, 1);
                                                }
                                            } // End Invoke: lappend
                                        } else {
                                            { // Invoke: ... $telem
                                                TclObject[] objv163 = TJC.grabObjv(interp, 2);
                                                TclObject tmp164;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv163[0] = const24;
                                                    // Arg 1 variable: $telem
                                                    tmp164 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                    tmp164.preserve();
                                                    objv163[1] = tmp164;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                        ? cmdcache14.cmd : null), objv163, 0);
                                                    if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                        updateCmdCache(interp, 14);
                                                    }
                                                } finally {
                                                    tmp164 = objv163[1];
                                                    if ( tmp164 != null ) {
                                                        tmp164.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv163, 2);
                                                }
                                            } // End Invoke: ...
                                            TclObject tmp165 = interp.getResult();
                                            ExprValue tmp166 = evs0;
                                            TJC.exprInitValue(interp, tmp166, tmp165);
                                            boolean tmp167 = tmp166.getBooleanValue(interp);
                                            if ( tmp167 ) {
                                                { // Invoke: set commands [...]
                                                    TclObject tmp168;
                                                    { // Invoke: lindex $argument_commands $i
                                                        TclObject tmp169 = null;
                                                        TclObject tmp170;
                                                        try {
                                                            tmp169 = getVarScalar(interp, "argument_commands", compiledLocals, 14);
                                                            tmp169.preserve();
                                                            tmp170 = getVarScalar(interp, "i", compiledLocals, 15);
                                                            TJC.lindexNonconst(interp, tmp169, tmp170);
                                                        } finally {
                                                            if ( tmp169 != null ) {
                                                                tmp169.release();
                                                            }
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp168 = interp.getResult();
                                                    setVarScalar(interp, "commands", tmp168, compiledLocals, 24);
                                                } // End Invoke: set
                                                { // Invoke: if ... ... else ...
                                                    { // Invoke: ... $commands
                                                        TclObject[] objv171 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp172;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv171[0] = const25;
                                                            // Arg 1 variable: $commands
                                                            tmp172 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                            tmp172.preserve();
                                                            objv171[1] = tmp172;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                                                ? cmdcache15.cmd : null), objv171, 0);
                                                            if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                                                updateCmdCache(interp, 15);
                                                            }
                                                        } finally {
                                                            tmp172 = objv171[1];
                                                            if ( tmp172 != null ) {
                                                                tmp172.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv171, 2);
                                                        }
                                                    } // End Invoke: ...
                                                    TclObject tmp173 = interp.getResult();
                                                    ExprValue tmp174 = evs0;
                                                    TJC.exprInitValue(interp, tmp174, tmp173);
                                                    boolean tmp175 = tmp174.getBooleanValue(interp);
                                                    if ( tmp175 ) {
                                                        { // Invoke: set uqtext {}
                                                            setVarScalar(interp, "uqtext", const12, compiledLocals, 19);
                                                        } // End Invoke: set
                                                        { // Invoke: set constants_found 1
                                                            setVarScalar(interp, "constants_found", const10, compiledLocals, 4);
                                                        } // End Invoke: set
                                                        { // Invoke: lappend types constant
                                                            TclObject[] objv176 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp177;
                                                            try {
                                                                // Arg 2 constant: constant
                                                                objv176[0] = const15;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "types", objv176, compiledLocals, 10);
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv176, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: lappend values $uqtext
                                                            TclObject[] objv178 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp179;
                                                            try {
                                                                // Arg 2 variable: $uqtext
                                                                tmp179 = getVarScalar(interp, "uqtext", compiledLocals, 19);
                                                                tmp179.preserve();
                                                                objv178[0] = tmp179;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "values", objv178, compiledLocals, 11);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv178, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: lappend instrs {[]}
                                                            TclObject[] objv180 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp181;
                                                            try {
                                                                // Arg 2 constant: {[]}
                                                                objv180[0] = const26;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "instrs", objv180, compiledLocals, 13);
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv180, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: lappend cmaps {}
                                                            TclObject[] objv182 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp183;
                                                            try {
                                                                // Arg 2 constant: {}
                                                                objv182[0] = const12;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "cmaps", objv182, compiledLocals, 12);
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv182, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: ... $uqtext
                                                            TclObject[] objv184 = TJC.grabObjv(interp, 2);
                                                            TclObject tmp185;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv184[0] = const16;
                                                                // Arg 1 variable: $uqtext
                                                                tmp185 = getVarScalar(interp, "uqtext", compiledLocals, 19);
                                                                tmp185.preserve();
                                                                objv184[1] = tmp185;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                                    ? cmdcache7.cmd : null), objv184, 0);
                                                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                                    updateCmdCache(interp, 7);
                                                                }
                                                            } finally {
                                                                tmp185 = objv184[1];
                                                                if ( tmp185 != null ) {
                                                                    tmp185.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv184, 2);
                                                            }
                                                        } // End Invoke: ...
                                                    } else {
                                                        { // Invoke: lappend types command
                                                            TclObject[] objv186 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp187;
                                                            try {
                                                                // Arg 2 constant: command
                                                                objv186[0] = const27;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "types", objv186, compiledLocals, 10);
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv186, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: lappend values $commands
                                                            TclObject[] objv188 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp189;
                                                            try {
                                                                // Arg 2 variable: $commands
                                                                tmp189 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                                tmp189.preserve();
                                                                objv188[0] = tmp189;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "values", objv188, compiledLocals, 11);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv188, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: lappend instrs [...]
                                                            TclObject[] objv190 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp191;
                                                            try {
                                                                // Arg 2 command: [...]
                                                                { // Invoke: ... $script $telem
                                                                    TclObject[] objv192 = TJC.grabObjv(interp, 3);
                                                                    TclObject tmp193;
                                                                    try {
                                                                        // Arg 0 constant: ...
                                                                        objv192[0] = const28;
                                                                        // Arg 1 variable: $script
                                                                        tmp193 = getVarScalar(interp, "script", compiledLocals, 7);
                                                                        tmp193.preserve();
                                                                        objv192[1] = tmp193;
                                                                        // Arg 2 variable: $telem
                                                                        tmp193 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                                        tmp193.preserve();
                                                                        objv192[2] = tmp193;
                                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                            updateCmdCache(interp, 0);
                                                                        }
                                                                        TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                                                            ? cmdcache16.cmd : null), objv192, 0);
                                                                        if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                                                            updateCmdCache(interp, 16);
                                                                        }
                                                                    } finally {
                                                                        tmp193 = objv192[1];
                                                                        if ( tmp193 != null ) {
                                                                            tmp193.release();
                                                                        }
                                                                        tmp193 = objv192[2];
                                                                        if ( tmp193 != null ) {
                                                                            tmp193.release();
                                                                        }
                                                                        TJC.releaseObjv(interp, objv192, 3);
                                                                    }
                                                                } // End Invoke: ...
                                                                tmp191 = interp.getResult();
                                                                tmp191.preserve();
                                                                objv190[0] = tmp191;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "instrs", objv190, compiledLocals, 13);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv190, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: lappend cmaps {}
                                                            TclObject[] objv194 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp195;
                                                            try {
                                                                // Arg 2 constant: {}
                                                                objv194[0] = const12;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "cmaps", objv194, compiledLocals, 12);
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv194, 1);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: ... $commands
                                                            TclObject[] objv196 = TJC.grabObjv(interp, 2);
                                                            TclObject tmp197;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv196[0] = const29;
                                                                // Arg 1 variable: $commands
                                                                tmp197 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                                tmp197.preserve();
                                                                objv196[1] = tmp197;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                                                    ? cmdcache17.cmd : null), objv196, 0);
                                                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                                                    updateCmdCache(interp, 17);
                                                                }
                                                            } finally {
                                                                tmp197 = objv196[1];
                                                                if ( tmp197 != null ) {
                                                                    tmp197.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv196, 2);
                                                            }
                                                        } // End Invoke: ...
                                                    }
                                                } // End Invoke: if
                                            } else {
                                                { // Invoke: parse_is_word $telem
                                                    TclObject[] objv198 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp199;
                                                    try {
                                                        // Arg 0 constant: parse_is_word
                                                        objv198[0] = const30;
                                                        // Arg 1 variable: $telem
                                                        tmp199 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                        tmp199.preserve();
                                                        objv198[1] = tmp199;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                                            ? cmdcache18.cmd : null), objv198, 0);
                                                        if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                                            updateCmdCache(interp, 18);
                                                        }
                                                    } finally {
                                                        tmp199 = objv198[1];
                                                        if ( tmp199 != null ) {
                                                            tmp199.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv198, 2);
                                                    }
                                                } // End Invoke: parse_is_word
                                                TclObject tmp200 = interp.getResult();
                                                ExprValue tmp201 = evs0;
                                                TJC.exprInitValue(interp, tmp201, tmp200);
                                                boolean tmp202 = tmp201.getBooleanValue(interp);
                                                if ( tmp202 ) {
                                                    { // Invoke: set wrange [...]
                                                        TclObject tmp203;
                                                        { // Invoke: lindex $telem 1
                                                            TclObject tmp204 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                            tmp204 = TclList.index(interp, tmp204, 1);
                                                            if ( tmp204 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp204);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp203 = interp.getResult();
                                                        setVarScalar(interp, "wrange", tmp203, compiledLocals, 27);
                                                    } // End Invoke: set
                                                    { // Invoke: set qtext [...]
                                                        TclObject tmp205;
                                                        { // Invoke: parse getstring $script $wrange
                                                            TclObject[] objv206 = TJC.grabObjv(interp, 4);
                                                            TclObject tmp207;
                                                            try {
                                                                // Arg 0 constant: parse
                                                                objv206[0] = const31;
                                                                // Arg 1 constant: getstring
                                                                objv206[1] = const32;
                                                                // Arg 2 variable: $script
                                                                tmp207 = getVarScalar(interp, "script", compiledLocals, 7);
                                                                tmp207.preserve();
                                                                objv206[2] = tmp207;
                                                                // Arg 3 variable: $wrange
                                                                tmp207 = getVarScalar(interp, "wrange", compiledLocals, 27);
                                                                tmp207.preserve();
                                                                objv206[3] = tmp207;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                                                                    ? cmdcache19.cmd : null), objv206, 0);
                                                                if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                                                                    updateCmdCache(interp, 19);
                                                                }
                                                            } finally {
                                                                tmp207 = objv206[2];
                                                                if ( tmp207 != null ) {
                                                                    tmp207.release();
                                                                }
                                                                tmp207 = objv206[3];
                                                                if ( tmp207 != null ) {
                                                                    tmp207.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv206, 4);
                                                            }
                                                        } // End Invoke: parse
                                                        tmp205 = interp.getResult();
                                                        setVarScalar(interp, "qtext", tmp205, compiledLocals, 17);
                                                    } // End Invoke: set
                                                    { // Invoke: set commands [...]
                                                        TclObject tmp208;
                                                        { // Invoke: lindex $argument_commands $i
                                                            TclObject tmp209 = null;
                                                            TclObject tmp210;
                                                            try {
                                                                tmp209 = getVarScalar(interp, "argument_commands", compiledLocals, 14);
                                                                tmp209.preserve();
                                                                tmp210 = getVarScalar(interp, "i", compiledLocals, 15);
                                                                TJC.lindexNonconst(interp, tmp209, tmp210);
                                                            } finally {
                                                                if ( tmp209 != null ) {
                                                                    tmp209.release();
                                                                }
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp208 = interp.getResult();
                                                        setVarScalar(interp, "commands", tmp208, compiledLocals, 24);
                                                    } // End Invoke: set
                                                    { // Invoke: if {$commands != {}} ...
                                                        // Binary operator: $commands != ""
                                                        TclObject tmp211 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                        ExprValue tmp212 = evs0;
                                                        TJC.exprEqualsEmptyString(tmp212, tmp211, true);
                                                        // End Binary operator: !=
                                                        boolean tmp213 = ( tmp212.getIntValue() != 0 );
                                                        if ( tmp213 ) {
                                                            { // Invoke: ... $key $commands
                                                                TclObject[] objv214 = TJC.grabObjv(interp, 3);
                                                                TclObject tmp215;
                                                                try {
                                                                    // Arg 0 constant: ...
                                                                    objv214[0] = const18;
                                                                    // Arg 1 variable: $key
                                                                    tmp215 = getVarScalar(interp, "key", compiledLocals, 6);
                                                                    tmp215.preserve();
                                                                    objv214[1] = tmp215;
                                                                    // Arg 2 variable: $commands
                                                                    tmp215 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                                    tmp215.preserve();
                                                                    objv214[2] = tmp215;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                                        ? cmdcache9.cmd : null), objv214, 0);
                                                                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                                        updateCmdCache(interp, 9);
                                                                    }
                                                                } finally {
                                                                    tmp215 = objv214[1];
                                                                    if ( tmp215 != null ) {
                                                                        tmp215.release();
                                                                    }
                                                                    tmp215 = objv214[2];
                                                                    if ( tmp215 != null ) {
                                                                        tmp215.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv214, 3);
                                                                }
                                                            } // End Invoke: ...
                                                        }
                                                    } // End Invoke: if
                                                    { // Invoke: set wstree $telem
                                                        TclObject tmp216;
                                                        tmp216 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                        setVarScalar(interp, "wstree", tmp216, compiledLocals, 28);
                                                    } // End Invoke: set
                                                    { // Invoke: set type_winfo [...]
                                                        TclObject tmp217;
                                                        { // Invoke: ... $key $script $wstree
                                                            TclObject[] objv218 = TJC.grabObjv(interp, 4);
                                                            TclObject tmp219;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv218[0] = const33;
                                                                // Arg 1 variable: $key
                                                                tmp219 = getVarScalar(interp, "key", compiledLocals, 6);
                                                                tmp219.preserve();
                                                                objv218[1] = tmp219;
                                                                // Arg 2 variable: $script
                                                                tmp219 = getVarScalar(interp, "script", compiledLocals, 7);
                                                                tmp219.preserve();
                                                                objv218[2] = tmp219;
                                                                // Arg 3 variable: $wstree
                                                                tmp219 = getVarScalar(interp, "wstree", compiledLocals, 28);
                                                                tmp219.preserve();
                                                                objv218[3] = tmp219;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                                                                    ? cmdcache20.cmd : null), objv218, 0);
                                                                if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                                                                    updateCmdCache(interp, 20);
                                                                }
                                                            } finally {
                                                                tmp219 = objv218[1];
                                                                if ( tmp219 != null ) {
                                                                    tmp219.release();
                                                                }
                                                                tmp219 = objv218[2];
                                                                if ( tmp219 != null ) {
                                                                    tmp219.release();
                                                                }
                                                                tmp219 = objv218[3];
                                                                if ( tmp219 != null ) {
                                                                    tmp219.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv218, 4);
                                                            }
                                                        } // End Invoke: ...
                                                        tmp217 = interp.getResult();
                                                        setVarScalar(interp, "type_winfo", tmp217, compiledLocals, 29);
                                                    } // End Invoke: set
                                                    { // Invoke: if {$commands != {}} ...
                                                        // Binary operator: $commands != ""
                                                        TclObject tmp220 = getVarScalar(interp, "commands", compiledLocals, 24);
                                                        ExprValue tmp221 = evs0;
                                                        TJC.exprEqualsEmptyString(tmp221, tmp220, true);
                                                        // End Binary operator: !=
                                                        boolean tmp222 = ( tmp221.getIntValue() != 0 );
                                                        if ( tmp222 ) {
                                                            { // Invoke: ... $key
                                                                TclObject[] objv223 = TJC.grabObjv(interp, 2);
                                                                TclObject tmp224;
                                                                try {
                                                                    // Arg 0 constant: ...
                                                                    objv223[0] = const21;
                                                                    // Arg 1 variable: $key
                                                                    tmp224 = getVarScalar(interp, "key", compiledLocals, 6);
                                                                    tmp224.preserve();
                                                                    objv223[1] = tmp224;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                                        ? cmdcache12.cmd : null), objv223, 0);
                                                                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                                        updateCmdCache(interp, 12);
                                                                    }
                                                                } finally {
                                                                    tmp224 = objv223[1];
                                                                    if ( tmp224 != null ) {
                                                                        tmp224.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv223, 2);
                                                                }
                                                            } // End Invoke: ...
                                                        }
                                                    } // End Invoke: if
                                                    { // Invoke: set type [...]
                                                        TclObject tmp225;
                                                        { // Invoke: lindex $type_winfo 0
                                                            TclObject tmp226 = getVarScalar(interp, "type_winfo", compiledLocals, 29);
                                                            tmp226 = TclList.index(interp, tmp226, 0);
                                                            if ( tmp226 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp226);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp225 = interp.getResult();
                                                        setVarScalar(interp, "type", tmp225, compiledLocals, 30);
                                                    } // End Invoke: set
                                                    { // Invoke: set value [...]
                                                        TclObject tmp227;
                                                        { // Invoke: lindex $type_winfo 1
                                                            TclObject tmp228 = getVarScalar(interp, "type_winfo", compiledLocals, 29);
                                                            tmp228 = TclList.index(interp, tmp228, 1);
                                                            if ( tmp228 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp228);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp227 = interp.getResult();
                                                        setVarScalar(interp, "value", tmp227, compiledLocals, 31);
                                                    } // End Invoke: set
                                                    { // Invoke: set cmap [...]
                                                        TclObject tmp229;
                                                        { // Invoke: lindex $type_winfo 2
                                                            TclObject tmp230 = getVarScalar(interp, "type_winfo", compiledLocals, 29);
                                                            tmp230 = TclList.index(interp, tmp230, 2);
                                                            if ( tmp230 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp230);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp229 = interp.getResult();
                                                        setVarScalar(interp, "cmap", tmp229, compiledLocals, 20);
                                                    } // End Invoke: set
                                                    { // Invoke: if ... ...
                                                        // Binary operator: $type == "constant"
                                                        TclObject tmp231 = getVarScalar(interp, "type", compiledLocals, 30);
                                                        boolean tmp232 = tmp231.toString().equals("constant");
                                                        ExprValue tmp233 = evs0;
                                                        tmp233.setIntValue(tmp232);
                                                        // End Binary operator: ==
                                                        boolean tmp234 = ( tmp233.getIntValue() != 0 );
                                                        if ( tmp234 ) {
                                                            { // Invoke: set constants_found 1
                                                                setVarScalar(interp, "constants_found", const10, compiledLocals, 4);
                                                            } // End Invoke: set
                                                            { // Invoke: ... $value
                                                                TclObject[] objv235 = TJC.grabObjv(interp, 2);
                                                                TclObject tmp236;
                                                                try {
                                                                    // Arg 0 constant: ...
                                                                    objv235[0] = const16;
                                                                    // Arg 1 variable: $value
                                                                    tmp236 = getVarScalar(interp, "value", compiledLocals, 31);
                                                                    tmp236.preserve();
                                                                    objv235[1] = tmp236;
                                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                        updateCmdCache(interp, 0);
                                                                    }
                                                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                                        ? cmdcache7.cmd : null), objv235, 0);
                                                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                                        updateCmdCache(interp, 7);
                                                                    }
                                                                } finally {
                                                                    tmp236 = objv235[1];
                                                                    if ( tmp236 != null ) {
                                                                        tmp236.release();
                                                                    }
                                                                    TJC.releaseObjv(interp, objv235, 2);
                                                                }
                                                            } // End Invoke: ...
                                                        }
                                                    } // End Invoke: if
                                                    { // Invoke: lappend types $type
                                                        TclObject[] objv237 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp238;
                                                        try {
                                                            // Arg 2 variable: $type
                                                            tmp238 = getVarScalar(interp, "type", compiledLocals, 30);
                                                            tmp238.preserve();
                                                            objv237[0] = tmp238;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "types", objv237, compiledLocals, 10);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv237, 1);
                                                        }
                                                    } // End Invoke: lappend
                                                    { // Invoke: lappend values $value
                                                        TclObject[] objv239 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp240;
                                                        try {
                                                            // Arg 2 variable: $value
                                                            tmp240 = getVarScalar(interp, "value", compiledLocals, 31);
                                                            tmp240.preserve();
                                                            objv239[0] = tmp240;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "values", objv239, compiledLocals, 11);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv239, 1);
                                                        }
                                                    } // End Invoke: lappend
                                                    { // Invoke: lappend instrs $qtext
                                                        TclObject[] objv241 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp242;
                                                        try {
                                                            // Arg 2 variable: $qtext
                                                            tmp242 = getVarScalar(interp, "qtext", compiledLocals, 17);
                                                            tmp242.preserve();
                                                            objv241[0] = tmp242;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "instrs", objv241, compiledLocals, 13);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv241, 1);
                                                        }
                                                    } // End Invoke: lappend
                                                    { // Invoke: lappend cmaps $cmap
                                                        TclObject[] objv243 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp244;
                                                        try {
                                                            // Arg 2 variable: $cmap
                                                            tmp244 = getVarScalar(interp, "cmap", compiledLocals, 20);
                                                            tmp244.preserve();
                                                            objv243[0] = tmp244;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "cmaps", objv243, compiledLocals, 12);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv243, 1);
                                                        }
                                                    } // End Invoke: lappend
                                                } else {
                                                    { // Invoke: error "..."
                                                        TclObject[] objv245 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp246;
                                                        try {
                                                            // Arg 0 constant: error
                                                            objv245[0] = const2;
                                                            // Arg 1 word: "..."
                                                            StringBuffer sbtmp247 = new StringBuffer(64);
                                                            sbtmp247.append("unsupported type at argument index ");
                                                            tmp246 = getVarScalar(interp, "i", compiledLocals, 15);
                                                            sbtmp247.append(tmp246.toString());
                                                            sbtmp247.append(", telem is: ");
                                                            sbtmp247.append("{");
                                                            tmp246 = getVarScalar(interp, "telem", compiledLocals, 16);
                                                            sbtmp247.append(tmp246.toString());
                                                            sbtmp247.append("}");
                                                            tmp246 = TclString.newInstance(sbtmp247);
                                                            tmp246.preserve();
                                                            objv245[1] = tmp246;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                                ? cmdcache2.cmd : null), objv245, 0);
                                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                                updateCmdCache(interp, 2);
                                                            }
                                                        } finally {
                                                            tmp246 = objv245[1];
                                                            if ( tmp246 != null ) {
                                                                tmp246.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv245, 2);
                                                        }
                                                    } // End Invoke: error
                                                }
                                            }
                                        }
                                    }
                                } // End Invoke: if
                                { // Invoke: incr i
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 1, compiledLocals, 15);
                                } // End Invoke: incr
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp55 != null ) {
                                tmp55.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: if ... ...
                        // Binary operator: [...] != [...]
                        { // Invoke: llength $types
                            TclObject tmp248 = getVarScalar(interp, "types", compiledLocals, 10);
                            int tmp249 = TclList.getLength(interp, tmp248);
                            interp.setResult(tmp249);
                        } // End Invoke: llength
                        TclObject tmp250 = interp.getResult();
                        ExprValue tmp251 = evs0;
                        TJC.exprInitValue(interp, tmp251, tmp250);
                        { // Invoke: llength $values
                            TclObject tmp252 = getVarScalar(interp, "values", compiledLocals, 11);
                            int tmp253 = TclList.getLength(interp, tmp252);
                            interp.setResult(tmp253);
                        } // End Invoke: llength
                        TclObject tmp254 = interp.getResult();
                        ExprValue tmp255 = evs1;
                        TJC.exprInitValue(interp, tmp255, tmp254);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp251, tmp255);
                        // End Binary operator: !=
                        boolean tmp256 = ( tmp251.getIntValue() != 0 );
                        if ( tmp256 ) {
                            { // Invoke: error "..."
                                TclObject[] objv257 = TJC.grabObjv(interp, 2);
                                TclObject tmp258;
                                try {
                                    // Arg 0 constant: error
                                    objv257[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp259 = new StringBuffer(64);
                                    sbtmp259.append("num types vs values mismatch, ");
                                    { // Invoke: llength $types
                                        TclObject tmp260 = getVarScalar(interp, "types", compiledLocals, 10);
                                        int tmp261 = TclList.getLength(interp, tmp260);
                                        interp.setResult(tmp261);
                                    } // End Invoke: llength
                                    tmp258 = interp.getResult();
                                    sbtmp259.append(tmp258.toString());
                                    sbtmp259.append(" != ");
                                    { // Invoke: llength $values
                                        TclObject tmp262 = getVarScalar(interp, "values", compiledLocals, 11);
                                        int tmp263 = TclList.getLength(interp, tmp262);
                                        interp.setResult(tmp263);
                                    } // End Invoke: llength
                                    tmp258 = interp.getResult();
                                    sbtmp259.append(tmp258.toString());
                                    tmp258 = TclString.newInstance(sbtmp259);
                                    tmp258.preserve();
                                    objv257[1] = tmp258;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv257, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp258 = objv257[1];
                                    if ( tmp258 != null ) {
                                        tmp258.release();
                                    }
                                    TJC.releaseObjv(interp, objv257, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: [...] != $num_args
                        { // Invoke: llength $types
                            TclObject tmp264 = getVarScalar(interp, "types", compiledLocals, 10);
                            int tmp265 = TclList.getLength(interp, tmp264);
                            interp.setResult(tmp265);
                        } // End Invoke: llength
                        TclObject tmp266 = interp.getResult();
                        ExprValue tmp267 = evs0;
                        TJC.exprInitValue(interp, tmp267, tmp266);
                        TclObject tmp268 = getVarScalar(interp, "num_args", compiledLocals, 9);
                        ExprValue tmp269 = evs1;
                        TJC.exprInitValue(interp, tmp269, tmp268);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp267, tmp269);
                        // End Binary operator: !=
                        boolean tmp270 = ( tmp267.getIntValue() != 0 );
                        if ( tmp270 ) {
                            { // Invoke: error "..."
                                TclObject[] objv271 = TJC.grabObjv(interp, 2);
                                TclObject tmp272;
                                try {
                                    // Arg 0 constant: error
                                    objv271[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp273 = new StringBuffer(64);
                                    sbtmp273.append("num types vs num_args mismatch, ");
                                    { // Invoke: llength $types
                                        TclObject tmp274 = getVarScalar(interp, "types", compiledLocals, 10);
                                        int tmp275 = TclList.getLength(interp, tmp274);
                                        interp.setResult(tmp275);
                                    } // End Invoke: llength
                                    tmp272 = interp.getResult();
                                    sbtmp273.append(tmp272.toString());
                                    sbtmp273.append(" != ");
                                    tmp272 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                    sbtmp273.append(tmp272.toString());
                                    tmp272 = TclString.newInstance(sbtmp273);
                                    tmp272.preserve();
                                    objv271[1] = tmp272;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv271, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp272 = objv271[1];
                                    if ( tmp272 != null ) {
                                        tmp272.release();
                                    }
                                    TJC.releaseObjv(interp, objv271, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set "..." $types
                        TclObject tmp276;
                        String tmp277;
                        StringBuffer sbtmp278 = new StringBuffer(64);
                        tmp276 = getVarScalar(interp, "key", compiledLocals, 6);
                        sbtmp278.append(tmp276.toString());
                        sbtmp278.append(",types");
                        tmp277 = sbtmp278.toString();
                        tmp276 = getVarScalar(interp, "types", compiledLocals, 10);
                        tmp276 = setVarArray(interp, "_compileproc_key_info", tmp277, tmp276, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: set "..." $values
                        TclObject tmp279;
                        String tmp280;
                        StringBuffer sbtmp281 = new StringBuffer(64);
                        tmp279 = getVarScalar(interp, "key", compiledLocals, 6);
                        sbtmp281.append(tmp279.toString());
                        sbtmp281.append(",values");
                        tmp280 = sbtmp281.toString();
                        tmp279 = getVarScalar(interp, "values", compiledLocals, 11);
                        tmp279 = setVarArray(interp, "_compileproc_key_info", tmp280, tmp279, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: set "..." $instrs
                        TclObject tmp282;
                        String tmp283;
                        StringBuffer sbtmp284 = new StringBuffer(64);
                        tmp282 = getVarScalar(interp, "key", compiledLocals, 6);
                        sbtmp284.append(tmp282.toString());
                        sbtmp284.append(",instrs");
                        tmp283 = sbtmp284.toString();
                        tmp282 = getVarScalar(interp, "instrs", compiledLocals, 13);
                        tmp282 = setVarArray(interp, "_compileproc_key_info", tmp283, tmp282, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: set "..." $num_args
                        TclObject tmp285;
                        String tmp286;
                        StringBuffer sbtmp287 = new StringBuffer(64);
                        tmp285 = getVarScalar(interp, "key", compiledLocals, 6);
                        sbtmp287.append(tmp285.toString());
                        sbtmp287.append(",num_args");
                        tmp286 = sbtmp287.toString();
                        tmp285 = getVarScalar(interp, "num_args", compiledLocals, 9);
                        tmp285 = setVarArray(interp, "_compileproc_key_info", tmp286, tmp285, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: set "..." $cmaps
                        TclObject tmp288;
                        String tmp289;
                        StringBuffer sbtmp290 = new StringBuffer(64);
                        tmp288 = getVarScalar(interp, "key", compiledLocals, 6);
                        sbtmp290.append(tmp288.toString());
                        sbtmp290.append(",cmaps");
                        tmp289 = sbtmp290.toString();
                        tmp288 = getVarScalar(interp, "cmaps", compiledLocals, 12);
                        tmp288 = setVarArray(interp, "_compileproc_key_info", tmp289, tmp288, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        TclObject tmp291 = getVarArray(interp, "_compileproc", "options,omit_results", compiledLocals, 1);
                        ExprValue tmp292 = evs0;
                        TJC.exprInitValue(interp, tmp292, tmp291);
                        boolean tmp293 = tmp292.getBooleanValue(interp);
                        if ( tmp293 ) {
                            { // Invoke: set is_nested [...]
                                TclObject tmp294;
                                { // Invoke: descend_get_data $key nested
                                    TclObject[] objv295 = TJC.grabObjv(interp, 3);
                                    TclObject tmp296;
                                    try {
                                        // Arg 0 constant: descend_get_data
                                        objv295[0] = const3;
                                        // Arg 1 variable: $key
                                        tmp296 = getVarScalar(interp, "key", compiledLocals, 6);
                                        tmp296.preserve();
                                        objv295[1] = tmp296;
                                        // Arg 2 constant: nested
                                        objv295[2] = const34;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv295, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp296 = objv295[1];
                                        if ( tmp296 != null ) {
                                            tmp296.release();
                                        }
                                        TJC.releaseObjv(interp, objv295, 3);
                                    }
                                } // End Invoke: descend_get_data
                                tmp294 = interp.getResult();
                                setVarScalar(interp, "is_nested", tmp294, compiledLocals, 32);
                            } // End Invoke: set
                            { // Invoke: set is_last_key [...]
                                TclObject tmp297;
                                { // Invoke: expr {$key == $last_key}
                                    // Binary operator: $key == $last_key
                                    TclObject tmp298 = getVarScalar(interp, "key", compiledLocals, 6);
                                    ExprValue tmp299 = evs0;
                                    TJC.exprInitValue(interp, tmp299, tmp298);
                                    TclObject tmp300 = getVarScalar(interp, "last_key", compiledLocals, 5);
                                    ExprValue tmp301 = evs1;
                                    TJC.exprInitValue(interp, tmp301, tmp300);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp299, tmp301);
                                    // End Binary operator: ==
                                    interp.setResult( tmp299.getIntValue() != 0 );
                                } // End Invoke: expr
                                tmp297 = interp.getResult();
                                setVarScalar(interp, "is_last_key", tmp297, compiledLocals, 33);
                            } // End Invoke: set
                            { // Invoke: if {$is_last_key} ...
                                TclObject tmp302 = getVarScalar(interp, "is_last_key", compiledLocals, 33);
                                boolean tmp303 = TJC.getBoolean(interp, tmp302);
                                if ( tmp303 ) {
                                    { // Invoke: if ... ... else ...
                                        { // Invoke: info exists "..."
                                            TclObject[] objv304 = TJC.grabObjv(interp, 3);
                                            TclObject tmp305;
                                            try {
                                                // Arg 0 constant: info
                                                objv304[0] = const35;
                                                // Arg 1 constant: exists
                                                objv304[1] = const36;
                                                // Arg 2 word: "..."
                                                StringBuffer sbtmp306 = new StringBuffer(64);
                                                sbtmp306.append("_compileproc_key_info(");
                                                tmp305 = getVarScalar(interp, "key", compiledLocals, 6);
                                                sbtmp306.append(tmp305.toString());
                                                sbtmp306.append(",container)");
                                                tmp305 = TclString.newInstance(sbtmp306);
                                                tmp305.preserve();
                                                objv304[2] = tmp305;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache21_cmdEpoch == cmdcache21.cmdEpoch)
                                                    ? cmdcache21.cmd : null), objv304, 0);
                                                if ( cmdcache21_cmdEpoch != cmdcache21.cmdEpoch ) {
                                                    updateCmdCache(interp, 21);
                                                }
                                            } finally {
                                                tmp305 = objv304[2];
                                                if ( tmp305 != null ) {
                                                    tmp305.release();
                                                }
                                                TJC.releaseObjv(interp, objv304, 3);
                                            }
                                        } // End Invoke: info
                                        TclObject tmp307 = interp.getResult();
                                        ExprValue tmp308 = evs0;
                                        TJC.exprInitValue(interp, tmp308, tmp307);
                                        boolean tmp309 = tmp308.getBooleanValue(interp);
                                        if ( tmp309 ) {
                                            { // Invoke: set container_key $...
                                                TclObject tmp310;
                                                StringBuffer sbtmp311 = new StringBuffer(64);
                                                tmp310 = getVarScalar(interp, "key", compiledLocals, 6);
                                                sbtmp311.append(tmp310.toString());
                                                sbtmp311.append(",container");
                                                tmp310 = getVarArray(interp, "_compileproc_key_info", sbtmp311.toString(), compiledLocals, 2);
                                                setVarScalar(interp, "container_key", tmp310, compiledLocals, 34);
                                            } // End Invoke: set
                                            { // Invoke: set container_result $...
                                                TclObject tmp312;
                                                StringBuffer sbtmp313 = new StringBuffer(64);
                                                tmp312 = getVarScalar(interp, "container_key", compiledLocals, 34);
                                                sbtmp313.append(tmp312.toString());
                                                sbtmp313.append(",result");
                                                tmp312 = getVarArray(interp, "_compileproc_key_info", sbtmp313.toString(), compiledLocals, 2);
                                                setVarScalar(interp, "container_result", tmp312, compiledLocals, 35);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: set container_key ""
                                                setVarScalar(interp, "container_key", const12, compiledLocals, 34);
                                            } // End Invoke: set
                                            { // Invoke: set container_result 1
                                                setVarScalar(interp, "container_result", const10, compiledLocals, 35);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                    { // Invoke: if ... ...
                                        // Binary operator: () && [...]
                                        // Binary operator: $container_result && ()
                                        TclObject tmp314 = getVarScalar(interp, "container_result", compiledLocals, 35);
                                        ExprValue tmp315 = evs0;
                                        TJC.exprInitValue(interp, tmp315, tmp314);
                                        if (tmp315.getBooleanValue(interp)) {
                                        // Binary operator: $container_key != ""
                                        TclObject tmp316 = getVarScalar(interp, "container_key", compiledLocals, 34);
                                        ExprValue tmp317 = evs1;
                                        TJC.exprEqualsEmptyString(tmp317, tmp316, true);
                                        // End Binary operator: !=
                                        tmp315.setIntValue(tmp317.getBooleanValue(interp));
                                        } else {
                                        tmp315.setIntValue(0);
                                        } // End if: $container_result
                                        // End Binary operator: &&
                                        if (tmp315.getBooleanValue(interp)) {
                                        { // Invoke: ... $container_key
                                            TclObject[] objv318 = TJC.grabObjv(interp, 2);
                                            TclObject tmp319;
                                            try {
                                                // Arg 0 constant: ...
                                                objv318[0] = const37;
                                                // Arg 1 variable: $container_key
                                                tmp319 = getVarScalar(interp, "container_key", compiledLocals, 34);
                                                tmp319.preserve();
                                                objv318[1] = tmp319;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache22_cmdEpoch == cmdcache22.cmdEpoch)
                                                    ? cmdcache22.cmd : null), objv318, 0);
                                                if ( cmdcache22_cmdEpoch != cmdcache22.cmdEpoch ) {
                                                    updateCmdCache(interp, 22);
                                                }
                                            } finally {
                                                tmp319 = objv318[1];
                                                if ( tmp319 != null ) {
                                                    tmp319.release();
                                                }
                                                TJC.releaseObjv(interp, objv318, 2);
                                            }
                                        } // End Invoke: ...
                                        TclObject tmp320 = interp.getResult();
                                        ExprValue tmp321 = evs1;
                                        TJC.exprInitValue(interp, tmp321, tmp320);
                                        tmp315.setIntValue(tmp321.getBooleanValue(interp));
                                        } else {
                                        tmp315.setIntValue(0);
                                        } // End if: ()
                                        // End Binary operator: &&
                                        boolean tmp322 = ( tmp315.getIntValue() != 0 );
                                        if ( tmp322 ) {
                                            { // Invoke: set container_result 0
                                                setVarScalar(interp, "container_result", const7, compiledLocals, 35);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                    { // Invoke: if ... ...
                                        // Binary operator: $container_key != ""
                                        TclObject tmp323 = getVarScalar(interp, "container_key", compiledLocals, 34);
                                        ExprValue tmp324 = evs0;
                                        TJC.exprEqualsEmptyString(tmp324, tmp323, true);
                                        // End Binary operator: !=
                                        boolean tmp325 = ( tmp324.getIntValue() != 0 );
                                        if ( tmp325 ) {
                                            { // Invoke: set tuple [...]
                                                TclObject tmp326;
                                                { // Invoke: ... $container_key
                                                    TclObject[] objv327 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp328;
                                                    try {
                                                        // Arg 0 constant: ...
                                                        objv327[0] = const38;
                                                        // Arg 1 variable: $container_key
                                                        tmp328 = getVarScalar(interp, "container_key", compiledLocals, 34);
                                                        tmp328.preserve();
                                                        objv327[1] = tmp328;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache23_cmdEpoch == cmdcache23.cmdEpoch)
                                                            ? cmdcache23.cmd : null), objv327, 0);
                                                        if ( cmdcache23_cmdEpoch != cmdcache23.cmdEpoch ) {
                                                            updateCmdCache(interp, 23);
                                                        }
                                                    } finally {
                                                        tmp328 = objv327[1];
                                                        if ( tmp328 != null ) {
                                                            tmp328.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv327, 2);
                                                    }
                                                } // End Invoke: ...
                                                tmp326 = interp.getResult();
                                                setVarScalar(interp, "tuple", tmp326, compiledLocals, 36);
                                            } // End Invoke: set
                                            { // Invoke: if {[lindex $tuple 0]} ...
                                                { // Invoke: lindex $tuple 0
                                                    TclObject tmp329 = getVarScalar(interp, "tuple", compiledLocals, 36);
                                                    tmp329 = TclList.index(interp, tmp329, 0);
                                                    if ( tmp329 == null ) {
                                                        interp.resetResult();
                                                    } else {
                                                        interp.setResult(tmp329);
                                                    }
                                                } // End Invoke: lindex
                                                TclObject tmp330 = interp.getResult();
                                                ExprValue tmp331 = evs0;
                                                TJC.exprInitValue(interp, tmp331, tmp330);
                                                boolean tmp332 = tmp331.getBooleanValue(interp);
                                                if ( tmp332 ) {
                                                    { // Invoke: set has_varname [...]
                                                        TclObject tmp333;
                                                        { // Invoke: lindex $tuple 1
                                                            TclObject tmp334 = getVarScalar(interp, "tuple", compiledLocals, 36);
                                                            tmp334 = TclList.index(interp, tmp334, 1);
                                                            if ( tmp334 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp334);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp333 = interp.getResult();
                                                        setVarScalar(interp, "has_varname", tmp333, compiledLocals, 37);
                                                    } // End Invoke: set
                                                    { // Invoke: set container_result $has_varname
                                                        TclObject tmp335;
                                                        tmp335 = getVarScalar(interp, "has_varname", compiledLocals, 37);
                                                        setVarScalar(interp, "container_result", tmp335, compiledLocals, 35);
                                                    } // End Invoke: set
                                                }
                                            } // End Invoke: if
                                        }
                                    } // End Invoke: if
                                }
                            } // End Invoke: if
                            { // Invoke: if ... ... else ...
                                // Binary operator: $is_last_key && ()
                                TclObject tmp336 = getVarScalar(interp, "is_last_key", compiledLocals, 33);
                                ExprValue tmp337 = evs0;
                                TJC.exprInitValue(interp, tmp337, tmp336);
                                if (tmp337.getBooleanValue(interp)) {
                                // Binary operator: $container_result || $is_nested
                                TclObject tmp338 = getVarScalar(interp, "container_result", compiledLocals, 35);
                                ExprValue tmp339 = evs1;
                                TJC.exprInitValue(interp, tmp339, tmp338);
                                if (!tmp339.getBooleanValue(interp)) {
                                TclObject tmp340 = getVarScalar(interp, "is_nested", compiledLocals, 32);
                                ExprValue tmp341 = evs2;
                                TJC.exprInitValue(interp, tmp341, tmp340);
                                tmp339.setIntValue(tmp341.getBooleanValue(interp));
                                } else {
                                tmp339.setIntValue(1);
                                } // End if: !$container_result
                                // End Binary operator: ||
                                tmp337.setIntValue(tmp339.getBooleanValue(interp));
                                } else {
                                tmp337.setIntValue(0);
                                } // End if: $is_last_key
                                // End Binary operator: &&
                                boolean tmp342 = ( tmp337.getIntValue() != 0 );
                                if ( tmp342 ) {
                                    { // Invoke: set "..." 1
                                        TclObject tmp343;
                                        String tmp344;
                                        StringBuffer sbtmp345 = new StringBuffer(64);
                                        tmp343 = getVarScalar(interp, "key", compiledLocals, 6);
                                        sbtmp345.append(tmp343.toString());
                                        sbtmp345.append(",result");
                                        tmp344 = sbtmp345.toString();
                                        setVarArray(interp, "_compileproc_key_info", tmp344, const10, compiledLocals, 2);
                                    } // End Invoke: set
                                } else {
                                    { // Invoke: set "..." 0
                                        TclObject tmp346;
                                        String tmp347;
                                        StringBuffer sbtmp348 = new StringBuffer(64);
                                        tmp346 = getVarScalar(interp, "key", compiledLocals, 6);
                                        sbtmp348.append(tmp346.toString());
                                        sbtmp348.append(",result");
                                        tmp347 = sbtmp348.toString();
                                        setVarArray(interp, "_compileproc_key_info", tmp347, const7, compiledLocals, 2);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: [...] && [...]
                        { // Invoke: ... $key
                            TclObject[] objv349 = TJC.grabObjv(interp, 2);
                            TclObject tmp350;
                            try {
                                // Arg 0 constant: ...
                                objv349[0] = const39;
                                // Arg 1 variable: $key
                                tmp350 = getVarScalar(interp, "key", compiledLocals, 6);
                                tmp350.preserve();
                                objv349[1] = tmp350;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache24_cmdEpoch == cmdcache24.cmdEpoch)
                                    ? cmdcache24.cmd : null), objv349, 0);
                                if ( cmdcache24_cmdEpoch != cmdcache24.cmdEpoch ) {
                                    updateCmdCache(interp, 24);
                                }
                            } finally {
                                tmp350 = objv349[1];
                                if ( tmp350 != null ) {
                                    tmp350.release();
                                }
                                TJC.releaseObjv(interp, objv349, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp351 = interp.getResult();
                        ExprValue tmp352 = evs0;
                        TJC.exprInitValue(interp, tmp352, tmp351);
                        if (tmp352.getBooleanValue(interp)) {
                        { // Invoke: ... $key
                            TclObject[] objv353 = TJC.grabObjv(interp, 2);
                            TclObject tmp354;
                            try {
                                // Arg 0 constant: ...
                                objv353[0] = const40;
                                // Arg 1 variable: $key
                                tmp354 = getVarScalar(interp, "key", compiledLocals, 6);
                                tmp354.preserve();
                                objv353[1] = tmp354;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache25_cmdEpoch == cmdcache25.cmdEpoch)
                                    ? cmdcache25.cmd : null), objv353, 0);
                                if ( cmdcache25_cmdEpoch != cmdcache25.cmdEpoch ) {
                                    updateCmdCache(interp, 25);
                                }
                            } finally {
                                tmp354 = objv353[1];
                                if ( tmp354 != null ) {
                                    tmp354.release();
                                }
                                TJC.releaseObjv(interp, objv353, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp355 = interp.getResult();
                        ExprValue tmp356 = evs1;
                        TJC.exprInitValue(interp, tmp356, tmp355);
                        tmp352.setIntValue(tmp356.getBooleanValue(interp));
                        } else {
                        tmp352.setIntValue(0);
                        } // End if: [...]
                        // End Binary operator: &&
                        boolean tmp357 = ( tmp352.getIntValue() != 0 );
                        if ( tmp357 ) {
                            { // Invoke: ... $key
                                TclObject[] objv358 = TJC.grabObjv(interp, 2);
                                TclObject tmp359;
                                try {
                                    // Arg 0 constant: ...
                                    objv358[0] = const41;
                                    // Arg 1 variable: $key
                                    tmp359 = getVarScalar(interp, "key", compiledLocals, 6);
                                    tmp359.preserve();
                                    objv358[1] = tmp359;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache26_cmdEpoch == cmdcache26.cmdEpoch)
                                        ? cmdcache26.cmd : null), objv358, 0);
                                    if ( cmdcache26_cmdEpoch != cmdcache26.cmdEpoch ) {
                                        updateCmdCache(interp, 26);
                                    }
                                } finally {
                                    tmp359 = objv358[1];
                                    if ( tmp359 != null ) {
                                        tmp359.release();
                                    }
                                    TJC.releaseObjv(interp, objv358, 2);
                                }
                            } // End Invoke: ...
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp5 != null ) {
                    tmp5.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$constants_found} ...
            TclObject tmp360 = getVarScalar(interp, "constants_found", compiledLocals, 4);
            boolean tmp361 = TJC.getBoolean(interp, tmp360);
            if ( tmp361 ) {
                { // Invoke: set cmd_needs_init 1
                    setVarScalar(interp, "cmd_needs_init", const10, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set ... $cmd_needs_init
            TclObject tmp362;
            tmp362 = getVarScalar(interp, "cmd_needs_init", compiledLocals, 3);
            setVarArray(interp, "_compileproc_key_info", "cmd_needs_init", tmp362, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... $constants_found
            TclObject tmp363;
            tmp363 = getVarScalar(interp, "constants_found", compiledLocals, 4);
            setVarArray(interp, "_compileproc_key_info", "constants_found", tmp363, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_scan_keys");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("end");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_arguments_undetermined");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_get_data");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("script");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("tree");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_commands");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(0);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_is_simple_text");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse_get_simple_text");
        const9.preserve(); const9.preserve();
        const10 = TclInteger.newInstance(1);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("text");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("\\\\");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(2);
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("constant");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("compileproc_constant_cache_add");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("parse_is_word_variable");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compileproc_childkey_reset");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("lindex");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("compileproc_scan_variable");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("compileproc_childkey_validate");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("variable");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("parse_get_word_variable");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("parse_is_word_command");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_is_empty_command");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("[]");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("command");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("parse_get_word_command");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("compileproc_scan_keys");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("parse_is_word");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("parse");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("getstring");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("compileproc_scan_word");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("nested");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("info");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("exists");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("compileproc_is_result_reset_container_command");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("compileproc_container_catch_with_varname");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("compileproc_is_container_command");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("compileproc_can_inline_container");
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("compileproc_scan_keys_in_container");
        const41.preserve(); const41.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;
    WrappedCommand cmdcache20;
    int cmdcache20_cmdEpoch;
    WrappedCommand cmdcache21;
    int cmdcache21_cmdEpoch;
    WrappedCommand cmdcache22;
    int cmdcache22_cmdEpoch;
    WrappedCommand cmdcache23;
    int cmdcache23_cmdEpoch;
    WrappedCommand cmdcache24;
    int cmdcache24_cmdEpoch;
    WrappedCommand cmdcache25;
    int cmdcache25_cmdEpoch;
    WrappedCommand cmdcache26;
    int cmdcache26_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                cmdcache20 = TJC.INVALID_COMMAND_CACHE;
                cmdcache20_cmdEpoch = 0;
                cmdcache21 = TJC.INVALID_COMMAND_CACHE;
                cmdcache21_cmdEpoch = 0;
                cmdcache22 = TJC.INVALID_COMMAND_CACHE;
                cmdcache22_cmdEpoch = 0;
                cmdcache23 = TJC.INVALID_COMMAND_CACHE;
                cmdcache23_cmdEpoch = 0;
                cmdcache24 = TJC.INVALID_COMMAND_CACHE;
                cmdcache24_cmdEpoch = 0;
                cmdcache25 = TJC.INVALID_COMMAND_CACHE;
                cmdcache25_cmdEpoch = 0;
                cmdcache26 = TJC.INVALID_COMMAND_CACHE;
                cmdcache26_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_arguments_undetermined";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "descend_get_data";
                break;
            }
            case 4: {
                cmdName = "descend_commands";
                break;
            }
            case 5: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 6: {
                cmdName = "parse_get_simple_text";
                break;
            }
            case 7: {
                cmdName = "compileproc_constant_cache_add";
                break;
            }
            case 8: {
                cmdName = "parse_is_word_variable";
                break;
            }
            case 9: {
                cmdName = "compileproc_childkey_reset";
                break;
            }
            case 10: {
                cmdName = "lindex";
                break;
            }
            case 11: {
                cmdName = "compileproc_scan_variable";
                break;
            }
            case 12: {
                cmdName = "compileproc_childkey_validate";
                break;
            }
            case 13: {
                cmdName = "parse_get_word_variable";
                break;
            }
            case 14: {
                cmdName = "parse_is_word_command";
                break;
            }
            case 15: {
                cmdName = "compileproc_is_empty_command";
                break;
            }
            case 16: {
                cmdName = "parse_get_word_command";
                break;
            }
            case 17: {
                cmdName = "compileproc_scan_keys";
                break;
            }
            case 18: {
                cmdName = "parse_is_word";
                break;
            }
            case 19: {
                cmdName = "parse";
                break;
            }
            case 20: {
                cmdName = "compileproc_scan_word";
                break;
            }
            case 21: {
                cmdName = "info";
                break;
            }
            case 22: {
                cmdName = "compileproc_is_result_reset_container_command";
                break;
            }
            case 23: {
                cmdName = "compileproc_container_catch_with_varname";
                break;
            }
            case 24: {
                cmdName = "compileproc_is_container_command";
                break;
            }
            case 25: {
                cmdName = "compileproc_can_inline_container";
                break;
            }
            case 26: {
                cmdName = "compileproc_scan_keys_in_container";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
            case 20: {
                cmdcache20 = lwcmd;
                cmdcache20_cmdEpoch = cmdEpoch;
                break;
            }
            case 21: {
                cmdcache21 = lwcmd;
                cmdcache21_cmdEpoch = cmdEpoch;
                break;
            }
            case 22: {
                cmdcache22 = lwcmd;
                cmdcache22_cmdEpoch = cmdEpoch;
                break;
            }
            case 23: {
                cmdcache23 = lwcmd;
                cmdcache23_cmdEpoch = cmdEpoch;
                break;
            }
            case 24: {
                cmdcache24 = lwcmd;
                cmdcache24_cmdEpoch = cmdEpoch;
                break;
            }
            case 25: {
                cmdcache25 = lwcmd;
                cmdcache25_cmdEpoch = cmdEpoch;
                break;
            }
            case 26: {
                cmdcache26 = lwcmd;
                cmdcache26_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "keys",
        "_compileproc",
        "_compileproc_key_info",
        "cmd_needs_init",
        "constants_found",
        "last_key",
        "key",
        "script",
        "tree",
        "num_args",
        "types",
        "values",
        "cmaps",
        "instrs",
        "argument_commands",
        "i",
        "telem",
        "qtext",
        "brace_quoted",
        "uqtext",
        "cmap",
        "bs_uqtext",
        "len",
        "c",
        "commands",
        "vstree",
        "vinfo",
        "wrange",
        "wstree",
        "type_winfo",
        "type",
        "value",
        "is_nested",
        "is_last_key",
        "container_key",
        "container_result",
        "tuple",
        "has_varname"
    };
} // end class CompileprocScanKeysCmd

