// TJC implementation of procedure _compileproc_scan_variable_iterator
package tjc;
import tcl.lang.*;

public class CompileprocScanVariableIteratorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script stree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 5);
        } // End Invoke: global
        { // Invoke: upvar #0 ... results
            TclObject[] objv0 = TJC.grabObjv(interp, 4);
            try {
                // Arg 0 constant: upvar
                objv0[0] = const0;
                // Arg 1 constant: #0
                objv0[1] = const1;
                // Arg 2 constant: ...
                objv0[2] = const2;
                // Arg 3 constant: results
                objv0[3] = const3;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv0, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv0, 4);
            }
        } // End Invoke: upvar
        { // Invoke: switch -exact -- $type {scalar} ... {array text} ... {array scalar} ... {array command} ... {array word} ... {word begin} ... {word end} ... {word text} ... {word scalar} ... {word command} ... {word array text} ... {word array scalar} ... {word array command} ... {word array word} ... default ...
            TclObject tmp1 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp2 = tmp1.toString();
            int tmp2_length = tmp2.length();
            char tmp2_first = '\n';
            if ( tmp2_length > 0 ) {
                tmp2_first = tmp2.charAt(0);
            }
            interp.resetResult();
            if ( tmp2_length == 6 && tmp2_first == 's'
                    && tmp2.compareTo("scalar") == 0 ) {
                // Pattern {scalar}
                { // Invoke: lappend results $type [...]
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    TclObject tmp4;
                    try {
                        // Arg 2 variable: $type
                        tmp4 = getVarScalar(interp, "type", compiledLocals, 2);
                        tmp4.preserve();
                        objv3[0] = tmp4;
                        // Arg 3 command: [...]
                        { // Invoke: lindex $values 0
                            TclObject tmp5 = getVarScalar(interp, "values", compiledLocals, 3);
                            tmp5 = TclList.index(interp, tmp5, 0);
                            if ( tmp5 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp5);
                            }
                        } // End Invoke: lindex
                        tmp4 = interp.getResult();
                        tmp4.preserve();
                        objv3[1] = tmp4;
                        interp.resetResult();
                        tmp4 = lappendVarScalar(interp, "results", objv3, compiledLocals, 6);
                        interp.setResult(tmp4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv3, 2);
                    }
                } // End Invoke: lappend
            } else if ( tmp2_length == 10 && tmp2_first == 'a'
                    && tmp2.compareTo("array text") == 0 ) {
                // Pattern {array text}
                { // Invoke: lappend results $type $values
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 2 variable: $type
                        tmp7 = getVarScalar(interp, "type", compiledLocals, 2);
                        tmp7.preserve();
                        objv6[0] = tmp7;
                        // Arg 3 variable: $values
                        tmp7 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        interp.resetResult();
                        tmp7 = lappendVarScalar(interp, "results", objv6, compiledLocals, 6);
                        interp.setResult(tmp7);
                    } finally {
                        TJC.releaseObjvElems(interp, objv6, 2);
                    }
                } // End Invoke: lappend
            } else if ( tmp2_length == 12 && tmp2_first == 'a'
                    && tmp2.compareTo("array scalar") == 0 ) {
                // Pattern {array scalar}
                { // Invoke: lappend results $type $values
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    TclObject tmp9;
                    try {
                        // Arg 2 variable: $type
                        tmp9 = getVarScalar(interp, "type", compiledLocals, 2);
                        tmp9.preserve();
                        objv8[0] = tmp9;
                        // Arg 3 variable: $values
                        tmp9 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        interp.resetResult();
                        tmp9 = lappendVarScalar(interp, "results", objv8, compiledLocals, 6);
                        interp.setResult(tmp9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv8, 2);
                    }
                } // End Invoke: lappend
            } else if ( tmp2_length == 13 && tmp2_first == 'a'
                    && tmp2.compareTo("array command") == 0 ) {
                // Pattern {array command}
                { // Invoke: set key $...
                    TclObject tmp10;
                    tmp10 = getVarArray(interp, "_compileproc", "var_scan_key", compiledLocals, 5);
                    setVarScalar(interp, "key", tmp10, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set ckeys [...]
                    TclObject tmp11;
                    { // Invoke: ... $key
                        TclObject[] objv12 = TJC.grabObjv(interp, 2);
                        TclObject tmp13;
                        try {
                            // Arg 0 constant: ...
                            objv12[0] = const4;
                            // Arg 1 variable: $key
                            tmp13 = getVarScalar(interp, "key", compiledLocals, 7);
                            tmp13.preserve();
                            objv12[1] = tmp13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv12, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp13 = objv12[1];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            TJC.releaseObjv(interp, objv12, 2);
                        }
                    } // End Invoke: ...
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "ckeys", tmp11, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $ckeys
                        TclObject[] objv14 = TJC.grabObjv(interp, 2);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: ...
                            objv14[0] = const5;
                            // Arg 1 variable: $ckeys
                            tmp15 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                            tmp15.preserve();
                            objv14[1] = tmp15;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv14, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp15 = objv14[1];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp16 = interp.getResult();
                    ExprValue tmp17 = evs0;
                    TJC.exprInitValue(interp, tmp17, tmp16);
                    boolean tmp18 = tmp17.getBooleanValue(interp);
                    if ( tmp18 ) {
                        { // Invoke: set ckeys {}
                            setVarScalar(interp, "ckeys", const6, compiledLocals, 8);
                        } // End Invoke: set
                    } else {
                        { // Invoke: ... $ckeys
                            TclObject[] objv19 = TJC.grabObjv(interp, 2);
                            TclObject tmp20;
                            try {
                                // Arg 0 constant: ...
                                objv19[0] = const7;
                                // Arg 1 variable: $ckeys
                                tmp20 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                                tmp20.preserve();
                                objv19[1] = tmp20;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv19, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp20 = objv19[1];
                                if ( tmp20 != null ) {
                                    tmp20.release();
                                }
                                TJC.releaseObjv(interp, objv19, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: lappend results $type [...]
                    TclObject[] objv21 = TJC.grabObjv(interp, 2);
                    TclObject tmp22;
                    try {
                        // Arg 2 variable: $type
                        tmp22 = getVarScalar(interp, "type", compiledLocals, 2);
                        tmp22.preserve();
                        objv21[0] = tmp22;
                        // Arg 3 command: [...]
                        { // Invoke: list [...] $ckeys
                            TclObject tmp23 = TclList.newInstance();
                            TclObject tmp24;
                            try {
                                { // Invoke: lindex $values 0
                                    TclObject tmp25 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp25 = TclList.index(interp, tmp25, 0);
                                    if ( tmp25 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp25);
                                    }
                                } // End Invoke: lindex
                                tmp24 = interp.getResult();
                                TclList.append(interp, tmp23, tmp24);
                                tmp24 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                                TclList.append(interp, tmp23, tmp24);
                            } catch (TclException ex) {
                                tmp23.release();
                                throw ex;
                            }
                            interp.setResult(tmp23);
                        } // End Invoke: list
                        tmp22 = interp.getResult();
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        interp.resetResult();
                        tmp22 = lappendVarScalar(interp, "results", objv21, compiledLocals, 6);
                        interp.setResult(tmp22);
                    } finally {
                        TJC.releaseObjvElems(interp, objv21, 2);
                    }
                } // End Invoke: lappend
            } else if ( tmp2_length == 10 && tmp2_first == 'a'
                    && tmp2.compareTo("array word") == 0 ) {
                // Pattern {array word}
                { // Invoke: lappend results $type $values
                    TclObject[] objv26 = TJC.grabObjv(interp, 2);
                    TclObject tmp27;
                    try {
                        // Arg 2 variable: $type
                        tmp27 = getVarScalar(interp, "type", compiledLocals, 2);
                        tmp27.preserve();
                        objv26[0] = tmp27;
                        // Arg 3 variable: $values
                        tmp27 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp27.preserve();
                        objv26[1] = tmp27;
                        interp.resetResult();
                        tmp27 = lappendVarScalar(interp, "results", objv26, compiledLocals, 6);
                        interp.setResult(tmp27);
                    } finally {
                        TJC.releaseObjvElems(interp, objv26, 2);
                    }
                } // End Invoke: lappend
            } else if ( tmp2_length == 10 && tmp2_first == 'w'
                    && tmp2.compareTo("word begin") == 0 ) {
                // Pattern {word begin}
            } else if ( tmp2_length == 8 && tmp2_first == 'w'
                    && tmp2.compareTo("word end") == 0 ) {
                // Pattern {word end}
            } else if ( tmp2_length == 9 && tmp2_first == 'w'
                    && tmp2.compareTo("word text") == 0 ) {
                // Pattern {word text}
                { // Invoke: set word [...]
                    TclObject tmp28;
                    { // Invoke: ...
                        TclObject[] objv29 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv29[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv29, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv29, 1);
                        }
                    } // End Invoke: ...
                    tmp28 = interp.getResult();
                    setVarScalar(interp, "word", tmp28, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv30 = TJC.grabObjv(interp, 1);
                    TclObject tmp31;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list "text" [...]
                            TclObject tmp32 = TclList.newInstance();
                            TclObject tmp33;
                            try {
                                TclList.append(interp, tmp32, const9);
                                { // Invoke: lindex $values 0
                                    TclObject tmp34 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp34 = TclList.index(interp, tmp34, 0);
                                    if ( tmp34 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp34);
                                    }
                                } // End Invoke: lindex
                                tmp33 = interp.getResult();
                                TclList.append(interp, tmp32, tmp33);
                            } catch (TclException ex) {
                                tmp32.release();
                                throw ex;
                            }
                            interp.setResult(tmp32);
                        } // End Invoke: list
                        tmp31 = interp.getResult();
                        tmp31.preserve();
                        objv30[0] = tmp31;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv30, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv30, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv35 = TJC.grabObjv(interp, 2);
                    TclObject tmp36;
                    try {
                        // Arg 0 constant: ...
                        objv35[0] = const8;
                        // Arg 1 variable: $word
                        tmp36 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp36.preserve();
                        objv35[1] = tmp36;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv35, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp36 = objv35[1];
                        if ( tmp36 != null ) {
                            tmp36.release();
                        }
                        TJC.releaseObjv(interp, objv35, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp2_length == 11 && tmp2_first == 'w'
                    && tmp2.compareTo("word scalar") == 0 ) {
                // Pattern {word scalar}
                { // Invoke: set word [...]
                    TclObject tmp37;
                    { // Invoke: ...
                        TclObject[] objv38 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv38[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv38, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv38, 1);
                        }
                    } // End Invoke: ...
                    tmp37 = interp.getResult();
                    setVarScalar(interp, "word", tmp37, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv39 = TJC.grabObjv(interp, 1);
                    TclObject tmp40;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list scalar [...]
                            TclObject tmp41 = TclList.newInstance();
                            TclObject tmp42;
                            try {
                                TclList.append(interp, tmp41, const10);
                                { // Invoke: lindex $values 0
                                    TclObject tmp43 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp43 = TclList.index(interp, tmp43, 0);
                                    if ( tmp43 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp43);
                                    }
                                } // End Invoke: lindex
                                tmp42 = interp.getResult();
                                TclList.append(interp, tmp41, tmp42);
                            } catch (TclException ex) {
                                tmp41.release();
                                throw ex;
                            }
                            interp.setResult(tmp41);
                        } // End Invoke: list
                        tmp40 = interp.getResult();
                        tmp40.preserve();
                        objv39[0] = tmp40;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv39, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv39, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv44 = TJC.grabObjv(interp, 2);
                    TclObject tmp45;
                    try {
                        // Arg 0 constant: ...
                        objv44[0] = const8;
                        // Arg 1 variable: $word
                        tmp45 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp45.preserve();
                        objv44[1] = tmp45;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv44, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp45 = objv44[1];
                        if ( tmp45 != null ) {
                            tmp45.release();
                        }
                        TJC.releaseObjv(interp, objv44, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp2_length == 12 && tmp2_first == 'w'
                    && tmp2.compareTo("word command") == 0 ) {
                // Pattern {word command}
                { // Invoke: set key $...
                    TclObject tmp46;
                    tmp46 = getVarArray(interp, "_compileproc", "var_scan_key", compiledLocals, 5);
                    setVarScalar(interp, "key", tmp46, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set ckeys [...]
                    TclObject tmp47;
                    { // Invoke: ... $key
                        TclObject[] objv48 = TJC.grabObjv(interp, 2);
                        TclObject tmp49;
                        try {
                            // Arg 0 constant: ...
                            objv48[0] = const4;
                            // Arg 1 variable: $key
                            tmp49 = getVarScalar(interp, "key", compiledLocals, 7);
                            tmp49.preserve();
                            objv48[1] = tmp49;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv48, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp49 = objv48[1];
                            if ( tmp49 != null ) {
                                tmp49.release();
                            }
                            TJC.releaseObjv(interp, objv48, 2);
                        }
                    } // End Invoke: ...
                    tmp47 = interp.getResult();
                    setVarScalar(interp, "ckeys", tmp47, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $ckeys
                        TclObject[] objv50 = TJC.grabObjv(interp, 2);
                        TclObject tmp51;
                        try {
                            // Arg 0 constant: ...
                            objv50[0] = const5;
                            // Arg 1 variable: $ckeys
                            tmp51 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                            tmp51.preserve();
                            objv50[1] = tmp51;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv50, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp51 = objv50[1];
                            if ( tmp51 != null ) {
                                tmp51.release();
                            }
                            TJC.releaseObjv(interp, objv50, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp52 = interp.getResult();
                    ExprValue tmp53 = evs0;
                    TJC.exprInitValue(interp, tmp53, tmp52);
                    boolean tmp54 = tmp53.getBooleanValue(interp);
                    if ( tmp54 ) {
                        { // Invoke: set ckeys {}
                            setVarScalar(interp, "ckeys", const6, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: ... {}
                            TclObject[] objv55 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv55[0] = const11;
                                // Arg 1 constant: {}
                                objv55[1] = const6;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv55, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv55, 2);
                            }
                        } // End Invoke: ...
                    } else {
                        { // Invoke: ... $ckeys
                            TclObject[] objv56 = TJC.grabObjv(interp, 2);
                            TclObject tmp57;
                            try {
                                // Arg 0 constant: ...
                                objv56[0] = const7;
                                // Arg 1 variable: $ckeys
                                tmp57 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                                tmp57.preserve();
                                objv56[1] = tmp57;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv56, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp57 = objv56[1];
                                if ( tmp57 != null ) {
                                    tmp57.release();
                                }
                                TJC.releaseObjv(interp, objv56, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: set word [...]
                    TclObject tmp58;
                    { // Invoke: ...
                        TclObject[] objv59 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv59[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv59, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv59, 1);
                        }
                    } // End Invoke: ...
                    tmp58 = interp.getResult();
                    setVarScalar(interp, "word", tmp58, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv60 = TJC.grabObjv(interp, 1);
                    TclObject tmp61;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list $type $ckeys
                            TclObject tmp62 = TclList.newInstance();
                            TclObject tmp63;
                            try {
                                tmp63 = getVarScalar(interp, "type", compiledLocals, 2);
                                TclList.append(interp, tmp62, tmp63);
                                tmp63 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                                TclList.append(interp, tmp62, tmp63);
                            } catch (TclException ex) {
                                tmp62.release();
                                throw ex;
                            }
                            interp.setResult(tmp62);
                        } // End Invoke: list
                        tmp61 = interp.getResult();
                        tmp61.preserve();
                        objv60[0] = tmp61;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv60, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv60, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv64 = TJC.grabObjv(interp, 2);
                    TclObject tmp65;
                    try {
                        // Arg 0 constant: ...
                        objv64[0] = const8;
                        // Arg 1 variable: $word
                        tmp65 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp65.preserve();
                        objv64[1] = tmp65;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv64, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp65 = objv64[1];
                        if ( tmp65 != null ) {
                            tmp65.release();
                        }
                        TJC.releaseObjv(interp, objv64, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp2_length == 15 && tmp2_first == 'w'
                    && tmp2.compareTo("word array text") == 0 ) {
                // Pattern {word array text}
                { // Invoke: set word [...]
                    TclObject tmp66;
                    { // Invoke: ...
                        TclObject[] objv67 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv67[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv67, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv67, 1);
                        }
                    } // End Invoke: ...
                    tmp66 = interp.getResult();
                    setVarScalar(interp, "word", tmp66, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv68 = TJC.grabObjv(interp, 1);
                    TclObject tmp69;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list {array text} $values
                            TclObject tmp70 = TclList.newInstance();
                            TclObject tmp71;
                            try {
                                TclList.append(interp, tmp70, const12);
                                tmp71 = getVarScalar(interp, "values", compiledLocals, 3);
                                TclList.append(interp, tmp70, tmp71);
                            } catch (TclException ex) {
                                tmp70.release();
                                throw ex;
                            }
                            interp.setResult(tmp70);
                        } // End Invoke: list
                        tmp69 = interp.getResult();
                        tmp69.preserve();
                        objv68[0] = tmp69;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv68, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv68, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv72 = TJC.grabObjv(interp, 2);
                    TclObject tmp73;
                    try {
                        // Arg 0 constant: ...
                        objv72[0] = const8;
                        // Arg 1 variable: $word
                        tmp73 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp73.preserve();
                        objv72[1] = tmp73;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv72, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp73 = objv72[1];
                        if ( tmp73 != null ) {
                            tmp73.release();
                        }
                        TJC.releaseObjv(interp, objv72, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp2_length == 17 && tmp2_first == 'w'
                    && tmp2.compareTo("word array scalar") == 0 ) {
                // Pattern {word array scalar}
                { // Invoke: set word [...]
                    TclObject tmp74;
                    { // Invoke: ...
                        TclObject[] objv75 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv75[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv75, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv75, 1);
                        }
                    } // End Invoke: ...
                    tmp74 = interp.getResult();
                    setVarScalar(interp, "word", tmp74, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv76 = TJC.grabObjv(interp, 1);
                    TclObject tmp77;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list {array scalar} $values
                            TclObject tmp78 = TclList.newInstance();
                            TclObject tmp79;
                            try {
                                TclList.append(interp, tmp78, const13);
                                tmp79 = getVarScalar(interp, "values", compiledLocals, 3);
                                TclList.append(interp, tmp78, tmp79);
                            } catch (TclException ex) {
                                tmp78.release();
                                throw ex;
                            }
                            interp.setResult(tmp78);
                        } // End Invoke: list
                        tmp77 = interp.getResult();
                        tmp77.preserve();
                        objv76[0] = tmp77;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv76, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv76, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv80 = TJC.grabObjv(interp, 2);
                    TclObject tmp81;
                    try {
                        // Arg 0 constant: ...
                        objv80[0] = const8;
                        // Arg 1 variable: $word
                        tmp81 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp81.preserve();
                        objv80[1] = tmp81;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv80, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp81 = objv80[1];
                        if ( tmp81 != null ) {
                            tmp81.release();
                        }
                        TJC.releaseObjv(interp, objv80, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp2_length == 18 && tmp2_first == 'w'
                    && tmp2.compareTo("word array command") == 0 ) {
                // Pattern {word array command}
                { // Invoke: set key $...
                    TclObject tmp82;
                    tmp82 = getVarArray(interp, "_compileproc", "var_scan_key", compiledLocals, 5);
                    setVarScalar(interp, "key", tmp82, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set ckeys [...]
                    TclObject tmp83;
                    { // Invoke: ... $key
                        TclObject[] objv84 = TJC.grabObjv(interp, 2);
                        TclObject tmp85;
                        try {
                            // Arg 0 constant: ...
                            objv84[0] = const4;
                            // Arg 1 variable: $key
                            tmp85 = getVarScalar(interp, "key", compiledLocals, 7);
                            tmp85.preserve();
                            objv84[1] = tmp85;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv84, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp85 = objv84[1];
                            if ( tmp85 != null ) {
                                tmp85.release();
                            }
                            TJC.releaseObjv(interp, objv84, 2);
                        }
                    } // End Invoke: ...
                    tmp83 = interp.getResult();
                    setVarScalar(interp, "ckeys", tmp83, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $ckeys
                        TclObject[] objv86 = TJC.grabObjv(interp, 2);
                        TclObject tmp87;
                        try {
                            // Arg 0 constant: ...
                            objv86[0] = const5;
                            // Arg 1 variable: $ckeys
                            tmp87 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                            tmp87.preserve();
                            objv86[1] = tmp87;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv86, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp87 = objv86[1];
                            if ( tmp87 != null ) {
                                tmp87.release();
                            }
                            TJC.releaseObjv(interp, objv86, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp88 = interp.getResult();
                    ExprValue tmp89 = evs0;
                    TJC.exprInitValue(interp, tmp89, tmp88);
                    boolean tmp90 = tmp89.getBooleanValue(interp);
                    if ( tmp90 ) {
                        { // Invoke: set ckeys {}
                            setVarScalar(interp, "ckeys", const6, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: ... {}
                            TclObject[] objv91 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv91[0] = const11;
                                // Arg 1 constant: {}
                                objv91[1] = const6;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv91, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv91, 2);
                            }
                        } // End Invoke: ...
                    } else {
                        { // Invoke: ... $ckeys
                            TclObject[] objv92 = TJC.grabObjv(interp, 2);
                            TclObject tmp93;
                            try {
                                // Arg 0 constant: ...
                                objv92[0] = const7;
                                // Arg 1 variable: $ckeys
                                tmp93 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                                tmp93.preserve();
                                objv92[1] = tmp93;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv92, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp93 = objv92[1];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                TJC.releaseObjv(interp, objv92, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: set word [...]
                    TclObject tmp94;
                    { // Invoke: ...
                        TclObject[] objv95 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv95[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv95, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv95, 1);
                        }
                    } // End Invoke: ...
                    tmp94 = interp.getResult();
                    setVarScalar(interp, "word", tmp94, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv96 = TJC.grabObjv(interp, 1);
                    TclObject tmp97;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list {array command} [...]
                            TclObject tmp98 = TclList.newInstance();
                            TclObject tmp99;
                            try {
                                TclList.append(interp, tmp98, const14);
                                { // Invoke: list [...] $ckeys
                                    TclObject tmp100 = TclList.newInstance();
                                    TclObject tmp101;
                                    try {
                                        { // Invoke: lindex $values 0
                                            TclObject tmp102 = getVarScalar(interp, "values", compiledLocals, 3);
                                            tmp102 = TclList.index(interp, tmp102, 0);
                                            if ( tmp102 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp102);
                                            }
                                        } // End Invoke: lindex
                                        tmp101 = interp.getResult();
                                        TclList.append(interp, tmp100, tmp101);
                                        tmp101 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                                        TclList.append(interp, tmp100, tmp101);
                                    } catch (TclException ex) {
                                        tmp100.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp100);
                                } // End Invoke: list
                                tmp99 = interp.getResult();
                                TclList.append(interp, tmp98, tmp99);
                            } catch (TclException ex) {
                                tmp98.release();
                                throw ex;
                            }
                            interp.setResult(tmp98);
                        } // End Invoke: list
                        tmp97 = interp.getResult();
                        tmp97.preserve();
                        objv96[0] = tmp97;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv96, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv96, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv103 = TJC.grabObjv(interp, 2);
                    TclObject tmp104;
                    try {
                        // Arg 0 constant: ...
                        objv103[0] = const8;
                        // Arg 1 variable: $word
                        tmp104 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp104.preserve();
                        objv103[1] = tmp104;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv103, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp104 = objv103[1];
                        if ( tmp104 != null ) {
                            tmp104.release();
                        }
                        TJC.releaseObjv(interp, objv103, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp2_length == 15 && tmp2_first == 'w'
                    && tmp2.compareTo("word array word") == 0 ) {
                // Pattern {word array word}
                { // Invoke: set word [...]
                    TclObject tmp105;
                    { // Invoke: ...
                        TclObject[] objv106 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv106[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv106, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv106, 1);
                        }
                    } // End Invoke: ...
                    tmp105 = interp.getResult();
                    setVarScalar(interp, "word", tmp105, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv107 = TJC.grabObjv(interp, 1);
                    TclObject tmp108;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list {array word} $values
                            TclObject tmp109 = TclList.newInstance();
                            TclObject tmp110;
                            try {
                                TclList.append(interp, tmp109, const15);
                                tmp110 = getVarScalar(interp, "values", compiledLocals, 3);
                                TclList.append(interp, tmp109, tmp110);
                            } catch (TclException ex) {
                                tmp109.release();
                                throw ex;
                            }
                            interp.setResult(tmp109);
                        } // End Invoke: list
                        tmp108 = interp.getResult();
                        tmp108.preserve();
                        objv107[0] = tmp108;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv107, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv107, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv111 = TJC.grabObjv(interp, 2);
                    TclObject tmp112;
                    try {
                        // Arg 0 constant: ...
                        objv111[0] = const8;
                        // Arg 1 variable: $word
                        tmp112 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp112.preserve();
                        objv111[1] = tmp112;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv111, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp112 = objv111[1];
                        if ( tmp112 != null ) {
                            tmp112.release();
                        }
                        TJC.releaseObjv(interp, objv111, 2);
                    }
                } // End Invoke: ...
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv113 = TJC.grabObjv(interp, 2);
                    TclObject tmp114;
                    try {
                        // Arg 0 constant: error
                        objv113[0] = const16;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp115 = new StringBuffer(64);
                        sbtmp115.append("unknown variable type ");
                        sbtmp115.append("{");
                        tmp114 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp115.append(tmp114.toString());
                        sbtmp115.append("}");
                        tmp114 = TclString.newInstance(sbtmp115);
                        tmp114.preserve();
                        objv113[1] = tmp114;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv113, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp114 = objv113[1];
                        if ( tmp114 != null ) {
                            tmp114.release();
                        }
                        TJC.releaseObjv(interp, objv113, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_compileproc_scan_variable_iterator");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("upvar");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("#0");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc(var_scan_results)");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("results");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_childkey_next");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_is_empty_command");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_scan_keys");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_variable_iterate_word_value");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("text");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("scalar");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_constant_cache_add");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("array text");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("array scalar");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("array command");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("array word");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("error");
        const16.preserve(); const16.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "upvar";
                break;
            }
            case 2: {
                cmdName = "compileproc_childkey_next";
                break;
            }
            case 3: {
                cmdName = "compileproc_is_empty_command";
                break;
            }
            case 4: {
                cmdName = "compileproc_scan_keys";
                break;
            }
            case 5: {
                cmdName = "parse_variable_iterate_word_value";
                break;
            }
            case 6: {
                cmdName = "compileproc_constant_cache_add";
                break;
            }
            case 7: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "type",
        "values",
        "ranges",
        "_compileproc",
        "results",
        "key",
        "ckeys",
        "word"
    };
} // end class CompileprocScanVariableIteratorCmd

