// TJC implementation of procedure compileproc_scan_word
package tjc;
import tcl.lang.*;

public class CompileprocScanWordCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 16, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "key script wstree");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "script", objv[2], compiledLocals, 1);
        setVarScalar(interp, "wstree", objv[3], compiledLocals, 2);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 3);
        } // End Invoke: global
        { // Invoke: set saved_word_scan_key $...
            TclObject tmp0;
            tmp0 = getVarArray(interp, "_compileproc", "word_scan_key", compiledLocals, 3);
            setVarScalar(interp, "saved_word_scan_key", tmp0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set ... $...
            TclObject tmp1;
            tmp1 = getVarArray(interp, "_compileproc", "word_scan_results", compiledLocals, 3);
            setVarScalar(interp, "saved_word_scan_results", tmp1, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set ... $key
            TclObject tmp2;
            tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
            setVarArray(interp, "_compileproc", "word_scan_key", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "word_scan_results", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: parse_word_iterate $script $wstree ...
            TclObject[] objv3 = TJC.grabObjv(interp, 4);
            TclObject tmp4;
            try {
                // Arg 0 constant: parse_word_iterate
                objv3[0] = const1;
                // Arg 1 variable: $script
                tmp4 = getVarScalar(interp, "script", compiledLocals, 1);
                tmp4.preserve();
                objv3[1] = tmp4;
                // Arg 2 variable: $wstree
                tmp4 = getVarScalar(interp, "wstree", compiledLocals, 2);
                tmp4.preserve();
                objv3[2] = tmp4;
                // Arg 3 constant: ...
                objv3[3] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv3, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                tmp4 = objv3[1];
                if ( tmp4 != null ) {
                    tmp4.release();
                }
                tmp4 = objv3[2];
                if ( tmp4 != null ) {
                    tmp4.release();
                }
                TJC.releaseObjv(interp, objv3, 4);
            }
        } // End Invoke: parse_word_iterate
        { // Invoke: set winfo $...
            TclObject tmp5;
            tmp5 = getVarArray(interp, "_compileproc", "word_scan_results", compiledLocals, 3);
            setVarScalar(interp, "winfo", tmp5, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set ... $saved_word_scan_key
            TclObject tmp6;
            tmp6 = getVarScalar(interp, "saved_word_scan_key", compiledLocals, 4);
            setVarArray(interp, "_compileproc", "word_scan_key", tmp6, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... $...
            TclObject tmp7;
            tmp7 = getVarScalar(interp, "saved_word_scan_results", compiledLocals, 5);
            setVarArray(interp, "_compileproc", "word_scan_results", tmp7, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set all_text 1
            setVarScalar(interp, "all_text", const3, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: foreach wi $winfo ...
            TclObject tmp8 = null;
            try {
                tmp8 = getVarScalar(interp, "winfo", compiledLocals, 6);
                tmp8.preserve();
                final int tmp8_length = TclList.getLength(interp, tmp8);

                for ( int index9 = 0 ; index9 < tmp8_length ; index9++ ) {
                    TclObject tmp10 = TclList.index(interp, tmp8, index9);
                    try {
                        setVarScalar(interp, "wi", tmp10, compiledLocals, 8);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "wi");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set type [...]
                        TclObject tmp11;
                        { // Invoke: lindex $wi 0
                            TclObject tmp12 = getVarScalar(interp, "wi", compiledLocals, 8);
                            tmp12 = TclList.index(interp, tmp12, 0);
                            if ( tmp12 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp12);
                            }
                        } // End Invoke: lindex
                        tmp11 = interp.getResult();
                        setVarScalar(interp, "type", tmp11, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: if {$type != "text"} ...
                        // Binary operator: $type != "text"
                        TclObject tmp13 = getVarScalar(interp, "type", compiledLocals, 9);
                        boolean tmp14 = ! tmp13.toString().equals("text");
                        ExprValue tmp15 = evs0;
                        tmp15.setIntValue(tmp14);
                        // End Binary operator: !=
                        boolean tmp16 = ( tmp15.getIntValue() != 0 );
                        if ( tmp16 ) {
                            { // Invoke: set all_text 0
                                setVarScalar(interp, "all_text", const4, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: break
                                if ( true ) { break; }
                            } // End Invoke: break
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp8 != null ) {
                    tmp8.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$all_text} ... else ...
            TclObject tmp17 = getVarScalar(interp, "all_text", compiledLocals, 7);
            boolean tmp18 = TJC.getBoolean(interp, tmp17);
            if ( tmp18 ) {
                { // Invoke: set all_str ""
                    setVarScalar(interp, "all_str", const0, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: set has_escapes 0
                    setVarScalar(interp, "has_escapes", const4, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set cmap [...]
                    TclObject tmp19;
                    { // Invoke: list
                        TclObject tmp20 = TclList.newInstance();
                        interp.setResult(tmp20);
                    } // End Invoke: list
                    tmp19 = interp.getResult();
                    setVarScalar(interp, "cmap", tmp19, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: foreach wi $winfo ...
                    TclObject tmp21 = null;
                    try {
                        tmp21 = getVarScalar(interp, "winfo", compiledLocals, 6);
                        tmp21.preserve();
                        final int tmp21_length = TclList.getLength(interp, tmp21);

                        for ( int index22 = 0 ; index22 < tmp21_length ; index22++ ) {
                            TclObject tmp23 = TclList.index(interp, tmp21, index22);
                            try {
                                setVarScalar(interp, "wi", tmp23, compiledLocals, 8);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "wi");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set str [...]
                                TclObject tmp24;
                                { // Invoke: lindex $wi 1
                                    TclObject tmp25 = getVarScalar(interp, "wi", compiledLocals, 8);
                                    tmp25 = TclList.index(interp, tmp25, 1);
                                    if ( tmp25 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp25);
                                    }
                                } // End Invoke: lindex
                                tmp24 = interp.getResult();
                                setVarScalar(interp, "str", tmp24, compiledLocals, 13);
                            } // End Invoke: set
                            { // Invoke: append all_str $str
                                TclObject[] objv26 = TJC.grabObjv(interp, 1);
                                TclObject tmp27;
                                try {
                                    // Arg 2 variable: $str
                                    tmp27 = getVarScalar(interp, "str", compiledLocals, 13);
                                    tmp27.preserve();
                                    objv26[0] = tmp27;
                                    interp.resetResult();
                                    appendVarScalar(interp, "all_str", objv26, compiledLocals, 10);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv26, 1);
                                }
                            } // End Invoke: append
                            { // Invoke: if ... ... else ...
                                // Binary operator: [...] == "\\"
                                { // Invoke: string index $str 0
                                    TclObject tmp28 = getVarScalar(interp, "str", compiledLocals, 13);
                                    String tmp29 = tmp28.toString();
                                    TclObject tmp30 = TJC.stringIndex(interp, tmp29, const4);
                                    interp.setResult(tmp30);
                                } // End Invoke: string
                                TclObject tmp31 = interp.getResult();
                                boolean tmp32 = tmp31.toString().equals("\\");
                                ExprValue tmp33 = evs0;
                                tmp33.setIntValue(tmp32);
                                // End Binary operator: ==
                                boolean tmp34 = ( tmp33.getIntValue() != 0 );
                                if ( tmp34 ) {
                                    { // Invoke: set has_escapes 1
                                        setVarScalar(interp, "has_escapes", const3, compiledLocals, 11);
                                    } // End Invoke: set
                                    { // Invoke: lappend cmap [...]
                                        TclObject[] objv35 = TJC.grabObjv(interp, 1);
                                        TclObject tmp36;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: string length $str
                                                TclObject tmp37 = getVarScalar(interp, "str", compiledLocals, 13);
                                                int tmp38 = tmp37.toString().length();
                                                interp.setResult(tmp38);
                                            } // End Invoke: string
                                            tmp36 = interp.getResult();
                                            tmp36.preserve();
                                            objv35[0] = tmp36;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "cmap", objv35, compiledLocals, 12);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv35, 1);
                                        }
                                    } // End Invoke: lappend
                                } else {
                                    { // Invoke: set len [...]
                                        TclObject tmp39;
                                        { // Invoke: string length $str
                                            TclObject tmp40 = getVarScalar(interp, "str", compiledLocals, 13);
                                            int tmp41 = tmp40.toString().length();
                                            interp.setResult(tmp41);
                                        } // End Invoke: string
                                        tmp39 = interp.getResult();
                                        setVarScalar(interp, "len", tmp39, compiledLocals, 14);
                                    } // End Invoke: set
                                    { // Invoke: for {set i 0} {$i < $len} {incr i} ...
                                        { // Invoke: set i 0
                                            setVarScalar(interp, "i", const4, compiledLocals, 15);
                                        } // End Invoke: set
                                        for ( boolean skip47 = true ; true ; ) {
                                            if ( skip47 ) {
                                                skip47 = false;
                                            } else {
                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: incr i
                                                    interp.resetResult();
                                                    incrVarScalar(interp, "i", 1, compiledLocals, 15);
                                                } // End Invoke: incr
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }

                                            // Binary operator: $i < $len
                                            TclObject tmp42 = getVarScalar(interp, "i", compiledLocals, 15);
                                            ExprValue tmp43 = evs0;
                                            TJC.exprInitValue(interp, tmp43, tmp42);
                                            TclObject tmp44 = getVarScalar(interp, "len", compiledLocals, 14);
                                            ExprValue tmp45 = evs1;
                                            TJC.exprInitValue(interp, tmp45, tmp44);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp43, tmp45);
                                            // End Binary operator: <
                                            boolean tmp46 = ( tmp43.getIntValue() != 0 );
                                            if ( ! tmp46 ) { break; }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: lappend cmap 1
                                                TclObject[] objv48 = TJC.grabObjv(interp, 1);
                                                TclObject tmp49;
                                                try {
                                                    // Arg 2 constant: 1
                                                    objv48[0] = const3;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "cmap", objv48, compiledLocals, 12);
                                                } finally {
                                                    TJC.releaseObjv(interp, objv48, 1);
                                                }
                                            } // End Invoke: lappend
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } // End Invoke: for
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp21 != null ) {
                            tmp21.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if {!$has_escapes} ...
                    // Unary operator: ! $has_escapes
                    TclObject tmp50 = getVarScalar(interp, "has_escapes", compiledLocals, 11);
                    ExprValue tmp51 = evs0;
                    if ( tmp50.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp51, tmp50);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp51, tmp50);
                    }
                    // End Unary operator: !
                    boolean tmp52 = ( tmp51.getIntValue() != 0 );
                    if ( tmp52 ) {
                        { // Invoke: set cmap {}
                            setVarScalar(interp, "cmap", const0, compiledLocals, 12);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: return [...]
                    { // Invoke: list constant $all_str $cmap
                        TclObject tmp53 = TclList.newInstance();
                        TclObject tmp54;
                        try {
                            TclList.append(interp, tmp53, const5);
                            tmp54 = getVarScalar(interp, "all_str", compiledLocals, 10);
                            TclList.append(interp, tmp53, tmp54);
                            tmp54 = getVarScalar(interp, "cmap", compiledLocals, 12);
                            TclList.append(interp, tmp53, tmp54);
                        } catch (TclException ex) {
                            tmp53.release();
                            throw ex;
                        }
                        interp.setResult(tmp53);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return [...]
                    { // Invoke: list word $winfo {}
                        TclObject tmp55 = TclList.newInstance();
                        TclObject tmp56;
                        try {
                            TclList.append(interp, tmp55, const6);
                            tmp56 = getVarScalar(interp, "winfo", compiledLocals, 6);
                            TclList.append(interp, tmp55, tmp56);
                            TclList.append(interp, tmp55, const0);
                        } catch (TclException ex) {
                            tmp55.release();
                            throw ex;
                        }
                        interp.setResult(tmp55);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_scan_word");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("parse_word_iterate");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc_scan_word_iterate");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("constant");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("word");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_word_iterate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "script",
        "wstree",
        "_compileproc",
        "saved_word_scan_key",
        "saved_word_scan_results",
        "winfo",
        "all_text",
        "wi",
        "type",
        "all_str",
        "has_escapes",
        "cmap",
        "str",
        "len",
        "i"
    };
} // end class CompileprocScanWordCmd

