// TJC implementation of procedure descend_check_container_command
package tjc;
import tcl.lang.*;

public class DescendCheckContainerCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set result [...]
            TclObject tmp0;
            { // Invoke: ... $key
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "result", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: lindex $result 0
                TclObject tmp3 = getVarScalar(interp, "result", compiledLocals, 2);
                tmp3 = TclList.index(interp, tmp3, 0);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs0;
            TJC.exprInitValue(interp, tmp5, tmp4);
            ExprValue tmp6 = evs1;
            tmp6.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp5, tmp6);
            // End Binary operator: ==
            boolean tmp7 = ( tmp5.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: ... $key
                TclObject[] objv8 = TJC.grabObjv(interp, 2);
                TclObject tmp9;
                try {
                    // Arg 0 constant: ...
                    objv8[0] = const1;
                    // Arg 1 variable: $key
                    tmp9 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp9.preserve();
                    objv8[1] = tmp9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv8, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp9 = objv8[1];
                    if ( tmp9 != null ) {
                        tmp9.release();
                    }
                    TJC.releaseObjv(interp, objv8, 2);
                }
            } // End Invoke: ...
            TclObject tmp10 = interp.getResult();
            ExprValue tmp11 = evs0;
            TJC.exprInitValue(interp, tmp11, tmp10);
            boolean tmp12 = tmp11.getBooleanValue(interp);
            if ( tmp12 ) {
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp13;
            { // Invoke: lindex $result 1
                TclObject tmp14 = getVarScalar(interp, "result", compiledLocals, 2);
                tmp14 = TclList.index(interp, tmp14, 1);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp13, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: switch -exact -- $cmdname {::after} - {after} ... {::catch} - {catch} ... {::expr} - {expr} ... {::for} - {for} ... {::foreach} - {foreach} ... {::if} - {if} ... {::lsort} - {lsort} ... {::switch} - {switch} ... {::while} - {while} ... default ...
            TclObject tmp15 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            String tmp16 = tmp15.toString();
            int tmp16_length = tmp16.length();
            char tmp16_first = '\n';
            if ( tmp16_length > 0 ) {
                tmp16_first = tmp16.charAt(0);
            }
            if ( ( tmp16_length == 7 && tmp16_first == ':'
                    && tmp16.compareTo("::after") == 0 ) ||
                ( tmp16_length == 5 && tmp16_first == 'a'
                    && tmp16.compareTo("after") == 0 ) ) {
                // Pattern {after}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const2, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 7 && tmp16_first == ':'
                    && tmp16.compareTo("::catch") == 0 ) ||
                ( tmp16_length == 5 && tmp16_first == 'c'
                    && tmp16.compareTo("catch") == 0 ) ) {
                // Pattern {catch}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const3, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 6 && tmp16_first == ':'
                    && tmp16.compareTo("::expr") == 0 ) ||
                ( tmp16_length == 4 && tmp16_first == 'e'
                    && tmp16.compareTo("expr") == 0 ) ) {
                // Pattern {expr}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const4, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 5 && tmp16_first == ':'
                    && tmp16.compareTo("::for") == 0 ) ||
                ( tmp16_length == 3 && tmp16_first == 'f'
                    && tmp16.compareTo("for") == 0 ) ) {
                // Pattern {for}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const5, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 9 && tmp16_first == ':'
                    && tmp16.compareTo("::foreach") == 0 ) ||
                ( tmp16_length == 7 && tmp16_first == 'f'
                    && tmp16.compareTo("foreach") == 0 ) ) {
                // Pattern {foreach}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const6, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 4 && tmp16_first == ':'
                    && tmp16.compareTo("::if") == 0 ) ||
                ( tmp16_length == 2 && tmp16_first == 'i'
                    && tmp16.compareTo("if") == 0 ) ) {
                // Pattern {if}
                { // Invoke: set descend_cmd descend_container_if
                    setVarScalar(interp, "descend_cmd", const7, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 7 && tmp16_first == ':'
                    && tmp16.compareTo("::lsort") == 0 ) ||
                ( tmp16_length == 5 && tmp16_first == 'l'
                    && tmp16.compareTo("lsort") == 0 ) ) {
                // Pattern {lsort}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const8, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 8 && tmp16_first == ':'
                    && tmp16.compareTo("::switch") == 0 ) ||
                ( tmp16_length == 6 && tmp16_first == 's'
                    && tmp16.compareTo("switch") == 0 ) ) {
                // Pattern {switch}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const9, compiledLocals, 4);
                } // End Invoke: set
            } else if ( ( tmp16_length == 7 && tmp16_first == ':'
                    && tmp16.compareTo("::while") == 0 ) ||
                ( tmp16_length == 5 && tmp16_first == 'w'
                    && tmp16.compareTo("while") == 0 ) ) {
                // Pattern {while}
                { // Invoke: set descend_cmd ...
                    setVarScalar(interp, "descend_cmd", const10, compiledLocals, 4);
                } // End Invoke: set
            } else {
                // Pattern default
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        { // Invoke: set ... [...]
            TclObject tmp17;
            { // Invoke: linsert $... 0 $cmdname
                TclObject[] objv18 = TJC.grabObjv(interp, 4);
                TclObject tmp19;
                try {
                    // Arg 0 constant: linsert
                    objv18[0] = const11;
                    // Arg 1 variable: $...
                    tmp19 = getVarArray(interp, "_descend", "container_stack", compiledLocals, 1);
                    tmp19.preserve();
                    objv18[1] = tmp19;
                    // Arg 2 constant: 0
                    objv18[2] = const12;
                    // Arg 3 variable: $cmdname
                    tmp19 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                    tmp19.preserve();
                    objv18[3] = tmp19;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv18, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp19 = objv18[1];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    tmp19 = objv18[3];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 4);
                }
            } // End Invoke: linsert
            tmp17 = interp.getResult();
            setVarArray(interp, "_descend", "container_stack", tmp17, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: namespace eval :: [...]
            TclObject[] objv20 = TJC.grabObjv(interp, 4);
            TclObject tmp21;
            try {
                // Arg 0 constant: namespace
                objv20[0] = const13;
                // Arg 1 constant: eval
                objv20[1] = const14;
                // Arg 2 constant: ::
                objv20[2] = const15;
                // Arg 3 command: [...]
                { // Invoke: list $descend_cmd $key
                    TclObject tmp22 = TclList.newInstance();
                    TclObject tmp23;
                    try {
                        tmp23 = getVarScalar(interp, "descend_cmd", compiledLocals, 4);
                        TclList.append(interp, tmp22, tmp23);
                        tmp23 = getVarScalar(interp, "key", compiledLocals, 0);
                        TclList.append(interp, tmp22, tmp23);
                    } catch (TclException ex) {
                        tmp22.release();
                        throw ex;
                    }
                    interp.setResult(tmp22);
                } // End Invoke: list
                tmp21 = interp.getResult();
                tmp21.preserve();
                objv20[3] = tmp21;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv20, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                tmp21 = objv20[3];
                if ( tmp21 != null ) {
                    tmp21.release();
                }
                TJC.releaseObjv(interp, objv20, 4);
            }
        } // End Invoke: namespace
        { // Invoke: set ... [...]
            TclObject tmp24;
            { // Invoke: lreplace $... 0 0
                TclObject[] objv25 = TJC.grabObjv(interp, 4);
                TclObject tmp26;
                try {
                    // Arg 0 constant: lreplace
                    objv25[0] = const16;
                    // Arg 1 variable: $...
                    tmp26 = getVarArray(interp, "_descend", "container_stack", compiledLocals, 1);
                    tmp26.preserve();
                    objv25[1] = tmp26;
                    // Arg 2 constant: 0
                    objv25[2] = const12;
                    // Arg 3 constant: 0
                    objv25[3] = const12;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv25, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp26 = objv25[1];
                    if ( tmp26 != null ) {
                        tmp26.release();
                    }
                    TJC.releaseObjv(interp, objv25, 4);
                }
            } // End Invoke: lreplace
            tmp24 = interp.getResult();
            setVarArray(interp, "_descend", "container_stack", tmp24, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_check_container_command");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_command_name");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_arguments_undetermined");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_after");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_container_catch");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_container_expr");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_container_for");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_foreach");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_if");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_lsort");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_container_switch");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_container_while");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("linsert");
        const11.preserve(); const11.preserve();
        const12 = TclInteger.newInstance(0);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("namespace");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("eval");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("::");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("lreplace");
        const16.preserve(); const16.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_command_name";
                break;
            }
            case 2: {
                cmdName = "descend_arguments_undetermined";
                break;
            }
            case 3: {
                cmdName = "linsert";
                break;
            }
            case 4: {
                cmdName = "namespace";
                break;
            }
            case 5: {
                cmdName = "lreplace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "result",
        "cmdname",
        "descend_cmd"
    };
} // end class DescendCheckContainerCommandCmd

