// TJC implementation of procedure descend_next_command
package tjc;
import tcl.lang.*;

public class DescendNextCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 24, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "script range nested undetermined");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "range", objv[2], compiledLocals, 1);
        setVarScalar(interp, "nested", objv[3], compiledLocals, 2);
        setVarScalar(interp, "undetermined", objv[4], compiledLocals, 3);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 4);
        } // End Invoke: global
        { // Invoke: set charlength [...]
            TclObject tmp0;
            { // Invoke: parse charlength $script $range
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: parse
                    objv1[0] = const0;
                    // Arg 1 constant: charlength
                    objv1[1] = const1;
                    // Arg 2 variable: $script
                    tmp2 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 variable: $range
                    tmp2 = getVarScalar(interp, "range", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[3] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[3];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: parse
            tmp0 = interp.getResult();
            setVarScalar(interp, "charlength", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$charlength == 0} ...
            // Binary operator: $charlength == 0
            TclObject tmp3 = getVarScalar(interp, "charlength", compiledLocals, 5);
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp4, tmp5);
            // End Binary operator: ==
            boolean tmp6 = ( tmp4.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: return ""
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: global _tjc
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 6);
        } // End Invoke: global
        { // Invoke: set _tjc(parse_error) ""
            setVarArray(interp, "_tjc", "parse_error", const2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: catch ... err
                int code7 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: parse command $script $range
                    TclObject[] objv8 = TJC.grabObjv(interp, 4);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: parse
                        objv8[0] = const0;
                        // Arg 1 constant: command
                        objv8[1] = const3;
                        // Arg 2 variable: $script
                        tmp9 = getVarScalar(interp, "script", compiledLocals, 0);
                        tmp9.preserve();
                        objv8[2] = tmp9;
                        // Arg 3 variable: $range
                        tmp9 = getVarScalar(interp, "range", compiledLocals, 1);
                        tmp9.preserve();
                        objv8[3] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv8, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp9 = objv8[2];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        tmp9 = objv8[3];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 4);
                    }
                } // End Invoke: parse
                } catch (TclException ex) {
                    code7 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 7);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code7);
            } // End Invoke: catch
            TclObject tmp10 = interp.getResult();
            ExprValue tmp11 = evs0;
            TJC.exprInitValue(interp, tmp11, tmp10);
            boolean tmp12 = tmp11.getBooleanValue(interp);
            if ( tmp12 ) {
                { // Invoke: set handled 0
                    setVarScalar(interp, "handled", const4, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set bracket [...]
                    TclObject tmp13;
                    { // Invoke: string match ... $err
                        TclObject[] objv14 = TJC.grabObjv(interp, 4);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: string
                            objv14[0] = const5;
                            // Arg 1 constant: match
                            objv14[1] = const6;
                            // Arg 2 constant: ...
                            objv14[2] = const7;
                            // Arg 3 variable: $err
                            tmp15 = getVarScalar(interp, "err", compiledLocals, 7);
                            tmp15.preserve();
                            objv14[3] = tmp15;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv14, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp15 = objv14[3];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 4);
                        }
                    } // End Invoke: string
                    tmp13 = interp.getResult();
                    setVarScalar(interp, "bracket", tmp13, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if {$bracket} ...
                    TclObject tmp16 = getVarScalar(interp, "bracket", compiledLocals, 9);
                    boolean tmp17 = TJC.getBoolean(interp, tmp16);
                    if ( tmp17 ) {
                        { // Invoke: set _tjc(parse_error) ...
                            setVarArray(interp, "_tjc", "parse_error", const8, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set handled 1
                            setVarScalar(interp, "handled", const9, compiledLocals, 8);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if {$handled} ...
                    TclObject tmp18 = getVarScalar(interp, "handled", compiledLocals, 8);
                    boolean tmp19 = TJC.getBoolean(interp, tmp18);
                    if ( tmp19 ) {
                        { // Invoke: set _tjc(parse_script) [...]
                            TclObject tmp20;
                            { // Invoke: parse getstring $script $range
                                TclObject[] objv21 = TJC.grabObjv(interp, 4);
                                TclObject tmp22;
                                try {
                                    // Arg 0 constant: parse
                                    objv21[0] = const0;
                                    // Arg 1 constant: getstring
                                    objv21[1] = const10;
                                    // Arg 2 variable: $script
                                    tmp22 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp22.preserve();
                                    objv21[2] = tmp22;
                                    // Arg 3 variable: $range
                                    tmp22 = getVarScalar(interp, "range", compiledLocals, 1);
                                    tmp22.preserve();
                                    objv21[3] = tmp22;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv21, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp22 = objv21[2];
                                    if ( tmp22 != null ) {
                                        tmp22.release();
                                    }
                                    tmp22 = objv21[3];
                                    if ( tmp22 != null ) {
                                        tmp22.release();
                                    }
                                    TJC.releaseObjv(interp, objv21, 4);
                                }
                            } // End Invoke: parse
                            tmp20 = interp.getResult();
                            setVarArray(interp, "_tjc", "parse_script", tmp20, compiledLocals, 6);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: return -code error -errorcode $::errorCode $err
                    TclObject[] objv23 = TJC.grabObjv(interp, 6);
                    TclObject tmp24;
                    try {
                        // Arg 0 constant: return
                        objv23[0] = const11;
                        // Arg 1 constant: -code
                        objv23[1] = const12;
                        // Arg 2 constant: error
                        objv23[2] = const13;
                        // Arg 3 constant: -errorcode
                        objv23[3] = const14;
                        // Arg 4 variable: $::errorCode
                        initVarScoped(interp, "::errorCode", compiledLocals, 10);
                        tmp24 = getVarScalar(interp, "::errorCode", compiledLocals, 10);
                        tmp24.preserve();
                        objv23[4] = tmp24;
                        // Arg 5 variable: $err
                        tmp24 = getVarScalar(interp, "err", compiledLocals, 7);
                        tmp24.preserve();
                        objv23[5] = tmp24;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv23, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp24 = objv23[4];
                        if ( tmp24 != null ) {
                            tmp24.release();
                        }
                        tmp24 = objv23[5];
                        if ( tmp24 != null ) {
                            tmp24.release();
                        }
                        TJC.releaseObjv(interp, objv23, 6);
                    }
                } // End Invoke: return
            } else {
                { // Invoke: set result $err
                    TclObject tmp25;
                    tmp25 = getVarScalar(interp, "err", compiledLocals, 7);
                    setVarScalar(interp, "result", tmp25, compiledLocals, 11);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set comment [...]
            TclObject tmp26;
            { // Invoke: lindex $result 0
                TclObject tmp27 = getVarScalar(interp, "result", compiledLocals, 11);
                tmp27 = TclList.index(interp, tmp27, 0);
                if ( tmp27 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp27);
                }
            } // End Invoke: lindex
            tmp26 = interp.getResult();
            setVarScalar(interp, "comment", tmp26, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set command [...]
            TclObject tmp28;
            { // Invoke: lindex $result 1
                TclObject tmp29 = getVarScalar(interp, "result", compiledLocals, 11);
                tmp29 = TclList.index(interp, tmp29, 1);
                if ( tmp29 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp29);
                }
            } // End Invoke: lindex
            tmp28 = interp.getResult();
            setVarScalar(interp, "command", tmp28, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set rest [...]
            TclObject tmp30;
            { // Invoke: lindex $result 2
                TclObject tmp31 = getVarScalar(interp, "result", compiledLocals, 11);
                tmp31 = TclList.index(interp, tmp31, 2);
                if ( tmp31 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp31);
                }
            } // End Invoke: lindex
            tmp30 = interp.getResult();
            setVarScalar(interp, "rest", tmp30, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp32;
            { // Invoke: lindex $result 3
                TclObject tmp33 = getVarScalar(interp, "result", compiledLocals, 11);
                tmp33 = TclList.index(interp, tmp33, 3);
                if ( tmp33 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp33);
                }
            } // End Invoke: lindex
            tmp32 = interp.getResult();
            setVarScalar(interp, "tree", tmp32, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: [...] == 0
            { // Invoke: lindex $command 1
                TclObject tmp34 = getVarScalar(interp, "command", compiledLocals, 13);
                tmp34 = TclList.index(interp, tmp34, 1);
                if ( tmp34 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp34);
                }
            } // End Invoke: lindex
            TclObject tmp35 = interp.getResult();
            ExprValue tmp36 = evs0;
            TJC.exprInitValue(interp, tmp36, tmp35);
            ExprValue tmp37 = evs1;
            tmp37.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp36, tmp37);
            // End Binary operator: ==
            if (!tmp36.getBooleanValue(interp)) {
            // Binary operator: [...] == ";"
            { // Invoke: string trim [...]
                TclObject[] objv38 = TJC.grabObjv(interp, 3);
                TclObject tmp39;
                try {
                    // Arg 0 constant: string
                    objv38[0] = const5;
                    // Arg 1 constant: trim
                    objv38[1] = const15;
                    // Arg 2 command: [...]
                    { // Invoke: parse getstring $script $command
                        TclObject[] objv40 = TJC.grabObjv(interp, 4);
                        TclObject tmp41;
                        try {
                            // Arg 0 constant: parse
                            objv40[0] = const0;
                            // Arg 1 constant: getstring
                            objv40[1] = const10;
                            // Arg 2 variable: $script
                            tmp41 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp41.preserve();
                            objv40[2] = tmp41;
                            // Arg 3 variable: $command
                            tmp41 = getVarScalar(interp, "command", compiledLocals, 13);
                            tmp41.preserve();
                            objv40[3] = tmp41;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv40, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp41 = objv40[2];
                            if ( tmp41 != null ) {
                                tmp41.release();
                            }
                            tmp41 = objv40[3];
                            if ( tmp41 != null ) {
                                tmp41.release();
                            }
                            TJC.releaseObjv(interp, objv40, 4);
                        }
                    } // End Invoke: parse
                    tmp39 = interp.getResult();
                    tmp39.preserve();
                    objv38[2] = tmp39;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv38, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp39 = objv38[2];
                    if ( tmp39 != null ) {
                        tmp39.release();
                    }
                    TJC.releaseObjv(interp, objv38, 3);
                }
            } // End Invoke: string
            TclObject tmp42 = interp.getResult();
            boolean tmp43 = tmp42.toString().equals(";");
            ExprValue tmp44 = evs1;
            tmp44.setIntValue(tmp43);
            // End Binary operator: ==
            tmp36.setIntValue(tmp44.getBooleanValue(interp));
            } else {
            tmp36.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp45 = ( tmp36.getIntValue() != 0 );
            if ( tmp45 ) {
                { // Invoke: return [...]
                    { // Invoke: list continue $rest
                        TclObject tmp46 = TclList.newInstance();
                        TclObject tmp47;
                        try {
                            TclList.append(interp, tmp46, const16);
                            tmp47 = getVarScalar(interp, "rest", compiledLocals, 14);
                            TclList.append(interp, tmp46, tmp47);
                        } catch (TclException ex) {
                            tmp46.release();
                            throw ex;
                        }
                        interp.setResult(tmp46);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set key [...]
            TclObject tmp48;
            { // Invoke: descend_next_key
                TclObject[] objv49 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: descend_next_key
                    objv49[0] = const17;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv49, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv49, 1);
                }
            } // End Invoke: descend_next_key
            tmp48 = interp.getResult();
            setVarScalar(interp, "key", tmp48, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: set "..." $script
            TclObject tmp50;
            String tmp51;
            StringBuffer sbtmp52 = new StringBuffer(64);
            tmp50 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp52.append(tmp50.toString());
            sbtmp52.append(",script");
            tmp51 = sbtmp52.toString();
            tmp50 = getVarScalar(interp, "script", compiledLocals, 0);
            tmp50 = setVarArray(interp, "_descend", tmp51, tmp50, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == "end"
            { // Invoke: lindex $range 1
                TclObject tmp53 = getVarScalar(interp, "range", compiledLocals, 1);
                tmp53 = TclList.index(interp, tmp53, 1);
                if ( tmp53 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp53);
                }
            } // End Invoke: lindex
            TclObject tmp54 = interp.getResult();
            boolean tmp55 = tmp54.toString().equals("end");
            ExprValue tmp56 = evs0;
            tmp56.setIntValue(tmp55);
            // End Binary operator: ==
            boolean tmp57 = ( tmp56.getIntValue() != 0 );
            if ( tmp57 ) {
                { // Invoke: set whole_range [...]
                    TclObject tmp58;
                    { // Invoke: parse getrange $script
                        TclObject[] objv59 = TJC.grabObjv(interp, 3);
                        TclObject tmp60;
                        try {
                            // Arg 0 constant: parse
                            objv59[0] = const0;
                            // Arg 1 constant: getrange
                            objv59[1] = const18;
                            // Arg 2 variable: $script
                            tmp60 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp60.preserve();
                            objv59[2] = tmp60;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv59, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp60 = objv59[2];
                            if ( tmp60 != null ) {
                                tmp60.release();
                            }
                            TJC.releaseObjv(interp, objv59, 3);
                        }
                    } // End Invoke: parse
                    tmp58 = interp.getResult();
                    setVarScalar(interp, "whole_range", tmp58, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set whole_range_len [...]
                    TclObject tmp61;
                    { // Invoke: lindex $whole_range 1
                        TclObject tmp62 = getVarScalar(interp, "whole_range", compiledLocals, 17);
                        tmp62 = TclList.index(interp, tmp62, 1);
                        if ( tmp62 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp62);
                        }
                    } // End Invoke: lindex
                    tmp61 = interp.getResult();
                    setVarScalar(interp, "whole_range_len", tmp61, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: set range_start [...]
                    TclObject tmp63;
                    { // Invoke: lindex $range 0
                        TclObject tmp64 = getVarScalar(interp, "range", compiledLocals, 1);
                        tmp64 = TclList.index(interp, tmp64, 0);
                        if ( tmp64 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp64);
                        }
                    } // End Invoke: lindex
                    tmp63 = interp.getResult();
                    setVarScalar(interp, "range_start", tmp63, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: set range_len [...]
                    TclObject tmp65;
                    { // Invoke: lindex $range 1
                        TclObject tmp66 = getVarScalar(interp, "range", compiledLocals, 1);
                        tmp66 = TclList.index(interp, tmp66, 1);
                        if ( tmp66 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp66);
                        }
                    } // End Invoke: lindex
                    tmp65 = interp.getResult();
                    setVarScalar(interp, "range_len", tmp65, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: set range [...]
                    TclObject tmp67;
                    { // Invoke: list $range_start [...]
                        TclObject tmp68 = TclList.newInstance();
                        TclObject tmp69;
                        try {
                            tmp69 = getVarScalar(interp, "range_start", compiledLocals, 19);
                            TclList.append(interp, tmp68, tmp69);
                            { // Invoke: expr ...
                                // Binary operator: $whole_range_len - $range_start
                                TclObject tmp70 = getVarScalar(interp, "whole_range_len", compiledLocals, 18);
                                ExprValue tmp71 = evs0;
                                TJC.exprInitValue(interp, tmp71, tmp70);
                                TclObject tmp72 = getVarScalar(interp, "range_start", compiledLocals, 19);
                                ExprValue tmp73 = evs1;
                                TJC.exprInitValue(interp, tmp73, tmp72);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp71, tmp73);
                                // End Binary operator: -
                                TJC.exprSetResult(interp, tmp71);
                            } // End Invoke: expr
                            tmp69 = interp.getResult();
                            TclList.append(interp, tmp68, tmp69);
                        } catch (TclException ex) {
                            tmp68.release();
                            throw ex;
                        }
                        interp.setResult(tmp68);
                    } // End Invoke: list
                    tmp67 = interp.getResult();
                    setVarScalar(interp, "range", tmp67, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set _descend($key,range) $range
            TclObject tmp74;
            String tmp75;
            StringBuffer sbtmp76 = new StringBuffer(64);
            tmp74 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp76.append(tmp74.toString());
            sbtmp76.append(",range");
            tmp75 = sbtmp76.toString();
            tmp74 = getVarScalar(interp, "range", compiledLocals, 1);
            tmp74 = setVarArray(interp, "_descend", tmp75, tmp74, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." $comment
            TclObject tmp77;
            String tmp78;
            StringBuffer sbtmp79 = new StringBuffer(64);
            tmp77 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp79.append(tmp77.toString());
            sbtmp79.append(",comment");
            tmp78 = sbtmp79.toString();
            tmp77 = getVarScalar(interp, "comment", compiledLocals, 12);
            tmp77 = setVarArray(interp, "_descend", tmp78, tmp77, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." $command
            TclObject tmp80;
            String tmp81;
            StringBuffer sbtmp82 = new StringBuffer(64);
            tmp80 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp82.append(tmp80.toString());
            sbtmp82.append(",command");
            tmp81 = sbtmp82.toString();
            tmp80 = getVarScalar(interp, "command", compiledLocals, 13);
            tmp80 = setVarArray(interp, "_descend", tmp81, tmp80, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set _descend($key,rest) $rest
            TclObject tmp83;
            String tmp84;
            StringBuffer sbtmp85 = new StringBuffer(64);
            tmp83 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp85.append(tmp83.toString());
            sbtmp85.append(",rest");
            tmp84 = sbtmp85.toString();
            tmp83 = getVarScalar(interp, "rest", compiledLocals, 14);
            tmp83 = setVarArray(interp, "_descend", tmp84, tmp83, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set _descend($key,tree) $tree
            TclObject tmp86;
            String tmp87;
            StringBuffer sbtmp88 = new StringBuffer(64);
            tmp86 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp88.append(tmp86.toString());
            sbtmp88.append(",tree");
            tmp87 = sbtmp88.toString();
            tmp86 = getVarScalar(interp, "tree", compiledLocals, 15);
            tmp86 = setVarArray(interp, "_descend", tmp87, tmp86, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." $nested
            TclObject tmp89;
            String tmp90;
            StringBuffer sbtmp91 = new StringBuffer(64);
            tmp89 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp91.append(tmp89.toString());
            sbtmp91.append(",nested");
            tmp90 = sbtmp91.toString();
            tmp89 = getVarScalar(interp, "nested", compiledLocals, 2);
            tmp89 = setVarArray(interp, "_descend", tmp90, tmp89, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." $undetermined
            TclObject tmp92;
            String tmp93;
            StringBuffer sbtmp94 = new StringBuffer(64);
            tmp92 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp94.append(tmp92.toString());
            sbtmp94.append(",undetermined");
            tmp93 = sbtmp94.toString();
            tmp92 = getVarScalar(interp, "undetermined", compiledLocals, 3);
            tmp92 = setVarArray(interp, "_descend", tmp93, tmp92, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set _descend($key,usage) 0
            TclObject tmp95;
            String tmp96;
            StringBuffer sbtmp97 = new StringBuffer(64);
            tmp95 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp97.append(tmp95.toString());
            sbtmp97.append(",usage");
            tmp96 = sbtmp97.toString();
            setVarArray(interp, "_descend", tmp96, const4, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set commands [...]
            TclObject tmp98;
            { // Invoke: list
                TclObject tmp99 = TclList.newInstance();
                interp.setResult(tmp99);
            } // End Invoke: list
            tmp98 = interp.getResult();
            setVarScalar(interp, "commands", tmp98, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp100;
            { // Invoke: llength $tree
                TclObject tmp101 = getVarScalar(interp, "tree", compiledLocals, 15);
                int tmp102 = TclList.getLength(interp, tmp101);
                interp.setResult(tmp102);
            } // End Invoke: llength
            tmp100 = interp.getResult();
            setVarScalar(interp, "len", tmp100, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const4, compiledLocals, 23);
            } // End Invoke: set
            for ( boolean skip108 = true ; true ; ) {
                if ( skip108 ) {
                    skip108 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 23);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp103 = getVarScalar(interp, "i", compiledLocals, 23);
                ExprValue tmp104 = evs0;
                TJC.exprInitValue(interp, tmp104, tmp103);
                TclObject tmp105 = getVarScalar(interp, "len", compiledLocals, 22);
                ExprValue tmp106 = evs1;
                TJC.exprInitValue(interp, tmp106, tmp105);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp104, tmp106);
                // End Binary operator: <
                boolean tmp107 = ( tmp104.getIntValue() != 0 );
                if ( ! tmp107 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: lappend commands {}
                    TclObject[] objv109 = TJC.grabObjv(interp, 1);
                    TclObject tmp110;
                    try {
                        // Arg 2 constant: {}
                        objv109[0] = const2;
                        interp.resetResult();
                        lappendVarScalar(interp, "commands", objv109, compiledLocals, 21);
                    } finally {
                        TJC.releaseObjv(interp, objv109, 1);
                    }
                } // End Invoke: lappend
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: set "..." $commands
            TclObject tmp111;
            String tmp112;
            StringBuffer sbtmp113 = new StringBuffer(64);
            tmp111 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp113.append(tmp111.toString());
            sbtmp113.append(",commands");
            tmp112 = sbtmp113.toString();
            tmp111 = getVarScalar(interp, "commands", compiledLocals, 21);
            tmp111 = setVarArray(interp, "_descend", tmp112, tmp111, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." [...]
            TclObject tmp114;
            String tmp116;
            StringBuffer sbtmp117 = new StringBuffer(64);
            tmp114 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp117.append(tmp114.toString());
            sbtmp117.append(",container_commands");
            tmp116 = sbtmp117.toString();
            { // Invoke: list
                TclObject tmp115 = TclList.newInstance();
                interp.setResult(tmp115);
            } // End Invoke: list
            tmp114 = interp.getResult();
            tmp114 = setVarArray(interp, "_descend", tmp116, tmp114, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." {}
            TclObject tmp118;
            String tmp119;
            StringBuffer sbtmp120 = new StringBuffer(64);
            tmp118 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp120.append(tmp118.toString());
            sbtmp120.append(",validated");
            tmp119 = sbtmp120.toString();
            setVarArray(interp, "_descend", tmp119, const2, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." 0
            TclObject tmp121;
            String tmp122;
            StringBuffer sbtmp123 = new StringBuffer(64);
            tmp121 = getVarScalar(interp, "key", compiledLocals, 16);
            sbtmp123.append(tmp121.toString());
            sbtmp123.append(",static_container");
            tmp122 = sbtmp123.toString();
            setVarArray(interp, "_descend", tmp122, const4, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: return $key
            TclObject tmp124 = getVarScalar(interp, "key", compiledLocals, 16);
            interp.resetResult();
            interp.setResult(tmp124);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_next_command");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("charlength");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("command");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("match");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("*missing close-bracket*");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("missing close-bracket");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("getstring");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("return");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("-code");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("error");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("-errorcode");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("trim");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("continue");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("descend_next_key");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("getrange");
        const18.preserve(); const18.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse";
                break;
            }
            case 2: {
                cmdName = "string";
                break;
            }
            case 3: {
                cmdName = "return";
                break;
            }
            case 4: {
                cmdName = "descend_next_key";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "range",
        "nested",
        "undetermined",
        "_descend",
        "charlength",
        "_tjc",
        "err",
        "handled",
        "bracket",
        "::errorCode",
        "result",
        "comment",
        "command",
        "rest",
        "tree",
        "key",
        "whole_range",
        "whole_range_len",
        "range_start",
        "range_len",
        "commands",
        "len",
        "i"
    };
} // end class DescendNextCommandCmd

