// TJC implementation of procedure descend_report_command_callback
package tjc;
import tcl.lang.*;

public class DescendReportCommandCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "cmd ?when?");
        }
        setVarScalar(interp, "cmd", objv[1], compiledLocals, 0);
        setVarScalar(interp, "when", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        { // Invoke: global _descend_callbacks
            TJC.makeGlobalLinkVar(interp, "_descend_callbacks", "_descend_callbacks", 2);
        } // End Invoke: global
        { // Invoke: if {$when == "start"} ... elseif {$when == "finish"} ... else ...
            // Binary operator: $when == "start"
            TclObject tmp0 = getVarScalar(interp, "when", compiledLocals, 1);
            boolean tmp1 = tmp0.toString().equals("start");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set ... $cmd
                    TclObject tmp4;
                    tmp4 = getVarScalar(interp, "cmd", compiledLocals, 0);
                    tmp4 = setVarArray(interp, "_descend_callbacks", "report_command", tmp4, compiledLocals, 2);
                    interp.setResult(tmp4);
                } // End Invoke: set
            } else {
                // Binary operator: $when == "finish"
                TclObject tmp5 = getVarScalar(interp, "when", compiledLocals, 1);
                boolean tmp6 = tmp5.toString().equals("finish");
                ExprValue tmp7 = evs0;
                tmp7.setIntValue(tmp6);
                // End Binary operator: ==
                boolean tmp8 = ( tmp7.getIntValue() != 0 );
                if ( tmp8 ) {
                    { // Invoke: set ... $cmd
                        TclObject tmp9;
                        tmp9 = getVarScalar(interp, "cmd", compiledLocals, 0);
                        tmp9 = setVarArray(interp, "_descend_callbacks", "report_command_finish", tmp9, compiledLocals, 2);
                        interp.setResult(tmp9);
                    } // End Invoke: set
                } else {
                    { // Invoke: error "..."
                        TclObject[] objv10 = TJC.grabObjv(interp, 2);
                        TclObject tmp11;
                        try {
                            // Arg 0 constant: error
                            objv10[0] = const1;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp12 = new StringBuffer(64);
                            sbtmp12.append("unknow when value ");
                            sbtmp12.append("\"");
                            tmp11 = getVarScalar(interp, "when", compiledLocals, 1);
                            sbtmp12.append(tmp11.toString());
                            sbtmp12.append("\"");
                            sbtmp12.append(", must be start or finish");
                            tmp11 = TclString.newInstance(sbtmp12);
                            tmp11.preserve();
                            objv10[1] = tmp11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv10, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp11 = objv10[1];
                            if ( tmp11 != null ) {
                                tmp11.release();
                            }
                            TJC.releaseObjv(interp, objv10, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_report_command_callback");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("start");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cmd",
        "when",
        "_descend_callbacks"
    };
} // end class DescendReportCommandCallbackCmd

