// TJC implementation of procedure descend_tree_get_command
package tjc;
import tcl.lang.*;

public class DescendTreeGetCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script tree");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "tree", objv[2], compiledLocals, 1);
        { // Invoke: set cmd [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "cmd", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp2;
            { // Invoke: llength $tree
                TclObject tmp3 = getVarScalar(interp, "tree", compiledLocals, 1);
                int tmp4 = TclList.getLength(interp, tmp3);
                interp.setResult(tmp4);
            } // End Invoke: llength
            tmp2 = interp.getResult();
            setVarScalar(interp, "len", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const0, compiledLocals, 4);
            } // End Invoke: set
            for ( boolean skip10 = true ; true ; ) {
                if ( skip10 ) {
                    skip10 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 4);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp5 = getVarScalar(interp, "i", compiledLocals, 4);
                ExprValue tmp6 = evs0;
                TJC.exprInitValue(interp, tmp6, tmp5);
                TclObject tmp7 = getVarScalar(interp, "len", compiledLocals, 3);
                ExprValue tmp8 = evs1;
                TJC.exprInitValue(interp, tmp8, tmp7);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp6, tmp8);
                // End Binary operator: <
                boolean tmp9 = ( tmp6.getIntValue() != 0 );
                if ( ! tmp9 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set result [...]
                    TclObject tmp11;
                    { // Invoke: descend_tree_get $script $tree $i
                        TclObject[] objv12 = TJC.grabObjv(interp, 4);
                        TclObject tmp13;
                        try {
                            // Arg 0 constant: descend_tree_get
                            objv12[0] = const1;
                            // Arg 1 variable: $script
                            tmp13 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp13.preserve();
                            objv12[1] = tmp13;
                            // Arg 2 variable: $tree
                            tmp13 = getVarScalar(interp, "tree", compiledLocals, 1);
                            tmp13.preserve();
                            objv12[2] = tmp13;
                            // Arg 3 variable: $i
                            tmp13 = getVarScalar(interp, "i", compiledLocals, 4);
                            tmp13.preserve();
                            objv12[3] = tmp13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv12, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp13 = objv12[1];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            tmp13 = objv12[2];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            tmp13 = objv12[3];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            TJC.releaseObjv(interp, objv12, 4);
                        }
                    } // End Invoke: descend_tree_get
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "result", tmp11, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: [...] == 1
                    { // Invoke: lindex $result 0
                        TclObject tmp14 = getVarScalar(interp, "result", compiledLocals, 5);
                        tmp14 = TclList.index(interp, tmp14, 0);
                        if ( tmp14 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp14);
                        }
                    } // End Invoke: lindex
                    TclObject tmp15 = interp.getResult();
                    ExprValue tmp16 = evs0;
                    TJC.exprInitValue(interp, tmp16, tmp15);
                    ExprValue tmp17 = evs1;
                    tmp17.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp16, tmp17);
                    // End Binary operator: ==
                    boolean tmp18 = ( tmp16.getIntValue() != 0 );
                    if ( tmp18 ) {
                        { // Invoke: lappend cmd [...]
                            TclObject[] objv19 = TJC.grabObjv(interp, 1);
                            TclObject tmp20;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $result 1
                                    TclObject tmp21 = getVarScalar(interp, "result", compiledLocals, 5);
                                    tmp21 = TclList.index(interp, tmp21, 1);
                                    if ( tmp21 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp21);
                                    }
                                } // End Invoke: lindex
                                tmp20 = interp.getResult();
                                tmp20.preserve();
                                objv19[0] = tmp20;
                                interp.resetResult();
                                lappendVarScalar(interp, "cmd", objv19, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv19, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: lappend cmd UNKNOWN
                            TclObject[] objv22 = TJC.grabObjv(interp, 1);
                            TclObject tmp23;
                            try {
                                // Arg 2 constant: UNKNOWN
                                objv22[0] = const2;
                                interp.resetResult();
                                lappendVarScalar(interp, "cmd", objv22, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjv(interp, objv22, 1);
                            }
                        } // End Invoke: lappend
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: return $cmd
            TclObject tmp24 = getVarScalar(interp, "cmd", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp24);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_tree_get_command");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_tree_get");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("UNKNOWN");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_tree_get";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "tree",
        "cmd",
        "len",
        "i",
        "result"
    };
} // end class DescendTreeGetCommandCmd

