// TJC implementation of procedure _descend_tree_print
package tjc;
import tcl.lang.*;

public class DescendTreePrintCmd2 extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script tree");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "tree", objv[2], compiledLocals, 1);
        { // Invoke: if {$tree == {}} ...
            // Binary operator: $tree == ""
            TclObject tmp0 = getVarScalar(interp, "tree", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: foreach tuple $tree ...
            TclObject tmp3 = null;
            try {
                tmp3 = getVarScalar(interp, "tree", compiledLocals, 1);
                tmp3.preserve();
                final int tmp3_length = TclList.getLength(interp, tmp3);

                for ( int index4 = 0 ; index4 < tmp3_length ; index4++ ) {
                    TclObject tmp5 = TclList.index(interp, tmp3, index4);
                    try {
                        setVarScalar(interp, "tuple", tmp5, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "tuple");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set type [...]
                        TclObject tmp6;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp7 = getVarScalar(interp, "tuple", compiledLocals, 2);
                            tmp7 = TclList.index(interp, tmp7, 0);
                            if ( tmp7 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp7);
                            }
                        } // End Invoke: lindex
                        tmp6 = interp.getResult();
                        setVarScalar(interp, "type", tmp6, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set range [...]
                        TclObject tmp8;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp9 = getVarScalar(interp, "tuple", compiledLocals, 2);
                            tmp9 = TclList.index(interp, tmp9, 1);
                            if ( tmp9 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp9);
                            }
                        } // End Invoke: lindex
                        tmp8 = interp.getResult();
                        setVarScalar(interp, "range", tmp8, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: set subtree [...]
                        TclObject tmp10;
                        { // Invoke: lindex $tuple 2
                            TclObject tmp11 = getVarScalar(interp, "tuple", compiledLocals, 2);
                            tmp11 = TclList.index(interp, tmp11, 2);
                            if ( tmp11 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp11);
                            }
                        } // End Invoke: lindex
                        tmp10 = interp.getResult();
                        setVarScalar(interp, "subtree", tmp10, compiledLocals, 5);
                    } // End Invoke: set
                    { // Invoke: puts "..."
                        TclObject[] objv12 = TJC.grabObjv(interp, 2);
                        TclObject tmp13;
                        try {
                            // Arg 0 constant: puts
                            objv12[0] = const0;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp14 = new StringBuffer(64);
                            sbtmp14.append("\"");
                            { // Invoke: parse getstring $script $range
                                TclObject[] objv15 = TJC.grabObjv(interp, 4);
                                TclObject tmp16;
                                try {
                                    // Arg 0 constant: parse
                                    objv15[0] = const1;
                                    // Arg 1 constant: getstring
                                    objv15[1] = const2;
                                    // Arg 2 variable: $script
                                    tmp16 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp16.preserve();
                                    objv15[2] = tmp16;
                                    // Arg 3 variable: $range
                                    tmp16 = getVarScalar(interp, "range", compiledLocals, 4);
                                    tmp16.preserve();
                                    objv15[3] = tmp16;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv15, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp16 = objv15[2];
                                    if ( tmp16 != null ) {
                                        tmp16.release();
                                    }
                                    tmp16 = objv15[3];
                                    if ( tmp16 != null ) {
                                        tmp16.release();
                                    }
                                    TJC.releaseObjv(interp, objv15, 4);
                                }
                            } // End Invoke: parse
                            tmp13 = interp.getResult();
                            sbtmp14.append(tmp13.toString());
                            sbtmp14.append("\"");
                            sbtmp14.append(" : type ");
                            tmp13 = getVarScalar(interp, "type", compiledLocals, 3);
                            sbtmp14.append(tmp13.toString());
                            sbtmp14.append(" : range ");
                            tmp13 = getVarScalar(interp, "range", compiledLocals, 4);
                            sbtmp14.append(tmp13.toString());
                            tmp13 = TclString.newInstance(sbtmp14);
                            tmp13.preserve();
                            objv12[1] = tmp13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv12, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp13 = objv12[1];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            TJC.releaseObjv(interp, objv12, 2);
                        }
                    } // End Invoke: puts
                    { // Invoke: _descend_tree_print $script $subtree
                        TclObject[] objv17 = TJC.grabObjv(interp, 3);
                        TclObject tmp18;
                        try {
                            // Arg 0 constant: _descend_tree_print
                            objv17[0] = const3;
                            // Arg 1 variable: $script
                            tmp18 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp18.preserve();
                            objv17[1] = tmp18;
                            // Arg 2 variable: $subtree
                            tmp18 = getVarScalar(interp, "subtree", compiledLocals, 5);
                            tmp18.preserve();
                            objv17[2] = tmp18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv17, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp18 = objv17[1];
                            if ( tmp18 != null ) {
                                tmp18.release();
                            }
                            tmp18 = objv17[2];
                            if ( tmp18 != null ) {
                                tmp18.release();
                            }
                            TJC.releaseObjv(interp, objv17, 3);
                        }
                    } // End Invoke: _descend_tree_print
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
                interp.resetResult();
            } finally {
                if ( tmp3 != null ) {
                    tmp3.release();
                }
            }
        } // End Invoke: foreach
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_descend_tree_print");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("puts");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("parse");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("getstring");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_descend_tree_print");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse";
                break;
            }
            case 2: {
                cmdName = "puts";
                break;
            }
            case 3: {
                cmdName = "_descend_tree_print";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "tree",
        "tuple",
        "type",
        "range",
        "subtree"
    };
} // end class DescendTreePrintCmd2

