// TJC implementation of procedure emitter_cmd_proc_start
package tjc;
import tcl.lang.*;

public class EmitterCmdProcStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: if ... ...
            // Binary operator: [...] != 0
            { // Invoke: emitter_indent_level
                TclObject[] objv0 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent_level
                    objv0[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 1);
                }
            } // End Invoke: emitter_indent_level
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            ExprValue tmp3 = evs1;
            tmp3.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp2, tmp3);
            // End Binary operator: !=
            boolean tmp4 = ( tmp2.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("expected indent level of zero, got ");
                        { // Invoke: emitter_indent_level
                            TclObject[] objv8 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent_level
                                objv8[0] = const0;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv8, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv8, 1);
                            }
                        } // End Invoke: emitter_indent_level
                        tmp6 = interp.getResult();
                        sbtmp7.append(tmp6.toString());
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: emitter_indent_level +1
            TclObject[] objv9 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv9[0] = const0;
                // Arg 1 constant: +1
                objv9[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv9, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv9, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const3, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: append buffer [...] ...
            TclObject[] objv10 = TJC.grabObjv(interp, 2);
            TclObject tmp11;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv12 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv12[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv12, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 1);
                    }
                } // End Invoke: emitter_indent
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[0] = tmp11;
                // Arg 3 constant: ...
                objv10[1] = const5;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv10, compiledLocals, 0);
            } finally {
                tmp11 = objv10[0];
                if ( tmp11 != null ) {
                    tmp11.release();
                }
                TJC.releaseObjv(interp, objv10, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv13 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv13[0] = const0;
                // Arg 1 constant: +1
                objv13[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv13, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv13, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ... [...] ...
            TclObject[] objv14 = TJC.grabObjv(interp, 4);
            TclObject tmp15;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv16 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv16[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv16, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv16, 1);
                    }
                } // End Invoke: emitter_indent
                tmp15 = interp.getResult();
                tmp15.preserve();
                objv14[0] = tmp15;
                // Arg 3 constant: ...
                objv14[1] = const6;
                // Arg 4 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv17[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv17, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 1);
                    }
                } // End Invoke: emitter_indent
                tmp15 = interp.getResult();
                tmp15.preserve();
                objv14[2] = tmp15;
                // Arg 5 constant: ...
                objv14[3] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv14, compiledLocals, 0);
            } finally {
                tmp15 = objv14[0];
                if ( tmp15 != null ) {
                    tmp15.release();
                }
                tmp15 = objv14[2];
                if ( tmp15 != null ) {
                    tmp15.release();
                }
                TJC.releaseObjv(interp, objv14, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv18 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv18[0] = const0;
                // Arg 1 constant: +1
                objv18[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv18, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv18, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv19 = TJC.grabObjv(interp, 2);
            TclObject tmp20;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv21 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv21[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv21, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv21, 1);
                    }
                } // End Invoke: emitter_indent
                tmp20 = interp.getResult();
                tmp20.preserve();
                objv19[0] = tmp20;
                // Arg 3 constant: ...
                objv19[1] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv19, compiledLocals, 0);
            } finally {
                tmp20 = objv19[0];
                if ( tmp20 != null ) {
                    tmp20.release();
                }
                TJC.releaseObjv(interp, objv19, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -2
            TclObject[] objv22 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv22[0] = const0;
                // Arg 1 constant: -2
                objv22[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv22, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv22, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv23 = TJC.grabObjv(interp, 2);
            TclObject tmp24;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv25 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv25[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv25, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv25, 1);
                    }
                } // End Invoke: emitter_indent
                tmp24 = interp.getResult();
                tmp24.preserve();
                objv23[0] = tmp24;
                // Arg 3 constant: ...
                objv23[1] = const10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv23, compiledLocals, 0);
            } finally {
                tmp24 = objv23[0];
                if ( tmp24 != null ) {
                    tmp24.release();
                }
                TJC.releaseObjv(interp, objv23, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv26 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv26[0] = const0;
                // Arg 1 constant: +1
                objv26[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv26, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv26, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if ... ...
            // Binary operator: [...] != 2
            { // Invoke: emitter_indent_level
                TclObject[] objv27 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent_level
                    objv27[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv27, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv27, 1);
                }
            } // End Invoke: emitter_indent_level
            TclObject tmp28 = interp.getResult();
            ExprValue tmp29 = evs0;
            TJC.exprInitValue(interp, tmp29, tmp28);
            ExprValue tmp30 = evs1;
            tmp30.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp29, tmp30);
            // End Binary operator: !=
            boolean tmp31 = ( tmp29.getIntValue() != 0 );
            if ( tmp31 ) {
                { // Invoke: error "..."
                    TclObject[] objv32 = TJC.grabObjv(interp, 2);
                    TclObject tmp33;
                    try {
                        // Arg 0 constant: error
                        objv32[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp34 = new StringBuffer(64);
                        sbtmp34.append("expected indent level of 2 at method start, got ");
                        { // Invoke: emitter_indent_level
                            TclObject[] objv35 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent_level
                                objv35[0] = const0;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv35, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv35, 1);
                            }
                        } // End Invoke: emitter_indent_level
                        tmp33 = interp.getResult();
                        sbtmp34.append(tmp33.toString());
                        tmp33 = TclString.newInstance(sbtmp34);
                        tmp33.preserve();
                        objv32[1] = tmp33;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv32, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp33 = objv32[1];
                        if ( tmp33 != null ) {
                            tmp33.release();
                        }
                        TJC.releaseObjv(interp, objv32, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp36 = getVarScalar(interp, "buffer", compiledLocals, 0);
            interp.resetResult();
            interp.setResult(tmp36);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_cmd_proc_start");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_indent_level");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("+1");
        TclInteger.get(interp, const2);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("public void cmdProc(\n");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("Interp interp,\n");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("TclObject[] objv)\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("throws TclException\n");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(-2);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("{\n");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "buffer"
    };
} // end class EmitterCmdProcStartCmd

