// TJC implementation of procedure emitter_container_for_skip_start
package tjc;
import tcl.lang.*;

public class EmitterContainerForSkipStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$tmpsymbol == ""} ...
            // Binary operator: $tmpsymbol == ""
            TclObject tmp0 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: error "empty tmpsymbol"
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv3[0] = const1;
                        // Arg 1 constant: "empty tmpsymbol"
                        objv3[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] "if ( " $tmpsymbol ...
            TclObject[] objv4 = TJC.grabObjv(interp, 4);
            TclObject tmp5;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv6 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv6[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv6, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv6, 1);
                    }
                } // End Invoke: emitter_indent
                tmp5 = interp.getResult();
                tmp5.preserve();
                objv4[0] = tmp5;
                // Arg 3 constant: "if ( "
                objv4[1] = const4;
                // Arg 4 variable: $tmpsymbol
                tmp5 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                tmp5.preserve();
                objv4[2] = tmp5;
                // Arg 5 constant: ...
                objv4[3] = const5;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv4, compiledLocals, 1);
            } finally {
                tmp5 = objv4[0];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                tmp5 = objv4[2];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                TJC.releaseObjv(interp, objv4, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv7 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv7[0] = const6;
                // Arg 1 constant: +1
                objv7[1] = const7;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv7, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                TJC.releaseObjv(interp, objv7, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] $tmpsymbol ...
            TclObject[] objv8 = TJC.grabObjv(interp, 3);
            TclObject tmp9;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv10 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv10[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv10, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv10, 1);
                    }
                } // End Invoke: emitter_indent
                tmp9 = interp.getResult();
                tmp9.preserve();
                objv8[0] = tmp9;
                // Arg 3 variable: $tmpsymbol
                tmp9 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                tmp9.preserve();
                objv8[1] = tmp9;
                // Arg 4 constant: ...
                objv8[2] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv8, compiledLocals, 1);
            } finally {
                tmp9 = objv8[0];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                tmp9 = objv8[1];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                TJC.releaseObjv(interp, objv8, 3);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv11 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv11[0] = const6;
                // Arg 1 constant: -1
                objv11[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv11, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                TJC.releaseObjv(interp, objv11, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv12 = TJC.grabObjv(interp, 2);
            TclObject tmp13;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv14 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv14[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv14, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv14, 1);
                    }
                } // End Invoke: emitter_indent
                tmp13 = interp.getResult();
                tmp13.preserve();
                objv12[0] = tmp13;
                // Arg 3 constant: ...
                objv12[1] = const10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv12, compiledLocals, 1);
            } finally {
                tmp13 = objv12[0];
                if ( tmp13 != null ) {
                    tmp13.release();
                }
                TJC.releaseObjv(interp, objv12, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv15 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv15[0] = const6;
                // Arg 1 constant: +1
                objv15[1] = const7;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv15, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                TJC.releaseObjv(interp, objv15, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: return $buffer
            TclObject tmp16 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp16);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_for_skip_start");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("empty tmpsymbol");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("if ( ");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance(" ) {\n");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_indent_level");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("+1");
        TclInteger.get(interp, const7);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(" = false;\n");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(-1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("} else {\n");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "emitter_indent_level";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "buffer"
    };
} // end class EmitterContainerForSkipStartCmd

