// TJC implementation of procedure emitter_container_foreach_var_try_end
package tjc;
import tcl.lang.*;

public class EmitterContainerForeachVarTryEndCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "varname");
        }
        setVarScalar(interp, "varname", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -1
            TclObject[] objv0 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv0[0] = const1;
                // Arg 1 constant: -1
                objv0[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv0, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv0, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv1 = TJC.grabObjv(interp, 2);
            TclObject tmp2;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv3 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv3[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv3, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 1);
                    }
                } // End Invoke: emitter_indent
                tmp2 = interp.getResult();
                tmp2.preserve();
                objv1[0] = tmp2;
                // Arg 3 constant: ...
                objv1[1] = const4;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv1, compiledLocals, 1);
            } finally {
                tmp2 = objv1[0];
                if ( tmp2 != null ) {
                    tmp2.release();
                }
                TJC.releaseObjv(interp, objv1, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv4 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv4[0] = const1;
                // Arg 1 constant: +1
                objv4[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv4, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv4, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set jstr [...]
            TclObject tmp5;
            { // Invoke: ... $varname
                TclObject[] objv6 = TJC.grabObjv(interp, 2);
                TclObject tmp7;
                try {
                    // Arg 0 constant: ...
                    objv6[0] = const6;
                    // Arg 1 variable: $varname
                    tmp7 = getVarScalar(interp, "varname", compiledLocals, 0);
                    tmp7.preserve();
                    objv6[1] = tmp7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv6, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp7 = objv6[1];
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                    TJC.releaseObjv(interp, objv6, 2);
                }
            } // End Invoke: ...
            tmp5 = interp.getResult();
            setVarScalar(interp, "jstr", tmp5, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...] ... $jstr ...
            TclObject[] objv8 = TJC.grabObjv(interp, 4);
            TclObject tmp9;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv10 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv10[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv10, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv10, 1);
                    }
                } // End Invoke: emitter_indent
                tmp9 = interp.getResult();
                tmp9.preserve();
                objv8[0] = tmp9;
                // Arg 3 constant: ...
                objv8[1] = const7;
                // Arg 4 variable: $jstr
                tmp9 = getVarScalar(interp, "jstr", compiledLocals, 2);
                tmp9.preserve();
                objv8[2] = tmp9;
                // Arg 5 constant: ...
                objv8[3] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv8, compiledLocals, 1);
            } finally {
                tmp9 = objv8[0];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                tmp9 = objv8[2];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                TJC.releaseObjv(interp, objv8, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv11 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv11[0] = const1;
                // Arg 1 constant: -1
                objv11[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv11, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv11, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv12 = TJC.grabObjv(interp, 2);
            TclObject tmp13;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv14 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv14[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv14, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv14, 1);
                    }
                } // End Invoke: emitter_indent
                tmp13 = interp.getResult();
                tmp13.preserve();
                objv12[0] = tmp13;
                // Arg 3 constant: ...
                objv12[1] = const9;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv12, compiledLocals, 1);
            } finally {
                tmp13 = objv12[0];
                if ( tmp13 != null ) {
                    tmp13.release();
                }
                TJC.releaseObjv(interp, objv12, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp15 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp15);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_foreach_var_try_end");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent_level");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(-1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("} catch (TclException ex) {\n");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("+1");
        TclInteger.get(interp, const5);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_backslash_tcl_string");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("TJC.foreachVarErr(interp, \"");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("\");\n");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("}\n");
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "varname",
        "buffer",
        "jstr"
    };
} // end class EmitterContainerForeachVarTryEndCmd

