// TJC implementation of procedure emitter_container_switch_assign
package tjc;
import tcl.lang.*;

public class EmitterContainerSwitchAssignCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "arraysym index tmpsym valsym");
        }
        setVarScalar(interp, "arraysym", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        setVarScalar(interp, "tmpsym", objv[3], compiledLocals, 2);
        setVarScalar(interp, "valsym", objv[4], compiledLocals, 3);
        { // Invoke: return [...]
            { // Invoke: ... $arraysym $index $tmpsym $valsym
                TclObject[] objv0 = TJC.grabObjv(interp, 5);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const0;
                    // Arg 1 variable: $arraysym
                    tmp1 = getVarScalar(interp, "arraysym", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    // Arg 2 variable: $index
                    tmp1 = getVarScalar(interp, "index", compiledLocals, 1);
                    tmp1.preserve();
                    objv0[2] = tmp1;
                    // Arg 3 variable: $tmpsym
                    tmp1 = getVarScalar(interp, "tmpsym", compiledLocals, 2);
                    tmp1.preserve();
                    objv0[3] = tmp1;
                    // Arg 4 variable: $valsym
                    tmp1 = getVarScalar(interp, "valsym", compiledLocals, 3);
                    tmp1.preserve();
                    objv0[4] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    tmp1 = objv0[2];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    tmp1 = objv0[3];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    tmp1 = objv0[4];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 5);
                }
            } // End Invoke: ...
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_switch_assign");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_invoke_command_assign");
        const0.preserve(); const0.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_invoke_command_assign";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "arraysym",
        "index",
        "tmpsym",
        "valsym"
    };
} // end class EmitterContainerSwitchAssignCmd

