// TJC implementation of procedure emitter_indent
package tjc;
import tcl.lang.*;

public class EmitterIndentCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: set indent_level $...
            TclObject tmp0;
            initVarScoped(interp, "::_emitter", compiledLocals, 0);
            tmp0 = getVarArray(interp, "::_emitter", "indent_level", compiledLocals, 0);
            setVarScalar(interp, "indent_level", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: switch -exact -- $indent_level {0} ... {1} ... {2} ... {3} ... {4} ... {5} ... {6} ... {7} ... {8} ... {9} ... {10} ... default ...
            TclObject tmp1 = getVarScalar(interp, "indent_level", compiledLocals, 1);
            String tmp2 = tmp1.toString();
            int tmp2_length = tmp2.length();
            char tmp2_first = '\n';
            if ( tmp2_length > 0 ) {
                tmp2_first = tmp2.charAt(0);
            }
            interp.resetResult();
            if ( tmp2_length == 1 && tmp2_first == '0' ) {
                // Pattern {0}
                { // Invoke: return ""
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '1' ) {
                // Pattern {1}
                { // Invoke: return "    "
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '2' ) {
                // Pattern {2}
                { // Invoke: return "        "
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '3' ) {
                // Pattern {3}
                { // Invoke: return "            "
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '4' ) {
                // Pattern {4}
                { // Invoke: return "                "
                    interp.resetResult();
                    interp.setResult(const4);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '5' ) {
                // Pattern {5}
                { // Invoke: return ...
                    interp.resetResult();
                    interp.setResult(const5);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '6' ) {
                // Pattern {6}
                { // Invoke: return ...
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '7' ) {
                // Pattern {7}
                { // Invoke: return ...
                    interp.resetResult();
                    interp.setResult(const7);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '8' ) {
                // Pattern {8}
                { // Invoke: return ...
                    interp.resetResult();
                    interp.setResult(const8);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 1 && tmp2_first == '9' ) {
                // Pattern {9}
                { // Invoke: return ...
                    interp.resetResult();
                    interp.setResult(const9);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp2_length == 2 && tmp2_first == '1'
                    && tmp2.compareTo("10") == 0 ) {
                // Pattern {10}
                { // Invoke: return ...
                    interp.resetResult();
                    interp.setResult(const10);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: return [...]
                    { // Invoke: string repeat "    " $indent_level
                        TclObject[] objv3 = TJC.grabObjv(interp, 4);
                        TclObject tmp4;
                        try {
                            // Arg 0 constant: string
                            objv3[0] = const11;
                            // Arg 1 constant: repeat
                            objv3[1] = const12;
                            // Arg 2 constant: "    "
                            objv3[2] = const1;
                            // Arg 3 variable: $indent_level
                            tmp4 = getVarScalar(interp, "indent_level", compiledLocals, 1);
                            tmp4.preserve();
                            objv3[3] = tmp4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv3, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp4 = objv3[3];
                            if ( tmp4 != null ) {
                                tmp4.release();
                            }
                            TJC.releaseObjv(interp, objv3, 4);
                        }
                    } // End Invoke: string
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_indent");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("    ");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("        ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("            ");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("                ");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("                    ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("                        ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("                            ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("                                ");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("                                    ");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("                                        ");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("string");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("repeat");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "::_emitter",
        "indent_level"
    };
} // end class EmitterIndentCmd

