// TJC implementation of procedure jdk_config_parse
package tjc;
import tcl.lang.*;

public class JdkConfigParseCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "buffer");
        }
        setVarScalar(interp, "buffer", objv[1], compiledLocals, 0);
        { // Invoke: global _jdk_config
            TJC.makeGlobalLinkVar(interp, "_jdk_config", "_jdk_config", 1);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set lines [...]
            TclObject tmp0;
            { // Invoke: split $buffer ...
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: split
                    objv1[0] = const1;
                    // Arg 1 variable: $buffer
                    tmp2 = getVarScalar(interp, "buffer", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: ...
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: split
            tmp0 = interp.getResult();
            setVarScalar(interp, "lines", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set parsed 0
            setVarScalar(interp, "parsed", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set linenum 1
            setVarScalar(interp, "linenum", const3, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: foreach line $lines ...
            TclObject tmp3 = null;
            try {
                tmp3 = getVarScalar(interp, "lines", compiledLocals, 3);
                tmp3.preserve();
                final int tmp3_length = TclList.getLength(interp, tmp3);

                for ( int index4 = 0 ; index4 < tmp3_length ; index4++ ) {
                    TclObject tmp5 = TclList.index(interp, tmp3, index4);
                    try {
                        setVarScalar(interp, "line", tmp5, compiledLocals, 6);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "line");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {$debug} ...
                        TclObject tmp6 = getVarScalar(interp, "debug", compiledLocals, 2);
                        boolean tmp7 = TJC.getBoolean(interp, tmp6);
                        if ( tmp7 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv8 = TJC.grabObjv(interp, 2);
                                TclObject tmp9;
                                try {
                                    // Arg 0 constant: puts
                                    objv8[0] = const4;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp10 = new StringBuffer(64);
                                    sbtmp10.append("processing line ");
                                    sbtmp10.append("\"");
                                    tmp9 = getVarScalar(interp, "line", compiledLocals, 6);
                                    sbtmp10.append(tmp9.toString());
                                    sbtmp10.append("\"");
                                    tmp9 = TclString.newInstance(sbtmp10);
                                    tmp9.preserve();
                                    objv8[1] = tmp9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv8, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp9 = objv8[1];
                                    if ( tmp9 != null ) {
                                        tmp9.release();
                                    }
                                    TJC.releaseObjv(interp, objv8, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: [...] == ""
                        { // Invoke: string trim $line
                            TclObject[] objv11 = TJC.grabObjv(interp, 3);
                            TclObject tmp12;
                            try {
                                // Arg 0 constant: string
                                objv11[0] = const5;
                                // Arg 1 constant: trim
                                objv11[1] = const6;
                                // Arg 2 variable: $line
                                tmp12 = getVarScalar(interp, "line", compiledLocals, 6);
                                tmp12.preserve();
                                objv11[2] = tmp12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv11, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp12 = objv11[2];
                                if ( tmp12 != null ) {
                                    tmp12.release();
                                }
                                TJC.releaseObjv(interp, objv11, 3);
                            }
                        } // End Invoke: string
                        TclObject tmp13 = interp.getResult();
                        ExprValue tmp14 = evs0;
                        TJC.exprEqualsEmptyString(tmp14, tmp13, false);
                        // End Binary operator: ==
                        boolean tmp15 = ( tmp14.getIntValue() != 0 );
                        if ( tmp15 ) {
                            { // Invoke: incr linenum
                                interp.resetResult();
                                incrVarScalar(interp, "linenum", 1, compiledLocals, 5);
                            } // End Invoke: incr
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: [...] == "#"
                        { // Invoke: string index $line 0
                            TclObject tmp16 = getVarScalar(interp, "line", compiledLocals, 6);
                            String tmp17 = tmp16.toString();
                            TclObject tmp18 = TJC.stringIndex(interp, tmp17, const0);
                            interp.setResult(tmp18);
                        } // End Invoke: string
                        TclObject tmp19 = interp.getResult();
                        boolean tmp20 = tmp19.toString().equals("#");
                        ExprValue tmp21 = evs0;
                        tmp21.setIntValue(tmp20);
                        // End Binary operator: ==
                        boolean tmp22 = ( tmp21.getIntValue() != 0 );
                        if ( tmp22 ) {
                            { // Invoke: incr linenum
                                interp.resetResult();
                                incrVarScalar(interp, "linenum", 1, compiledLocals, 5);
                            } // End Invoke: incr
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: set pat ...
                        setVarScalar(interp, "pat", const7, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        { // Invoke: regexp $pat $line whole sub1 sub2
                            TclObject[] objv23 = TJC.grabObjv(interp, 6);
                            TclObject tmp24;
                            try {
                                // Arg 0 constant: regexp
                                objv23[0] = const8;
                                // Arg 1 variable: $pat
                                tmp24 = getVarScalar(interp, "pat", compiledLocals, 7);
                                tmp24.preserve();
                                objv23[1] = tmp24;
                                // Arg 2 variable: $line
                                tmp24 = getVarScalar(interp, "line", compiledLocals, 6);
                                tmp24.preserve();
                                objv23[2] = tmp24;
                                // Arg 3 constant: whole
                                objv23[3] = const9;
                                // Arg 4 constant: sub1
                                objv23[4] = const10;
                                // Arg 5 constant: sub2
                                objv23[5] = const11;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv23, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp24 = objv23[1];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                tmp24 = objv23[2];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                TJC.releaseObjv(interp, objv23, 6);
                            }
                        } // End Invoke: regexp
                        TclObject tmp25 = interp.getResult();
                        ExprValue tmp26 = evs0;
                        TJC.exprInitValue(interp, tmp26, tmp25);
                        boolean tmp27 = tmp26.getBooleanValue(interp);
                        if ( tmp27 ) {
                            { // Invoke: set varname $sub1
                                TclObject tmp28;
                                tmp28 = getVarScalar(interp, "sub1", compiledLocals, 8);
                                setVarScalar(interp, "varname", tmp28, compiledLocals, 9);
                            } // End Invoke: set
                            { // Invoke: set varvalue $sub2
                                TclObject tmp29;
                                tmp29 = getVarScalar(interp, "sub2", compiledLocals, 10);
                                setVarScalar(interp, "varvalue", tmp29, compiledLocals, 11);
                            } // End Invoke: set
                            { // Invoke: if ... ...
                                // Unary operator: ! [...]
                                { // Invoke: jdk_config_isvar $varname
                                    TclObject[] objv30 = TJC.grabObjv(interp, 2);
                                    TclObject tmp31;
                                    try {
                                        // Arg 0 constant: jdk_config_isvar
                                        objv30[0] = const12;
                                        // Arg 1 variable: $varname
                                        tmp31 = getVarScalar(interp, "varname", compiledLocals, 9);
                                        tmp31.preserve();
                                        objv30[1] = tmp31;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv30, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp31 = objv30[1];
                                        if ( tmp31 != null ) {
                                            tmp31.release();
                                        }
                                        TJC.releaseObjv(interp, objv30, 2);
                                    }
                                } // End Invoke: jdk_config_isvar
                                TclObject tmp32 = interp.getResult();
                                ExprValue tmp33 = evs0;
                                if ( tmp32.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp33, tmp32);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp33, tmp32);
                                }
                                // End Unary operator: !
                                boolean tmp34 = ( tmp33.getIntValue() != 0 );
                                if ( tmp34 ) {
                                    { // Invoke: error "..."
                                        TclObject[] objv35 = TJC.grabObjv(interp, 2);
                                        TclObject tmp36;
                                        try {
                                            // Arg 0 constant: error
                                            objv35[0] = const13;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp37 = new StringBuffer(64);
                                            sbtmp37.append("Invalid config spec at line ");
                                            tmp36 = getVarScalar(interp, "linenum", compiledLocals, 5);
                                            sbtmp37.append(tmp36.toString());
                                            sbtmp37.append(": ");
                                            tmp36 = getVarScalar(interp, "varname", compiledLocals, 9);
                                            sbtmp37.append(tmp36.toString());
                                            sbtmp37.append(" is not a valid variable name");
                                            tmp36 = TclString.newInstance(sbtmp37);
                                            tmp36.preserve();
                                            objv35[1] = tmp36;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv35, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            tmp36 = objv35[1];
                                            if ( tmp36 != null ) {
                                                tmp36.release();
                                            }
                                            TJC.releaseObjv(interp, objv35, 2);
                                        }
                                    } // End Invoke: error
                                }
                            } // End Invoke: if
                            { // Invoke: incr parsed
                                interp.resetResult();
                                incrVarScalar(interp, "parsed", 1, compiledLocals, 4);
                            } // End Invoke: incr
                            { // Invoke: if ... ...
                                // Binary operator: () && ()
                                // Binary operator: [...] == "\""
                                { // Invoke: string index $varvalue 0
                                    TclObject tmp38 = getVarScalar(interp, "varvalue", compiledLocals, 11);
                                    String tmp39 = tmp38.toString();
                                    TclObject tmp40 = TJC.stringIndex(interp, tmp39, const0);
                                    interp.setResult(tmp40);
                                } // End Invoke: string
                                TclObject tmp41 = interp.getResult();
                                boolean tmp42 = tmp41.toString().equals("\"");
                                ExprValue tmp43 = evs0;
                                tmp43.setIntValue(tmp42);
                                // End Binary operator: ==
                                if (tmp43.getBooleanValue(interp)) {
                                // Binary operator: [...] == "\""
                                { // Invoke: string index $varvalue end
                                    TclObject tmp44 = getVarScalar(interp, "varvalue", compiledLocals, 11);
                                    String tmp45 = tmp44.toString();
                                    TclObject tmp46 = TJC.stringIndex(interp, tmp45, const14);
                                    interp.setResult(tmp46);
                                } // End Invoke: string
                                TclObject tmp47 = interp.getResult();
                                boolean tmp48 = tmp47.toString().equals("\"");
                                ExprValue tmp49 = evs1;
                                tmp49.setIntValue(tmp48);
                                // End Binary operator: ==
                                tmp43.setIntValue(tmp49.getBooleanValue(interp));
                                } else {
                                tmp43.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                boolean tmp50 = ( tmp43.getIntValue() != 0 );
                                if ( tmp50 ) {
                                    { // Invoke: set varvalue [...]
                                        TclObject tmp51;
                                        { // Invoke: string range $varvalue 1 end-1
                                            TclObject tmp52 = getVarScalar(interp, "varvalue", compiledLocals, 11);
                                            String tmp53 = tmp52.toString();
                                            TclObject tmp54 = const3;
                                            tmp54.preserve();
                                            TclObject tmp55 = const15;
                                            TclObject tmp56 = TJC.stringRange(interp, tmp53, tmp54, tmp55);
                                            interp.setResult(tmp56);
                                        } // End Invoke: string
                                        tmp51 = interp.getResult();
                                        setVarScalar(interp, "varvalue", tmp51, compiledLocals, 11);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            { // Invoke: set "..." $varvalue
                                TclObject tmp57;
                                tmp57 = getVarScalar(interp, "varname", compiledLocals, 9);
                                String tmp58 = tmp57.toString();
                                tmp57 = getVarScalar(interp, "varvalue", compiledLocals, 11);
                                tmp57 = setVarArray(interp, "_jdk_config", tmp58, tmp57, compiledLocals, 1);
                            } // End Invoke: set
                        } else {
                            { // Invoke: error "..."
                                TclObject[] objv59 = TJC.grabObjv(interp, 2);
                                TclObject tmp60;
                                try {
                                    // Arg 0 constant: error
                                    objv59[0] = const13;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp61 = new StringBuffer(64);
                                    sbtmp61.append("Invalid config spec at line ");
                                    tmp60 = getVarScalar(interp, "linenum", compiledLocals, 5);
                                    sbtmp61.append(tmp60.toString());
                                    tmp60 = TclString.newInstance(sbtmp61);
                                    tmp60.preserve();
                                    objv59[1] = tmp60;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv59, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp60 = objv59[1];
                                    if ( tmp60 != null ) {
                                        tmp60.release();
                                    }
                                    TJC.releaseObjv(interp, objv59, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: incr linenum
                        interp.resetResult();
                        incrVarScalar(interp, "linenum", 1, compiledLocals, 5);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp3 != null ) {
                    tmp3.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return $parsed
            TclObject tmp62 = getVarScalar(interp, "parsed", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp62);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_config_parse");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("split");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("\n");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("puts");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("trim");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("^([A-Z]+) *= *(.*)$");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("regexp");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("whole");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("sub1");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("sub2");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("jdk_config_isvar");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("error");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("end");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("end-1");
        const15.preserve(); const15.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "split";
                break;
            }
            case 2: {
                cmdName = "puts";
                break;
            }
            case 3: {
                cmdName = "string";
                break;
            }
            case 4: {
                cmdName = "regexp";
                break;
            }
            case 5: {
                cmdName = "jdk_config_isvar";
                break;
            }
            case 6: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "buffer",
        "_jdk_config",
        "debug",
        "lines",
        "parsed",
        "linenum",
        "line",
        "pat",
        "sub1",
        "varname",
        "sub2",
        "varvalue"
    };
} // end class JdkConfigParseCmd

