// TJC implementation of procedure module_parse_command
package tjc;
import tcl.lang.*;

public class ModuleParseCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 17, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "cmdstr linenum");
        }
        setVarScalar(interp, "cmdstr", objv[1], compiledLocals, 0);
        setVarScalar(interp, "linenum", objv[2], compiledLocals, 1);
        { // Invoke: global _module
            TJC.makeGlobalLinkVar(interp, "_module", "_module", 2);
        } // End Invoke: global
        { // Invoke: set nparsed 0
            setVarScalar(interp, "nparsed", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: regexp {^([A-Z|_]+)} $cmdstr whole sub1
                TclObject[] objv0 = TJC.grabObjv(interp, 5);
                TclObject tmp1;
                try {
                    // Arg 0 constant: regexp
                    objv0[0] = const1;
                    // Arg 1 constant: {^([A-Z|_]+)}
                    objv0[1] = const2;
                    // Arg 2 variable: $cmdstr
                    tmp1 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[2] = tmp1;
                    // Arg 3 constant: whole
                    objv0[3] = const3;
                    // Arg 4 constant: sub1
                    objv0[4] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[2];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 5);
                }
            } // End Invoke: regexp
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("Module command not found in input ");
                        sbtmp7.append("\"");
                        tmp6 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append("\"");
                        sbtmp7.append(", at line ");
                        tmp6 = getVarScalar(interp, "linenum", compiledLocals, 1);
                        sbtmp7.append(tmp6.toString());
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set cmd $sub1
            TclObject tmp8;
            tmp8 = getVarScalar(interp, "sub1", compiledLocals, 4);
            setVarScalar(interp, "cmd", tmp8, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: switch -exact -- $cmd {PACKAGE} ... {OPTIONS} ... {SOURCE} ... {INCLUDE_SOURCE} ... {INIT_SOURCE} ... {PROC_OPTIONS} ... default ...
            TclObject tmp9 = getVarScalar(interp, "cmd", compiledLocals, 5);
            String tmp10 = tmp9.toString();
            int tmp10_length = tmp10.length();
            char tmp10_first = '\n';
            if ( tmp10_length > 0 ) {
                tmp10_first = tmp10.charAt(0);
            }
            if ( tmp10_length == 7 && tmp10_first == 'P'
                    && tmp10.compareTo("PACKAGE") == 0 ) {
                // Pattern {PACKAGE}
                { // Invoke: set clist [...]
                    TclObject tmp11;
                    { // Invoke: module_space_split $cmdstr
                        TclObject[] objv12 = TJC.grabObjv(interp, 2);
                        TclObject tmp13;
                        try {
                            // Arg 0 constant: module_space_split
                            objv12[0] = const6;
                            // Arg 1 variable: $cmdstr
                            tmp13 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                            tmp13.preserve();
                            objv12[1] = tmp13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv12, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp13 = objv12[1];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            TJC.releaseObjv(interp, objv12, 2);
                        }
                    } // End Invoke: module_space_split
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "clist", tmp11, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] != 2
                    { // Invoke: llength $clist
                        TclObject tmp14 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp15 = TclList.getLength(interp, tmp14);
                        interp.setResult(tmp15);
                    } // End Invoke: llength
                    TclObject tmp16 = interp.getResult();
                    ExprValue tmp17 = evs0;
                    TJC.exprInitValue(interp, tmp17, tmp16);
                    ExprValue tmp18 = evs1;
                    tmp18.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp17, tmp18);
                    // End Binary operator: !=
                    boolean tmp19 = ( tmp17.getIntValue() != 0 );
                    if ( tmp19 ) {
                        { // Invoke: error "..."
                            TclObject[] objv20 = TJC.grabObjv(interp, 2);
                            TclObject tmp21;
                            try {
                                // Arg 0 constant: error
                                objv20[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp22 = new StringBuffer(64);
                                sbtmp22.append("Module command PACKAGE requires 1 argument, at line ");
                                tmp21 = getVarScalar(interp, "linenum", compiledLocals, 1);
                                sbtmp22.append(tmp21.toString());
                                tmp21 = TclString.newInstance(sbtmp22);
                                tmp21.preserve();
                                objv20[1] = tmp21;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv20, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp21 = objv20[1];
                                if ( tmp21 != null ) {
                                    tmp21.release();
                                }
                                TJC.releaseObjv(interp, objv20, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set nparsed [...]
                    TclObject tmp23;
                    { // Invoke: llength $clist
                        TclObject tmp24 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp25 = TclList.getLength(interp, tmp24);
                        interp.setResult(tmp25);
                    } // End Invoke: llength
                    tmp23 = interp.getResult();
                    setVarScalar(interp, "nparsed", tmp23, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set package [...]
                    TclObject tmp26;
                    { // Invoke: lindex $clist 1
                        TclObject tmp27 = getVarScalar(interp, "clist", compiledLocals, 6);
                        tmp27 = TclList.index(interp, tmp27, 1);
                        if ( tmp27 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp27);
                        }
                    } // End Invoke: lindex
                    tmp26 = interp.getResult();
                    setVarScalar(interp, "package", tmp26, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $::tcl_platform(...) == "java"
                    initVarScoped(interp, "::tcl_platform", compiledLocals, 8);
                    TclObject tmp28 = getVarArray(interp, "::tcl_platform", "platform", compiledLocals, 8);
                    boolean tmp29 = tmp28.toString().equals("java");
                    ExprValue tmp30 = evs0;
                    tmp30.setIntValue(tmp29);
                    // End Binary operator: ==
                    boolean tmp31 = ( tmp30.getIntValue() != 0 );
                    if ( tmp31 ) {
                        { // Invoke: set pat {[^0-9|A-Z|a-z|_|.]}
                            setVarScalar(interp, "pat", const7, compiledLocals, 9);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set pat {[^[:alnum:]|_|.]}
                            setVarScalar(interp, "pat", const8, compiledLocals, 9);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    { // Invoke: regexp $pat $package whole
                        TclObject[] objv32 = TJC.grabObjv(interp, 4);
                        TclObject tmp33;
                        try {
                            // Arg 0 constant: regexp
                            objv32[0] = const1;
                            // Arg 1 variable: $pat
                            tmp33 = getVarScalar(interp, "pat", compiledLocals, 9);
                            tmp33.preserve();
                            objv32[1] = tmp33;
                            // Arg 2 variable: $package
                            tmp33 = getVarScalar(interp, "package", compiledLocals, 7);
                            tmp33.preserve();
                            objv32[2] = tmp33;
                            // Arg 3 constant: whole
                            objv32[3] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv32, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp33 = objv32[1];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            tmp33 = objv32[2];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            TJC.releaseObjv(interp, objv32, 4);
                        }
                    } // End Invoke: regexp
                    TclObject tmp34 = interp.getResult();
                    ExprValue tmp35 = evs0;
                    TJC.exprInitValue(interp, tmp35, tmp34);
                    boolean tmp36 = tmp35.getBooleanValue(interp);
                    if ( tmp36 ) {
                        { // Invoke: if ... ... elseif ... ...
                            // Binary operator: $whole == "\""
                            TclObject tmp37 = getVarScalar(interp, "whole", compiledLocals, 10);
                            boolean tmp38 = tmp37.toString().equals("\"");
                            ExprValue tmp39 = evs0;
                            tmp39.setIntValue(tmp38);
                            // End Binary operator: ==
                            boolean tmp40 = ( tmp39.getIntValue() != 0 );
                            if ( tmp40 ) {
                                { // Invoke: set whole ...
                                    setVarScalar(interp, "whole", const9, compiledLocals, 10);
                                } // End Invoke: set
                            } else {
                                // Binary operator: $whole == "\t"
                                TclObject tmp41 = getVarScalar(interp, "whole", compiledLocals, 10);
                                boolean tmp42 = tmp41.toString().equals("\t");
                                ExprValue tmp43 = evs0;
                                tmp43.setIntValue(tmp42);
                                // End Binary operator: ==
                                boolean tmp44 = ( tmp43.getIntValue() != 0 );
                                if ( tmp44 ) {
                                    { // Invoke: set whole ...
                                        setVarScalar(interp, "whole", const10, compiledLocals, 10);
                                    } // End Invoke: set
                                }
                            }
                        } // End Invoke: if
                        { // Invoke: error "..."
                            TclObject[] objv45 = TJC.grabObjv(interp, 2);
                            TclObject tmp46;
                            try {
                                // Arg 0 constant: error
                                objv45[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp47 = new StringBuffer(64);
                                sbtmp47.append("Module command PACKAGE name contains an invalid character ");
                                sbtmp47.append("\"");
                                tmp46 = getVarScalar(interp, "whole", compiledLocals, 10);
                                sbtmp47.append(tmp46.toString());
                                sbtmp47.append("\"");
                                tmp46 = TclString.newInstance(sbtmp47);
                                tmp46.preserve();
                                objv45[1] = tmp46;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv45, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp46 = objv45[1];
                                if ( tmp46 != null ) {
                                    tmp46.release();
                                }
                                TJC.releaseObjv(interp, objv45, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set _module(package) $package
                    TclObject tmp48;
                    tmp48 = getVarScalar(interp, "package", compiledLocals, 7);
                    setVarArray(interp, "_module", "package", tmp48, compiledLocals, 2);
                } // End Invoke: set
            } else if ( tmp10_length == 7 && tmp10_first == 'O'
                    && tmp10.compareTo("OPTIONS") == 0 ) {
                // Pattern {OPTIONS}
                { // Invoke: set clist [...]
                    TclObject tmp49;
                    { // Invoke: module_space_split $cmdstr
                        TclObject[] objv50 = TJC.grabObjv(interp, 2);
                        TclObject tmp51;
                        try {
                            // Arg 0 constant: module_space_split
                            objv50[0] = const6;
                            // Arg 1 variable: $cmdstr
                            tmp51 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                            tmp51.preserve();
                            objv50[1] = tmp51;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv50, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp51 = objv50[1];
                            if ( tmp51 != null ) {
                                tmp51.release();
                            }
                            TJC.releaseObjv(interp, objv50, 2);
                        }
                    } // End Invoke: module_space_split
                    tmp49 = interp.getResult();
                    setVarScalar(interp, "clist", tmp49, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] == 0
                    { // Invoke: llength $clist
                        TclObject tmp52 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp53 = TclList.getLength(interp, tmp52);
                        interp.setResult(tmp53);
                    } // End Invoke: llength
                    TclObject tmp54 = interp.getResult();
                    ExprValue tmp55 = evs0;
                    TJC.exprInitValue(interp, tmp55, tmp54);
                    ExprValue tmp56 = evs1;
                    tmp56.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp55, tmp56);
                    // End Binary operator: ==
                    boolean tmp57 = ( tmp55.getIntValue() != 0 );
                    if ( tmp57 ) {
                        { // Invoke: error ...
                            TclObject[] objv58 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: error
                                objv58[0] = const5;
                                // Arg 1 constant: ...
                                objv58[1] = const11;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv58, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv58, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set nparsed [...]
                    TclObject tmp59;
                    { // Invoke: llength $clist
                        TclObject tmp60 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp61 = TclList.getLength(interp, tmp60);
                        interp.setResult(tmp61);
                    } // End Invoke: llength
                    tmp59 = interp.getResult();
                    setVarScalar(interp, "nparsed", tmp59, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set cargs [...]
                    TclObject tmp62;
                    { // Invoke: lrange $clist 1 end
                        TclObject[] objv63 = TJC.grabObjv(interp, 4);
                        TclObject tmp64;
                        try {
                            // Arg 0 constant: lrange
                            objv63[0] = const12;
                            // Arg 1 variable: $clist
                            tmp64 = getVarScalar(interp, "clist", compiledLocals, 6);
                            tmp64.preserve();
                            objv63[1] = tmp64;
                            // Arg 2 constant: 1
                            objv63[2] = const13;
                            // Arg 3 constant: end
                            objv63[3] = const14;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv63, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp64 = objv63[1];
                            if ( tmp64 != null ) {
                                tmp64.release();
                            }
                            TJC.releaseObjv(interp, objv63, 4);
                        }
                    } // End Invoke: lrange
                    tmp62 = interp.getResult();
                    setVarScalar(interp, "cargs", tmp62, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set _module(options) [...]
                    TclObject tmp65;
                    { // Invoke: module_options_parse $cargs OPTIONS $linenum
                        TclObject[] objv66 = TJC.grabObjv(interp, 4);
                        TclObject tmp67;
                        try {
                            // Arg 0 constant: module_options_parse
                            objv66[0] = const15;
                            // Arg 1 variable: $cargs
                            tmp67 = getVarScalar(interp, "cargs", compiledLocals, 11);
                            tmp67.preserve();
                            objv66[1] = tmp67;
                            // Arg 2 constant: OPTIONS
                            objv66[2] = const16;
                            // Arg 3 variable: $linenum
                            tmp67 = getVarScalar(interp, "linenum", compiledLocals, 1);
                            tmp67.preserve();
                            objv66[3] = tmp67;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv66, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp67 = objv66[1];
                            if ( tmp67 != null ) {
                                tmp67.release();
                            }
                            tmp67 = objv66[3];
                            if ( tmp67 != null ) {
                                tmp67.release();
                            }
                            TJC.releaseObjv(interp, objv66, 4);
                        }
                    } // End Invoke: module_options_parse
                    tmp65 = interp.getResult();
                    setVarArray(interp, "_module", "options", tmp65, compiledLocals, 2);
                } // End Invoke: set
            } else if ( tmp10_length == 6 && tmp10_first == 'S'
                    && tmp10.compareTo("SOURCE") == 0 ) {
                // Pattern {SOURCE}
                { // Invoke: set clist [...]
                    TclObject tmp68;
                    { // Invoke: module_space_split $cmdstr
                        TclObject[] objv69 = TJC.grabObjv(interp, 2);
                        TclObject tmp70;
                        try {
                            // Arg 0 constant: module_space_split
                            objv69[0] = const6;
                            // Arg 1 variable: $cmdstr
                            tmp70 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                            tmp70.preserve();
                            objv69[1] = tmp70;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv69, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp70 = objv69[1];
                            if ( tmp70 != null ) {
                                tmp70.release();
                            }
                            TJC.releaseObjv(interp, objv69, 2);
                        }
                    } // End Invoke: module_space_split
                    tmp68 = interp.getResult();
                    setVarScalar(interp, "clist", tmp68, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] < 2
                    { // Invoke: llength $clist
                        TclObject tmp71 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp72 = TclList.getLength(interp, tmp71);
                        interp.setResult(tmp72);
                    } // End Invoke: llength
                    TclObject tmp73 = interp.getResult();
                    ExprValue tmp74 = evs0;
                    TJC.exprInitValue(interp, tmp74, tmp73);
                    ExprValue tmp75 = evs1;
                    tmp75.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp74, tmp75);
                    // End Binary operator: <
                    boolean tmp76 = ( tmp74.getIntValue() != 0 );
                    if ( tmp76 ) {
                        { // Invoke: error "..."
                            TclObject[] objv77 = TJC.grabObjv(interp, 2);
                            TclObject tmp78;
                            try {
                                // Arg 0 constant: error
                                objv77[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp79 = new StringBuffer(64);
                                sbtmp79.append("Module command SOURCE requires 1 or more arguments, at line ");
                                tmp78 = getVarScalar(interp, "linenum", compiledLocals, 1);
                                sbtmp79.append(tmp78.toString());
                                tmp78 = TclString.newInstance(sbtmp79);
                                tmp78.preserve();
                                objv77[1] = tmp78;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv77, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp78 = objv77[1];
                                if ( tmp78 != null ) {
                                    tmp78.release();
                                }
                                TJC.releaseObjv(interp, objv77, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set nparsed [...]
                    TclObject tmp80;
                    { // Invoke: llength $clist
                        TclObject tmp81 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp82 = TclList.getLength(interp, tmp81);
                        interp.setResult(tmp82);
                    } // End Invoke: llength
                    tmp80 = interp.getResult();
                    setVarScalar(interp, "nparsed", tmp80, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set _module(source) [...]
                    TclObject tmp83;
                    { // Invoke: lrange $clist 1 end
                        TclObject[] objv84 = TJC.grabObjv(interp, 4);
                        TclObject tmp85;
                        try {
                            // Arg 0 constant: lrange
                            objv84[0] = const12;
                            // Arg 1 variable: $clist
                            tmp85 = getVarScalar(interp, "clist", compiledLocals, 6);
                            tmp85.preserve();
                            objv84[1] = tmp85;
                            // Arg 2 constant: 1
                            objv84[2] = const13;
                            // Arg 3 constant: end
                            objv84[3] = const14;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv84, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp85 = objv84[1];
                            if ( tmp85 != null ) {
                                tmp85.release();
                            }
                            TJC.releaseObjv(interp, objv84, 4);
                        }
                    } // End Invoke: lrange
                    tmp83 = interp.getResult();
                    setVarArray(interp, "_module", "source", tmp83, compiledLocals, 2);
                } // End Invoke: set
            } else if ( tmp10_length == 14 && tmp10_first == 'I'
                    && tmp10.compareTo("INCLUDE_SOURCE") == 0 ) {
                // Pattern {INCLUDE_SOURCE}
                { // Invoke: set clist [...]
                    TclObject tmp86;
                    { // Invoke: module_space_split $cmdstr
                        TclObject[] objv87 = TJC.grabObjv(interp, 2);
                        TclObject tmp88;
                        try {
                            // Arg 0 constant: module_space_split
                            objv87[0] = const6;
                            // Arg 1 variable: $cmdstr
                            tmp88 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                            tmp88.preserve();
                            objv87[1] = tmp88;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv87, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp88 = objv87[1];
                            if ( tmp88 != null ) {
                                tmp88.release();
                            }
                            TJC.releaseObjv(interp, objv87, 2);
                        }
                    } // End Invoke: module_space_split
                    tmp86 = interp.getResult();
                    setVarScalar(interp, "clist", tmp86, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] < 2
                    { // Invoke: llength $clist
                        TclObject tmp89 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp90 = TclList.getLength(interp, tmp89);
                        interp.setResult(tmp90);
                    } // End Invoke: llength
                    TclObject tmp91 = interp.getResult();
                    ExprValue tmp92 = evs0;
                    TJC.exprInitValue(interp, tmp92, tmp91);
                    ExprValue tmp93 = evs1;
                    tmp93.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp92, tmp93);
                    // End Binary operator: <
                    boolean tmp94 = ( tmp92.getIntValue() != 0 );
                    if ( tmp94 ) {
                        { // Invoke: error "..."
                            TclObject[] objv95 = TJC.grabObjv(interp, 2);
                            TclObject tmp96;
                            try {
                                // Arg 0 constant: error
                                objv95[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp97 = new StringBuffer(64);
                                sbtmp97.append("Module command INCLUDE_SOURCE requires 1 or more arguments, at line ");
                                tmp96 = getVarScalar(interp, "linenum", compiledLocals, 1);
                                sbtmp97.append(tmp96.toString());
                                tmp96 = TclString.newInstance(sbtmp97);
                                tmp96.preserve();
                                objv95[1] = tmp96;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv95, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp96 = objv95[1];
                                if ( tmp96 != null ) {
                                    tmp96.release();
                                }
                                TJC.releaseObjv(interp, objv95, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set nparsed [...]
                    TclObject tmp98;
                    { // Invoke: llength $clist
                        TclObject tmp99 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp100 = TclList.getLength(interp, tmp99);
                        interp.setResult(tmp100);
                    } // End Invoke: llength
                    tmp98 = interp.getResult();
                    setVarScalar(interp, "nparsed", tmp98, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp101;
                    { // Invoke: lrange $clist 1 end
                        TclObject[] objv102 = TJC.grabObjv(interp, 4);
                        TclObject tmp103;
                        try {
                            // Arg 0 constant: lrange
                            objv102[0] = const12;
                            // Arg 1 variable: $clist
                            tmp103 = getVarScalar(interp, "clist", compiledLocals, 6);
                            tmp103.preserve();
                            objv102[1] = tmp103;
                            // Arg 2 constant: 1
                            objv102[2] = const13;
                            // Arg 3 constant: end
                            objv102[3] = const14;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv102, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp103 = objv102[1];
                            if ( tmp103 != null ) {
                                tmp103.release();
                            }
                            TJC.releaseObjv(interp, objv102, 4);
                        }
                    } // End Invoke: lrange
                    tmp101 = interp.getResult();
                    setVarArray(interp, "_module", "include_source", tmp101, compiledLocals, 2);
                } // End Invoke: set
            } else if ( tmp10_length == 11 && tmp10_first == 'I'
                    && tmp10.compareTo("INIT_SOURCE") == 0 ) {
                // Pattern {INIT_SOURCE}
                { // Invoke: set clist [...]
                    TclObject tmp104;
                    { // Invoke: module_space_split $cmdstr
                        TclObject[] objv105 = TJC.grabObjv(interp, 2);
                        TclObject tmp106;
                        try {
                            // Arg 0 constant: module_space_split
                            objv105[0] = const6;
                            // Arg 1 variable: $cmdstr
                            tmp106 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                            tmp106.preserve();
                            objv105[1] = tmp106;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv105, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp106 = objv105[1];
                            if ( tmp106 != null ) {
                                tmp106.release();
                            }
                            TJC.releaseObjv(interp, objv105, 2);
                        }
                    } // End Invoke: module_space_split
                    tmp104 = interp.getResult();
                    setVarScalar(interp, "clist", tmp104, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] != 2
                    { // Invoke: llength $clist
                        TclObject tmp107 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp108 = TclList.getLength(interp, tmp107);
                        interp.setResult(tmp108);
                    } // End Invoke: llength
                    TclObject tmp109 = interp.getResult();
                    ExprValue tmp110 = evs0;
                    TJC.exprInitValue(interp, tmp110, tmp109);
                    ExprValue tmp111 = evs1;
                    tmp111.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp110, tmp111);
                    // End Binary operator: !=
                    boolean tmp112 = ( tmp110.getIntValue() != 0 );
                    if ( tmp112 ) {
                        { // Invoke: error "..."
                            TclObject[] objv113 = TJC.grabObjv(interp, 2);
                            TclObject tmp114;
                            try {
                                // Arg 0 constant: error
                                objv113[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp115 = new StringBuffer(64);
                                sbtmp115.append("Module command INIT_SOURCE requires 1 argument, at line ");
                                tmp114 = getVarScalar(interp, "linenum", compiledLocals, 1);
                                sbtmp115.append(tmp114.toString());
                                tmp114 = TclString.newInstance(sbtmp115);
                                tmp114.preserve();
                                objv113[1] = tmp114;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv113, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp114 = objv113[1];
                                if ( tmp114 != null ) {
                                    tmp114.release();
                                }
                                TJC.releaseObjv(interp, objv113, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set nparsed [...]
                    TclObject tmp116;
                    { // Invoke: llength $clist
                        TclObject tmp117 = getVarScalar(interp, "clist", compiledLocals, 6);
                        int tmp118 = TclList.getLength(interp, tmp117);
                        interp.setResult(tmp118);
                    } // End Invoke: llength
                    tmp116 = interp.getResult();
                    setVarScalar(interp, "nparsed", tmp116, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set _module(init_source) [...]
                    TclObject tmp119;
                    { // Invoke: lindex $clist 1
                        TclObject tmp120 = getVarScalar(interp, "clist", compiledLocals, 6);
                        tmp120 = TclList.index(interp, tmp120, 1);
                        if ( tmp120 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp120);
                        }
                    } // End Invoke: lindex
                    tmp119 = interp.getResult();
                    setVarArray(interp, "_module", "init_source", tmp119, compiledLocals, 2);
                } // End Invoke: set
            } else if ( tmp10_length == 12 && tmp10_first == 'P'
                    && tmp10.compareTo("PROC_OPTIONS") == 0 ) {
                // Pattern {PROC_OPTIONS}
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: regexp ... $cmdstr whole sub1 sub2
                        TclObject[] objv121 = TJC.grabObjv(interp, 6);
                        TclObject tmp122;
                        try {
                            // Arg 0 constant: regexp
                            objv121[0] = const1;
                            // Arg 1 constant: ...
                            objv121[1] = const17;
                            // Arg 2 variable: $cmdstr
                            tmp122 = getVarScalar(interp, "cmdstr", compiledLocals, 0);
                            tmp122.preserve();
                            objv121[2] = tmp122;
                            // Arg 3 constant: whole
                            objv121[3] = const3;
                            // Arg 4 constant: sub1
                            objv121[4] = const4;
                            // Arg 5 constant: sub2
                            objv121[5] = const18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv121, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp122 = objv121[2];
                            if ( tmp122 != null ) {
                                tmp122.release();
                            }
                            TJC.releaseObjv(interp, objv121, 6);
                        }
                    } // End Invoke: regexp
                    TclObject tmp123 = interp.getResult();
                    ExprValue tmp124 = evs0;
                    if ( tmp123.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp124, tmp123);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp124, tmp123);
                    }
                    // End Unary operator: !
                    boolean tmp125 = ( tmp124.getIntValue() != 0 );
                    if ( tmp125 ) {
                        { // Invoke: error "..."
                            TclObject[] objv126 = TJC.grabObjv(interp, 2);
                            TclObject tmp127;
                            try {
                                // Arg 0 constant: error
                                objv126[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp128 = new StringBuffer(64);
                                sbtmp128.append("Module command PROC_OPTIONS format not matched, at line ");
                                tmp127 = getVarScalar(interp, "linenum", compiledLocals, 1);
                                sbtmp128.append(tmp127.toString());
                                tmp127 = TclString.newInstance(sbtmp128);
                                tmp127.preserve();
                                objv126[1] = tmp127;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv126, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp127 = objv126[1];
                                if ( tmp127 != null ) {
                                    tmp127.release();
                                }
                                TJC.releaseObjv(interp, objv126, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set plist [...]
                    TclObject tmp129;
                    { // Invoke: module_space_split $sub1
                        TclObject[] objv130 = TJC.grabObjv(interp, 2);
                        TclObject tmp131;
                        try {
                            // Arg 0 constant: module_space_split
                            objv130[0] = const6;
                            // Arg 1 variable: $sub1
                            tmp131 = getVarScalar(interp, "sub1", compiledLocals, 4);
                            tmp131.preserve();
                            objv130[1] = tmp131;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv130, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp131 = objv130[1];
                            if ( tmp131 != null ) {
                                tmp131.release();
                            }
                            TJC.releaseObjv(interp, objv130, 2);
                        }
                    } // End Invoke: module_space_split
                    tmp129 = interp.getResult();
                    setVarScalar(interp, "plist", tmp129, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] == 0
                    { // Invoke: llength $plist
                        TclObject tmp132 = getVarScalar(interp, "plist", compiledLocals, 12);
                        int tmp133 = TclList.getLength(interp, tmp132);
                        interp.setResult(tmp133);
                    } // End Invoke: llength
                    TclObject tmp134 = interp.getResult();
                    ExprValue tmp135 = evs0;
                    TJC.exprInitValue(interp, tmp135, tmp134);
                    ExprValue tmp136 = evs1;
                    tmp136.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp135, tmp136);
                    // End Binary operator: ==
                    boolean tmp137 = ( tmp135.getIntValue() != 0 );
                    if ( tmp137 ) {
                        { // Invoke: error "..."
                            TclObject[] objv138 = TJC.grabObjv(interp, 2);
                            TclObject tmp139;
                            try {
                                // Arg 0 constant: error
                                objv138[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp140 = new StringBuffer(64);
                                sbtmp140.append("Module command PROC_OPTIONS requires 1 or more proc names, at line ");
                                tmp139 = getVarScalar(interp, "linenum", compiledLocals, 1);
                                sbtmp140.append(tmp139.toString());
                                tmp139 = TclString.newInstance(sbtmp140);
                                tmp139.preserve();
                                objv138[1] = tmp139;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv138, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp139 = objv138[1];
                                if ( tmp139 != null ) {
                                    tmp139.release();
                                }
                                TJC.releaseObjv(interp, objv138, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set alist [...]
                    TclObject tmp141;
                    { // Invoke: module_space_split $sub2
                        TclObject[] objv142 = TJC.grabObjv(interp, 2);
                        TclObject tmp143;
                        try {
                            // Arg 0 constant: module_space_split
                            objv142[0] = const6;
                            // Arg 1 variable: $sub2
                            tmp143 = getVarScalar(interp, "sub2", compiledLocals, 13);
                            tmp143.preserve();
                            objv142[1] = tmp143;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv142, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp143 = objv142[1];
                            if ( tmp143 != null ) {
                                tmp143.release();
                            }
                            TJC.releaseObjv(interp, objv142, 2);
                        }
                    } // End Invoke: module_space_split
                    tmp141 = interp.getResult();
                    setVarScalar(interp, "alist", tmp141, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] == 0
                    { // Invoke: llength $alist
                        TclObject tmp144 = getVarScalar(interp, "alist", compiledLocals, 14);
                        int tmp145 = TclList.getLength(interp, tmp144);
                        interp.setResult(tmp145);
                    } // End Invoke: llength
                    TclObject tmp146 = interp.getResult();
                    ExprValue tmp147 = evs0;
                    TJC.exprInitValue(interp, tmp147, tmp146);
                    ExprValue tmp148 = evs1;
                    tmp148.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp147, tmp148);
                    // End Binary operator: ==
                    boolean tmp149 = ( tmp147.getIntValue() != 0 );
                    if ( tmp149 ) {
                        { // Invoke: error "..."
                            TclObject[] objv150 = TJC.grabObjv(interp, 2);
                            TclObject tmp151;
                            try {
                                // Arg 0 constant: error
                                objv150[0] = const5;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp152 = new StringBuffer(64);
                                sbtmp152.append("Module command PROC_OPTIONS requires 1 or more option arguments, at line ");
                                tmp151 = getVarScalar(interp, "linenum", compiledLocals, 1);
                                sbtmp152.append(tmp151.toString());
                                tmp151 = TclString.newInstance(sbtmp152);
                                tmp151.preserve();
                                objv150[1] = tmp151;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv150, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp151 = objv150[1];
                                if ( tmp151 != null ) {
                                    tmp151.release();
                                }
                                TJC.releaseObjv(interp, objv150, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set nparsed [...]
                    TclObject tmp153;
                    { // Invoke: expr ...
                        // Binary operator: 2 + [...]
                        ExprValue tmp154 = evs0;
                        tmp154.setIntValue(2);
                        { // Invoke: llength $alist
                            TclObject tmp155 = getVarScalar(interp, "alist", compiledLocals, 14);
                            int tmp156 = TclList.getLength(interp, tmp155);
                            interp.setResult(tmp156);
                        } // End Invoke: llength
                        TclObject tmp157 = interp.getResult();
                        ExprValue tmp158 = evs1;
                        TJC.exprInitValue(interp, tmp158, tmp157);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp154, tmp158);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp154);
                    } // End Invoke: expr
                    tmp153 = interp.getResult();
                    setVarScalar(interp, "nparsed", tmp153, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set options [...]
                    TclObject tmp159;
                    { // Invoke: module_options_parse $alist PROC_OPTIONS $linenum
                        TclObject[] objv160 = TJC.grabObjv(interp, 4);
                        TclObject tmp161;
                        try {
                            // Arg 0 constant: module_options_parse
                            objv160[0] = const15;
                            // Arg 1 variable: $alist
                            tmp161 = getVarScalar(interp, "alist", compiledLocals, 14);
                            tmp161.preserve();
                            objv160[1] = tmp161;
                            // Arg 2 constant: PROC_OPTIONS
                            objv160[2] = const19;
                            // Arg 3 variable: $linenum
                            tmp161 = getVarScalar(interp, "linenum", compiledLocals, 1);
                            tmp161.preserve();
                            objv160[3] = tmp161;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv160, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp161 = objv160[1];
                            if ( tmp161 != null ) {
                                tmp161.release();
                            }
                            tmp161 = objv160[3];
                            if ( tmp161 != null ) {
                                tmp161.release();
                            }
                            TJC.releaseObjv(interp, objv160, 4);
                        }
                    } // End Invoke: module_options_parse
                    tmp159 = interp.getResult();
                    setVarScalar(interp, "options", tmp159, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: foreach pname $plist ...
                    TclObject tmp162 = null;
                    try {
                        tmp162 = getVarScalar(interp, "plist", compiledLocals, 12);
                        tmp162.preserve();
                        final int tmp162_length = TclList.getLength(interp, tmp162);

                        for ( int index163 = 0 ; index163 < tmp162_length ; index163++ ) {
                            TclObject tmp164 = TclList.index(interp, tmp162, index163);
                            try {
                                setVarScalar(interp, "pname", tmp164, compiledLocals, 16);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "pname");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: lappend ... [...]
                                TclObject[] objv165 = TJC.grabObjv(interp, 1);
                                TclObject tmp166;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: list $pname $options
                                        TclObject tmp167 = TclList.newInstance();
                                        TclObject tmp168;
                                        try {
                                            tmp168 = getVarScalar(interp, "pname", compiledLocals, 16);
                                            TclList.append(interp, tmp167, tmp168);
                                            tmp168 = getVarScalar(interp, "options", compiledLocals, 15);
                                            TclList.append(interp, tmp167, tmp168);
                                        } catch (TclException ex) {
                                            tmp167.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp167);
                                    } // End Invoke: list
                                    tmp166 = interp.getResult();
                                    tmp166.preserve();
                                    objv165[0] = tmp166;
                                    interp.resetResult();
                                    lappendVarArray(interp, "_module", "proc_options", objv165, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv165, 1);
                                }
                            } // End Invoke: lappend
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp162 != null ) {
                            tmp162.release();
                        }
                    }
                } // End Invoke: foreach
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv169 = TJC.grabObjv(interp, 2);
                    TclObject tmp170;
                    try {
                        // Arg 0 constant: error
                        objv169[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp171 = new StringBuffer(64);
                        sbtmp171.append("Unknown module command ");
                        tmp170 = getVarScalar(interp, "cmd", compiledLocals, 5);
                        sbtmp171.append(tmp170.toString());
                        sbtmp171.append(", at line ");
                        tmp170 = getVarScalar(interp, "linenum", compiledLocals, 1);
                        sbtmp171.append(tmp170.toString());
                        tmp170 = TclString.newInstance(sbtmp171);
                        tmp170.preserve();
                        objv169[1] = tmp170;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv169, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp170 = objv169[1];
                        if ( tmp170 != null ) {
                            tmp170.release();
                        }
                        TJC.releaseObjv(interp, objv169, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: return $nparsed
            TclObject tmp172 = getVarScalar(interp, "nparsed", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp172);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_parse_command");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("regexp");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("^([A-Z|_]+)");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("whole");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("sub1");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("module_space_split");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("[^0-9|A-Z|a-z|_|.]");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("[^[:alnum:]|_|.]");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("\\\"");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("\\t");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("no elements in OPTIONS string");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("lrange");
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(1);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("end");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("module_options_parse");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("OPTIONS");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("^PROC_OPTIONS +\\{([A-Z|a-z|0-9|_|:| ]*)\\} +(.*)$");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("sub2");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("PROC_OPTIONS");
        const19.preserve(); const19.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "regexp";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "module_space_split";
                break;
            }
            case 4: {
                cmdName = "lrange";
                break;
            }
            case 5: {
                cmdName = "module_options_parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cmdstr",
        "linenum",
        "_module",
        "nparsed",
        "sub1",
        "cmd",
        "clist",
        "package",
        "::tcl_platform",
        "pat",
        "whole",
        "cargs",
        "plist",
        "sub2",
        "alist",
        "options",
        "pname"
    };
} // end class ModuleParseCommandCmd

