// TJC implementation of procedure nameproc_init
package tjc;
import tcl.lang.*;

public class NameprocInitCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "package");
        }
        setVarScalar(interp, "package", objv[1], compiledLocals, 0);
        { // Invoke: global _nameproc
            TJC.makeGlobalLinkVar(interp, "_nameproc", "_nameproc", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            { // Invoke: info exists _nameproc
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: _nameproc
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            boolean tmp3 = tmp2.getBooleanValue(interp);
            if ( tmp3 ) {
                { // Invoke: unset _nameproc
                    TclObject[] objv4 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv4[0] = const3;
                        // Arg 1 constant: _nameproc
                        objv4[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv4, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv4, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: set _nameproc(package) $package
            TclObject tmp5;
            tmp5 = getVarScalar(interp, "package", compiledLocals, 0);
            tmp5 = setVarArray(interp, "_nameproc", "package", tmp5, compiledLocals, 1);
            interp.setResult(tmp5);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "nameproc_init");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_nameproc");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("unset");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "unset";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "package",
        "_nameproc"
    };
} // end class NameprocInitCmd

