// TJC implementation of procedure _parse_expr_iterate_evaluate_value
package tjc;
import tcl.lang.*;

public class ParseExprIterateEvaluateValueCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "cmd_elem");
        }
        setVarScalar(interp, "cmd_elem", objv[1], compiledLocals, 0);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 1);
        } // End Invoke: global
        { // Invoke: set type [...]
            TclObject tmp0;
            { // Invoke: lindex $cmd_elem 0
                TclObject tmp1 = getVarScalar(interp, "cmd_elem", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "type", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_parse", "parse_expr_iterate_type_value", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set cmd [...]
            TclObject tmp2;
            { // Invoke: lindex $cmd_elem 1
                TclObject tmp3 = getVarScalar(interp, "cmd_elem", compiledLocals, 0);
                tmp3 = TclList.index(interp, tmp3, 1);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "cmd", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: namespace eval :: [...]
            TclObject[] objv4 = TJC.grabObjv(interp, 4);
            TclObject tmp5;
            try {
                // Arg 0 constant: namespace
                objv4[0] = const1;
                // Arg 1 constant: eval
                objv4[1] = const2;
                // Arg 2 constant: ::
                objv4[2] = const3;
                // Arg 3 command: [...]
                { // Invoke: lrange $cmd 0 end
                    TclObject[] objv6 = TJC.grabObjv(interp, 4);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: lrange
                        objv6[0] = const4;
                        // Arg 1 variable: $cmd
                        tmp7 = getVarScalar(interp, "cmd", compiledLocals, 3);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        // Arg 2 constant: 0
                        objv6[2] = const5;
                        // Arg 3 constant: end
                        objv6[3] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 4);
                    }
                } // End Invoke: lrange
                tmp5 = interp.getResult();
                tmp5.preserve();
                objv4[3] = tmp5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv4, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp5 = objv4[3];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                TJC.releaseObjv(interp, objv4, 4);
            }
        } // End Invoke: namespace
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: $_parse(...) == ""
            TclObject tmp8 = getVarArray(interp, "_parse", "parse_expr_iterate_type_value", compiledLocals, 1);
            ExprValue tmp9 = evs0;
            TJC.exprEqualsEmptyString(tmp9, tmp8, false);
            // End Binary operator: ==
            if (tmp9.getBooleanValue(interp)) {
            // Binary operator: [...] == "literal operand"
            { // Invoke: lindex $cmd 3
                TclObject tmp10 = getVarScalar(interp, "cmd", compiledLocals, 3);
                tmp10 = TclList.index(interp, tmp10, 3);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            TclObject tmp11 = interp.getResult();
            boolean tmp12 = tmp11.toString().equals("literal operand");
            ExprValue tmp13 = evs1;
            tmp13.setIntValue(tmp12);
            // End Binary operator: ==
            tmp9.setIntValue(tmp13.getBooleanValue(interp));
            } else {
            tmp9.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp14 = ( tmp9.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: set ... [...]
                    TclObject tmp15;
                    { // Invoke: lindex $cmd 4 0
                        TclObject[] objv16 = TJC.grabObjv(interp, 4);
                        TclObject tmp17;
                        try {
                            // Arg 0 constant: lindex
                            objv16[0] = const7;
                            // Arg 1 variable: $cmd
                            tmp17 = getVarScalar(interp, "cmd", compiledLocals, 3);
                            tmp17.preserve();
                            objv16[1] = tmp17;
                            // Arg 2 constant: 4
                            objv16[2] = const8;
                            // Arg 3 constant: 0
                            objv16[3] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv16, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp17 = objv16[1];
                            if ( tmp17 != null ) {
                                tmp17.release();
                            }
                            TJC.releaseObjv(interp, objv16, 4);
                        }
                    } // End Invoke: lindex
                    tmp15 = interp.getResult();
                    setVarArray(interp, "_parse", "parse_expr_iterate_type_value", tmp15, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set type_val $...
            TclObject tmp18;
            tmp18 = getVarArray(interp, "_parse", "parse_expr_iterate_type_value", compiledLocals, 1);
            setVarScalar(interp, "type_val", tmp18, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: return $type_val
            TclObject tmp19 = getVarScalar(interp, "type_val", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp19);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_expr_iterate_evaluate_value");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("namespace");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("eval");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("::");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("lrange");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("end");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("lindex");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(4);
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lrange";
                break;
            }
            case 2: {
                cmdName = "namespace";
                break;
            }
            case 3: {
                cmdName = "lindex";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cmd_elem",
        "_parse",
        "type",
        "cmd",
        "type_val"
    };
} // end class ParseExprIterateEvaluateValueCmd

