// TJC implementation of procedure parse_get_scalar_variable
package tjc;
import tcl.lang.*;

public class ParseGetScalarVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script stree");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        { // Invoke: set variable_tree [...]
            TclObject tmp0;
            { // Invoke: lindex $stree 2
                TclObject tmp1 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp1 = TclList.index(interp, tmp1, 2);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "variable_tree", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set range [...]
            TclObject tmp2;
            { // Invoke: lindex $variable_tree 0 1
                TclObject[] objv3 = TJC.grabObjv(interp, 4);
                TclObject tmp4;
                try {
                    // Arg 0 constant: lindex
                    objv3[0] = const0;
                    // Arg 1 variable: $variable_tree
                    tmp4 = getVarScalar(interp, "variable_tree", compiledLocals, 2);
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    // Arg 2 constant: 0
                    objv3[2] = const1;
                    // Arg 3 constant: 1
                    objv3[3] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 4);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "range", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: parse getstring $script $range
                TclObject[] objv5 = TJC.grabObjv(interp, 4);
                TclObject tmp6;
                try {
                    // Arg 0 constant: parse
                    objv5[0] = const3;
                    // Arg 1 constant: getstring
                    objv5[1] = const4;
                    // Arg 2 variable: $script
                    tmp6 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp6.preserve();
                    objv5[2] = tmp6;
                    // Arg 3 variable: $range
                    tmp6 = getVarScalar(interp, "range", compiledLocals, 3);
                    tmp6.preserve();
                    objv5[3] = tmp6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv5, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp6 = objv5[2];
                    if ( tmp6 != null ) {
                        tmp6.release();
                    }
                    tmp6 = objv5[3];
                    if ( tmp6 != null ) {
                        tmp6.release();
                    }
                    TJC.releaseObjv(interp, objv5, 4);
                }
            } // End Invoke: parse
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_get_scalar_variable");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("lindex");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("getstring");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            case 2: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "variable_tree",
        "range"
    };
} // end class ParseGetScalarVariableCmd

