// TJC implementation of procedure parse_is_command
package tjc;
import tcl.lang.*;

public class ParseIsCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "stree");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        { // Invoke: return [...]
            { // Invoke: expr ...
                // Binary operator: [...] == "command"
                { // Invoke: lindex $stree 0
                    TclObject tmp0 = getVarScalar(interp, "stree", compiledLocals, 0);
                    tmp0 = TclList.index(interp, tmp0, 0);
                    if ( tmp0 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp0);
                    }
                } // End Invoke: lindex
                TclObject tmp1 = interp.getResult();
                boolean tmp2 = tmp1.toString().equals("command");
                ExprValue tmp3 = evs0;
                tmp3.setIntValue(tmp2);
                // End Binary operator: ==
                interp.setResult( tmp3.getIntValue() != 0 );
            } // End Invoke: expr
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_command");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "stree"
    };
} // end class ParseIsCommandCmd

