// TJC implementation of procedure parse_word_iterate
package tjc;
import tcl.lang.*;

public class ParseWordIterateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 30, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "script stree cmd");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "cmd", objv[3], compiledLocals, 2);
        { // Invoke: set saved_word_value [...]
            TclObject tmp0;
            { // Invoke: ...
                TclObject[] objv1 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv1, 1);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "saved_word_value", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set cmdlist [...]
            TclObject tmp2;
            { // Invoke: list
                TclObject tmp3 = TclList.newInstance();
                interp.setResult(tmp3);
            } // End Invoke: list
            tmp2 = interp.getResult();
            setVarScalar(interp, "cmdlist", tmp2, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: parse_is_word $stree
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: parse_is_word
                    objv4[0] = const1;
                    // Arg 1 variable: $stree
                    tmp5 = getVarScalar(interp, "stree", compiledLocals, 1);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: parse_is_word
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("expected word stree but got ");
                        sbtmp11.append("{");
                        tmp10 = getVarScalar(interp, "stree", compiledLocals, 1);
                        sbtmp11.append(tmp10.toString());
                        sbtmp11.append("}");
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set elements_stree [...]
            TclObject tmp12;
            { // Invoke: lindex $stree 2
                TclObject tmp13 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp13 = TclList.index(interp, tmp13, 2);
                if ( tmp13 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp13);
                }
            } // End Invoke: lindex
            tmp12 = interp.getResult();
            setVarScalar(interp, "elements_stree", tmp12, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set atype {word begin}
            setVarScalar(interp, "atype", const3, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set avalues {}
            setVarScalar(interp, "avalues", const4, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set aranges {}
            setVarScalar(interp, "aranges", const4, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: lappend cmdlist [...]
            TclObject[] objv14 = TJC.grabObjv(interp, 1);
            TclObject tmp15;
            try {
                // Arg 2 command: [...]
                { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                    TclObject tmp16 = TclList.newInstance();
                    TclObject tmp17;
                    try {
                        tmp17 = getVarScalar(interp, "cmd", compiledLocals, 2);
                        TclList.append(interp, tmp16, tmp17);
                        tmp17 = getVarScalar(interp, "script", compiledLocals, 0);
                        TclList.append(interp, tmp16, tmp17);
                        tmp17 = getVarScalar(interp, "stree", compiledLocals, 1);
                        TclList.append(interp, tmp16, tmp17);
                        tmp17 = getVarScalar(interp, "atype", compiledLocals, 6);
                        TclList.append(interp, tmp16, tmp17);
                        tmp17 = getVarScalar(interp, "avalues", compiledLocals, 7);
                        TclList.append(interp, tmp16, tmp17);
                        tmp17 = getVarScalar(interp, "aranges", compiledLocals, 8);
                        TclList.append(interp, tmp16, tmp17);
                    } catch (TclException ex) {
                        tmp16.release();
                        throw ex;
                    }
                    interp.setResult(tmp16);
                } // End Invoke: list
                tmp15 = interp.getResult();
                tmp15.preserve();
                objv14[0] = tmp15;
                interp.resetResult();
                lappendVarScalar(interp, "cmdlist", objv14, compiledLocals, 4);
            } finally {
                TJC.releaseObjvElems(interp, objv14, 1);
            }
        } // End Invoke: lappend
        { // Invoke: foreach elements_tuple $elements_stree ...
            TclObject tmp18 = null;
            try {
                tmp18 = getVarScalar(interp, "elements_stree", compiledLocals, 5);
                tmp18.preserve();
                final int tmp18_length = TclList.getLength(interp, tmp18);

                for ( int index19 = 0 ; index19 < tmp18_length ; index19++ ) {
                    TclObject tmp20 = TclList.index(interp, tmp18, index19);
                    try {
                        setVarScalar(interp, "elements_tuple", tmp20, compiledLocals, 9);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "elements_tuple");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set type [...]
                        TclObject tmp21;
                        { // Invoke: lindex $elements_tuple 0
                            TclObject tmp22 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                            tmp22 = TclList.index(interp, tmp22, 0);
                            if ( tmp22 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp22);
                            }
                        } // End Invoke: lindex
                        tmp21 = interp.getResult();
                        setVarScalar(interp, "type", tmp21, compiledLocals, 10);
                    } // End Invoke: set
                    { // Invoke: switch -exact -- $type {backslash} ... {command} ... {text} ... {variable} ... default ...
                        TclObject tmp23 = getVarScalar(interp, "type", compiledLocals, 10);
                        String tmp24 = tmp23.toString();
                        int tmp24_length = tmp24.length();
                        char tmp24_first = '\n';
                        if ( tmp24_length > 0 ) {
                            tmp24_first = tmp24.charAt(0);
                        }
                        if ( tmp24_length == 9 && tmp24_first == 'b'
                                && tmp24.compareTo("backslash") == 0 ) {
                            // Pattern {backslash}
                            { // Invoke: set bs_stree $elements_tuple
                                TclObject tmp25;
                                tmp25 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                setVarScalar(interp, "bs_stree", tmp25, compiledLocals, 11);
                            } // End Invoke: set
                            { // Invoke: set bs_range [...]
                                TclObject tmp26;
                                { // Invoke: lindex $elements_tuple 1
                                    TclObject tmp27 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                    tmp27 = TclList.index(interp, tmp27, 1);
                                    if ( tmp27 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp27);
                                    }
                                } // End Invoke: lindex
                                tmp26 = interp.getResult();
                                setVarScalar(interp, "bs_range", tmp26, compiledLocals, 12);
                            } // End Invoke: set
                            { // Invoke: set bs_start [...]
                                TclObject tmp28;
                                { // Invoke: lindex $bs_range 0
                                    TclObject tmp29 = getVarScalar(interp, "bs_range", compiledLocals, 12);
                                    tmp29 = TclList.index(interp, tmp29, 0);
                                    if ( tmp29 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp29);
                                    }
                                } // End Invoke: lindex
                                tmp28 = interp.getResult();
                                setVarScalar(interp, "bs_start", tmp28, compiledLocals, 13);
                            } // End Invoke: set
                            { // Invoke: set bs_len [...]
                                TclObject tmp30;
                                { // Invoke: lindex $bs_range 1
                                    TclObject tmp31 = getVarScalar(interp, "bs_range", compiledLocals, 12);
                                    tmp31 = TclList.index(interp, tmp31, 1);
                                    if ( tmp31 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp31);
                                    }
                                } // End Invoke: lindex
                                tmp30 = interp.getResult();
                                setVarScalar(interp, "bs_len", tmp30, compiledLocals, 14);
                            } // End Invoke: set
                            { // Invoke: incr bs_start 1
                                interp.resetResult();
                                incrVarScalar(interp, "bs_start", 1, compiledLocals, 13);
                            } // End Invoke: incr
                            { // Invoke: incr bs_len -1
                                interp.resetResult();
                                incrVarScalar(interp, "bs_len", -1, compiledLocals, 14);
                            } // End Invoke: incr
                            { // Invoke: set bs_range [...]
                                TclObject tmp32;
                                { // Invoke: list $bs_start $bs_len
                                    TclObject tmp33 = TclList.newInstance();
                                    TclObject tmp34;
                                    try {
                                        tmp34 = getVarScalar(interp, "bs_start", compiledLocals, 13);
                                        TclList.append(interp, tmp33, tmp34);
                                        tmp34 = getVarScalar(interp, "bs_len", compiledLocals, 14);
                                        TclList.append(interp, tmp33, tmp34);
                                    } catch (TclException ex) {
                                        tmp33.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp33);
                                } // End Invoke: list
                                tmp32 = interp.getResult();
                                setVarScalar(interp, "bs_range", tmp32, compiledLocals, 12);
                            } // End Invoke: set
                            { // Invoke: set bs_text [...]
                                TclObject tmp35;
                                { // Invoke: parse getstring $script $bs_range
                                    TclObject[] objv36 = TJC.grabObjv(interp, 4);
                                    TclObject tmp37;
                                    try {
                                        // Arg 0 constant: parse
                                        objv36[0] = const5;
                                        // Arg 1 constant: getstring
                                        objv36[1] = const6;
                                        // Arg 2 variable: $script
                                        tmp37 = getVarScalar(interp, "script", compiledLocals, 0);
                                        tmp37.preserve();
                                        objv36[2] = tmp37;
                                        // Arg 3 variable: $bs_range
                                        tmp37 = getVarScalar(interp, "bs_range", compiledLocals, 12);
                                        tmp37.preserve();
                                        objv36[3] = tmp37;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv36, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp37 = objv36[2];
                                        if ( tmp37 != null ) {
                                            tmp37.release();
                                        }
                                        tmp37 = objv36[3];
                                        if ( tmp37 != null ) {
                                            tmp37.release();
                                        }
                                        TJC.releaseObjv(interp, objv36, 4);
                                    }
                                } // End Invoke: parse
                                tmp35 = interp.getResult();
                                setVarScalar(interp, "bs_text", tmp35, compiledLocals, 15);
                            } // End Invoke: set
                            { // Invoke: set atype "backslash"
                                setVarScalar(interp, "atype", const7, compiledLocals, 6);
                            } // End Invoke: set
                            { // Invoke: set avalues [...]
                                TclObject tmp38;
                                { // Invoke: list $bs_text
                                    TclObject tmp39 = TclList.newInstance();
                                    TclObject tmp40;
                                    tmp40 = getVarScalar(interp, "bs_text", compiledLocals, 15);
                                    TclList.append(interp, tmp39, tmp40);
                                    interp.setResult(tmp39);
                                } // End Invoke: list
                                tmp38 = interp.getResult();
                                setVarScalar(interp, "avalues", tmp38, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: set aranges [...]
                                TclObject tmp41;
                                { // Invoke: list $bs_range
                                    TclObject tmp42 = TclList.newInstance();
                                    TclObject tmp43;
                                    tmp43 = getVarScalar(interp, "bs_range", compiledLocals, 12);
                                    TclList.append(interp, tmp42, tmp43);
                                    interp.setResult(tmp42);
                                } // End Invoke: list
                                tmp41 = interp.getResult();
                                setVarScalar(interp, "aranges", tmp41, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: lappend cmdlist [...]
                                TclObject[] objv44 = TJC.grabObjv(interp, 1);
                                TclObject tmp45;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: list $cmd $script $bs_stree $atype $avalues $aranges
                                        TclObject tmp46 = TclList.newInstance();
                                        TclObject tmp47;
                                        try {
                                            tmp47 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                            TclList.append(interp, tmp46, tmp47);
                                            tmp47 = getVarScalar(interp, "script", compiledLocals, 0);
                                            TclList.append(interp, tmp46, tmp47);
                                            tmp47 = getVarScalar(interp, "bs_stree", compiledLocals, 11);
                                            TclList.append(interp, tmp46, tmp47);
                                            tmp47 = getVarScalar(interp, "atype", compiledLocals, 6);
                                            TclList.append(interp, tmp46, tmp47);
                                            tmp47 = getVarScalar(interp, "avalues", compiledLocals, 7);
                                            TclList.append(interp, tmp46, tmp47);
                                            tmp47 = getVarScalar(interp, "aranges", compiledLocals, 8);
                                            TclList.append(interp, tmp46, tmp47);
                                        } catch (TclException ex) {
                                            tmp46.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp46);
                                    } // End Invoke: list
                                    tmp45 = interp.getResult();
                                    tmp45.preserve();
                                    objv44[0] = tmp45;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "cmdlist", objv44, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv44, 1);
                                }
                            } // End Invoke: lappend
                        } else if ( tmp24_length == 7 && tmp24_first == 'c'
                                && tmp24.compareTo("command") == 0 ) {
                            // Pattern {command}
                            { // Invoke: set command_stree $elements_tuple
                                TclObject tmp48;
                                tmp48 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                setVarScalar(interp, "command_stree", tmp48, compiledLocals, 16);
                            } // End Invoke: set
                            { // Invoke: set command_range [...]
                                TclObject tmp49;
                                { // Invoke: lindex $elements_tuple 1
                                    TclObject tmp50 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                    tmp50 = TclList.index(interp, tmp50, 1);
                                    if ( tmp50 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp50);
                                    }
                                } // End Invoke: lindex
                                tmp49 = interp.getResult();
                                setVarScalar(interp, "command_range", tmp49, compiledLocals, 17);
                            } // End Invoke: set
                            { // Invoke: set commandtext_range [...]
                                TclObject tmp51;
                                { // Invoke: ... $script $command_range
                                    TclObject[] objv52 = TJC.grabObjv(interp, 3);
                                    TclObject tmp53;
                                    try {
                                        // Arg 0 constant: ...
                                        objv52[0] = const8;
                                        // Arg 1 variable: $script
                                        tmp53 = getVarScalar(interp, "script", compiledLocals, 0);
                                        tmp53.preserve();
                                        objv52[1] = tmp53;
                                        // Arg 2 variable: $command_range
                                        tmp53 = getVarScalar(interp, "command_range", compiledLocals, 17);
                                        tmp53.preserve();
                                        objv52[2] = tmp53;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv52, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp53 = objv52[1];
                                        if ( tmp53 != null ) {
                                            tmp53.release();
                                        }
                                        tmp53 = objv52[2];
                                        if ( tmp53 != null ) {
                                            tmp53.release();
                                        }
                                        TJC.releaseObjv(interp, objv52, 3);
                                    }
                                } // End Invoke: ...
                                tmp51 = interp.getResult();
                                setVarScalar(interp, "commandtext_range", tmp51, compiledLocals, 18);
                            } // End Invoke: set
                            { // Invoke: set commandtext [...]
                                TclObject tmp54;
                                { // Invoke: parse getstring $script $commandtext_range
                                    TclObject[] objv55 = TJC.grabObjv(interp, 4);
                                    TclObject tmp56;
                                    try {
                                        // Arg 0 constant: parse
                                        objv55[0] = const5;
                                        // Arg 1 constant: getstring
                                        objv55[1] = const6;
                                        // Arg 2 variable: $script
                                        tmp56 = getVarScalar(interp, "script", compiledLocals, 0);
                                        tmp56.preserve();
                                        objv55[2] = tmp56;
                                        // Arg 3 variable: $commandtext_range
                                        tmp56 = getVarScalar(interp, "commandtext_range", compiledLocals, 18);
                                        tmp56.preserve();
                                        objv55[3] = tmp56;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv55, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp56 = objv55[2];
                                        if ( tmp56 != null ) {
                                            tmp56.release();
                                        }
                                        tmp56 = objv55[3];
                                        if ( tmp56 != null ) {
                                            tmp56.release();
                                        }
                                        TJC.releaseObjv(interp, objv55, 4);
                                    }
                                } // End Invoke: parse
                                tmp54 = interp.getResult();
                                setVarScalar(interp, "commandtext", tmp54, compiledLocals, 19);
                            } // End Invoke: set
                            { // Invoke: set atype "command"
                                setVarScalar(interp, "atype", const9, compiledLocals, 6);
                            } // End Invoke: set
                            { // Invoke: set avalues [...]
                                TclObject tmp57;
                                { // Invoke: list $commandtext
                                    TclObject tmp58 = TclList.newInstance();
                                    TclObject tmp59;
                                    tmp59 = getVarScalar(interp, "commandtext", compiledLocals, 19);
                                    TclList.append(interp, tmp58, tmp59);
                                    interp.setResult(tmp58);
                                } // End Invoke: list
                                tmp57 = interp.getResult();
                                setVarScalar(interp, "avalues", tmp57, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: set aranges [...]
                                TclObject tmp60;
                                { // Invoke: list $commandtext_range
                                    TclObject tmp61 = TclList.newInstance();
                                    TclObject tmp62;
                                    tmp62 = getVarScalar(interp, "commandtext_range", compiledLocals, 18);
                                    TclList.append(interp, tmp61, tmp62);
                                    interp.setResult(tmp61);
                                } // End Invoke: list
                                tmp60 = interp.getResult();
                                setVarScalar(interp, "aranges", tmp60, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: lappend cmdlist [...]
                                TclObject[] objv63 = TJC.grabObjv(interp, 1);
                                TclObject tmp64;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: list $cmd $script $command_stree $atype $avalues $aranges
                                        TclObject tmp65 = TclList.newInstance();
                                        TclObject tmp66;
                                        try {
                                            tmp66 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                            TclList.append(interp, tmp65, tmp66);
                                            tmp66 = getVarScalar(interp, "script", compiledLocals, 0);
                                            TclList.append(interp, tmp65, tmp66);
                                            tmp66 = getVarScalar(interp, "command_stree", compiledLocals, 16);
                                            TclList.append(interp, tmp65, tmp66);
                                            tmp66 = getVarScalar(interp, "atype", compiledLocals, 6);
                                            TclList.append(interp, tmp65, tmp66);
                                            tmp66 = getVarScalar(interp, "avalues", compiledLocals, 7);
                                            TclList.append(interp, tmp65, tmp66);
                                            tmp66 = getVarScalar(interp, "aranges", compiledLocals, 8);
                                            TclList.append(interp, tmp65, tmp66);
                                        } catch (TclException ex) {
                                            tmp65.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp65);
                                    } // End Invoke: list
                                    tmp64 = interp.getResult();
                                    tmp64.preserve();
                                    objv63[0] = tmp64;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "cmdlist", objv63, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv63, 1);
                                }
                            } // End Invoke: lappend
                        } else if ( tmp24_length == 4 && tmp24_first == 't'
                                && tmp24.compareTo("text") == 0 ) {
                            // Pattern {text}
                            { // Invoke: set text_stree $elements_tuple
                                TclObject tmp67;
                                tmp67 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                setVarScalar(interp, "text_stree", tmp67, compiledLocals, 20);
                            } // End Invoke: set
                            { // Invoke: set text_range [...]
                                TclObject tmp68;
                                { // Invoke: lindex $elements_tuple 1
                                    TclObject tmp69 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                    tmp69 = TclList.index(interp, tmp69, 1);
                                    if ( tmp69 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp69);
                                    }
                                } // End Invoke: lindex
                                tmp68 = interp.getResult();
                                setVarScalar(interp, "text_range", tmp68, compiledLocals, 21);
                            } // End Invoke: set
                            { // Invoke: set text [...]
                                TclObject tmp70;
                                { // Invoke: parse getstring $script $text_range
                                    TclObject[] objv71 = TJC.grabObjv(interp, 4);
                                    TclObject tmp72;
                                    try {
                                        // Arg 0 constant: parse
                                        objv71[0] = const5;
                                        // Arg 1 constant: getstring
                                        objv71[1] = const6;
                                        // Arg 2 variable: $script
                                        tmp72 = getVarScalar(interp, "script", compiledLocals, 0);
                                        tmp72.preserve();
                                        objv71[2] = tmp72;
                                        // Arg 3 variable: $text_range
                                        tmp72 = getVarScalar(interp, "text_range", compiledLocals, 21);
                                        tmp72.preserve();
                                        objv71[3] = tmp72;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv71, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp72 = objv71[2];
                                        if ( tmp72 != null ) {
                                            tmp72.release();
                                        }
                                        tmp72 = objv71[3];
                                        if ( tmp72 != null ) {
                                            tmp72.release();
                                        }
                                        TJC.releaseObjv(interp, objv71, 4);
                                    }
                                } // End Invoke: parse
                                tmp70 = interp.getResult();
                                setVarScalar(interp, "text", tmp70, compiledLocals, 22);
                            } // End Invoke: set
                            { // Invoke: set atype "text"
                                setVarScalar(interp, "atype", const10, compiledLocals, 6);
                            } // End Invoke: set
                            { // Invoke: set avalues [...]
                                TclObject tmp73;
                                { // Invoke: list $text
                                    TclObject tmp74 = TclList.newInstance();
                                    TclObject tmp75;
                                    tmp75 = getVarScalar(interp, "text", compiledLocals, 22);
                                    TclList.append(interp, tmp74, tmp75);
                                    interp.setResult(tmp74);
                                } // End Invoke: list
                                tmp73 = interp.getResult();
                                setVarScalar(interp, "avalues", tmp73, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: set aranges [...]
                                TclObject tmp76;
                                { // Invoke: list $text_range
                                    TclObject tmp77 = TclList.newInstance();
                                    TclObject tmp78;
                                    tmp78 = getVarScalar(interp, "text_range", compiledLocals, 21);
                                    TclList.append(interp, tmp77, tmp78);
                                    interp.setResult(tmp77);
                                } // End Invoke: list
                                tmp76 = interp.getResult();
                                setVarScalar(interp, "aranges", tmp76, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: lappend cmdlist [...]
                                TclObject[] objv79 = TJC.grabObjv(interp, 1);
                                TclObject tmp80;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: list $cmd $script $text_stree $atype $avalues $aranges
                                        TclObject tmp81 = TclList.newInstance();
                                        TclObject tmp82;
                                        try {
                                            tmp82 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                            TclList.append(interp, tmp81, tmp82);
                                            tmp82 = getVarScalar(interp, "script", compiledLocals, 0);
                                            TclList.append(interp, tmp81, tmp82);
                                            tmp82 = getVarScalar(interp, "text_stree", compiledLocals, 20);
                                            TclList.append(interp, tmp81, tmp82);
                                            tmp82 = getVarScalar(interp, "atype", compiledLocals, 6);
                                            TclList.append(interp, tmp81, tmp82);
                                            tmp82 = getVarScalar(interp, "avalues", compiledLocals, 7);
                                            TclList.append(interp, tmp81, tmp82);
                                            tmp82 = getVarScalar(interp, "aranges", compiledLocals, 8);
                                            TclList.append(interp, tmp81, tmp82);
                                        } catch (TclException ex) {
                                            tmp81.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp81);
                                    } // End Invoke: list
                                    tmp80 = interp.getResult();
                                    tmp80.preserve();
                                    objv79[0] = tmp80;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "cmdlist", objv79, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv79, 1);
                                }
                            } // End Invoke: lappend
                        } else if ( tmp24_length == 8 && tmp24_first == 'v'
                                && tmp24.compareTo("variable") == 0 ) {
                            // Pattern {variable}
                            { // Invoke: set variable_stree $elements_tuple
                                TclObject tmp83;
                                tmp83 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                setVarScalar(interp, "variable_stree", tmp83, compiledLocals, 23);
                            } // End Invoke: set
                            { // Invoke: set variable_range [...]
                                TclObject tmp84;
                                { // Invoke: lindex $elements_tuple 1
                                    TclObject tmp85 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                    tmp85 = TclList.index(interp, tmp85, 1);
                                    if ( tmp85 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp85);
                                    }
                                } // End Invoke: lindex
                                tmp84 = interp.getResult();
                                setVarScalar(interp, "variable_range", tmp84, compiledLocals, 24);
                            } // End Invoke: set
                            { // Invoke: set variable [...]
                                TclObject tmp86;
                                { // Invoke: parse getstring $script $variable_range
                                    TclObject[] objv87 = TJC.grabObjv(interp, 4);
                                    TclObject tmp88;
                                    try {
                                        // Arg 0 constant: parse
                                        objv87[0] = const5;
                                        // Arg 1 constant: getstring
                                        objv87[1] = const6;
                                        // Arg 2 variable: $script
                                        tmp88 = getVarScalar(interp, "script", compiledLocals, 0);
                                        tmp88.preserve();
                                        objv87[2] = tmp88;
                                        // Arg 3 variable: $variable_range
                                        tmp88 = getVarScalar(interp, "variable_range", compiledLocals, 24);
                                        tmp88.preserve();
                                        objv87[3] = tmp88;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv87, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp88 = objv87[2];
                                        if ( tmp88 != null ) {
                                            tmp88.release();
                                        }
                                        tmp88 = objv87[3];
                                        if ( tmp88 != null ) {
                                            tmp88.release();
                                        }
                                        TJC.releaseObjv(interp, objv87, 4);
                                    }
                                } // End Invoke: parse
                                tmp86 = interp.getResult();
                                setVarScalar(interp, "variable", tmp86, compiledLocals, 25);
                            } // End Invoke: set
                            { // Invoke: set atype "variable"
                                setVarScalar(interp, "atype", const11, compiledLocals, 6);
                            } // End Invoke: set
                            { // Invoke: set avalues [...]
                                TclObject tmp89;
                                { // Invoke: list $variable
                                    TclObject tmp90 = TclList.newInstance();
                                    TclObject tmp91;
                                    tmp91 = getVarScalar(interp, "variable", compiledLocals, 25);
                                    TclList.append(interp, tmp90, tmp91);
                                    interp.setResult(tmp90);
                                } // End Invoke: list
                                tmp89 = interp.getResult();
                                setVarScalar(interp, "avalues", tmp89, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: set aranges [...]
                                TclObject tmp92;
                                { // Invoke: list $variable_range
                                    TclObject tmp93 = TclList.newInstance();
                                    TclObject tmp94;
                                    tmp94 = getVarScalar(interp, "variable_range", compiledLocals, 24);
                                    TclList.append(interp, tmp93, tmp94);
                                    interp.setResult(tmp93);
                                } // End Invoke: list
                                tmp92 = interp.getResult();
                                setVarScalar(interp, "aranges", tmp92, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: lappend cmdlist [...]
                                TclObject[] objv95 = TJC.grabObjv(interp, 1);
                                TclObject tmp96;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: list $cmd $script $variable_stree $atype $avalues $aranges
                                        TclObject tmp97 = TclList.newInstance();
                                        TclObject tmp98;
                                        try {
                                            tmp98 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                            TclList.append(interp, tmp97, tmp98);
                                            tmp98 = getVarScalar(interp, "script", compiledLocals, 0);
                                            TclList.append(interp, tmp97, tmp98);
                                            tmp98 = getVarScalar(interp, "variable_stree", compiledLocals, 23);
                                            TclList.append(interp, tmp97, tmp98);
                                            tmp98 = getVarScalar(interp, "atype", compiledLocals, 6);
                                            TclList.append(interp, tmp97, tmp98);
                                            tmp98 = getVarScalar(interp, "avalues", compiledLocals, 7);
                                            TclList.append(interp, tmp97, tmp98);
                                            tmp98 = getVarScalar(interp, "aranges", compiledLocals, 8);
                                            TclList.append(interp, tmp97, tmp98);
                                        } catch (TclException ex) {
                                            tmp97.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp97);
                                    } // End Invoke: list
                                    tmp96 = interp.getResult();
                                    tmp96.preserve();
                                    objv95[0] = tmp96;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "cmdlist", objv95, compiledLocals, 4);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv95, 1);
                                }
                            } // End Invoke: lappend
                        } else {
                            // Pattern default
                            { // Invoke: error "..."
                                TclObject[] objv99 = TJC.grabObjv(interp, 2);
                                TclObject tmp100;
                                try {
                                    // Arg 0 constant: error
                                    objv99[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp101 = new StringBuffer(64);
                                    sbtmp101.append("unsupported word element type ");
                                    sbtmp101.append("\"");
                                    tmp100 = getVarScalar(interp, "type", compiledLocals, 10);
                                    sbtmp101.append(tmp100.toString());
                                    sbtmp101.append("\"");
                                    sbtmp101.append(" in elements_tuple ");
                                    sbtmp101.append("{");
                                    tmp100 = getVarScalar(interp, "elements_tuple", compiledLocals, 9);
                                    sbtmp101.append(tmp100.toString());
                                    sbtmp101.append("}");
                                    tmp100 = TclString.newInstance(sbtmp101);
                                    tmp100.preserve();
                                    objv99[1] = tmp100;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv99, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp100 = objv99[1];
                                    if ( tmp100 != null ) {
                                        tmp100.release();
                                    }
                                    TJC.releaseObjv(interp, objv99, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: switch
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp18 != null ) {
                    tmp18.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $cmdlist
                TclObject tmp102 = getVarScalar(interp, "cmdlist", compiledLocals, 4);
                int tmp103 = TclList.getLength(interp, tmp102);
                interp.setResult(tmp103);
            } // End Invoke: llength
            TclObject tmp104 = interp.getResult();
            ExprValue tmp105 = evs0;
            TJC.exprInitValue(interp, tmp105, tmp104);
            ExprValue tmp106 = evs1;
            tmp106.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp105, tmp106);
            // End Binary operator: ==
            boolean tmp107 = ( tmp105.getIntValue() != 0 );
            if ( tmp107 ) {
                { // Invoke: error ...
                    TclObject[] objv108 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv108[0] = const2;
                        // Arg 1 constant: ...
                        objv108[1] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv108, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv108, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set atype {word end}
            setVarScalar(interp, "atype", const13, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set avalues {}
            setVarScalar(interp, "avalues", const4, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set aranges {}
            setVarScalar(interp, "aranges", const4, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: lappend cmdlist [...]
            TclObject[] objv109 = TJC.grabObjv(interp, 1);
            TclObject tmp110;
            try {
                // Arg 2 command: [...]
                { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                    TclObject tmp111 = TclList.newInstance();
                    TclObject tmp112;
                    try {
                        tmp112 = getVarScalar(interp, "cmd", compiledLocals, 2);
                        TclList.append(interp, tmp111, tmp112);
                        tmp112 = getVarScalar(interp, "script", compiledLocals, 0);
                        TclList.append(interp, tmp111, tmp112);
                        tmp112 = getVarScalar(interp, "stree", compiledLocals, 1);
                        TclList.append(interp, tmp111, tmp112);
                        tmp112 = getVarScalar(interp, "atype", compiledLocals, 6);
                        TclList.append(interp, tmp111, tmp112);
                        tmp112 = getVarScalar(interp, "avalues", compiledLocals, 7);
                        TclList.append(interp, tmp111, tmp112);
                        tmp112 = getVarScalar(interp, "aranges", compiledLocals, 8);
                        TclList.append(interp, tmp111, tmp112);
                    } catch (TclException ex) {
                        tmp111.release();
                        throw ex;
                    }
                    interp.setResult(tmp111);
                } // End Invoke: list
                tmp110 = interp.getResult();
                tmp110.preserve();
                objv109[0] = tmp110;
                interp.resetResult();
                lappendVarScalar(interp, "cmdlist", objv109, compiledLocals, 4);
            } finally {
                TJC.releaseObjvElems(interp, objv109, 1);
            }
        } // End Invoke: lappend
        { // Invoke: set atype {word}
            setVarScalar(interp, "atype", const14, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set avalues __WORD_VALUE__
            setVarScalar(interp, "avalues", const15, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set aranges {}
            setVarScalar(interp, "aranges", const4, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: lappend cmdlist [...]
            TclObject[] objv113 = TJC.grabObjv(interp, 1);
            TclObject tmp114;
            try {
                // Arg 2 command: [...]
                { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                    TclObject tmp115 = TclList.newInstance();
                    TclObject tmp116;
                    try {
                        tmp116 = getVarScalar(interp, "cmd", compiledLocals, 2);
                        TclList.append(interp, tmp115, tmp116);
                        tmp116 = getVarScalar(interp, "script", compiledLocals, 0);
                        TclList.append(interp, tmp115, tmp116);
                        tmp116 = getVarScalar(interp, "stree", compiledLocals, 1);
                        TclList.append(interp, tmp115, tmp116);
                        tmp116 = getVarScalar(interp, "atype", compiledLocals, 6);
                        TclList.append(interp, tmp115, tmp116);
                        tmp116 = getVarScalar(interp, "avalues", compiledLocals, 7);
                        TclList.append(interp, tmp115, tmp116);
                        tmp116 = getVarScalar(interp, "aranges", compiledLocals, 8);
                        TclList.append(interp, tmp115, tmp116);
                    } catch (TclException ex) {
                        tmp115.release();
                        throw ex;
                    }
                    interp.setResult(tmp115);
                } // End Invoke: list
                tmp114 = interp.getResult();
                tmp114.preserve();
                objv113[0] = tmp114;
                interp.resetResult();
                lappendVarScalar(interp, "cmdlist", objv113, compiledLocals, 4);
            } finally {
                TJC.releaseObjvElems(interp, objv113, 1);
            }
        } // End Invoke: lappend
        { // Invoke: foreach cmd $cmdlist ...
            TclObject tmp117 = null;
            try {
                tmp117 = getVarScalar(interp, "cmdlist", compiledLocals, 4);
                tmp117.preserve();
                final int tmp117_length = TclList.getLength(interp, tmp117);

                for ( int index118 = 0 ; index118 < tmp117_length ; index118++ ) {
                    TclObject tmp119 = TclList.index(interp, tmp117, index118);
                    try {
                        setVarScalar(interp, "cmd", tmp119, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cmd");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ...
                        // Binary operator: [...] != 6
                        { // Invoke: llength $cmd
                            TclObject tmp120 = getVarScalar(interp, "cmd", compiledLocals, 2);
                            int tmp121 = TclList.getLength(interp, tmp120);
                            interp.setResult(tmp121);
                        } // End Invoke: llength
                        TclObject tmp122 = interp.getResult();
                        ExprValue tmp123 = evs0;
                        TJC.exprInitValue(interp, tmp123, tmp122);
                        ExprValue tmp124 = evs1;
                        tmp124.setIntValue(6);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp123, tmp124);
                        // End Binary operator: !=
                        boolean tmp125 = ( tmp123.getIntValue() != 0 );
                        if ( tmp125 ) {
                            { // Invoke: error "..."
                                TclObject[] objv126 = TJC.grabObjv(interp, 2);
                                TclObject tmp127;
                                try {
                                    // Arg 0 constant: error
                                    objv126[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp128 = new StringBuffer(64);
                                    sbtmp128.append("expected 6 arguments, callback format is CMD SCRIPT STREE TYPE VALUES RANGES but cmd was ");
                                    sbtmp128.append("{");
                                    tmp127 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                    sbtmp128.append(tmp127.toString());
                                    sbtmp128.append("}");
                                    tmp127 = TclString.newInstance(sbtmp128);
                                    tmp127.preserve();
                                    objv126[1] = tmp127;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv126, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp127 = objv126[1];
                                    if ( tmp127 != null ) {
                                        tmp127.release();
                                    }
                                    TJC.releaseObjv(interp, objv126, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set atype [...]
                        TclObject tmp129;
                        { // Invoke: lindex $cmd 3
                            TclObject tmp130 = getVarScalar(interp, "cmd", compiledLocals, 2);
                            tmp130 = TclList.index(interp, tmp130, 3);
                            if ( tmp130 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp130);
                            }
                        } // End Invoke: lindex
                        tmp129 = interp.getResult();
                        setVarScalar(interp, "atype", tmp129, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: set avalues [...]
                        TclObject tmp131;
                        { // Invoke: lindex $cmd 4
                            TclObject tmp132 = getVarScalar(interp, "cmd", compiledLocals, 2);
                            tmp132 = TclList.index(interp, tmp132, 4);
                            if ( tmp132 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp132);
                            }
                        } // End Invoke: lindex
                        tmp131 = interp.getResult();
                        setVarScalar(interp, "avalues", tmp131, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: if ... ... elseif ... ... elseif ... ...
                        // Binary operator: $atype == "word begin"
                        TclObject tmp133 = getVarScalar(interp, "atype", compiledLocals, 6);
                        boolean tmp134 = tmp133.toString().equals("word begin");
                        ExprValue tmp135 = evs0;
                        tmp135.setIntValue(tmp134);
                        // End Binary operator: ==
                        boolean tmp136 = ( tmp135.getIntValue() != 0 );
                        if ( tmp136 ) {
                            { // Invoke: ... {}
                                TclObject[] objv137 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: ...
                                    objv137[0] = const0;
                                    // Arg 1 constant: {}
                                    objv137[1] = const4;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv137, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv137, 2);
                                }
                            } // End Invoke: ...
                        } else {
                            // Binary operator: $atype == "word end"
                            TclObject tmp138 = getVarScalar(interp, "atype", compiledLocals, 6);
                            boolean tmp139 = tmp138.toString().equals("word end");
                            ExprValue tmp140 = evs0;
                            tmp140.setIntValue(tmp139);
                            // End Binary operator: ==
                            boolean tmp141 = ( tmp140.getIntValue() != 0 );
                            if ( tmp141 ) {
                                { // Invoke: set word_value [...]
                                    TclObject tmp142;
                                    { // Invoke: ...
                                        TclObject[] objv143 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv143[0] = const0;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                ? cmdcache1.cmd : null), objv143, 0);
                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                updateCmdCache(interp, 1);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv143, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp142 = interp.getResult();
                                    setVarScalar(interp, "word_value", tmp142, compiledLocals, 26);
                                } // End Invoke: set
                            } else {
                                // Binary operator: $avalues == "__WORD_VALUE__"
                                TclObject tmp144 = getVarScalar(interp, "avalues", compiledLocals, 7);
                                boolean tmp145 = tmp144.toString().equals("__WORD_VALUE__");
                                ExprValue tmp146 = evs0;
                                tmp146.setIntValue(tmp145);
                                // End Binary operator: ==
                                boolean tmp147 = ( tmp146.getIntValue() != 0 );
                                if ( tmp147 ) {
                                    { // Invoke: if ... ...
                                        // Unary operator: ! [...]
                                        { // Invoke: info exists word_value
                                            TclObject[] objv148 = TJC.grabObjv(interp, 3);
                                            try {
                                                // Arg 0 constant: info
                                                objv148[0] = const16;
                                                // Arg 1 constant: exists
                                                objv148[1] = const17;
                                                // Arg 2 constant: word_value
                                                objv148[2] = const18;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                    ? cmdcache6.cmd : null), objv148, 0);
                                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                    updateCmdCache(interp, 6);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv148, 3);
                                            }
                                        } // End Invoke: info
                                        TclObject tmp149 = interp.getResult();
                                        ExprValue tmp150 = evs0;
                                        if ( tmp149.isIntType() ) {
                                            TJC.exprUnaryNotOperatorKnownInt(tmp150, tmp149);
                                        } else {
                                            TJC.exprUnaryNotOperator(interp, tmp150, tmp149);
                                        }
                                        // End Unary operator: !
                                        boolean tmp151 = ( tmp150.getIntValue() != 0 );
                                        if ( tmp151 ) {
                                            { // Invoke: error ...
                                                TclObject[] objv152 = TJC.grabObjv(interp, 2);
                                                try {
                                                    // Arg 0 constant: error
                                                    objv152[0] = const2;
                                                    // Arg 1 constant: ...
                                                    objv152[1] = const19;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                        ? cmdcache3.cmd : null), objv152, 0);
                                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                        updateCmdCache(interp, 3);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv152, 2);
                                                }
                                            } // End Invoke: error
                                        }
                                    } // End Invoke: if
                                    { // Invoke: set new_avalues $word_value
                                        TclObject tmp153;
                                        tmp153 = getVarScalar(interp, "word_value", compiledLocals, 26);
                                        setVarScalar(interp, "new_avalues", tmp153, compiledLocals, 27);
                                    } // End Invoke: set
                                    { // Invoke: set new_cmd [...]
                                        TclObject tmp154;
                                        { // Invoke: lrange $cmd 0 3
                                            TclObject[] objv155 = TJC.grabObjv(interp, 4);
                                            TclObject tmp156;
                                            try {
                                                // Arg 0 constant: lrange
                                                objv155[0] = const20;
                                                // Arg 1 variable: $cmd
                                                tmp156 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                tmp156.preserve();
                                                objv155[1] = tmp156;
                                                // Arg 2 constant: 0
                                                objv155[2] = const21;
                                                // Arg 3 constant: 3
                                                objv155[3] = const22;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                    ? cmdcache7.cmd : null), objv155, 0);
                                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                    updateCmdCache(interp, 7);
                                                }
                                            } finally {
                                                tmp156 = objv155[1];
                                                if ( tmp156 != null ) {
                                                    tmp156.release();
                                                }
                                                TJC.releaseObjv(interp, objv155, 4);
                                            }
                                        } // End Invoke: lrange
                                        tmp154 = interp.getResult();
                                        setVarScalar(interp, "new_cmd", tmp154, compiledLocals, 28);
                                    } // End Invoke: set
                                    { // Invoke: lappend new_cmd $new_avalues
                                        TclObject[] objv157 = TJC.grabObjv(interp, 1);
                                        TclObject tmp158;
                                        try {
                                            // Arg 2 variable: $new_avalues
                                            tmp158 = getVarScalar(interp, "new_avalues", compiledLocals, 27);
                                            tmp158.preserve();
                                            objv157[0] = tmp158;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "new_cmd", objv157, compiledLocals, 28);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv157, 1);
                                        }
                                    } // End Invoke: lappend
                                    { // Invoke: lappend new_cmd [...]
                                        TclObject[] objv159 = TJC.grabObjv(interp, 1);
                                        TclObject tmp160;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $cmd 5
                                                TclObject tmp161 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                tmp161 = TclList.index(interp, tmp161, 5);
                                                if ( tmp161 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp161);
                                                }
                                            } // End Invoke: lindex
                                            tmp160 = interp.getResult();
                                            tmp160.preserve();
                                            objv159[0] = tmp160;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "new_cmd", objv159, compiledLocals, 28);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv159, 1);
                                        }
                                    } // End Invoke: lappend
                                    { // Invoke: set cmd $new_cmd
                                        TclObject tmp162;
                                        tmp162 = getVarScalar(interp, "new_cmd", compiledLocals, 28);
                                        setVarScalar(interp, "cmd", tmp162, compiledLocals, 2);
                                    } // End Invoke: set
                                }
                            }
                        }
                    } // End Invoke: if
                    { // Invoke: namespace eval :: [...]
                        TclObject[] objv163 = TJC.grabObjv(interp, 4);
                        TclObject tmp164;
                        try {
                            // Arg 0 constant: namespace
                            objv163[0] = const23;
                            // Arg 1 constant: eval
                            objv163[1] = const24;
                            // Arg 2 constant: ::
                            objv163[2] = const25;
                            // Arg 3 command: [...]
                            { // Invoke: lrange $cmd 0 end
                                TclObject[] objv165 = TJC.grabObjv(interp, 4);
                                TclObject tmp166;
                                try {
                                    // Arg 0 constant: lrange
                                    objv165[0] = const20;
                                    // Arg 1 variable: $cmd
                                    tmp166 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                    tmp166.preserve();
                                    objv165[1] = tmp166;
                                    // Arg 2 constant: 0
                                    objv165[2] = const21;
                                    // Arg 3 constant: end
                                    objv165[3] = const26;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv165, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp166 = objv165[1];
                                    if ( tmp166 != null ) {
                                        tmp166.release();
                                    }
                                    TJC.releaseObjv(interp, objv165, 4);
                                }
                            } // End Invoke: lrange
                            tmp164 = interp.getResult();
                            tmp164.preserve();
                            objv163[3] = tmp164;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv163, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp164 = objv163[3];
                            if ( tmp164 != null ) {
                                tmp164.release();
                            }
                            TJC.releaseObjv(interp, objv163, 4);
                        }
                    } // End Invoke: namespace
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp117 != null ) {
                    tmp117.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set r_word [...]
            TclObject tmp167;
            { // Invoke: ...
                TclObject[] objv168 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv168[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv168, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv168, 1);
                }
            } // End Invoke: ...
            tmp167 = interp.getResult();
            setVarScalar(interp, "r_word", tmp167, compiledLocals, 29);
        } // End Invoke: set
        { // Invoke: ... $saved_word_value
            TclObject[] objv169 = TJC.grabObjv(interp, 2);
            TclObject tmp170;
            try {
                // Arg 0 constant: ...
                objv169[0] = const0;
                // Arg 1 variable: $saved_word_value
                tmp170 = getVarScalar(interp, "saved_word_value", compiledLocals, 3);
                tmp170.preserve();
                objv169[1] = tmp170;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv169, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                tmp170 = objv169[1];
                if ( tmp170 != null ) {
                    tmp170.release();
                }
                TJC.releaseObjv(interp, objv169, 2);
            }
        } // End Invoke: ...
        { // Invoke: return $r_word
            TclObject tmp171 = getVarScalar(interp, "r_word", compiledLocals, 29);
            interp.resetResult();
            interp.setResult(tmp171);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_word_iterate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_word_iterate_word_value");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("parse_is_word");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("word begin");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("getstring");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("backslash");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_range_without_brackets");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("command");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("variable");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("cmdlist length should not be zero");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("word end");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("word");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("__WORD_VALUE__");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("info");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("exists");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("word_value");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("__WORD_VALUE__ placeholder found with no previous {word begin/end}");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("lrange");
        const20.preserve(); const20.preserve();
        const21 = TclInteger.newInstance(0);
        const21.preserve(); const21.preserve();
        const22 = TclInteger.newInstance(3);
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("namespace");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("eval");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("::");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("end");
        const26.preserve(); const26.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_word_iterate_word_value";
                break;
            }
            case 2: {
                cmdName = "parse_is_word";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "parse";
                break;
            }
            case 5: {
                cmdName = "parse_range_without_brackets";
                break;
            }
            case 6: {
                cmdName = "info";
                break;
            }
            case 7: {
                cmdName = "lrange";
                break;
            }
            case 8: {
                cmdName = "namespace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "cmd",
        "saved_word_value",
        "cmdlist",
        "elements_stree",
        "atype",
        "avalues",
        "aranges",
        "elements_tuple",
        "type",
        "bs_stree",
        "bs_range",
        "bs_start",
        "bs_len",
        "bs_text",
        "command_stree",
        "command_range",
        "commandtext_range",
        "commandtext",
        "text_stree",
        "text_range",
        "text",
        "variable_stree",
        "variable_range",
        "variable",
        "word_value",
        "new_avalues",
        "new_cmd",
        "r_word"
    };
} // end class ParseWordIterateCmd

